/* Generated from posixwin.scm by the CHICKEN compiler
   http://www.call-with-current-continuation.org
   2008-03-23 21:47
   Version 3.0.0 - linux-unix-gnu-x86	[ manyargs dload ptables applyhook ]
   (c)2000-2008 Felix L. Winkelmann	compiled 2008-02-01 on debian (Linux)
   command line: posixwin.scm -quiet -no-trace -optimize-level 2 -include-path . -explicit-use -output-file posixwin.c
   unit: posix
*/

#include "chicken.h"

#ifndef WIN32_LEAN_AND_MEAN
# define WIN32_LEAN_AND_MEAN
#endif

/*
MinGW should have winsock2.h and ws2tcpip.h as well.
The CMake build will set HAVE_WINSOCK2_H and HAVE_WS2TCPIP_H.
However, the _MSC_VER test is still needed for vcbuild.bat.
./configure doesn't test for these.  It should, for MinGW.
*/
#if (_MSC_VER > 1300) || (defined(HAVE_WINSOCK2_H) && defined(HAVE_WS2TCPIP_H))
# include <winsock2.h>
# include <ws2tcpip.h>
#else
# include <winsock.h>
#endif

#include <signal.h>
#include <errno.h>
#include <io.h>
#include <stdio.h>
#include <process.h>

static int C_not_implemented(void);
int C_not_implemented() { return -1; }

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <direct.h>

#include <time.h>

#define ARG_MAX		256
#define PIPE_BUF	512
#ifndef ENV_MAX
# define ENV_MAX	1024
#endif

static C_TLS char *C_exec_args[ ARG_MAX ];
static C_TLS char *C_exec_env[ ENV_MAX ];
static C_TLS struct group *C_group;
static C_TLS int C_pipefds[ 2 ];
static C_TLS time_t C_secs;
static C_TLS struct tm C_tm;
static C_TLS struct stat C_statbuf;

/* pipe handles */
static C_TLS HANDLE C_rd0, C_wr0, C_wr0_, C_rd1, C_wr1, C_rd1_;
static C_TLS HANDLE C_save0, C_save1; /* saved I/O handles */
static C_TLS char C_rdbuf; /* one-char buffer for read */
static C_TLS int C_exstatus;

/* platform information; initialized for cached testing */
static C_TLS char C_hostname[256] = "";
static C_TLS char C_osver[16] = "";
static C_TLS char C_osrel[16] = "";
static C_TLS char C_processor[16] = "";
static C_TLS char C_shlcmd[256] = "";

/* Windows NT or better */
static int C_isNT = 0;

/* Current user name */
static C_TLS TCHAR C_username[255 + 1] = "";

/* Directory Operations */

#define C_mkdir(str)	    C_fix(mkdir(C_c_string(str)))
#define C_chdir(str)	    C_fix(chdir(C_c_string(str)))
#define C_rmdir(str)	    C_fix(rmdir(C_c_string(str)))

#ifndef __WATCOMC__
/* DIRENT stuff */
struct dirent
{
    char *		d_name;
};

typedef struct
{
    struct _finddata_t	fdata;
    int			handle;
    struct dirent	current;
} DIR;

static DIR * C_fcall
opendir(const char *name)
{
    int name_len = strlen(name);
    DIR *dir = (DIR *)malloc(sizeof(DIR));
    char *what;
    if (!dir)
    {
	errno = ENOMEM;
	return NULL;
    }
    what = (char *)malloc(name_len + 3);
    if (!what)
    {
	free(dir);
	errno = ENOMEM;
	return NULL;
    }
    strcpy(what, name);
    if (strchr("\\/", name[name_len - 1]))
	strcat(what, "*");
    else
	strcat(what, "\\*");

    dir->handle = _findfirst(what, &dir->fdata);
    if (dir->handle == -1)
    {
	free(what);
	free(dir);
	return NULL;
    }
    dir->current.d_name = NULL; /* as the first-time indicator */
    free(what);
    return dir;
}

static int C_fcall
closedir(DIR * dir)
{
    if (dir)
    {
	int res = _findclose(dir->handle);
	free(dir);
	return res;
    }
    return -1;
}

static struct dirent * C_fcall
readdir(DIR * dir)
{
    if (dir)
    {
	if (!dir->current.d_name /* first time after opendir */
	     || _findnext(dir->handle, &dir->fdata) != -1)
	{
	    dir->current.d_name = dir->fdata.name;
	    return &dir->current;
	}
    }
    return NULL;
}
#endif /* ifndef __WATCOMC__ */

#ifdef __WATCOMC__
# define mktemp _mktemp
/* there is no P_DETACH in Watcom CRTL */
# define P_DETACH P_NOWAIT
#endif

#define C_opendir(x,h)		C_set_block_item(h, 0, (C_word) opendir(C_c_string(x)))
#define C_closedir(h)		(closedir((DIR *)C_block_item(h, 0)), C_SCHEME_UNDEFINED)
#define C_readdir(h,e)		C_set_block_item(e, 0, (C_word) readdir((DIR *)C_block_item(h, 0)))
#define C_foundfile(e,b)	(strcpy(C_c_string(b), ((struct dirent *) C_block_item(e, 0))->d_name), C_fix(strlen(((struct dirent *) C_block_item(e, 0))->d_name)))

#define C_curdir(buf)	    (getcwd(C_c_string(buf), 256) ? C_fix(strlen(C_c_string(buf))) : C_SCHEME_FALSE)

#define open_binary_input_pipe(a, n, name)   C_mpointer(a, _popen(C_c_string(name), "r"))
#define open_text_input_pipe(a, n, name)     open_binary_input_pipe(a, n, name)
#define open_binary_output_pipe(a, n, name)  C_mpointer(a, _popen(C_c_string(name), "w"))
#define open_text_output_pipe(a, n, name)    open_binary_output_pipe(a, n, name)
#define close_pipe(p)			     C_fix(_pclose(C_port_file(p)))

#define C_set_file_ptr(port, ptr)  (C_set_block_item(port, 0, (C_block_item(ptr, 0))), C_SCHEME_UNDEFINED)

#define C_getpid	    getpid
#define C_chmod(fn, m)	    C_fix(chmod(C_data_pointer(fn), C_unfix(m)))
#define C_fdopen(a, n, fd, m) C_mpointer(a, fdopen(C_unfix(fd), C_c_string(m)))
#define C_C_fileno(p)	    C_fix(fileno(C_port_file(p)))
#define C_dup(x)	    C_fix(dup(C_unfix(x)))
#define C_dup2(x, y)	    C_fix(dup2(C_unfix(x), C_unfix(y)))
#define C_setvbuf(p, m, s)  C_fix(setvbuf(C_port_file(p), NULL, C_unfix(m), C_unfix(s)))
#define C_access(fn, m)	    C_fix(access((char *)C_data_pointer(fn), C_unfix(m)))
#define C_pipe(d, m)	    C_fix(_pipe(C_pipefds, PIPE_BUF, C_unfix(m)))
#define C_close(fd)	    C_fix(close(C_unfix(fd)))

#define C_getenventry(i)   environ[ i ]

#define C_putenv(s)	    C_fix(putenv((char *)C_data_pointer(s)))
#define C_stat(fn)	    C_fix(stat((char *)C_data_pointer(fn), &C_statbuf))
#define C_fstat(f)	    C_fix(fstat(C_unfix(f), &C_statbuf))

static C_word C_fcall
C_setenv(C_word x, C_word y)
{
    char *sx = C_data_pointer(x),
	 *sy = C_data_pointer(y);
    int n1 = C_strlen(sx),
	n2 = C_strlen(sy);
    char *buf = (char *)C_malloc(n1 + n2 + 2);
    if (buf == NULL)
	return(C_fix(0));
    else
    {
	C_strcpy(buf, sx);
	buf[ n1 ] = '=';
	C_strcpy(buf + n1 + 1, sy);
	return(C_fix(putenv(buf)));
    }
}

static void C_fcall
C_set_arg_string(char **where, int i, char *dat, int len)
{
    char *ptr;
    if (dat)
    {
	ptr = (char *)C_malloc(len + 1);
	C_memcpy(ptr, dat, len);
	ptr[ len ] = '\0';
    }
    else
	ptr = NULL;
    where[ i ] = ptr;
}

static void C_fcall
C_free_arg_string(char **where) {
  while (*where) C_free(*(where++));
}

#define C_set_exec_arg(i, a, len)	C_set_arg_string(C_exec_args, i, a, len)
#define C_set_exec_env(i, a, len)	C_set_arg_string(C_exec_env, i, a, len)

#define C_free_exec_args()		(C_free_arg_string(C_exec_args), C_SCHEME_TRUE)
#define C_free_exec_env()		(C_free_arg_string(C_exec_env), C_SCHEME_TRUE)

#define C_execvp(f)	    C_fix(execvp(C_data_pointer(f), (const char *const *)C_exec_args))
#define C_execve(f)	    C_fix(execve(C_data_pointer(f), (const char *const *)C_exec_args, (const char *const *)C_exec_env))

/* MS replacement for the fork-exec pair */
#define C_spawnvp(m, f)	    C_fix(spawnvp(C_unfix(m), C_data_pointer(f), (const char *const *)C_exec_args))
#define C_spawnvpe(m, f)    C_fix(spawnvpe(C_unfix(m), C_data_pointer(f), (const char *const *)C_exec_args, (const char *const *)C_exec_env))

#define C_open(fn, fl, m)   C_fix(open(C_c_string(fn), C_unfix(fl), C_unfix(m)))
#define C_read(fd, b, n)    C_fix(read(C_unfix(fd), C_data_pointer(b), C_unfix(n)))
#define C_write(fd, b, n)   C_fix(write(C_unfix(fd), C_data_pointer(b), C_unfix(n)))
#define C_mkstemp(t)	    C_fix(mktemp(C_c_string(t)))

#define C_ftell(p)	    C_fix(ftell(C_port_file(p)))
#define C_fseek(p, n, w)    C_mk_nbool(fseek(C_port_file(p), C_unfix(n), C_unfix(w)))
#define C_lseek(fd, o, w)   C_fix(lseek(C_unfix(fd), C_unfix(o), C_unfix(w)))

#define C_flushall()	    C_fix(_flushall())

#define C_ctime(n)	    (C_secs = (n), ctime(&C_secs))

#define C_tm_set_08(v) \
        (memset(&C_tm, 0, sizeof(struct tm)), \
        C_tm.tm_sec = C_unfix(C_block_item(v, 0)), \
        C_tm.tm_min = C_unfix(C_block_item(v, 1)), \
        C_tm.tm_hour = C_unfix(C_block_item(v, 2)), \
        C_tm.tm_mday = C_unfix(C_block_item(v, 3)), \
        C_tm.tm_mon = C_unfix(C_block_item(v, 4)), \
        C_tm.tm_year = C_unfix(C_block_item(v, 5)), \
        C_tm.tm_wday = C_unfix(C_block_item(v, 6)), \
        C_tm.tm_yday = C_unfix(C_block_item(v, 7)), \
        C_tm.tm_isdst = (C_block_item(v, 8) != C_SCHEME_FALSE))

#define C_tm_set(v) (C_tm_set_08(v), &C_tm)

#define C_asctime(v)    (asctime(C_tm_set(v)))
#define C_mktime(v)     ((C_temporary_flonum = mktime(C_tm_set(v))) != -1)

#define TIME_STRING_MAXLENGTH 255
static char C_time_string [TIME_STRING_MAXLENGTH + 1];
#undef TIME_STRING_MAXLENGTH

#define C_strftime(v, f) \
        (strftime(C_time_string, sizeof(C_time_string), C_c_string(f), C_tm_set(v)) ? C_time_string : NULL)

/*
  mapping from Win32 error codes to errno
*/

typedef struct
{
    DWORD   win32;
    int	    libc;
} errmap_t;

static errmap_t errmap[] =
{
    {ERROR_INVALID_FUNCTION,	  EINVAL},
    {ERROR_FILE_NOT_FOUND,	  ENOENT},
    {ERROR_PATH_NOT_FOUND,	  ENOENT},
    {ERROR_TOO_MANY_OPEN_FILES,	  EMFILE},
    {ERROR_ACCESS_DENIED,	  EACCES},
    {ERROR_INVALID_HANDLE,	  EBADF},
    {ERROR_ARENA_TRASHED,	  ENOMEM},
    {ERROR_NOT_ENOUGH_MEMORY,	  ENOMEM},
    {ERROR_INVALID_BLOCK,	  ENOMEM},
    {ERROR_BAD_ENVIRONMENT,	  E2BIG},
    {ERROR_BAD_FORMAT,		  ENOEXEC},
    {ERROR_INVALID_ACCESS,	  EINVAL},
    {ERROR_INVALID_DATA,	  EINVAL},
    {ERROR_INVALID_DRIVE,	  ENOENT},
    {ERROR_CURRENT_DIRECTORY,	  EACCES},
    {ERROR_NOT_SAME_DEVICE,	  EXDEV},
    {ERROR_NO_MORE_FILES,	  ENOENT},
    {ERROR_LOCK_VIOLATION,	  EACCES},
    {ERROR_BAD_NETPATH,		  ENOENT},
    {ERROR_NETWORK_ACCESS_DENIED, EACCES},
    {ERROR_BAD_NET_NAME,	  ENOENT},
    {ERROR_FILE_EXISTS,		  EEXIST},
    {ERROR_CANNOT_MAKE,		  EACCES},
    {ERROR_FAIL_I24,		  EACCES},
    {ERROR_INVALID_PARAMETER,	  EINVAL},
    {ERROR_NO_PROC_SLOTS,	  EAGAIN},
    {ERROR_DRIVE_LOCKED,	  EACCES},
    {ERROR_BROKEN_PIPE,		  EPIPE},
    {ERROR_DISK_FULL,		  ENOSPC},
    {ERROR_INVALID_TARGET_HANDLE, EBADF},
    {ERROR_INVALID_HANDLE,	  EINVAL},
    {ERROR_WAIT_NO_CHILDREN,	  ECHILD},
    {ERROR_CHILD_NOT_COMPLETE,	  ECHILD},
    {ERROR_DIRECT_ACCESS_HANDLE,  EBADF},
    {ERROR_NEGATIVE_SEEK,	  EINVAL},
    {ERROR_SEEK_ON_DEVICE,	  EACCES},
    {ERROR_DIR_NOT_EMPTY,	  ENOTEMPTY},
    {ERROR_NOT_LOCKED,		  EACCES},
    {ERROR_BAD_PATHNAME,	  ENOENT},
    {ERROR_MAX_THRDS_REACHED,	  EAGAIN},
    {ERROR_LOCK_FAILED,		  EACCES},
    {ERROR_ALREADY_EXISTS,	  EEXIST},
    {ERROR_FILENAME_EXCED_RANGE,  ENOENT},
    {ERROR_NESTING_NOT_ALLOWED,	  EAGAIN},
    {ERROR_NOT_ENOUGH_QUOTA,	  ENOMEM},
    {0, 0}
};

static void C_fcall
set_errno(DWORD w32err)
{
    errmap_t *map = errmap;
    for (; errmap->win32; ++map)
    {
	if (errmap->win32 == w32err)
	{
	    errno = errmap->libc;
	    return;
	}
    }
}

static int C_fcall
set_last_errno()
{
    set_errno(GetLastError());
    return 0;
}

/* Functions for creating process with redirected I/O */

static int C_fcall
zero_handles()
{
    C_rd0 = C_wr0 = C_wr0_ = INVALID_HANDLE_VALUE;
    C_rd1 = C_wr1 = C_rd1_ = INVALID_HANDLE_VALUE;
    C_save0 = C_save1 = INVALID_HANDLE_VALUE;
    return 1;
}

static int C_fcall
close_handles()
{
    if (C_rd0 != INVALID_HANDLE_VALUE)
	CloseHandle(C_rd0);
    if (C_rd1 != INVALID_HANDLE_VALUE)
	CloseHandle(C_rd1);
    if (C_wr0 != INVALID_HANDLE_VALUE)
	CloseHandle(C_wr0);
    if (C_wr1 != INVALID_HANDLE_VALUE)
	CloseHandle(C_wr1);
    if (C_rd1_ != INVALID_HANDLE_VALUE)
	CloseHandle(C_rd1_);
    if (C_wr0_ != INVALID_HANDLE_VALUE)
	CloseHandle(C_wr0_);
    if (C_save0 != INVALID_HANDLE_VALUE)
    {
	SetStdHandle(STD_INPUT_HANDLE, C_save0);
	CloseHandle(C_save0);
    }
    if (C_save1 != INVALID_HANDLE_VALUE)
    {
	SetStdHandle(STD_OUTPUT_HANDLE, C_save1);
	CloseHandle(C_save1);
    }
    return zero_handles();
}

static int C_fcall
redir_io()
{
    SECURITY_ATTRIBUTES sa;
    sa.nLength = sizeof(SECURITY_ATTRIBUTES);
    sa.bInheritHandle = TRUE;
    sa.lpSecurityDescriptor = NULL;

    zero_handles();

    C_save0 = GetStdHandle(STD_INPUT_HANDLE);
    C_save1 = GetStdHandle(STD_OUTPUT_HANDLE);
    if (!CreatePipe(&C_rd0, &C_wr0, &sa, 0)
	    || !SetStdHandle(STD_INPUT_HANDLE, C_rd0)
	    || !DuplicateHandle(GetCurrentProcess(), C_wr0, GetCurrentProcess(),
		&C_wr0_, 0, FALSE, DUPLICATE_SAME_ACCESS)
	    || !CreatePipe(&C_rd1, &C_wr1, &sa, 0)
	    || !SetStdHandle(STD_OUTPUT_HANDLE, C_wr1)
	    || !DuplicateHandle(GetCurrentProcess(), C_rd1, GetCurrentProcess(),
		&C_rd1_, 0, FALSE, DUPLICATE_SAME_ACCESS))
    {
	set_last_errno();
	close_handles();
	return 0;
    }

    CloseHandle(C_wr0);
    C_wr0 = INVALID_HANDLE_VALUE;
    CloseHandle(C_rd1);
    C_rd1 = INVALID_HANDLE_VALUE;
    return 1;
}

static int C_fcall
run_process(char *cmdline)
{
    PROCESS_INFORMATION pi;
    STARTUPINFO si;

    ZeroMemory(&pi, sizeof(PROCESS_INFORMATION));
    ZeroMemory(&si, sizeof(STARTUPINFO));
    si.cb = sizeof(STARTUPINFO);

    C_wr0_ = C_rd1_ = INVALID_HANDLE_VALUE; /* these handles are saved */

    if (CreateProcess(NULL, cmdline, NULL, NULL, TRUE, 0, NULL,
		      NULL, &si, &pi))
    {
	CloseHandle(pi.hThread);

	SetStdHandle(STD_INPUT_HANDLE, C_save0);
	SetStdHandle(STD_OUTPUT_HANDLE, C_save1);
	C_save0 = C_save1 = INVALID_HANDLE_VALUE;

	CloseHandle(C_rd0);
	CloseHandle(C_wr1);
	C_rd0 = C_wr1 = INVALID_HANDLE_VALUE;
	return (int)pi.hProcess;
    }
    else
	return set_last_errno();
}

static int C_fcall
pipe_write(int hpipe, void* buf, int count)
{
    DWORD done = 0;
    if (WriteFile((HANDLE)hpipe, buf, count, &done, NULL))
	return 1;
    else
	return set_last_errno();
}

static int C_fcall
pipe_read(int hpipe)
{
    DWORD done = 0;
    /* TODO:
    if (!pipe_ready(hpipe))
	go_to_sleep;
    */
    if (ReadFile((HANDLE)hpipe, &C_rdbuf, 1, &done, NULL))
    {
	if (done > 0) /* not EOF yet */
	    return 1;
	else
	    return -1;
    }
    return set_last_errno();
}

static int C_fcall
pipe_ready(int hpipe)
{
    DWORD avail = 0;
    if (PeekNamedPipe((HANDLE)hpipe, NULL, 0, NULL, &avail, NULL) && avail)
	return 1;
    else
    {
	Sleep(0); /* give pipe a chance */
	if (PeekNamedPipe((HANDLE)hpipe, NULL, 0, NULL, &avail, NULL))
	    return (avail > 0);
	else
	    return 0;
    }
}

#define C_zero_handles() C_fix(zero_handles())
#define C_close_handles() C_fix(close_handles())
#define C_redir_io() (redir_io() ? C_SCHEME_TRUE : C_SCHEME_FALSE)
#define C_run_process(cmdline) C_fix(run_process(C_c_string(cmdline)))
#define C_pipe_write(h, b, n) (pipe_write(C_unfix(h), C_c_string(b), C_unfix(n)) ? C_SCHEME_TRUE : C_SCHEME_FALSE)
#define C_pipe_read(h) C_fix(pipe_read(C_unfix(h)))
#define C_pipe_ready(h) (pipe_ready(C_unfix(h)) ? C_SCHEME_TRUE : C_SCHEME_FALSE)
#define close_handle(h) CloseHandle((HANDLE)h)

static int C_fcall
process_wait(int h, int t)
{
    if (WaitForSingleObject((HANDLE)h, (t ? 0 : INFINITE)) == WAIT_OBJECT_0)
    {
	DWORD ret;
	if (GetExitCodeProcess((HANDLE)h, &ret))
	{
	    CloseHandle((HANDLE)h);
	    C_exstatus = ret;
	    return 1;
	}
    }
    return set_last_errno();
}

#define C_process_wait(p, t) (process_wait(C_unfix(p), C_truep(t)) ? C_SCHEME_TRUE : C_SCHEME_FALSE)
#define C_sleep(t) (Sleep(C_unfix(t) * 1000), C_SCHEME_UNDEFINED)

static int C_fcall
get_hostname()
{
    /* Do we already have hostname? */
    if (strlen(C_hostname))
    {
	return 1;
    }
    else
    {
	WSADATA wsa;
	if (WSAStartup(MAKEWORD(1, 1), &wsa) == 0)
	{
	    int nok = gethostname(C_hostname, sizeof(C_hostname));
	    WSACleanup();
	    return !nok;
	}
	return 0;
    }
}

static int C_fcall
sysinfo()
{
    /* Do we need to build the sysinfo? */
    if (!strlen(C_osrel))
    {
	OSVERSIONINFO ovf;
	ZeroMemory(&ovf, sizeof(ovf));
	ovf.dwOSVersionInfoSize = sizeof(ovf);
	if (get_hostname() && GetVersionEx(&ovf))
	{
	    SYSTEM_INFO si;
	    _snprintf(C_osver, sizeof(C_osver) - 1, "%d.%d.%d",
			ovf.dwMajorVersion, ovf.dwMinorVersion, ovf.dwBuildNumber);
	    strncpy(C_osrel, "Win", sizeof(C_osrel) - 1);
	    switch (ovf.dwPlatformId)
	    {
	    case VER_PLATFORM_WIN32s:
		strncpy(C_osrel, "Win32s", sizeof(C_osrel) - 1);
		break;
	    case VER_PLATFORM_WIN32_WINDOWS:
		if (ovf.dwMajorVersion == 4)
		{
		    if (ovf.dwMinorVersion == 0)
			strncpy(C_osrel, "Win95", sizeof(C_osrel) - 1);
		    else if (ovf.dwMinorVersion == 10)
			strncpy(C_osrel, "Win98", sizeof(C_osrel) - 1);
		    else if (ovf.dwMinorVersion == 90)
			strncpy(C_osrel, "WinMe", sizeof(C_osrel) - 1);
		}
		break;
	    case VER_PLATFORM_WIN32_NT:
		C_isNT = 1;
		if (ovf.dwMajorVersion == 6)
		    strncpy(C_osrel, "WinVista", sizeof(C_osrel) - 1);
		else if (ovf.dwMajorVersion == 5)
		{
		    if (ovf.dwMinorVersion == 2)
			strncpy(C_osrel, "WinServer2003", sizeof(C_osrel) - 1);
		    else if (ovf.dwMinorVersion == 1)
			strncpy(C_osrel, "WinXP", sizeof(C_osrel) - 1);
		    else if ( ovf.dwMinorVersion == 0)
			strncpy(C_osrel, "Win2000", sizeof(C_osrel) - 1);
		}
		else if (ovf.dwMajorVersion <= 4)
		   strncpy(C_osrel, "WinNT", sizeof(C_osrel) - 1);
		break;
	    }
	    GetSystemInfo(&si);
	    strncpy(C_processor, "Unknown", sizeof(C_processor) - 1);
	    switch (si.wProcessorArchitecture)
	    {
	    case PROCESSOR_ARCHITECTURE_INTEL:
		strncpy(C_processor, "x86", sizeof(C_processor) - 1);
		break;
#	    ifdef PROCESSOR_ARCHITECTURE_IA64
	    case PROCESSOR_ARCHITECTURE_IA64:
		strncpy(C_processor, "IA64", sizeof(C_processor) - 1);
		break;
#	    endif
#	    ifdef PROCESSOR_ARCHITECTURE_AMD64
	    case PROCESSOR_ARCHITECTURE_AMD64:
		strncpy(C_processor, "x64", sizeof(C_processor) - 1);
		break;
#	    endif
#	    ifdef PROCESSOR_ARCHITECTURE_IA32_ON_WIN64
	    case PROCESSOR_ARCHITECTURE_IA32_ON_WIN64:
		strncpy(C_processor, "WOW64", sizeof(C_processor) - 1);
		break;
#	    endif
	    }
	}
	else
	    return set_last_errno();
    }
    return 1;
}

static int C_fcall
get_shlcmd()
{
    /* Do we need to build the shell command pathname? */
    if (!strlen(C_shlcmd))
    {
	if (sysinfo())
	{
	    char *cmdnam = C_isNT ? "\\cmd.exe" : "\\command.com";
	    UINT len = GetSystemDirectory(C_shlcmd, sizeof(C_shlcmd) - strlen(cmdnam));
	    if (len)
		strcpy(C_shlcmd + len, cmdnam);
	    else
		return set_last_errno();
	}
	else
	    return 0;
    }
    return 1;
}

#define C_get_hostname() (get_hostname() ? C_SCHEME_TRUE : C_SCHEME_FALSE)
#define C_sysinfo() (sysinfo() ? C_SCHEME_TRUE : C_SCHEME_FALSE)
#define C_get_shlcmd() (get_shlcmd() ? C_SCHEME_TRUE : C_SCHEME_FALSE)

/* GetUserName */

static int C_fcall
get_user_name()
{
    if (!strlen(C_username))
    {
	DWORD bufCharCount = sizeof(C_username) / sizeof(C_username[0]);
	if (!GetUserName(C_username, &bufCharCount))
	    return set_last_errno();
    }
    return 1;
}

#define C_get_user_name() (get_user_name() ? C_SCHEME_TRUE : C_SCHEME_FALSE)

/* User Information */

#if 0
static int C_fcall
get_netinfo()
{
    HINSTANCE hNet = 0,
	      hLoc = 0;

    if (isNT)
	hNet = LoadLibrary("netapi32.dll");
    else
    {
	hLoc = LoadLibrary("rlocal32.dll");
	hNet = LoadLibrary("radmin32.dll");
	//hNet = LoadLibrary("netapi.dll");
    }

    if (!hNet)
	return 0;

    
}
#endif

/*
    Spawn a process directly.
    Params:
    app		Command to execute.
    cmdlin	Command line (arguments).
    env		Environment for the new process (may be NULL).
    handle, stdin, stdout, stderr
		Spawned process info are returned in integers.
		When spawned process shares standard io stream with the parent
		process the respective value in handle, stdin, stdout, stderr
		is -1.
    params	A bitmask controling operation.
		Bit 1: Child & parent share standard input if this bit is set.
		Bit 2: Share standard output if bit is set.
		Bit 3: Share standard error if bit is set.

    Returns: zero return value indicates failure.
*/
static int C_fcall
C_process(const char * app, const char * cmdlin, const char ** env,
	  int * phandle,
	  int * pstdin_fd, int * pstdout_fd, int * pstderr_fd,
	  int params)
{
    int i;
    int success = TRUE;
    const int f_share_io[3] = { params & 1, params & 2, params & 4};
    int io_fds[3] = { -1, -1, -1 };
    HANDLE
	child_io_handles[3] = { NULL, NULL, NULL },
	standard_io_handles[3] = {
	    GetStdHandle(STD_INPUT_HANDLE),
	    GetStdHandle(STD_OUTPUT_HANDLE),
	    GetStdHandle(STD_ERROR_HANDLE)};
    const char modes[3] = "rww";
    HANDLE cur_process = GetCurrentProcess(), child_process = NULL;
    void* envblk = NULL;

    /****** create io handles & fds ***/

    for (i=0; i<3 && success; ++i)
    {
	if (f_share_io[i])
	{
	    success = DuplicateHandle(
		cur_process, standard_io_handles[i],
		cur_process, &child_io_handles[i],
		0, FALSE, DUPLICATE_SAME_ACCESS);
	}
	else
	{
	    HANDLE a, b;
	    success = CreatePipe(&a,&b,NULL,0);
	    if(success)
	    {
		HANDLE parent_end;
		if (modes[i]=='r') { child_io_handles[i]=a; parent_end=b; }
		else		   { parent_end=a; child_io_handles[i]=b; }
		success = (io_fds[i] = _open_osfhandle((long)parent_end,0)) >= 0;
	    }
	}
    }

    /****** make handles inheritable */

    for (i=0; i<3 && success; ++i)
	success = SetHandleInformation(child_io_handles[i], HANDLE_FLAG_INHERIT, -1);

#if 0 /* Requires a sorted list by key! */
    /****** create environment block if necessary ****/

    if (env && success)
    {
	char** p;
	int len = 0;

	for (p = env; *p; ++p) len += strlen(*p) + 1;

	if (envblk = C_malloc(len + 1))
	{
	    char* pb = (char*)envblk;
	    for (p = env; *p; ++p)
	    {
		strcpy(pb, *p);
		pb += strlen(*p) + 1;
	    }
	    *pb = '\0';
	}
	else
	    success = FALSE;
    }
#endif

    /****** finally spawn process ****/

    if (success)
    {
	PROCESS_INFORMATION pi;
	STARTUPINFO si;

	ZeroMemory(&pi,sizeof pi);
	ZeroMemory(&si,sizeof si);
	si.cb = sizeof si;
	si.dwFlags = STARTF_USESTDHANDLES;
	si.hStdInput = child_io_handles[0];
	si.hStdOutput = child_io_handles[1];
	si.hStdError = child_io_handles[2];

	/* FIXME passing 'app' param causes failure & possible stack corruption */
	success = CreateProcess(
	    NULL, (char*)cmdlin, NULL, NULL, TRUE, 0, envblk, NULL, &si, &pi);

	if (success)
	{
	    child_process=pi.hProcess;
	    CloseHandle(pi.hThread);
	}
	else
	    set_last_errno();
    }
    else
	set_last_errno();

    /****** cleanup & return *********/

    /* parent must close child end */
    for (i=0; i<3; ++i) CloseHandle(child_io_handles[i]);

    if (success)
    {
	*phandle = (int)child_process;
	*pstdin_fd = io_fds[0];
	*pstdout_fd = io_fds[1];
	*pstderr_fd = io_fds[2];
    }
    else
    {
	for (i=0; i<3; ++i) _close(io_fds[i]);
    }

    return success;
}

static C_PTABLE_ENTRY *create_ptable(void);
C_noret_decl(C_scheduler_toplevel)
C_externimport void C_ccall C_scheduler_toplevel(C_word c,C_word d,C_word k) C_noret;
C_noret_decl(C_regex_toplevel)
C_externimport void C_ccall C_regex_toplevel(C_word c,C_word d,C_word k) C_noret;
C_noret_decl(C_extras_toplevel)
C_externimport void C_ccall C_extras_toplevel(C_word c,C_word d,C_word k) C_noret;
C_noret_decl(C_utils_toplevel)
C_externimport void C_ccall C_utils_toplevel(C_word c,C_word d,C_word k) C_noret;

static C_TLS C_word lf[393];
static double C_possibly_force_alignment;
static C_char C_TLS li0[] C_aligned={C_lihdr(0,0,38),40,112,111,115,105,120,45,101,114,114,111,114,32,116,121,112,101,55,32,108,111,99,56,32,109,115,103,57,32,46,32,97,114,103,115,49,48,41,0,0,0,0,0,0};
static C_char C_TLS li1[] C_aligned={C_lihdr(0,0,39),40,102,105,108,101,45,111,112,101,110,32,102,105,108,101,110,97,109,101,49,51,32,102,108,97,103,115,49,52,32,46,32,109,111,100,101,49,53,41,0,0,0,0,0,0,0};
static C_char C_TLS li2[] C_aligned={C_lihdr(0,0,17),40,102,105,108,101,45,99,108,111,115,101,32,102,100,50,51,41,0};
static C_char C_TLS li3[] C_aligned={C_lihdr(0,0,34),40,102,105,108,101,45,114,101,97,100,32,102,100,50,55,32,115,105,122,101,50,56,32,46,32,98,117,102,102,101,114,50,57,41,0,0};
static C_char C_TLS li4[] C_aligned={C_lihdr(0,0,35),40,102,105,108,101,45,119,114,105,116,101,32,102,100,51,55,32,98,117,102,102,101,114,51,56,32,46,32,115,105,122,101,51,57,41,0,0,0};
static C_char C_TLS li5[] C_aligned={C_lihdr(0,0,25),40,102,105,108,101,45,109,107,115,116,101,109,112,32,116,101,109,112,108,97,116,101,52,56,41,0};
static C_char C_TLS li6[] C_aligned={C_lihdr(0,0,19),40,35,35,115,121,115,35,115,116,97,116,32,102,105,108,101,53,53,41,0,0,0};
static C_char C_TLS li7[] C_aligned={C_lihdr(0,0,23),40,102,105,108,101,45,115,116,97,116,32,102,53,57,32,46,32,103,53,56,54,48,41,0,0,0,0,0,0,0};
static C_char C_TLS li8[] C_aligned={C_lihdr(0,0,15),40,102,105,108,101,45,115,105,122,101,32,102,54,54,41,0,0,0,0,0,0,0};
static C_char C_TLS li9[] C_aligned={C_lihdr(0,0,28),40,102,105,108,101,45,109,111,100,105,102,105,99,97,116,105,111,110,45,116,105,109,101,32,102,54,56,41,0,0,0,0};
static C_char C_TLS li10[] C_aligned={C_lihdr(0,0,22),40,102,105,108,101,45,97,99,99,101,115,115,45,116,105,109,101,32,102,55,48,41,0,0,0,0,0,0};
static C_char C_TLS li11[] C_aligned={C_lihdr(0,0,22),40,102,105,108,101,45,99,104,97,110,103,101,45,116,105,109,101,32,102,55,50,41,0,0,0,0,0,0};
static C_char C_TLS li12[] C_aligned={C_lihdr(0,0,16),40,102,105,108,101,45,111,119,110,101,114,32,102,55,52,41};
static C_char C_TLS li13[] C_aligned={C_lihdr(0,0,22),40,102,105,108,101,45,112,101,114,109,105,115,115,105,111,110,115,32,102,55,54,41,0,0,0,0,0,0};
static C_char C_TLS li14[] C_aligned={C_lihdr(0,0,23),40,114,101,103,117,108,97,114,45,102,105,108,101,63,32,102,110,97,109,101,55,56,41,0,0,0,0,0,0,0};
static C_char C_TLS li15[] C_aligned={C_lihdr(0,0,24),40,115,121,109,98,111,108,105,99,45,108,105,110,107,63,32,102,110,97,109,101,56,49,41};
static C_char C_TLS li16[] C_aligned={C_lihdr(0,0,16),40,102,95,49,53,49,48,32,102,110,97,109,101,56,53,41};
static C_char C_TLS li17[] C_aligned={C_lihdr(0,0,18),40,115,116,97,116,45,116,121,112,101,32,110,97,109,101,56,52,41,0,0};
static C_char C_TLS li18[] C_aligned={C_lihdr(0,0,22),40,102,105,108,101,45,112,111,115,105,116,105,111,110,32,112,111,114,116,57,51,41,0,0,0,0,0,0};
static C_char C_TLS li19[] C_aligned={C_lihdr(0,0,44),40,115,101,116,45,102,105,108,101,45,112,111,115,105,116,105,111,110,33,32,112,111,114,116,57,55,32,112,111,115,57,56,32,46,32,119,104,101,110,99,101,57,57,41,0,0,0,0};
static C_char C_TLS li20[] C_aligned={C_lihdr(0,0,26),40,99,114,101,97,116,101,45,100,105,114,101,99,116,111,114,121,32,110,97,109,101,49,48,53,41,0,0};
static C_char C_TLS li21[] C_aligned={C_lihdr(0,0,26),40,99,104,97,110,103,101,45,100,105,114,101,99,116,111,114,121,32,110,97,109,101,49,48,56,41,0,0};
static C_char C_TLS li22[] C_aligned={C_lihdr(0,0,26),40,100,101,108,101,116,101,45,100,105,114,101,99,116,111,114,121,32,110,97,109,101,49,49,49,41,0,0};
static C_char C_TLS li23[] C_aligned={C_lihdr(0,0,6),40,108,111,111,112,41,0,0,0,0,0,0};
static C_char C_TLS li24[] C_aligned={C_lihdr(0,0,35),40,98,111,100,121,49,50,49,32,115,112,101,99,49,50,55,32,115,104,111,119,45,100,111,116,102,105,108,101,115,63,49,50,56,41,0,0,0};
static C_char C_TLS li25[] C_aligned={C_lihdr(0,0,35),40,100,101,102,45,115,104,111,119,45,100,111,116,102,105,108,101,115,63,49,50,52,32,37,115,112,101,99,49,49,57,49,52,56,41,0,0,0};
static C_char C_TLS li26[] C_aligned={C_lihdr(0,0,13),40,100,101,102,45,115,112,101,99,49,50,51,41,0,0,0,0,0};
static C_char C_TLS li27[] C_aligned={C_lihdr(0,0,21),40,100,105,114,101,99,116,111,114,121,32,46,32,103,49,49,55,49,49,56,41,0,0,0,0,0};
static C_char C_TLS li28[] C_aligned={C_lihdr(0,0,21),40,100,105,114,101,99,116,111,114,121,63,32,102,110,97,109,101,49,53,52,41,0,0,0,0,0};
static C_char C_TLS li29[] C_aligned={C_lihdr(0,0,29),40,99,117,114,114,101,110,116,45,100,105,114,101,99,116,111,114,121,32,46,32,103,49,53,56,49,53,57,41,0,0,0,0,0};
static C_char C_TLS li30[] C_aligned={C_lihdr(0,0,17),40,105,115,112,101,114,115,101,32,103,49,55,57,49,56,48,41,0};
static C_char C_TLS li31[] C_aligned={C_lihdr(0,0,6),40,115,101,112,63,41,0,0,0,0,0,0};
static C_char C_TLS li32[] C_aligned={C_lihdr(0,0,7),40,97,49,57,57,55,41,0,0,0,0,0,0,0};
static C_char C_TLS li33[] C_aligned={C_lihdr(0,0,15),40,97,49,57,57,49,32,103,49,56,53,49,57,48,41,0,0,0,0,0,0,0};
static C_char C_TLS li34[] C_aligned={C_lihdr(0,0,7),40,97,50,48,49,53,41,0,0,0,0,0,0,0};
static C_char C_TLS li35[] C_aligned={C_lihdr(0,0,7),40,97,50,48,50,55,41,0,0,0,0,0,0,0};
static C_char C_TLS li36[] C_aligned={C_lihdr(0,0,17),40,97,50,48,50,49,32,46,32,103,49,56,56,49,57,51,41,0};
static C_char C_TLS li37[] C_aligned={C_lihdr(0,0,7),40,97,50,48,48,57,41,0,0,0,0,0,0,0};
static C_char C_TLS li38[] C_aligned={C_lihdr(0,0,15),40,97,49,57,56,53,32,103,49,56,55,49,56,57,41,0,0,0,0,0,0,0};
static C_char C_TLS li39[] C_aligned={C_lihdr(0,0,5),40,99,119,100,41,0,0,0,0,0};
static C_char C_TLS li40[] C_aligned={C_lihdr(0,0,16),40,108,111,111,112,32,108,49,57,55,32,114,49,57,56,41};
static C_char C_TLS li41[] C_aligned={C_lihdr(0,0,24),40,99,97,110,111,110,105,99,97,108,45,112,97,116,104,32,112,97,116,104,49,57,52,41};
static C_char C_TLS li42[] C_aligned={C_lihdr(0,0,6),40,109,111,100,101,41,0,0,0,0,0,0};
static C_char C_TLS li43[] C_aligned={C_lihdr(0,0,14),40,98,97,100,109,111,100,101,32,109,50,48,53,41,0,0,0,0,0,0};
static C_char C_TLS li44[] C_aligned={C_lihdr(0,0,26),40,99,104,101,99,107,32,99,109,100,50,48,54,32,105,110,112,50,48,55,32,114,50,48,56,41,0,0};
static C_char C_TLS li45[] C_aligned={C_lihdr(0,0,31),40,111,112,101,110,45,105,110,112,117,116,45,112,105,112,101,32,99,109,100,50,49,50,32,46,32,109,50,49,51,41,0,0,0,0,0,0,0};
static C_char C_TLS li46[] C_aligned={C_lihdr(0,0,32),40,111,112,101,110,45,111,117,116,112,117,116,45,112,105,112,101,32,99,109,100,50,49,56,32,46,32,109,50,49,57,41};
static C_char C_TLS li47[] C_aligned={C_lihdr(0,0,26),40,99,108,111,115,101,45,105,110,112,117,116,45,112,105,112,101,32,112,111,114,116,50,50,52,41,0,0};
static C_char C_TLS li48[] C_aligned={C_lihdr(0,0,7),40,97,50,53,50,53,41,0,0,0,0,0,0,0};
static C_char C_TLS li49[] C_aligned={C_lihdr(0,0,20),40,97,50,53,51,49,32,46,32,114,101,115,117,108,116,115,50,52,50,41,0,0,0,0};
static C_char C_TLS li50[] C_aligned={C_lihdr(0,0,47),40,99,97,108,108,45,119,105,116,104,45,105,110,112,117,116,45,112,105,112,101,32,99,109,100,50,51,56,32,112,114,111,99,50,51,57,32,46,32,109,111,100,101,50,52,48,41,0,0,0,0,0,0,0};
static C_char C_TLS li51[] C_aligned={C_lihdr(0,0,7),40,97,50,53,52,57,41,0,0,0,0,0,0,0};
static C_char C_TLS li52[] C_aligned={C_lihdr(0,0,20),40,97,50,53,53,53,32,46,32,114,101,115,117,108,116,115,50,52,56,41,0,0,0,0};
static C_char C_TLS li53[] C_aligned={C_lihdr(0,0,48),40,99,97,108,108,45,119,105,116,104,45,111,117,116,112,117,116,45,112,105,112,101,32,99,109,100,50,52,52,32,112,114,111,99,50,52,53,32,46,32,109,111,100,101,50,52,54,41};
static C_char C_TLS li54[] C_aligned={C_lihdr(0,0,20),40,97,50,53,55,52,32,46,32,114,101,115,117,108,116,115,50,53,53,41,0,0,0,0};
static C_char C_TLS li55[] C_aligned={C_lihdr(0,0,48),40,119,105,116,104,45,105,110,112,117,116,45,102,114,111,109,45,112,105,112,101,32,99,109,100,50,53,48,32,116,104,117,110,107,50,53,49,32,46,32,109,111,100,101,50,53,50,41};
static C_char C_TLS li56[] C_aligned={C_lihdr(0,0,20),40,97,50,53,57,52,32,46,32,114,101,115,117,108,116,115,50,54,52,41,0,0,0,0};
static C_char C_TLS li57[] C_aligned={C_lihdr(0,0,47),40,119,105,116,104,45,111,117,116,112,117,116,45,116,111,45,112,105,112,101,32,99,109,100,50,53,57,32,116,104,117,110,107,50,54,48,32,46,32,109,111,100,101,50,54,49,41,0,0,0,0,0,0,0};
static C_char C_TLS li58[] C_aligned={C_lihdr(0,0,23),40,99,114,101,97,116,101,45,112,105,112,101,32,46,32,103,50,55,49,50,55,50,41,0,0,0,0,0,0,0};
static C_char C_TLS li59[] C_aligned={C_lihdr(0,0,23),40,115,105,103,110,97,108,45,104,97,110,100,108,101,114,32,115,105,103,50,56,48,41,0,0,0,0,0,0,0};
static C_char C_TLS li60[] C_aligned={C_lihdr(0,0,36),40,115,101,116,45,115,105,103,110,97,108,45,104,97,110,100,108,101,114,33,32,115,105,103,50,56,50,32,112,114,111,99,50,56,51,41,0,0,0,0};
static C_char C_TLS li61[] C_aligned={C_lihdr(0,0,41),40,35,35,115,121,115,35,105,110,116,101,114,114,117,112,116,45,104,111,111,107,32,114,101,97,115,111,110,50,56,54,32,115,116,97,116,101,50,56,55,41,0};
static C_char C_TLS li62[] C_aligned={C_lihdr(0,0,32),40,99,104,97,110,103,101,45,102,105,108,101,45,109,111,100,101,32,102,110,97,109,101,50,57,50,32,109,50,57,51,41};
static C_char C_TLS li63[] C_aligned={C_lihdr(0,0,33),40,99,104,101,99,107,32,102,105,108,101,110,97,109,101,50,57,56,32,97,99,99,50,57,57,32,108,111,99,51,48,48,41,0};
static C_char C_TLS li64[] C_aligned={C_lihdr(0,0,31),40,102,105,108,101,45,114,101,97,100,45,97,99,99,101,115,115,63,32,102,105,108,101,110,97,109,101,51,48,52,41,0,0,0,0,0,0,0};
static C_char C_TLS li65[] C_aligned={C_lihdr(0,0,32),40,102,105,108,101,45,119,114,105,116,101,45,97,99,99,101,115,115,63,32,102,105,108,101,110,97,109,101,51,48,53,41};
static C_char C_TLS li66[] C_aligned={C_lihdr(0,0,34),40,102,105,108,101,45,101,120,101,99,117,116,101,45,97,99,99,101,115,115,63,32,102,105,108,101,110,97,109,101,51,48,54,41,0,0};
static C_char C_TLS li67[] C_aligned={C_lihdr(0,0,18),40,109,111,100,101,32,105,110,112,51,49,50,32,109,51,49,51,41,0,0};
static C_char C_TLS li68[] C_aligned={C_lihdr(0,0,25),40,99,104,101,99,107,32,102,100,51,49,55,32,105,110,112,51,49,56,32,114,51,49,57,41,0};
static C_char C_TLS li69[] C_aligned={C_lihdr(0,0,31),40,111,112,101,110,45,105,110,112,117,116,45,102,105,108,101,42,32,102,100,51,50,51,32,46,32,109,51,50,52,41,0,0,0,0,0,0,0};
static C_char C_TLS li70[] C_aligned={C_lihdr(0,0,32),40,111,112,101,110,45,111,117,116,112,117,116,45,102,105,108,101,42,32,102,100,51,50,54,32,46,32,109,51,50,55,41};
static C_char C_TLS li71[] C_aligned={C_lihdr(0,0,22),40,112,111,114,116,45,62,102,105,108,101,110,111,32,112,111,114,116,51,51,50,41,0,0,0,0,0,0};
static C_char C_TLS li72[] C_aligned={C_lihdr(0,0,34),40,100,117,112,108,105,99,97,116,101,45,102,105,108,101,110,111,32,111,108,100,51,51,55,32,46,32,110,101,119,51,51,56,41,0,0};
static C_char C_TLS li73[] C_aligned={C_lihdr(0,0,22),40,115,101,116,101,110,118,32,118,97,114,51,52,53,32,118,97,108,51,52,54,41,0,0,0,0,0,0};
static C_char C_TLS li74[] C_aligned={C_lihdr(0,0,17),40,117,110,115,101,116,101,110,118,32,118,97,114,51,53,48,41,0};
static C_char C_TLS li75[] C_aligned={C_lihdr(0,0,11),40,115,99,97,110,32,106,51,54,52,41,0,0,0};
static C_char C_TLS li76[] C_aligned={C_lihdr(0,0,11),40,108,111,111,112,32,105,51,54,49,41,0,0,0};
static C_char C_TLS li77[] C_aligned={C_lihdr(0,0,21),40,99,117,114,114,101,110,116,45,101,110,118,105,114,111,110,109,101,110,116,41,0,0,0,0,0};
static C_char C_TLS li78[] C_aligned={C_lihdr(0,0,29),40,115,101,99,111,110,100,115,45,62,108,111,99,97,108,45,116,105,109,101,32,115,101,99,115,51,54,55,41,0,0,0,0,0};
static C_char C_TLS li79[] C_aligned={C_lihdr(0,0,27),40,115,101,99,111,110,100,115,45,62,117,116,99,45,116,105,109,101,32,115,101,99,115,51,54,57,41,0,0,0};
static C_char C_TLS li80[] C_aligned={C_lihdr(0,0,25),40,115,101,99,111,110,100,115,45,62,115,116,114,105,110,103,32,115,101,99,115,51,55,55,41,0};
static C_char C_TLS li81[] C_aligned={C_lihdr(0,0,30),40,116,105,109,101,45,62,115,116,114,105,110,103,32,116,109,51,57,52,32,46,32,103,51,57,51,51,57,53,41,0,0,0,0,0,0};
static C_char C_TLS li82[] C_aligned={C_lihdr(0,0,27),40,108,111,99,97,108,45,116,105,109,101,45,62,115,101,99,111,110,100,115,32,116,109,52,48,53,41,0,0,0};
static C_char C_TLS li83[] C_aligned={C_lihdr(0,0,29),40,108,111,99,97,108,45,116,105,109,101,122,111,110,101,45,97,98,98,114,101,118,105,97,116,105,111,110,41,0,0,0,0,0};
static C_char C_TLS li84[] C_aligned={C_lihdr(0,0,17),40,95,101,120,105,116,32,46,32,99,111,100,101,52,49,54,41,0};
static C_char C_TLS li85[] C_aligned={C_lihdr(0,0,47),40,115,101,116,45,98,117,102,102,101,114,105,110,103,45,109,111,100,101,33,32,112,111,114,116,52,49,55,32,109,111,100,101,52,49,56,32,46,32,115,105,122,101,52,49,57,41,0,0,0,0,0,0,0};
static C_char C_TLS li86[] C_aligned={C_lihdr(0,0,7),40,97,51,51,54,48,41,0,0,0,0,0,0,0};
static C_char C_TLS li87[] C_aligned={C_lihdr(0,0,13),40,108,111,111,112,32,102,110,115,52,53,50,41,0,0,0,0,0};
static C_char C_TLS li88[] C_aligned={C_lihdr(0,0,37),40,97,51,51,54,54,32,100,105,114,52,51,55,52,52,48,32,102,105,108,52,51,56,52,52,49,32,101,120,116,52,51,57,52,52,50,41,0,0,0,0,0};
static C_char C_TLS li89[] C_aligned={C_lihdr(0,0,20),40,99,111,110,99,45,108,111,111,112,32,112,97,116,104,115,52,51,53,41,0,0,0,0};
static C_char C_TLS li90[] C_aligned={C_lihdr(0,0,17),40,103,108,111,98,32,46,32,112,97,116,104,115,52,51,51,41,0};
static C_char C_TLS li91[] C_aligned={C_lihdr(0,0,11),40,108,111,111,112,32,105,52,55,48,41,0,0,0};
static C_char C_TLS li92[] C_aligned={C_lihdr(0,0,21),40,110,101,101,100,115,45,113,117,111,116,105,110,103,63,32,115,52,54,55,41,0,0,0,0,0};
static C_char C_TLS li93[] C_aligned={C_lihdr(0,0,22),40,108,111,111,112,32,105,108,115,116,52,55,51,32,111,108,115,116,52,55,52,41,0,0,0,0,0,0};
static C_char C_TLS li94[] C_aligned={C_lihdr(0,0,35),40,36,113,117,111,116,101,45,97,114,103,115,45,108,105,115,116,32,108,115,116,52,54,52,32,101,120,97,99,116,102,52,54,53,41,0,0,0};
static C_char C_TLS li95[] C_aligned={C_lihdr(0,0,32),40,115,101,116,97,114,103,32,97,52,56,51,52,56,55,32,97,52,56,50,52,56,56,32,97,52,56,49,52,56,57,41};
static C_char C_TLS li96[] C_aligned={C_lihdr(0,0,32),40,115,101,116,101,110,118,32,97,52,57,51,52,57,55,32,97,52,57,50,52,57,56,32,97,52,57,49,52,57,57,41};
static C_char C_TLS li97[] C_aligned={C_lihdr(0,0,17),40,100,111,53,48,53,32,108,53,48,55,32,105,53,48,56,41,0};
static C_char C_TLS li98[] C_aligned={C_lihdr(0,0,57),40,98,117,105,108,100,45,101,120,101,99,45,97,114,103,118,101,99,32,108,111,99,53,48,49,32,108,115,116,53,48,50,32,97,114,103,118,101,99,45,115,101,116,116,101,114,53,48,51,32,105,100,120,53,48,52,41,0};
static C_char C_TLS li99[] C_aligned={C_lihdr(0,0,62),40,36,101,120,101,99,45,115,101,116,117,112,32,108,111,99,53,49,52,32,102,105,108,101,110,97,109,101,53,49,53,32,97,114,103,108,115,116,53,49,54,32,101,110,118,108,115,116,53,49,55,32,101,120,97,99,116,102,53,49,56,41,0,0,0,0,0,0};
static C_char C_TLS li100[] C_aligned={C_lihdr(0,0,49),40,36,101,120,101,99,45,116,101,97,114,100,111,119,110,32,108,111,99,53,50,53,32,109,115,103,53,50,54,32,102,105,108,101,110,97,109,101,53,50,55,32,114,101,115,53,50,56,41,0};
static C_char C_TLS li101[] C_aligned={C_lihdr(0,0,39),40,98,111,100,121,53,51,56,32,97,114,103,108,115,116,53,52,53,32,101,110,118,108,115,116,53,52,54,32,101,120,97,99,116,102,53,52,55,41,0,0,0,0,0,0,0};
static C_char C_TLS li102[] C_aligned={C_lihdr(0,0,43),40,100,101,102,45,101,120,97,99,116,102,53,52,50,32,37,97,114,103,108,115,116,53,51,53,53,53,48,32,37,101,110,118,108,115,116,53,51,54,53,53,49,41,0,0,0};
static C_char C_TLS li103[] C_aligned={C_lihdr(0,0,29),40,100,101,102,45,101,110,118,108,115,116,53,52,49,32,37,97,114,103,108,115,116,53,51,53,53,53,51,41,0,0,0,0,0};
static C_char C_TLS li104[] C_aligned={C_lihdr(0,0,15),40,100,101,102,45,97,114,103,108,115,116,53,52,48,41,0,0,0,0,0,0,0};
static C_char C_TLS li105[] C_aligned={C_lihdr(0,0,39),40,112,114,111,99,101,115,115,45,101,120,101,99,117,116,101,32,102,105,108,101,110,97,109,101,53,51,51,32,46,32,103,53,51,50,53,51,52,41,0,0,0,0,0,0,0};
static C_char C_TLS li106[] C_aligned={C_lihdr(0,0,39),40,98,111,100,121,53,54,56,32,97,114,103,108,115,116,53,55,53,32,101,110,118,108,115,116,53,55,54,32,101,120,97,99,116,102,53,55,55,41,0,0,0,0,0,0,0};
static C_char C_TLS li107[] C_aligned={C_lihdr(0,0,43),40,100,101,102,45,101,120,97,99,116,102,53,55,50,32,37,97,114,103,108,115,116,53,54,53,53,56,48,32,37,101,110,118,108,115,116,53,54,54,53,56,49,41,0,0,0};
static C_char C_TLS li108[] C_aligned={C_lihdr(0,0,29),40,100,101,102,45,101,110,118,108,115,116,53,55,49,32,37,97,114,103,108,115,116,53,54,53,53,56,51,41,0,0,0,0,0};
static C_char C_TLS li109[] C_aligned={C_lihdr(0,0,15),40,100,101,102,45,97,114,103,108,115,116,53,55,48,41,0,0,0,0,0,0,0};
static C_char C_TLS li110[] C_aligned={C_lihdr(0,0,45),40,112,114,111,99,101,115,115,45,115,112,97,119,110,32,109,111,100,101,53,54,50,32,102,105,108,101,110,97,109,101,53,54,51,32,46,32,103,53,54,49,53,54,52,41,0,0,0,0,0};
static C_char C_TLS li111[] C_aligned={C_lihdr(0,0,20),40,99,117,114,114,101,110,116,45,112,114,111,99,101,115,115,45,105,100,41,0,0,0,0};
static C_char C_TLS li112[] C_aligned={C_lihdr(0,0,21),40,35,35,115,121,115,35,115,104,101,108,108,45,99,111,109,109,97,110,100,41,0,0,0,0,0};
static C_char C_TLS li113[] C_aligned={C_lihdr(0,0,41),40,35,35,115,121,115,35,115,104,101,108,108,45,99,111,109,109,97,110,100,45,97,114,103,117,109,101,110,116,115,32,99,109,100,108,105,110,53,57,54,41,0};
static C_char C_TLS li114[] C_aligned={C_lihdr(0,0,28),40,112,114,111,99,101,115,115,45,114,117,110,32,102,53,57,57,32,46,32,97,114,103,115,54,48,48,41,0,0,0,0};
static C_char C_TLS li115[] C_aligned={C_lihdr(0,0,22),40,99,108,111,115,101,45,104,97,110,100,108,101,32,97,54,48,50,54,48,53,41,0,0,0,0,0,0};
static C_char C_TLS li116[] C_aligned={C_lihdr(0,0,86),40,35,35,115,121,115,35,112,114,111,99,101,115,115,32,108,111,99,54,52,48,32,99,109,100,54,52,49,32,97,114,103,115,54,52,50,32,101,110,118,54,52,51,32,115,116,100,111,117,116,102,54,52,52,32,115,116,100,105,110,102,54,52,53,32,115,116,100,101,114,114,102,54,52,54,32,46,32,103,54,51,57,54,52,55,41,0,0,0,0,0,0};
static C_char C_TLS li117[] C_aligned={C_lihdr(0,0,15),40,97,52,48,57,52,32,103,54,56,55,54,56,56,41,0,0,0,0,0,0,0};
static C_char C_TLS li118[] C_aligned={C_lihdr(0,0,18),40,99,104,107,115,116,114,108,115,116,32,108,115,116,54,56,54,41,0,0};
static C_char C_TLS li119[] C_aligned={C_lihdr(0,0,7),40,97,52,49,49,50,41,0,0,0,0,0,0,0};
static C_char C_TLS li120[] C_aligned={C_lihdr(0,0,34),40,97,52,49,49,56,32,105,110,54,57,50,32,111,117,116,54,57,51,32,112,105,100,54,57,52,32,101,114,114,54,57,53,41,0,0};
static C_char C_TLS li121[] C_aligned={C_lihdr(0,0,57),40,37,112,114,111,99,101,115,115,32,108,111,99,54,55,57,32,101,114,114,63,54,56,48,32,99,109,100,54,56,49,32,97,114,103,115,54,56,50,32,101,110,118,54,56,51,32,101,120,97,99,116,102,54,56,52,41,0};
static C_char C_TLS li122[] C_aligned={C_lihdr(0,0,34),40,98,111,100,121,55,48,53,32,97,114,103,115,55,49,50,32,101,110,118,55,49,51,32,101,120,97,99,116,102,55,49,52,41,0,0};
static C_char C_TLS li123[] C_aligned={C_lihdr(0,0,38),40,100,101,102,45,101,120,97,99,116,102,55,48,57,32,37,97,114,103,115,55,48,50,55,49,54,32,37,101,110,118,55,48,51,55,49,55,41,0,0,0,0,0,0};
static C_char C_TLS li124[] C_aligned={C_lihdr(0,0,24),40,100,101,102,45,101,110,118,55,48,56,32,37,97,114,103,115,55,48,50,55,49,57,41};
static C_char C_TLS li125[] C_aligned={C_lihdr(0,0,13),40,100,101,102,45,97,114,103,115,55,48,55,41,0,0,0,0,0};
static C_char C_TLS li126[] C_aligned={C_lihdr(0,0,26),40,112,114,111,99,101,115,115,32,99,109,100,55,48,48,32,46,32,103,54,57,57,55,48,49,41,0,0};
static C_char C_TLS li127[] C_aligned={C_lihdr(0,0,34),40,98,111,100,121,55,51,51,32,97,114,103,115,55,52,48,32,101,110,118,55,52,49,32,101,120,97,99,116,102,55,52,50,41,0,0};
static C_char C_TLS li128[] C_aligned={C_lihdr(0,0,38),40,100,101,102,45,101,120,97,99,116,102,55,51,55,32,37,97,114,103,115,55,51,48,55,52,52,32,37,101,110,118,55,51,49,55,52,53,41,0,0,0,0,0,0};
static C_char C_TLS li129[] C_aligned={C_lihdr(0,0,24),40,100,101,102,45,101,110,118,55,51,54,32,37,97,114,103,115,55,51,48,55,52,55,41};
static C_char C_TLS li130[] C_aligned={C_lihdr(0,0,13),40,100,101,102,45,97,114,103,115,55,51,53,41,0,0,0,0,0};
static C_char C_TLS li131[] C_aligned={C_lihdr(0,0,27),40,112,114,111,99,101,115,115,42,32,99,109,100,55,50,56,32,46,32,103,55,50,55,55,50,57,41,0,0,0};
static C_char C_TLS li132[] C_aligned={C_lihdr(0,0,37),40,35,35,115,121,115,35,112,114,111,99,101,115,115,45,119,97,105,116,32,112,105,100,55,53,54,32,110,111,104,97,110,103,55,53,55,41,0,0,0,0,0};
static C_char C_TLS li133[] C_aligned={C_lihdr(0,0,7),40,97,52,51,51,56,41,0,0,0,0,0,0,0};
static C_char C_TLS li134[] C_aligned={C_lihdr(0,0,33),40,97,52,51,52,52,32,101,112,105,100,55,54,53,32,101,110,111,114,109,55,54,54,32,101,99,111,100,101,55,54,55,41,0};
static C_char C_TLS li135[] C_aligned={C_lihdr(0,0,31),40,112,114,111,99,101,115,115,45,119,97,105,116,32,112,105,100,55,53,56,32,46,32,97,114,103,115,55,53,57,41,0,0,0,0,0,0,0};
static C_char C_TLS li136[] C_aligned={C_lihdr(0,0,12),40,115,108,101,101,112,32,116,55,55,48,41,0,0,0,0};
static C_char C_TLS li137[] C_aligned={C_lihdr(0,0,15),40,103,101,116,45,104,111,115,116,45,110,97,109,101,41,0,0,0,0,0,0,0};
static C_char C_TLS li138[] C_aligned={C_lihdr(0,0,20),40,115,121,115,116,101,109,45,105,110,102,111,114,109,97,116,105,111,110,41,0,0,0,0};
static C_char C_TLS li139[] C_aligned={C_lihdr(0,0,19),40,99,117,114,114,101,110,116,45,117,115,101,114,45,110,97,109,101,41,0,0,0};
static C_char C_TLS li140[] C_aligned={C_lihdr(0,0,13),40,102,95,52,53,54,53,32,120,55,57,57,41,0,0,0,0,0};
static C_char C_TLS li141[] C_aligned={C_lihdr(0,0,7),40,97,52,53,48,53,41,0,0,0,0,0,0,0};
static C_char C_TLS li142[] C_aligned={C_lihdr(0,0,7),40,97,52,53,49,51,41,0,0,0,0,0,0,0};
static C_char C_TLS li143[] C_aligned={C_lihdr(0,0,7),40,97,52,53,50,55,41,0,0,0,0,0,0,0};
static C_char C_TLS li144[] C_aligned={C_lihdr(0,0,17),40,108,111,111,112,32,102,115,56,48,49,32,114,56,48,50,41,0};
static C_char C_TLS li145[] C_aligned={C_lihdr(0,0,15),40,102,95,52,53,56,49,32,46,32,95,55,57,55,41,0,0,0,0,0,0,0};
static C_char C_TLS li146[] C_aligned={C_lihdr(0,0,15),40,102,95,52,53,55,51,32,46,32,95,55,57,54,41,0,0,0,0,0,0,0};
static C_char C_TLS li147[] C_aligned={C_lihdr(0,0,34),40,98,111,100,121,55,56,52,32,97,99,116,105,111,110,55,57,49,32,105,100,55,57,50,32,108,105,109,105,116,55,57,51,41,0,0};
static C_char C_TLS li148[] C_aligned={C_lihdr(0,0,38),40,100,101,102,45,108,105,109,105,116,55,56,56,32,37,97,99,116,105,111,110,55,56,49,56,49,54,32,37,105,100,55,56,50,56,49,55,41,0,0,0,0,0,0};
static C_char C_TLS li149[] C_aligned={C_lihdr(0,0,25),40,100,101,102,45,105,100,55,56,55,32,37,97,99,116,105,111,110,55,56,49,56,49,57,41,0};
static C_char C_TLS li150[] C_aligned={C_lihdr(0,0,17),40,97,52,54,48,49,32,120,56,50,49,32,121,56,50,50,41,0};
static C_char C_TLS li151[] C_aligned={C_lihdr(0,0,15),40,100,101,102,45,97,99,116,105,111,110,55,56,54,41,0,0,0,0,0,0,0};
static C_char C_TLS li152[] C_aligned={C_lihdr(0,0,48),40,102,105,110,100,45,102,105,108,101,115,32,100,105,114,55,55,56,32,112,114,101,100,55,55,57,32,46,32,97,99,116,105,111,110,45,105,100,45,108,105,109,105,116,55,56,48,41};
static C_char C_TLS li153[] C_aligned={C_lihdr(0,0,26),40,99,104,97,110,103,101,45,102,105,108,101,45,111,119,110,101,114,32,46,32,95,56,50,57,41,0,0};
static C_char C_TLS li154[] C_aligned={C_lihdr(0,0,20),40,99,114,101,97,116,101,45,102,105,102,111,32,46,32,95,56,51,49,41,0,0,0,0};
static C_char C_TLS li155[] C_aligned={C_lihdr(0,0,23),40,99,114,101,97,116,101,45,115,101,115,115,105,111,110,32,46,32,95,56,51,50,41,0,0,0,0,0,0,0};
static C_char C_TLS li156[] C_aligned={C_lihdr(0,0,29),40,99,114,101,97,116,101,45,115,121,109,98,111,108,105,99,45,108,105,110,107,32,46,32,95,56,51,51,41,0,0,0,0,0};
static C_char C_TLS li157[] C_aligned={C_lihdr(0,0,35),40,99,117,114,114,101,110,116,45,101,102,102,101,99,116,105,118,101,45,103,114,111,117,112,45,105,100,32,46,32,95,56,51,52,41,0,0,0};
static C_char C_TLS li158[] C_aligned={C_lihdr(0,0,34),40,99,117,114,114,101,110,116,45,101,102,102,101,99,116,105,118,101,45,117,115,101,114,45,105,100,32,46,32,95,56,51,53,41,0,0};
static C_char C_TLS li159[] C_aligned={C_lihdr(0,0,36),40,99,117,114,114,101,110,116,45,101,102,102,101,99,116,105,118,101,45,117,115,101,114,45,110,97,109,101,32,46,32,95,56,51,54,41,0,0,0,0};
static C_char C_TLS li160[] C_aligned={C_lihdr(0,0,25),40,99,117,114,114,101,110,116,45,103,114,111,117,112,45,105,100,32,46,32,95,56,51,55,41,0};
static C_char C_TLS li161[] C_aligned={C_lihdr(0,0,24),40,99,117,114,114,101,110,116,45,117,115,101,114,45,105,100,32,46,32,95,56,51,56,41};
static C_char C_TLS li162[] C_aligned={C_lihdr(0,0,27),40,109,97,112,45,102,105,108,101,45,116,111,45,109,101,109,111,114,121,32,46,32,95,56,51,57,41,0,0,0};
static C_char C_TLS li163[] C_aligned={C_lihdr(0,0,18),40,102,105,108,101,45,108,105,110,107,32,46,32,95,56,52,48,41,0,0};
static C_char C_TLS li164[] C_aligned={C_lihdr(0,0,18),40,102,105,108,101,45,108,111,99,107,32,46,32,95,56,52,49,41,0,0};
static C_char C_TLS li165[] C_aligned={C_lihdr(0,0,27),40,102,105,108,101,45,108,111,99,107,47,98,108,111,99,107,105,110,103,32,46,32,95,56,52,50,41,0,0,0};
static C_char C_TLS li166[] C_aligned={C_lihdr(0,0,20),40,102,105,108,101,45,115,101,108,101,99,116,32,46,32,95,56,52,51,41,0,0,0,0};
static C_char C_TLS li167[] C_aligned={C_lihdr(0,0,23),40,102,105,108,101,45,116,101,115,116,45,108,111,99,107,32,46,32,95,56,52,52,41,0,0,0,0,0,0,0};
static C_char C_TLS li168[] C_aligned={C_lihdr(0,0,22),40,102,105,108,101,45,116,114,117,110,99,97,116,101,32,46,32,95,56,52,53,41,0,0,0,0,0,0};
static C_char C_TLS li169[] C_aligned={C_lihdr(0,0,20),40,102,105,108,101,45,117,110,108,111,99,107,32,46,32,95,56,52,54,41,0,0,0,0};
static C_char C_TLS li170[] C_aligned={C_lihdr(0,0,19),40,103,101,116,45,103,114,111,117,112,115,32,46,32,95,56,52,55,41,0,0,0};
static C_char C_TLS li171[] C_aligned={C_lihdr(0,0,26),40,103,114,111,117,112,45,105,110,102,111,114,109,97,116,105,111,110,32,46,32,95,56,52,56,41,0,0};
static C_char C_TLS li172[] C_aligned={C_lihdr(0,0,26),40,105,110,105,116,105,97,108,105,122,101,45,103,114,111,117,112,115,32,46,32,95,56,52,57,41,0,0};
static C_char C_TLS li173[] C_aligned={C_lihdr(0,0,35),40,109,101,109,111,114,121,45,109,97,112,112,101,100,45,102,105,108,101,45,112,111,105,110,116,101,114,32,46,32,95,56,53,48,41,0,0,0};
static C_char C_TLS li174[] C_aligned={C_lihdr(0,0,26),40,112,97,114,101,110,116,45,112,114,111,99,101,115,115,45,105,100,32,46,32,95,56,53,49,41,0,0};
static C_char C_TLS li175[] C_aligned={C_lihdr(0,0,21),40,112,114,111,99,101,115,115,45,102,111,114,107,32,46,32,95,56,53,50,41,0,0,0,0,0};
static C_char C_TLS li176[] C_aligned={C_lihdr(0,0,25),40,112,114,111,99,101,115,115,45,103,114,111,117,112,45,105,100,32,46,32,95,56,53,51,41,0};
static C_char C_TLS li177[] C_aligned={C_lihdr(0,0,23),40,112,114,111,99,101,115,115,45,115,105,103,110,97,108,32,46,32,95,56,53,52,41,0,0,0,0,0,0,0};
static C_char C_TLS li178[] C_aligned={C_lihdr(0,0,27),40,114,101,97,100,45,115,121,109,98,111,108,105,99,45,108,105,110,107,32,46,32,95,56,53,53,41,0,0,0};
static C_char C_TLS li179[] C_aligned={C_lihdr(0,0,19),40,115,101,116,45,97,108,97,114,109,33,32,46,32,95,56,53,54,41,0,0,0};
static C_char C_TLS li180[] C_aligned={C_lihdr(0,0,22),40,115,101,116,45,103,114,111,117,112,45,105,100,33,32,46,32,95,56,53,55,41,0,0,0,0,0,0};
static C_char C_TLS li181[] C_aligned={C_lihdr(0,0,20),40,115,101,116,45,103,114,111,117,112,115,33,32,46,32,95,56,53,56,41,0,0,0,0};
static C_char C_TLS li182[] C_aligned={C_lihdr(0,0,30),40,115,101,116,45,112,114,111,99,101,115,115,45,103,114,111,117,112,45,105,100,33,32,46,32,95,56,53,57,41,0,0,0,0,0,0};
static C_char C_TLS li183[] C_aligned={C_lihdr(0,0,28),40,115,101,116,45,114,111,111,116,45,100,105,114,101,99,116,111,114,121,33,32,46,32,95,56,54,48,41,0,0,0,0};
static C_char C_TLS li184[] C_aligned={C_lihdr(0,0,25),40,115,101,116,45,115,105,103,110,97,108,45,109,97,115,107,33,32,46,32,95,56,54,49,41,0};
static C_char C_TLS li185[] C_aligned={C_lihdr(0,0,21),40,115,101,116,45,117,115,101,114,45,105,100,33,32,46,32,95,56,54,50,41,0,0,0,0,0};
static C_char C_TLS li186[] C_aligned={C_lihdr(0,0,20),40,115,105,103,110,97,108,45,109,97,115,107,32,46,32,95,56,54,51,41,0,0,0,0};
static C_char C_TLS li187[] C_aligned={C_lihdr(0,0,21),40,115,105,103,110,97,108,45,109,97,115,107,33,32,46,32,95,56,54,52,41,0,0,0,0,0};
static C_char C_TLS li188[] C_aligned={C_lihdr(0,0,23),40,115,105,103,110,97,108,45,109,97,115,107,101,100,63,32,46,32,95,56,54,53,41,0,0,0,0,0,0,0};
static C_char C_TLS li189[] C_aligned={C_lihdr(0,0,23),40,115,105,103,110,97,108,45,117,110,109,97,115,107,33,32,46,32,95,56,54,54,41,0,0,0,0,0,0,0};
static C_char C_TLS li190[] C_aligned={C_lihdr(0,0,22),40,116,101,114,109,105,110,97,108,45,110,97,109,101,32,46,32,95,56,54,55,41,0,0,0,0,0,0};
static C_char C_TLS li191[] C_aligned={C_lihdr(0,0,23),40,116,101,114,109,105,110,97,108,45,112,111,114,116,63,32,46,32,95,56,54,56,41,0,0,0,0,0,0,0};
static C_char C_TLS li192[] C_aligned={C_lihdr(0,0,22),40,116,101,114,109,105,110,97,108,45,115,105,122,101,32,46,32,95,56,54,57,41,0,0,0,0,0,0};
static C_char C_TLS li193[] C_aligned={C_lihdr(0,0,31),40,117,110,109,97,112,45,102,105,108,101,45,102,114,111,109,45,109,101,109,111,114,121,32,46,32,95,56,55,48,41,0,0,0,0,0,0,0};
static C_char C_TLS li194[] C_aligned={C_lihdr(0,0,25),40,117,115,101,114,45,105,110,102,111,114,109,97,116,105,111,110,32,46,32,95,56,55,49,41,0};
static C_char C_TLS li195[] C_aligned={C_lihdr(0,0,26),40,117,116,99,45,116,105,109,101,45,62,115,101,99,111,110,100,115,32,46,32,95,56,55,50,41,0,0};
static C_char C_TLS li196[] C_aligned={C_lihdr(0,0,21),40,115,116,114,105,110,103,45,62,116,105,109,101,32,46,32,95,56,55,51,41,0,0,0,0,0};
static C_char C_TLS li197[] C_aligned={C_lihdr(0,0,12),40,102,105,102,111,63,32,95,56,55,52,41,0,0,0,0};
static C_char C_TLS li198[] C_aligned={C_lihdr(0,0,26),40,109,101,109,111,114,121,45,109,97,112,112,101,100,45,102,105,108,101,63,32,95,56,55,53,41,0,0};
static C_char C_TLS li199[] C_aligned={C_lihdr(0,0,10),40,116,111,112,108,101,118,101,108,41,0,0};


/* from k3933 */
static C_word C_fcall stub615(C_word C_buf,C_word C_a0,C_word C_a1,C_word C_a2,C_word C_a3,C_word C_a4,C_word C_a5,C_word C_a6,C_word C_a7) C_regparm;
C_regparm static C_word C_fcall stub615(C_word C_buf,C_word C_a0,C_word C_a1,C_word C_a2,C_word C_a3,C_word C_a4,C_word C_a5,C_word C_a6,C_word C_a7){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
char * t0=(char * )C_string_or_null(C_a0);
char * t1=(char * )C_string_or_null(C_a1);
void * t2=(void * )C_c_pointer_or_null(C_a2);
int *t3=(int *)C_c_pointer_or_null(C_a3);
int *t4=(int *)C_c_pointer_or_null(C_a4);
int *t5=(int *)C_c_pointer_or_null(C_a5);
int *t6=(int *)C_c_pointer_or_null(C_a6);
int t7=(int )C_unfix(C_a7);
C_r=C_mk_bool(C_process(t0,t1,t2,t3,t4,t5,t6,t7));
return C_r;}

/* from close-handle in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static C_word C_fcall stub603(C_word C_buf,C_word C_a0) C_regparm;
C_regparm static C_word C_fcall stub603(C_word C_buf,C_word C_a0){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
int t0=(int )C_truep(C_a0);
C_r=C_fix((C_word)close_handle(t0));
return C_r;}

/* from current-process-id in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static C_word C_fcall stub591(C_word C_buf) C_regparm;
C_regparm static C_word C_fcall stub591(C_word C_buf){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
C_r=C_fix((C_word)C_getpid());
return C_r;}

/* from k3562 */
static C_word C_fcall stub494(C_word C_buf,C_word C_a0,C_word C_a1,C_word C_a2) C_regparm;
C_regparm static C_word C_fcall stub494(C_word C_buf,C_word C_a0,C_word C_a1,C_word C_a2){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
int t0=(int )C_unfix(C_a0);
void * t1=(void * )C_data_pointer_or_null(C_a1);
int t2=(int )C_unfix(C_a2);
C_set_exec_env(t0,t1,t2);
return C_r;}

/* from k3545 */
static C_word C_fcall stub484(C_word C_buf,C_word C_a0,C_word C_a1,C_word C_a2) C_regparm;
C_regparm static C_word C_fcall stub484(C_word C_buf,C_word C_a0,C_word C_a1,C_word C_a2){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
int t0=(int )C_unfix(C_a0);
void * t1=(void * )C_data_pointer_or_null(C_a1);
int t2=(int )C_unfix(C_a2);
C_set_exec_arg(t0,t1,t2);
return C_r;}

/* from k3262 */
static C_word C_fcall stub413(C_word C_buf,C_word C_a0) C_regparm;
C_regparm static C_word C_fcall stub413(C_word C_buf,C_word C_a0){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
int t0=(int )C_unfix(C_a0);
_exit(t0);
return C_r;}

/* from local-timezone-abbreviation in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
#define return(x) C_cblock C_r = (C_mpointer(&C_a,(void*)(x))); goto C_ret; C_cblockend
static C_word C_fcall stub408(C_word C_buf) C_regparm;
C_regparm static C_word C_fcall stub408(C_word C_buf){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
char *z = (daylight ? _tzname[1] : _tzname[0]);return(z);
C_ret:
#undef return

return C_r;}

/* from strftime */
static C_word C_fcall stub388(C_word C_buf,C_word C_a0,C_word C_a1) C_regparm;
C_regparm static C_word C_fcall stub388(C_word C_buf,C_word C_a0,C_word C_a1){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
C_word t0=(C_word )(C_a0);
C_word t1=(C_word )(C_a1);
C_r=C_mpointer(&C_a,(void*)C_strftime(t0,t1));
return C_r;}

/* from asctime */
static C_word C_fcall stub382(C_word C_buf,C_word C_a0) C_regparm;
C_regparm static C_word C_fcall stub382(C_word C_buf,C_word C_a0){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
C_word t0=(C_word )(C_a0);
C_r=C_mpointer(&C_a,(void*)C_asctime(t0));
return C_r;}

/* from k3109 */
static C_word C_fcall stub373(C_word C_buf,C_word C_a0) C_regparm;
C_regparm static C_word C_fcall stub373(C_word C_buf,C_word C_a0){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
int t0=(int )C_num_to_int(C_a0);
C_r=C_mpointer(&C_a,(void*)C_ctime(t0));
return C_r;}

/* from k3016 */
static C_word C_fcall stub356(C_word C_buf,C_word C_a0) C_regparm;
C_regparm static C_word C_fcall stub356(C_word C_buf,C_word C_a0){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
int t0=(int )C_unfix(C_a0);
C_r=C_mpointer(&C_a,(void*)C_getenventry(t0));
return C_r;}

/* from k1142 */
static C_word C_fcall stub3(C_word C_buf,C_word C_a0) C_regparm;
C_regparm static C_word C_fcall stub3(C_word C_buf,C_word C_a0){
C_word C_r=C_SCHEME_UNDEFINED,*C_a=(C_word*)C_buf;
int t0=(int )C_unfix(C_a0);
C_r=C_mpointer(&C_a,(void*)strerror(t0));
return C_r;}

C_noret_decl(C_posix_toplevel)
C_externexport void C_ccall C_posix_toplevel(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1121)
static void C_ccall f_1121(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1124)
static void C_ccall f_1124(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1127)
static void C_ccall f_1127(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1130)
static void C_ccall f_1130(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1133)
static void C_ccall f_1133(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1519)
static void C_ccall f_1519(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1523)
static void C_ccall f_1523(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1527)
static void C_ccall f_1527(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1531)
static void C_ccall f_1531(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1535)
static void C_ccall f_1535(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1539)
static void C_ccall f_1539(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2679)
static void C_ccall f_2679(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4933)
static void C_ccall f_4933(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_4930)
static void C_ccall f_4930(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_4923)
static void C_ccall f_4923(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4917)
static void C_ccall f_4917(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4911)
static void C_ccall f_4911(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4905)
static void C_ccall f_4905(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4899)
static void C_ccall f_4899(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4893)
static void C_ccall f_4893(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4887)
static void C_ccall f_4887(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4881)
static void C_ccall f_4881(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4875)
static void C_ccall f_4875(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4869)
static void C_ccall f_4869(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4863)
static void C_ccall f_4863(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4857)
static void C_ccall f_4857(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4851)
static void C_ccall f_4851(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4845)
static void C_ccall f_4845(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4839)
static void C_ccall f_4839(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4833)
static void C_ccall f_4833(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4827)
static void C_ccall f_4827(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4821)
static void C_ccall f_4821(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4815)
static void C_ccall f_4815(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4809)
static void C_ccall f_4809(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4803)
static void C_ccall f_4803(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4797)
static void C_ccall f_4797(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4791)
static void C_ccall f_4791(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4785)
static void C_ccall f_4785(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4779)
static void C_ccall f_4779(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4773)
static void C_ccall f_4773(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4767)
static void C_ccall f_4767(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4761)
static void C_ccall f_4761(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4755)
static void C_ccall f_4755(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4749)
static void C_ccall f_4749(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4743)
static void C_ccall f_4743(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4737)
static void C_ccall f_4737(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4731)
static void C_ccall f_4731(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4725)
static void C_ccall f_4725(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4719)
static void C_ccall f_4719(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4713)
static void C_ccall f_4713(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4707)
static void C_ccall f_4707(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4701)
static void C_ccall f_4701(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4695)
static void C_ccall f_4695(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4689)
static void C_ccall f_4689(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4683)
static void C_ccall f_4683(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4677)
static void C_ccall f_4677(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4671)
static void C_ccall f_4671(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4665)
static void C_ccall f_4665(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4439)
static void C_ccall f_4439(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...) C_noret;
C_noret_decl(f_4439)
static void C_ccall f_4439r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t5) C_noret;
C_noret_decl(f_4596)
static void C_fcall f_4596(C_word t0,C_word t1) C_noret;
C_noret_decl(f_4602)
static void C_ccall f_4602(C_word c,C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_4591)
static void C_fcall f_4591(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_4586)
static void C_fcall f_4586(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_4441)
static void C_fcall f_4441(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_4573)
static void C_ccall f_4573(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4581)
static void C_ccall f_4581(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_4448)
static void C_fcall f_4448(C_word t0,C_word t1) C_noret;
C_noret_decl(f_4561)
static void C_ccall f_4561(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4458)
static void C_ccall f_4458(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4460)
static void C_fcall f_4460(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_4479)
static void C_ccall f_4479(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4547)
static void C_ccall f_4547(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4554)
static void C_ccall f_4554(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4541)
static void C_ccall f_4541(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4494)
static void C_ccall f_4494(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4528)
static void C_ccall f_4528(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4514)
static void C_ccall f_4514(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4526)
static void C_ccall f_4526(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4522)
static void C_ccall f_4522(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4506)
static void C_ccall f_4506(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4504)
static void C_ccall f_4504(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4565)
static void C_ccall f_4565(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_4424)
static void C_ccall f_4424(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4434)
static void C_ccall f_4434(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4393)
static void C_ccall f_4393(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4419)
static void C_ccall f_4419(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4404)
static void C_ccall f_4404(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4408)
static void C_ccall f_4408(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4412)
static void C_ccall f_4412(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4416)
static void C_ccall f_4416(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4381)
static void C_ccall f_4381(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4378)
static void C_ccall f_4378(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_4318)
static void C_ccall f_4318(C_word c,C_word t0,C_word t1,C_word t2,...) C_noret;
C_noret_decl(f_4318)
static void C_ccall f_4318r(C_word t0,C_word t1,C_word t2,C_word t4) C_noret;
C_noret_decl(f_4345)
static void C_ccall f_4345(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_4355)
static void C_ccall f_4355(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4339)
static void C_ccall f_4339(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4306)
static void C_ccall f_4306(C_word c,C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_4226)
static void C_ccall f_4226(C_word c,C_word t0,C_word t1,C_word t2,...) C_noret;
C_noret_decl(f_4226)
static void C_ccall f_4226r(C_word t0,C_word t1,C_word t2,C_word t4) C_noret;
C_noret_decl(f_4243)
static void C_fcall f_4243(C_word t0,C_word t1) C_noret;
C_noret_decl(f_4238)
static void C_fcall f_4238(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_4233)
static void C_fcall f_4233(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_4228)
static void C_fcall f_4228(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_4146)
static void C_ccall f_4146(C_word c,C_word t0,C_word t1,C_word t2,...) C_noret;
C_noret_decl(f_4146)
static void C_ccall f_4146r(C_word t0,C_word t1,C_word t2,C_word t4) C_noret;
C_noret_decl(f_4163)
static void C_fcall f_4163(C_word t0,C_word t1) C_noret;
C_noret_decl(f_4158)
static void C_fcall f_4158(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_4153)
static void C_fcall f_4153(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_4148)
static void C_fcall f_4148(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_4084)
static void C_fcall f_4084(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5,C_word t6) C_noret;
C_noret_decl(f_4140)
static void C_ccall f_4140(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4144)
static void C_ccall f_4144(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4105)
static void C_ccall f_4105(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4108)
static void C_ccall f_4108(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4119)
static void C_ccall f_4119(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5) C_noret;
C_noret_decl(f_4113)
static void C_ccall f_4113(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4086)
static void C_fcall f_4086(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_4095)
static void C_ccall f_4095(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_3965)
static void C_ccall f_3965(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5,C_word t6,C_word t7,C_word t8,...) C_noret;
C_noret_decl(f_3965)
static void C_ccall f_3965r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5,C_word t6,C_word t7,C_word t8,C_word t10) C_noret;
C_noret_decl(f_3969)
static void C_ccall f_3969(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4060)
static void C_ccall f_4060(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3972)
static void C_ccall f_3972(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4028)
static void C_ccall f_4028(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4032)
static void C_ccall f_4032(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4036)
static void C_ccall f_4036(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4040)
static void C_ccall f_4040(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4044)
static void C_ccall f_4044(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3907)
static void C_ccall f_3907(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3911)
static void C_ccall f_3911(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4021)
static void C_ccall f_4021(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4001)
static void C_ccall f_4001(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4005)
static void C_ccall f_4005(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_4009)
static void C_ccall f_4009(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3899)
static void C_ccall f_3899(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_3870)
static void C_ccall f_3870(C_word c,C_word t0,C_word t1,C_word t2,...) C_noret;
C_noret_decl(f_3870)
static void C_ccall f_3870r(C_word t0,C_word t1,C_word t2,C_word t4) C_noret;
C_noret_decl(f_3887)
static void C_ccall f_3887(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3891)
static void C_ccall f_3891(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3864)
static void C_ccall f_3864(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_3843)
static void C_ccall f_3843(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3847)
static void C_ccall f_3847(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3859)
static void C_ccall f_3859(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3840)
static void C_ccall f_3840(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3753)
static void C_ccall f_3753(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...) C_noret;
C_noret_decl(f_3753)
static void C_ccall f_3753r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t5) C_noret;
C_noret_decl(f_3777)
static void C_fcall f_3777(C_word t0,C_word t1) C_noret;
C_noret_decl(f_3772)
static void C_fcall f_3772(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_3767)
static void C_fcall f_3767(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_3755)
static void C_fcall f_3755(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_3759)
static void C_ccall f_3759(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3666)
static void C_ccall f_3666(C_word c,C_word t0,C_word t1,C_word t2,...) C_noret;
C_noret_decl(f_3666)
static void C_ccall f_3666r(C_word t0,C_word t1,C_word t2,C_word t4) C_noret;
C_noret_decl(f_3690)
static void C_fcall f_3690(C_word t0,C_word t1) C_noret;
C_noret_decl(f_3685)
static void C_fcall f_3685(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_3680)
static void C_fcall f_3680(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_3668)
static void C_fcall f_3668(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_3672)
static void C_ccall f_3672(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3651)
static void C_fcall f_3651(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_3655)
static void C_ccall f_3655(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3618)
static void C_fcall f_3618(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5,C_word t6) C_noret;
C_noret_decl(f_3625)
static void C_ccall f_3625(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3628)
static void C_ccall f_3628(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3645)
static void C_ccall f_3645(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3631)
static void C_ccall f_3631(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3634)
static void C_ccall f_3634(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3641)
static void C_ccall f_3641(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3568)
static void C_fcall f_3568(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_3580)
static void C_fcall f_3580(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_3599)
static void C_ccall f_3599(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3551)
static void C_ccall f_3551(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_3534)
static void C_ccall f_3534(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_3455)
static void C_fcall f_3455(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_3498)
static void C_fcall f_3498(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_3529)
static void C_ccall f_3529(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3526)
static void C_ccall f_3526(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3460)
static void C_fcall f_3460(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_3464)
static void C_ccall f_3464(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3469)
static void C_fcall f_3469(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_3493)
static void C_ccall f_3493(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3482)
static void C_ccall f_3482(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3340)
static void C_ccall f_3340(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_3340)
static void C_ccall f_3340r(C_word t0,C_word t1,C_word t3) C_noret;
C_noret_decl(f_3346)
static void C_fcall f_3346(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_3367)
static void C_ccall f_3367(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,C_word t4) C_noret;
C_noret_decl(f_3444)
static void C_ccall f_3444(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3371)
static void C_ccall f_3371(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3374)
static void C_ccall f_3374(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3377)
static void C_ccall f_3377(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3384)
static void C_ccall f_3384(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3386)
static void C_fcall f_3386(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_3403)
static void C_ccall f_3403(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3413)
static void C_ccall f_3413(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3417)
static void C_ccall f_3417(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3361)
static void C_ccall f_3361(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3281)
static void C_ccall f_3281(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...) C_noret;
C_noret_decl(f_3281)
static void C_ccall f_3281r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t5) C_noret;
C_noret_decl(f_3285)
static void C_ccall f_3285(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3291)
static void C_ccall f_3291(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3265)
static void C_ccall f_3265(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_3265)
static void C_ccall f_3265r(C_word t0,C_word t1,C_word t3) C_noret;
C_noret_decl(f_3253)
static void C_ccall f_3253(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3225)
static void C_ccall f_3225(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_3232)
static void C_ccall f_3232(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3145)
static void C_ccall f_3145(C_word c,C_word t0,C_word t1,C_word t2,...) C_noret;
C_noret_decl(f_3145)
static void C_ccall f_3145r(C_word t0,C_word t1,C_word t2,C_word t4) C_noret;
C_noret_decl(f_3149)
static void C_ccall f_3149(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3155)
static void C_ccall f_3155(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3177)
static void C_ccall f_3177(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3174)
static void C_ccall f_3174(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3164)
static void C_ccall f_3164(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3112)
static void C_ccall f_3112(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_3116)
static void C_ccall f_3116(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3093)
static void C_ccall f_3093(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_3084)
static void C_ccall f_3084(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_3019)
static void C_ccall f_3019(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3025)
static void C_fcall f_3025(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_3029)
static void C_ccall f_3029(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3037)
static void C_fcall f_3037(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_3063)
static void C_ccall f_3063(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3067)
static void C_ccall f_3067(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_3055)
static void C_ccall f_3055(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2999)
static void C_ccall f_2999(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_3007)
static void C_ccall f_3007(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2982)
static void C_ccall f_2982(C_word c,C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_2993)
static void C_ccall f_2993(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2997)
static void C_ccall f_2997(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2952)
static void C_ccall f_2952(C_word c,C_word t0,C_word t1,C_word t2,...) C_noret;
C_noret_decl(f_2952)
static void C_ccall f_2952r(C_word t0,C_word t1,C_word t2,C_word t4) C_noret;
C_noret_decl(f_2959)
static void C_fcall f_2959(C_word t0,C_word t1) C_noret;
C_noret_decl(f_2968)
static void C_ccall f_2968(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2962)
static void C_ccall f_2962(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2917)
static void C_ccall f_2917(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_2921)
static void C_ccall f_2921(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2950)
static void C_ccall f_2950(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2936)
static void C_ccall f_2936(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2930)
static void C_ccall f_2930(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2903)
static void C_ccall f_2903(C_word c,C_word t0,C_word t1,C_word t2,...) C_noret;
C_noret_decl(f_2903)
static void C_ccall f_2903r(C_word t0,C_word t1,C_word t2,C_word t4) C_noret;
C_noret_decl(f_2915)
static void C_ccall f_2915(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2889)
static void C_ccall f_2889(C_word c,C_word t0,C_word t1,C_word t2,...) C_noret;
C_noret_decl(f_2889)
static void C_ccall f_2889r(C_word t0,C_word t1,C_word t2,C_word t4) C_noret;
C_noret_decl(f_2901)
static void C_ccall f_2901(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2871)
static void C_fcall f_2871(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_2875)
static void C_ccall f_2875(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2887)
static void C_ccall f_2887(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2834)
static void C_fcall f_2834(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_2842)
static void C_ccall f_2842(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2825)
static void C_ccall f_2825(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_2819)
static void C_ccall f_2819(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_2813)
static void C_ccall f_2813(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_2789)
static void C_fcall f_2789(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_2811)
static void C_ccall f_2811(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2807)
static void C_ccall f_2807(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2799)
static void C_ccall f_2799(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2759)
static void C_ccall f_2759(C_word c,C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_2787)
static void C_ccall f_2787(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2783)
static void C_ccall f_2783(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2775)
static void C_ccall f_2775(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2703)
static void C_ccall f_2703(C_word c,C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_2713)
static void C_ccall f_2713(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2690)
static void C_ccall f_2690(C_word c,C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_2681)
static void C_ccall f_2681(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_2605)
static void C_ccall f_2605(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_2605)
static void C_ccall f_2605r(C_word t0,C_word t1,C_word t3) C_noret;
C_noret_decl(f_2609)
static void C_ccall f_2609(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2621)
static void C_ccall f_2621(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2612)
static void C_ccall f_2612(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2585)
static void C_ccall f_2585(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...) C_noret;
C_noret_decl(f_2585)
static void C_ccall f_2585r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t5) C_noret;
C_noret_decl(f_2589)
static void C_ccall f_2589(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2595)
static void C_ccall f_2595(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_2595)
static void C_ccall f_2595r(C_word t0,C_word t1,C_word t3) C_noret;
C_noret_decl(f_2599)
static void C_ccall f_2599(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2565)
static void C_ccall f_2565(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...) C_noret;
C_noret_decl(f_2565)
static void C_ccall f_2565r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t5) C_noret;
C_noret_decl(f_2569)
static void C_ccall f_2569(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2575)
static void C_ccall f_2575(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_2575)
static void C_ccall f_2575r(C_word t0,C_word t1,C_word t3) C_noret;
C_noret_decl(f_2579)
static void C_ccall f_2579(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2541)
static void C_ccall f_2541(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...) C_noret;
C_noret_decl(f_2541)
static void C_ccall f_2541r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t5) C_noret;
C_noret_decl(f_2545)
static void C_ccall f_2545(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2556)
static void C_ccall f_2556(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_2556)
static void C_ccall f_2556r(C_word t0,C_word t1,C_word t3) C_noret;
C_noret_decl(f_2560)
static void C_ccall f_2560(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2550)
static void C_ccall f_2550(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2517)
static void C_ccall f_2517(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...) C_noret;
C_noret_decl(f_2517)
static void C_ccall f_2517r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t5) C_noret;
C_noret_decl(f_2521)
static void C_ccall f_2521(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2532)
static void C_ccall f_2532(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_2532)
static void C_ccall f_2532r(C_word t0,C_word t1,C_word t3) C_noret;
C_noret_decl(f_2536)
static void C_ccall f_2536(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2526)
static void C_ccall f_2526(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2498)
static void C_ccall f_2498(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_2502)
static void C_ccall f_2502(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2505)
static void C_ccall f_2505(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2462)
static void C_ccall f_2462(C_word c,C_word t0,C_word t1,C_word t2,...) C_noret;
C_noret_decl(f_2462)
static void C_ccall f_2462r(C_word t0,C_word t1,C_word t2,C_word t4) C_noret;
C_noret_decl(f_2493)
static void C_ccall f_2493(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2483)
static void C_ccall f_2483(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2476)
static void C_ccall f_2476(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2426)
static void C_ccall f_2426(C_word c,C_word t0,C_word t1,C_word t2,...) C_noret;
C_noret_decl(f_2426)
static void C_ccall f_2426r(C_word t0,C_word t1,C_word t2,C_word t4) C_noret;
C_noret_decl(f_2457)
static void C_ccall f_2457(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2447)
static void C_ccall f_2447(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2440)
static void C_ccall f_2440(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2408)
static void C_fcall f_2408(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_2412)
static void C_ccall f_2412(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2424)
static void C_ccall f_2424(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2402)
static void C_fcall f_2402(C_word t0,C_word t1) C_noret;
C_noret_decl(f_2390)
static C_word C_fcall f_2390(C_word t0);
C_noret_decl(f_2033)
static void C_ccall f_2033(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_2380)
static void C_ccall f_2380(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2179)
static void C_fcall f_2179(C_word t0,C_word t1) C_noret;
C_noret_decl(f_2366)
static void C_ccall f_2366(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2355)
static void C_ccall f_2355(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2362)
static void C_ccall f_2362(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2209)
static void C_fcall f_2209(C_word t0,C_word t1) C_noret;
C_noret_decl(f_2348)
static void C_ccall f_2348(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2327)
static void C_ccall f_2327(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2344)
static void C_ccall f_2344(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2333)
static void C_ccall f_2333(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2340)
static void C_ccall f_2340(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2251)
static void C_fcall f_2251(C_word t0,C_word t1) C_noret;
C_noret_decl(f_2324)
static void C_ccall f_2324(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2303)
static void C_ccall f_2303(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2320)
static void C_ccall f_2320(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2309)
static void C_ccall f_2309(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2316)
static void C_ccall f_2316(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2257)
static void C_ccall f_2257(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2300)
static void C_ccall f_2300(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2296)
static void C_ccall f_2296(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2289)
static void C_ccall f_2289(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2285)
static void C_ccall f_2285(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2264)
static void C_ccall f_2264(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2268)
static void C_ccall f_2268(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2245)
static void C_ccall f_2245(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2232)
static void C_ccall f_2232(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2216)
static void C_ccall f_2216(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2220)
static void C_ccall f_2220(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2224)
static void C_ccall f_2224(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2203)
static void C_ccall f_2203(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2190)
static void C_ccall f_2190(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2186)
static void C_ccall f_2186(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2173)
static void C_ccall f_2173(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2040)
static void C_ccall f_2040(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2159)
static void C_ccall f_2159(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2047)
static void C_ccall f_2047(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2049)
static void C_fcall f_2049(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_2056)
static void C_ccall f_2056(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2131)
static void C_ccall f_2131(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2140)
static void C_ccall f_2140(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2128)
static void C_fcall f_2128(C_word t0,C_word t1) C_noret;
C_noret_decl(f_2062)
static void C_ccall f_2062(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2109)
static void C_ccall f_2109(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2097)
static void C_ccall f_2097(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2105)
static void C_ccall f_2105(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2101)
static void C_ccall f_2101(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2078)
static void C_ccall f_2078(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2086)
static void C_ccall f_2086(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2082)
static void C_ccall f_2082(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1977)
static void C_fcall f_1977(C_word t0,C_word t1) C_noret;
C_noret_decl(f_1986)
static void C_ccall f_1986(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_2010)
static void C_ccall f_2010(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2022)
static void C_ccall f_2022(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_2022)
static void C_ccall f_2022r(C_word t0,C_word t1,C_word t3) C_noret;
C_noret_decl(f_2028)
static void C_ccall f_2028(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_2016)
static void C_ccall f_2016(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1992)
static void C_ccall f_1992(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_1998)
static void C_ccall f_1998(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1984)
static void C_ccall f_1984(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1966)
static C_word C_fcall f_1966(C_word t0);
C_noret_decl(f_1961)
static void C_fcall f_1961(C_word t0,C_word t1) C_noret;
C_noret_decl(f_1910)
static void C_ccall f_1910(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_1910)
static void C_ccall f_1910r(C_word t0,C_word t1,C_word t3) C_noret;
C_noret_decl(f_1914)
static void C_ccall f_1914(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1923)
static void C_ccall f_1923(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1926)
static void C_ccall f_1926(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1883)
static void C_ccall f_1883(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_1908)
static void C_ccall f_1908(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1904)
static void C_ccall f_1904(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1890)
static void C_ccall f_1890(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1723)
static void C_ccall f_1723(C_word c,C_word t0,C_word t1,...) C_noret;
C_noret_decl(f_1723)
static void C_ccall f_1723r(C_word t0,C_word t1,C_word t3) C_noret;
C_noret_decl(f_1831)
static void C_fcall f_1831(C_word t0,C_word t1) C_noret;
C_noret_decl(f_1839)
static void C_ccall f_1839(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1826)
static void C_fcall f_1826(C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_1725)
static void C_fcall f_1725(C_word t0,C_word t1,C_word t2,C_word t3) C_noret;
C_noret_decl(f_1732)
static void C_ccall f_1732(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1735)
static void C_ccall f_1735(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1738)
static void C_ccall f_1738(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1825)
static void C_ccall f_1825(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1742)
static void C_ccall f_1742(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1759)
static void C_fcall f_1759(C_word t0,C_word t1) C_noret;
C_noret_decl(f_1769)
static void C_ccall f_1769(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1781)
static void C_fcall f_1781(C_word t0,C_word t1) C_noret;
C_noret_decl(f_1791)
static void C_ccall f_1791(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1751)
static void C_ccall f_1751(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1696)
static void C_ccall f_1696(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_1721)
static void C_ccall f_1721(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1717)
static void C_ccall f_1717(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1709)
static void C_ccall f_1709(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1669)
static void C_ccall f_1669(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_1694)
static void C_ccall f_1694(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1690)
static void C_ccall f_1690(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1682)
static void C_ccall f_1682(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1642)
static void C_ccall f_1642(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_1667)
static void C_ccall f_1667(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1663)
static void C_ccall f_1663(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1655)
static void C_ccall f_1655(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1581)
static void C_ccall f_1581(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...) C_noret;
C_noret_decl(f_1581)
static void C_ccall f_1581r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t5) C_noret;
C_noret_decl(f_1594)
static void C_ccall f_1594(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1609)
static void C_ccall f_1609(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1600)
static void C_ccall f_1600(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1603)
static void C_ccall f_1603(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1541)
static void C_ccall f_1541(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_1560)
static void C_ccall f_1560(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1545)
static void C_ccall f_1545(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1554)
static void C_ccall f_1554(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1548)
static void C_ccall f_1548(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1508)
static void C_fcall f_1508(C_word t0,C_word t1) C_noret;
C_noret_decl(f_1510)
static void C_ccall f_1510(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_1503)
static void C_ccall f_1503(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_1480)
static void C_ccall f_1480(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_1501)
static void C_ccall f_1501(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1487)
static void C_ccall f_1487(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1474)
static void C_ccall f_1474(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_1478)
static void C_ccall f_1478(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1468)
static void C_ccall f_1468(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_1472)
static void C_ccall f_1472(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1462)
static void C_ccall f_1462(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_1466)
static void C_ccall f_1466(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1456)
static void C_ccall f_1456(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_1460)
static void C_ccall f_1460(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1450)
static void C_ccall f_1450(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_1454)
static void C_ccall f_1454(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1444)
static void C_ccall f_1444(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_1448)
static void C_ccall f_1448(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1413)
static void C_ccall f_1413(C_word c,C_word t0,C_word t1,C_word t2,...) C_noret;
C_noret_decl(f_1413)
static void C_ccall f_1413r(C_word t0,C_word t1,C_word t2,C_word t4) C_noret;
C_noret_decl(f_1417)
static void C_ccall f_1417(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1420)
static void C_ccall f_1420(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1375)
static void C_fcall f_1375(C_word t0,C_word t1) C_noret;
C_noret_decl(f_1408)
static void C_ccall f_1408(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1404)
static void C_ccall f_1404(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1379)
static void C_ccall f_1379(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1388)
static void C_ccall f_1388(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1337)
static void C_ccall f_1337(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_1344)
static void C_ccall f_1344(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1347)
static void C_ccall f_1347(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1367)
static void C_ccall f_1367(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1350)
static void C_ccall f_1350(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1357)
static void C_ccall f_1357(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1295)
static void C_ccall f_1295(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...) C_noret;
C_noret_decl(f_1295)
static void C_ccall f_1295r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t5) C_noret;
C_noret_decl(f_1302)
static void C_ccall f_1302(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1317)
static void C_ccall f_1317(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1311)
static void C_ccall f_1311(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1250)
static void C_ccall f_1250(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...) C_noret;
C_noret_decl(f_1250)
static void C_ccall f_1250r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t5) C_noret;
C_noret_decl(f_1260)
static void C_ccall f_1260(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1263)
static void C_ccall f_1263(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1275)
static void C_ccall f_1275(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1266)
static void C_ccall f_1266(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1232)
static void C_ccall f_1232(C_word c,C_word t0,C_word t1,C_word t2) C_noret;
C_noret_decl(f_1245)
static void C_ccall f_1245(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1191)
static void C_ccall f_1191(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...) C_noret;
C_noret_decl(f_1191)
static void C_ccall f_1191r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t5) C_noret;
C_noret_decl(f_1224)
static void C_ccall f_1224(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1208)
static void C_ccall f_1208(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1217)
static void C_ccall f_1217(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1211)
static void C_ccall f_1211(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1145)
static void C_ccall f_1145(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,...) C_noret;
C_noret_decl(f_1145)
static void C_ccall f_1145r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t6) C_noret;
C_noret_decl(f_1149)
static void C_ccall f_1149(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1160)
static void C_ccall f_1160(C_word c,C_word t0,C_word t1) C_noret;
C_noret_decl(f_1156)
static void C_ccall f_1156(C_word c,C_word t0,C_word t1) C_noret;

C_noret_decl(trf_4596)
static void C_fcall trf_4596(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_4596(void *dummy){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
f_4596(t0,t1);}

C_noret_decl(trf_4591)
static void C_fcall trf_4591(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_4591(void *dummy){
C_word t2=C_pick(0);
C_word t1=C_pick(1);
C_word t0=C_pick(2);
C_adjust_stack(-3);
f_4591(t0,t1,t2);}

C_noret_decl(trf_4586)
static void C_fcall trf_4586(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_4586(void *dummy){
C_word t3=C_pick(0);
C_word t2=C_pick(1);
C_word t1=C_pick(2);
C_word t0=C_pick(3);
C_adjust_stack(-4);
f_4586(t0,t1,t2,t3);}

C_noret_decl(trf_4441)
static void C_fcall trf_4441(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_4441(void *dummy){
C_word t4=C_pick(0);
C_word t3=C_pick(1);
C_word t2=C_pick(2);
C_word t1=C_pick(3);
C_word t0=C_pick(4);
C_adjust_stack(-5);
f_4441(t0,t1,t2,t3,t4);}

C_noret_decl(trf_4448)
static void C_fcall trf_4448(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_4448(void *dummy){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
f_4448(t0,t1);}

C_noret_decl(trf_4460)
static void C_fcall trf_4460(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_4460(void *dummy){
C_word t3=C_pick(0);
C_word t2=C_pick(1);
C_word t1=C_pick(2);
C_word t0=C_pick(3);
C_adjust_stack(-4);
f_4460(t0,t1,t2,t3);}

C_noret_decl(trf_4243)
static void C_fcall trf_4243(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_4243(void *dummy){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
f_4243(t0,t1);}

C_noret_decl(trf_4238)
static void C_fcall trf_4238(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_4238(void *dummy){
C_word t2=C_pick(0);
C_word t1=C_pick(1);
C_word t0=C_pick(2);
C_adjust_stack(-3);
f_4238(t0,t1,t2);}

C_noret_decl(trf_4233)
static void C_fcall trf_4233(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_4233(void *dummy){
C_word t3=C_pick(0);
C_word t2=C_pick(1);
C_word t1=C_pick(2);
C_word t0=C_pick(3);
C_adjust_stack(-4);
f_4233(t0,t1,t2,t3);}

C_noret_decl(trf_4228)
static void C_fcall trf_4228(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_4228(void *dummy){
C_word t4=C_pick(0);
C_word t3=C_pick(1);
C_word t2=C_pick(2);
C_word t1=C_pick(3);
C_word t0=C_pick(4);
C_adjust_stack(-5);
f_4228(t0,t1,t2,t3,t4);}

C_noret_decl(trf_4163)
static void C_fcall trf_4163(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_4163(void *dummy){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
f_4163(t0,t1);}

C_noret_decl(trf_4158)
static void C_fcall trf_4158(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_4158(void *dummy){
C_word t2=C_pick(0);
C_word t1=C_pick(1);
C_word t0=C_pick(2);
C_adjust_stack(-3);
f_4158(t0,t1,t2);}

C_noret_decl(trf_4153)
static void C_fcall trf_4153(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_4153(void *dummy){
C_word t3=C_pick(0);
C_word t2=C_pick(1);
C_word t1=C_pick(2);
C_word t0=C_pick(3);
C_adjust_stack(-4);
f_4153(t0,t1,t2,t3);}

C_noret_decl(trf_4148)
static void C_fcall trf_4148(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_4148(void *dummy){
C_word t4=C_pick(0);
C_word t3=C_pick(1);
C_word t2=C_pick(2);
C_word t1=C_pick(3);
C_word t0=C_pick(4);
C_adjust_stack(-5);
f_4148(t0,t1,t2,t3,t4);}

C_noret_decl(trf_4084)
static void C_fcall trf_4084(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_4084(void *dummy){
C_word t6=C_pick(0);
C_word t5=C_pick(1);
C_word t4=C_pick(2);
C_word t3=C_pick(3);
C_word t2=C_pick(4);
C_word t1=C_pick(5);
C_word t0=C_pick(6);
C_adjust_stack(-7);
f_4084(t0,t1,t2,t3,t4,t5,t6);}

C_noret_decl(trf_4086)
static void C_fcall trf_4086(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_4086(void *dummy){
C_word t2=C_pick(0);
C_word t1=C_pick(1);
C_word t0=C_pick(2);
C_adjust_stack(-3);
f_4086(t0,t1,t2);}

C_noret_decl(trf_3777)
static void C_fcall trf_3777(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_3777(void *dummy){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
f_3777(t0,t1);}

C_noret_decl(trf_3772)
static void C_fcall trf_3772(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_3772(void *dummy){
C_word t2=C_pick(0);
C_word t1=C_pick(1);
C_word t0=C_pick(2);
C_adjust_stack(-3);
f_3772(t0,t1,t2);}

C_noret_decl(trf_3767)
static void C_fcall trf_3767(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_3767(void *dummy){
C_word t3=C_pick(0);
C_word t2=C_pick(1);
C_word t1=C_pick(2);
C_word t0=C_pick(3);
C_adjust_stack(-4);
f_3767(t0,t1,t2,t3);}

C_noret_decl(trf_3755)
static void C_fcall trf_3755(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_3755(void *dummy){
C_word t4=C_pick(0);
C_word t3=C_pick(1);
C_word t2=C_pick(2);
C_word t1=C_pick(3);
C_word t0=C_pick(4);
C_adjust_stack(-5);
f_3755(t0,t1,t2,t3,t4);}

C_noret_decl(trf_3690)
static void C_fcall trf_3690(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_3690(void *dummy){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
f_3690(t0,t1);}

C_noret_decl(trf_3685)
static void C_fcall trf_3685(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_3685(void *dummy){
C_word t2=C_pick(0);
C_word t1=C_pick(1);
C_word t0=C_pick(2);
C_adjust_stack(-3);
f_3685(t0,t1,t2);}

C_noret_decl(trf_3680)
static void C_fcall trf_3680(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_3680(void *dummy){
C_word t3=C_pick(0);
C_word t2=C_pick(1);
C_word t1=C_pick(2);
C_word t0=C_pick(3);
C_adjust_stack(-4);
f_3680(t0,t1,t2,t3);}

C_noret_decl(trf_3668)
static void C_fcall trf_3668(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_3668(void *dummy){
C_word t4=C_pick(0);
C_word t3=C_pick(1);
C_word t2=C_pick(2);
C_word t1=C_pick(3);
C_word t0=C_pick(4);
C_adjust_stack(-5);
f_3668(t0,t1,t2,t3,t4);}

C_noret_decl(trf_3651)
static void C_fcall trf_3651(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_3651(void *dummy){
C_word t4=C_pick(0);
C_word t3=C_pick(1);
C_word t2=C_pick(2);
C_word t1=C_pick(3);
C_word t0=C_pick(4);
C_adjust_stack(-5);
f_3651(t0,t1,t2,t3,t4);}

C_noret_decl(trf_3618)
static void C_fcall trf_3618(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_3618(void *dummy){
C_word t6=C_pick(0);
C_word t5=C_pick(1);
C_word t4=C_pick(2);
C_word t3=C_pick(3);
C_word t2=C_pick(4);
C_word t1=C_pick(5);
C_word t0=C_pick(6);
C_adjust_stack(-7);
f_3618(t0,t1,t2,t3,t4,t5,t6);}

C_noret_decl(trf_3568)
static void C_fcall trf_3568(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_3568(void *dummy){
C_word t4=C_pick(0);
C_word t3=C_pick(1);
C_word t2=C_pick(2);
C_word t1=C_pick(3);
C_word t0=C_pick(4);
C_adjust_stack(-5);
f_3568(t0,t1,t2,t3,t4);}

C_noret_decl(trf_3580)
static void C_fcall trf_3580(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_3580(void *dummy){
C_word t3=C_pick(0);
C_word t2=C_pick(1);
C_word t1=C_pick(2);
C_word t0=C_pick(3);
C_adjust_stack(-4);
f_3580(t0,t1,t2,t3);}

C_noret_decl(trf_3455)
static void C_fcall trf_3455(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_3455(void *dummy){
C_word t3=C_pick(0);
C_word t2=C_pick(1);
C_word t1=C_pick(2);
C_word t0=C_pick(3);
C_adjust_stack(-4);
f_3455(t0,t1,t2,t3);}

C_noret_decl(trf_3498)
static void C_fcall trf_3498(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_3498(void *dummy){
C_word t3=C_pick(0);
C_word t2=C_pick(1);
C_word t1=C_pick(2);
C_word t0=C_pick(3);
C_adjust_stack(-4);
f_3498(t0,t1,t2,t3);}

C_noret_decl(trf_3460)
static void C_fcall trf_3460(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_3460(void *dummy){
C_word t2=C_pick(0);
C_word t1=C_pick(1);
C_word t0=C_pick(2);
C_adjust_stack(-3);
f_3460(t0,t1,t2);}

C_noret_decl(trf_3469)
static void C_fcall trf_3469(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_3469(void *dummy){
C_word t2=C_pick(0);
C_word t1=C_pick(1);
C_word t0=C_pick(2);
C_adjust_stack(-3);
f_3469(t0,t1,t2);}

C_noret_decl(trf_3346)
static void C_fcall trf_3346(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_3346(void *dummy){
C_word t2=C_pick(0);
C_word t1=C_pick(1);
C_word t0=C_pick(2);
C_adjust_stack(-3);
f_3346(t0,t1,t2);}

C_noret_decl(trf_3386)
static void C_fcall trf_3386(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_3386(void *dummy){
C_word t2=C_pick(0);
C_word t1=C_pick(1);
C_word t0=C_pick(2);
C_adjust_stack(-3);
f_3386(t0,t1,t2);}

C_noret_decl(trf_3025)
static void C_fcall trf_3025(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_3025(void *dummy){
C_word t2=C_pick(0);
C_word t1=C_pick(1);
C_word t0=C_pick(2);
C_adjust_stack(-3);
f_3025(t0,t1,t2);}

C_noret_decl(trf_3037)
static void C_fcall trf_3037(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_3037(void *dummy){
C_word t2=C_pick(0);
C_word t1=C_pick(1);
C_word t0=C_pick(2);
C_adjust_stack(-3);
f_3037(t0,t1,t2);}

C_noret_decl(trf_2959)
static void C_fcall trf_2959(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_2959(void *dummy){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
f_2959(t0,t1);}

C_noret_decl(trf_2871)
static void C_fcall trf_2871(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_2871(void *dummy){
C_word t3=C_pick(0);
C_word t2=C_pick(1);
C_word t1=C_pick(2);
C_word t0=C_pick(3);
C_adjust_stack(-4);
f_2871(t0,t1,t2,t3);}

C_noret_decl(trf_2834)
static void C_fcall trf_2834(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_2834(void *dummy){
C_word t2=C_pick(0);
C_word t1=C_pick(1);
C_word t0=C_pick(2);
C_adjust_stack(-3);
f_2834(t0,t1,t2);}

C_noret_decl(trf_2789)
static void C_fcall trf_2789(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_2789(void *dummy){
C_word t3=C_pick(0);
C_word t2=C_pick(1);
C_word t1=C_pick(2);
C_word t0=C_pick(3);
C_adjust_stack(-4);
f_2789(t0,t1,t2,t3);}

C_noret_decl(trf_2408)
static void C_fcall trf_2408(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_2408(void *dummy){
C_word t3=C_pick(0);
C_word t2=C_pick(1);
C_word t1=C_pick(2);
C_word t0=C_pick(3);
C_adjust_stack(-4);
f_2408(t0,t1,t2,t3);}

C_noret_decl(trf_2402)
static void C_fcall trf_2402(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_2402(void *dummy){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
f_2402(t0,t1);}

C_noret_decl(trf_2179)
static void C_fcall trf_2179(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_2179(void *dummy){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
f_2179(t0,t1);}

C_noret_decl(trf_2209)
static void C_fcall trf_2209(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_2209(void *dummy){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
f_2209(t0,t1);}

C_noret_decl(trf_2251)
static void C_fcall trf_2251(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_2251(void *dummy){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
f_2251(t0,t1);}

C_noret_decl(trf_2049)
static void C_fcall trf_2049(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_2049(void *dummy){
C_word t3=C_pick(0);
C_word t2=C_pick(1);
C_word t1=C_pick(2);
C_word t0=C_pick(3);
C_adjust_stack(-4);
f_2049(t0,t1,t2,t3);}

C_noret_decl(trf_2128)
static void C_fcall trf_2128(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_2128(void *dummy){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
f_2128(t0,t1);}

C_noret_decl(trf_1977)
static void C_fcall trf_1977(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_1977(void *dummy){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
f_1977(t0,t1);}

C_noret_decl(trf_1961)
static void C_fcall trf_1961(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_1961(void *dummy){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
f_1961(t0,t1);}

C_noret_decl(trf_1831)
static void C_fcall trf_1831(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_1831(void *dummy){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
f_1831(t0,t1);}

C_noret_decl(trf_1826)
static void C_fcall trf_1826(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_1826(void *dummy){
C_word t2=C_pick(0);
C_word t1=C_pick(1);
C_word t0=C_pick(2);
C_adjust_stack(-3);
f_1826(t0,t1,t2);}

C_noret_decl(trf_1725)
static void C_fcall trf_1725(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_1725(void *dummy){
C_word t3=C_pick(0);
C_word t2=C_pick(1);
C_word t1=C_pick(2);
C_word t0=C_pick(3);
C_adjust_stack(-4);
f_1725(t0,t1,t2,t3);}

C_noret_decl(trf_1759)
static void C_fcall trf_1759(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_1759(void *dummy){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
f_1759(t0,t1);}

C_noret_decl(trf_1781)
static void C_fcall trf_1781(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_1781(void *dummy){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
f_1781(t0,t1);}

C_noret_decl(trf_1508)
static void C_fcall trf_1508(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_1508(void *dummy){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
f_1508(t0,t1);}

C_noret_decl(trf_1375)
static void C_fcall trf_1375(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall trf_1375(void *dummy){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
f_1375(t0,t1);}

C_noret_decl(tr6)
static void C_fcall tr6(C_proc6 k) C_regparm C_noret;
C_regparm static void C_fcall tr6(C_proc6 k){
C_word t5=C_pick(0);
C_word t4=C_pick(1);
C_word t3=C_pick(2);
C_word t2=C_pick(3);
C_word t1=C_pick(4);
C_word t0=C_pick(5);
C_adjust_stack(-6);
(k)(6,t0,t1,t2,t3,t4,t5);}

C_noret_decl(tr5)
static void C_fcall tr5(C_proc5 k) C_regparm C_noret;
C_regparm static void C_fcall tr5(C_proc5 k){
C_word t4=C_pick(0);
C_word t3=C_pick(1);
C_word t2=C_pick(2);
C_word t1=C_pick(3);
C_word t0=C_pick(4);
C_adjust_stack(-5);
(k)(5,t0,t1,t2,t3,t4);}

C_noret_decl(tr4)
static void C_fcall tr4(C_proc4 k) C_regparm C_noret;
C_regparm static void C_fcall tr4(C_proc4 k){
C_word t3=C_pick(0);
C_word t2=C_pick(1);
C_word t1=C_pick(2);
C_word t0=C_pick(3);
C_adjust_stack(-4);
(k)(4,t0,t1,t2,t3);}

C_noret_decl(tr3)
static void C_fcall tr3(C_proc3 k) C_regparm C_noret;
C_regparm static void C_fcall tr3(C_proc3 k){
C_word t2=C_pick(0);
C_word t1=C_pick(1);
C_word t0=C_pick(2);
C_adjust_stack(-3);
(k)(3,t0,t1,t2);}

C_noret_decl(tr2)
static void C_fcall tr2(C_proc2 k) C_regparm C_noret;
C_regparm static void C_fcall tr2(C_proc2 k){
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
(k)(2,t0,t1);}

C_noret_decl(tr5r)
static void C_fcall tr5r(C_proc5 k) C_regparm C_noret;
C_regparm static void C_fcall tr5r(C_proc5 k){
int n;
C_word *a,t5;
C_word t4=C_pick(0);
C_word t3=C_pick(1);
C_word t2=C_pick(2);
C_word t1=C_pick(3);
C_word t0=C_pick(4);
C_adjust_stack(-5);
n=C_rest_count(0);
a=C_alloc(n*3);
t5=C_restore_rest(a,n);
(k)(t0,t1,t2,t3,t4,t5);}

C_noret_decl(tr2r)
static void C_fcall tr2r(C_proc2 k) C_regparm C_noret;
C_regparm static void C_fcall tr2r(C_proc2 k){
int n;
C_word *a,t2;
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
n=C_rest_count(0);
a=C_alloc(n*3);
t2=C_restore_rest(a,n);
(k)(t0,t1,t2);}

C_noret_decl(tr9r)
static void C_fcall tr9r(C_proc9 k) C_regparm C_noret;
C_regparm static void C_fcall tr9r(C_proc9 k){
int n;
C_word *a,t9;
C_word t8=C_pick(0);
C_word t7=C_pick(1);
C_word t6=C_pick(2);
C_word t5=C_pick(3);
C_word t4=C_pick(4);
C_word t3=C_pick(5);
C_word t2=C_pick(6);
C_word t1=C_pick(7);
C_word t0=C_pick(8);
C_adjust_stack(-9);
n=C_rest_count(0);
a=C_alloc(n*3);
t9=C_restore_rest(a,n);
(k)(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9);}

C_noret_decl(tr3r)
static void C_fcall tr3r(C_proc3 k) C_regparm C_noret;
C_regparm static void C_fcall tr3r(C_proc3 k){
int n;
C_word *a,t3;
C_word t2=C_pick(0);
C_word t1=C_pick(1);
C_word t0=C_pick(2);
C_adjust_stack(-3);
n=C_rest_count(0);
a=C_alloc(n*3);
t3=C_restore_rest(a,n);
(k)(t0,t1,t2,t3);}

C_noret_decl(tr4r)
static void C_fcall tr4r(C_proc4 k) C_regparm C_noret;
C_regparm static void C_fcall tr4r(C_proc4 k){
int n;
C_word *a,t4;
C_word t3=C_pick(0);
C_word t2=C_pick(1);
C_word t1=C_pick(2);
C_word t0=C_pick(3);
C_adjust_stack(-4);
n=C_rest_count(0);
a=C_alloc(n*3);
t4=C_restore_rest(a,n);
(k)(t0,t1,t2,t3,t4);}

C_noret_decl(tr2rv)
static void C_fcall tr2rv(C_proc2 k) C_regparm C_noret;
C_regparm static void C_fcall tr2rv(C_proc2 k){
int n;
C_word *a,t2;
C_word t1=C_pick(0);
C_word t0=C_pick(1);
C_adjust_stack(-2);
n=C_rest_count(0);
a=C_alloc(n+1);
t2=C_restore_rest_vector(a,n);
(k)(t0,t1,t2);}

C_noret_decl(tr4rv)
static void C_fcall tr4rv(C_proc4 k) C_regparm C_noret;
C_regparm static void C_fcall tr4rv(C_proc4 k){
int n;
C_word *a,t4;
C_word t3=C_pick(0);
C_word t2=C_pick(1);
C_word t1=C_pick(2);
C_word t0=C_pick(3);
C_adjust_stack(-4);
n=C_rest_count(0);
a=C_alloc(n+1);
t4=C_restore_rest_vector(a,n);
(k)(t0,t1,t2,t3,t4);}

C_noret_decl(tr3rv)
static void C_fcall tr3rv(C_proc3 k) C_regparm C_noret;
C_regparm static void C_fcall tr3rv(C_proc3 k){
int n;
C_word *a,t3;
C_word t2=C_pick(0);
C_word t1=C_pick(1);
C_word t0=C_pick(2);
C_adjust_stack(-3);
n=C_rest_count(0);
a=C_alloc(n+1);
t3=C_restore_rest_vector(a,n);
(k)(t0,t1,t2,t3);}

/* toplevel */
static C_TLS int toplevel_initialized=0;
C_noret_decl(toplevel_trampoline)
static void C_fcall toplevel_trampoline(void *dummy) C_regparm C_noret;
C_regparm static void C_fcall toplevel_trampoline(void *dummy){
C_posix_toplevel(2,C_SCHEME_UNDEFINED,C_restore);}

void C_ccall C_posix_toplevel(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
if(toplevel_initialized) C_kontinue(t1,C_SCHEME_UNDEFINED);
else C_toplevel_entry(C_text("posix_toplevel"));
C_check_nursery_minimum(3);
if(!C_demand(3)){
C_save(t1);
C_reclaim((void*)toplevel_trampoline,NULL);}
toplevel_initialized=1;
if(!C_demand_2(3080)){
C_save(t1);
C_rereclaim2(3080*sizeof(C_word), 1);
t1=C_restore;}
a=C_alloc(3);
C_initialize_lf(lf,393);
lf[1]=C_decode_literal(C_heaptop,"\376B\000\000/this function is not available on this platform");
lf[3]=C_decode_literal(C_heaptop,"\376B\000\000\033too many optional arguments");
lf[4]=C_h_intern(&lf[4],13,"string-append");
lf[6]=C_h_intern(&lf[6],15,"\003syssignal-hook");
lf[7]=C_decode_literal(C_heaptop,"\376B\000\000\003 - ");
lf[8]=C_h_intern(&lf[8],17,"\003syspeek-c-string");
lf[9]=C_h_intern(&lf[9],16,"\003sysupdate-errno");
lf[10]=C_h_intern(&lf[10],15,"\003sysposix-error");
lf[11]=C_h_intern(&lf[11],8,"pipe/buf");
lf[12]=C_h_intern(&lf[12],11,"open/rdonly");
lf[13]=C_h_intern(&lf[13],11,"open/wronly");
lf[14]=C_h_intern(&lf[14],9,"open/rdwr");
lf[15]=C_h_intern(&lf[15],9,"open/read");
lf[16]=C_h_intern(&lf[16],10,"open/write");
lf[17]=C_h_intern(&lf[17],10,"open/creat");
lf[18]=C_h_intern(&lf[18],11,"open/append");
lf[19]=C_h_intern(&lf[19],9,"open/excl");
lf[20]=C_h_intern(&lf[20],10,"open/trunc");
lf[21]=C_h_intern(&lf[21],11,"open/binary");
lf[22]=C_h_intern(&lf[22],9,"open/text");
lf[23]=C_h_intern(&lf[23],14,"open/noinherit");
lf[24]=C_h_intern(&lf[24],10,"perm/irusr");
lf[25]=C_h_intern(&lf[25],10,"perm/iwusr");
lf[26]=C_h_intern(&lf[26],10,"perm/ixusr");
lf[27]=C_h_intern(&lf[27],10,"perm/irgrp");
lf[28]=C_h_intern(&lf[28],10,"perm/iwgrp");
lf[29]=C_h_intern(&lf[29],10,"perm/ixgrp");
lf[30]=C_h_intern(&lf[30],10,"perm/iroth");
lf[31]=C_h_intern(&lf[31],10,"perm/iwoth");
lf[32]=C_h_intern(&lf[32],10,"perm/ixoth");
lf[33]=C_h_intern(&lf[33],10,"perm/irwxu");
lf[34]=C_h_intern(&lf[34],10,"perm/irwxg");
lf[35]=C_h_intern(&lf[35],10,"perm/irwxo");
lf[36]=C_h_intern(&lf[36],9,"file-open");
lf[37]=C_h_intern(&lf[37],11,"\000file-error");
lf[38]=C_decode_literal(C_heaptop,"\376B\000\000\020cannot open file");
lf[39]=C_h_intern(&lf[39],17,"\003sysmake-c-string");
lf[40]=C_h_intern(&lf[40],20,"\003sysexpand-home-path");
lf[41]=C_h_intern(&lf[41],10,"file-close");
lf[42]=C_decode_literal(C_heaptop,"\376B\000\000\021cannot close file");
lf[43]=C_h_intern(&lf[43],11,"make-string");
lf[44]=C_h_intern(&lf[44],9,"file-read");
lf[45]=C_decode_literal(C_heaptop,"\376B\000\000\025cannot read from file");
lf[46]=C_h_intern(&lf[46],11,"\000type-error");
lf[47]=C_decode_literal(C_heaptop,"\376B\000\000(bad argument type - not a string or blob");
lf[48]=C_h_intern(&lf[48],10,"file-write");
lf[49]=C_decode_literal(C_heaptop,"\376B\000\000\024cannot write to file");
lf[50]=C_decode_literal(C_heaptop,"\376B\000\000(bad argument type - not a string or blob");
lf[51]=C_h_intern(&lf[51],13,"string-length");
lf[52]=C_h_intern(&lf[52],12,"file-mkstemp");
lf[53]=C_h_intern(&lf[53],13,"\003syssubstring");
lf[54]=C_decode_literal(C_heaptop,"\376B\000\000\034cannot create temporary file");
lf[55]=C_h_intern(&lf[55],8,"seek/set");
lf[56]=C_h_intern(&lf[56],8,"seek/end");
lf[57]=C_h_intern(&lf[57],8,"seek/cur");
lf[59]=C_decode_literal(C_heaptop,"\376B\000\000\022cannot access file");
lf[60]=C_decode_literal(C_heaptop,"\376B\000\000*bad argument type - not a fixnum or string");
lf[61]=C_h_intern(&lf[61],9,"file-stat");
lf[62]=C_h_intern(&lf[62],9,"\003syserror");
lf[63]=C_h_intern(&lf[63],9,"file-size");
lf[64]=C_h_intern(&lf[64],22,"file-modification-time");
lf[65]=C_h_intern(&lf[65],16,"file-access-time");
lf[66]=C_h_intern(&lf[66],16,"file-change-time");
lf[67]=C_h_intern(&lf[67],10,"file-owner");
lf[68]=C_h_intern(&lf[68],16,"file-permissions");
lf[69]=C_h_intern(&lf[69],13,"regular-file\077");
lf[70]=C_h_intern(&lf[70],13,"\003sysfile-info");
lf[71]=C_h_intern(&lf[71],14,"symbolic-link\077");
lf[72]=C_h_intern(&lf[72],13,"stat-regular\077");
lf[73]=C_h_intern(&lf[73],15,"stat-directory\077");
lf[74]=C_h_intern(&lf[74],17,"stat-char-device\077");
lf[75]=C_h_intern(&lf[75],18,"stat-block-device\077");
lf[76]=C_h_intern(&lf[76],10,"stat-fifo\077");
lf[77]=C_h_intern(&lf[77],13,"stat-symlink\077");
lf[78]=C_h_intern(&lf[78],12,"stat-socket\077");
lf[79]=C_h_intern(&lf[79],13,"file-position");
lf[80]=C_decode_literal(C_heaptop,"\376B\000\000%cannot retrieve file position of port");
lf[81]=C_h_intern(&lf[81],6,"stream");
lf[82]=C_decode_literal(C_heaptop,"\376B\000\000\014invalid file");
lf[83]=C_h_intern(&lf[83],5,"port\077");
lf[84]=C_h_intern(&lf[84],18,"set-file-position!");
lf[85]=C_decode_literal(C_heaptop,"\376B\000\000\030cannot set file position");
lf[86]=C_decode_literal(C_heaptop,"\376B\000\000\014invalid file");
lf[87]=C_h_intern(&lf[87],13,"\000bounds-error");
lf[88]=C_decode_literal(C_heaptop,"\376B\000\000\036invalid negative port position");
lf[89]=C_h_intern(&lf[89],16,"create-directory");
lf[90]=C_decode_literal(C_heaptop,"\376B\000\000\027cannot create directory");
lf[91]=C_h_intern(&lf[91],16,"change-directory");
lf[92]=C_decode_literal(C_heaptop,"\376B\000\000\037cannot change current directory");
lf[93]=C_h_intern(&lf[93],16,"delete-directory");
lf[94]=C_decode_literal(C_heaptop,"\376B\000\000\027cannot delete directory");
lf[95]=C_h_intern(&lf[95],6,"string");
lf[96]=C_h_intern(&lf[96],9,"directory");
lf[97]=C_decode_literal(C_heaptop,"\376B\000\000\025cannot open directory");
lf[98]=C_h_intern(&lf[98],16,"\003sysmake-pointer");
lf[99]=C_h_intern(&lf[99],17,"current-directory");
lf[100]=C_h_intern(&lf[100],10,"directory\077");
lf[101]=C_h_intern(&lf[101],27,"\003sysplatform-fixup-pathname");
lf[102]=C_decode_literal(C_heaptop,"\376B\000\000!cannot retrieve current directory");
lf[103]=C_h_intern(&lf[103],5,"null\077");
lf[104]=C_h_intern(&lf[104],6,"char=\077");
lf[105]=C_h_intern(&lf[105],8,"string=\077");
lf[106]=C_h_intern(&lf[106],16,"char-alphabetic\077");
lf[107]=C_h_intern(&lf[107],10,"string-ref");
lf[108]=C_h_intern(&lf[108],18,"string-intersperse");
lf[109]=C_decode_literal(C_heaptop,"\376B\000\000\001\134");
lf[110]=C_h_intern(&lf[110],17,"current-user-name");
lf[111]=C_h_intern(&lf[111],9,"condition");
lf[112]=C_decode_literal(C_heaptop,"\376B\000\000\003c:\134");
lf[113]=C_h_intern(&lf[113],22,"with-exception-handler");
lf[114]=C_h_intern(&lf[114],30,"call-with-current-continuation");
lf[115]=C_h_intern(&lf[115],14,"canonical-path");
lf[116]=C_decode_literal(C_heaptop,"\376B\000\000\000");
lf[117]=C_h_intern(&lf[117],7,"reverse");
lf[118]=C_decode_literal(C_heaptop,"\376B\000\000\001.");
lf[119]=C_decode_literal(C_heaptop,"\376B\000\000\002..");
lf[120]=C_h_intern(&lf[120],12,"string-split");
lf[121]=C_decode_literal(C_heaptop,"\376B\000\000\002/\134");
lf[122]=C_decode_literal(C_heaptop,"\376B\000\000\001\134");
lf[123]=C_decode_literal(C_heaptop,"\376B\000\000\001\134");
lf[124]=C_decode_literal(C_heaptop,"\376B\000\000\027Documents and Settings\134");
lf[125]=C_decode_literal(C_heaptop,"\376B\000\000\001\134");
lf[126]=C_decode_literal(C_heaptop,"\376B\000\000\001\134");
lf[127]=C_decode_literal(C_heaptop,"\376B\000\000\001\134");
lf[128]=C_h_intern(&lf[128],5,"\000text");
lf[129]=C_decode_literal(C_heaptop,"\376B\000\000#illegal input/output mode specifier");
lf[130]=C_decode_literal(C_heaptop,"\376B\000\000\020cannot open pipe");
lf[131]=C_h_intern(&lf[131],13,"\003sysmake-port");
lf[132]=C_h_intern(&lf[132],21,"\003sysstream-port-class");
lf[133]=C_decode_literal(C_heaptop,"\376B\000\000\006(pipe)");
lf[134]=C_h_intern(&lf[134],15,"open-input-pipe");
lf[135]=C_h_intern(&lf[135],7,"\000binary");
lf[136]=C_h_intern(&lf[136],16,"open-output-pipe");
lf[137]=C_h_intern(&lf[137],16,"close-input-pipe");
lf[138]=C_decode_literal(C_heaptop,"\376B\000\000\030error while closing pipe");
lf[139]=C_h_intern(&lf[139],14,"\003syscheck-port");
lf[140]=C_h_intern(&lf[140],17,"close-output-pipe");
lf[141]=C_h_intern(&lf[141],20,"call-with-input-pipe");
lf[142]=C_h_intern(&lf[142],21,"call-with-output-pipe");
lf[143]=C_h_intern(&lf[143],20,"with-input-from-pipe");
lf[144]=C_h_intern(&lf[144],18,"\003sysstandard-input");
lf[145]=C_h_intern(&lf[145],19,"with-output-to-pipe");
lf[146]=C_h_intern(&lf[146],19,"\003sysstandard-output");
lf[147]=C_h_intern(&lf[147],11,"create-pipe");
lf[148]=C_decode_literal(C_heaptop,"\376B\000\000\022cannot create pipe");
lf[149]=C_h_intern(&lf[149],11,"signal/term");
lf[150]=C_h_intern(&lf[150],10,"signal/int");
lf[151]=C_h_intern(&lf[151],10,"signal/fpe");
lf[152]=C_h_intern(&lf[152],10,"signal/ill");
lf[153]=C_h_intern(&lf[153],11,"signal/segv");
lf[154]=C_h_intern(&lf[154],11,"signal/abrt");
lf[155]=C_h_intern(&lf[155],12,"signal/break");
lf[156]=C_h_intern(&lf[156],11,"signal/alrm");
lf[157]=C_h_intern(&lf[157],11,"signal/chld");
lf[158]=C_h_intern(&lf[158],11,"signal/cont");
lf[159]=C_h_intern(&lf[159],10,"signal/hup");
lf[160]=C_h_intern(&lf[160],9,"signal/io");
lf[161]=C_h_intern(&lf[161],11,"signal/kill");
lf[162]=C_h_intern(&lf[162],11,"signal/pipe");
lf[163]=C_h_intern(&lf[163],11,"signal/prof");
lf[164]=C_h_intern(&lf[164],11,"signal/quit");
lf[165]=C_h_intern(&lf[165],11,"signal/stop");
lf[166]=C_h_intern(&lf[166],11,"signal/trap");
lf[167]=C_h_intern(&lf[167],11,"signal/tstp");
lf[168]=C_h_intern(&lf[168],10,"signal/urg");
lf[169]=C_h_intern(&lf[169],11,"signal/usr1");
lf[170]=C_h_intern(&lf[170],11,"signal/usr2");
lf[171]=C_h_intern(&lf[171],13,"signal/vtalrm");
lf[172]=C_h_intern(&lf[172],12,"signal/winch");
lf[173]=C_h_intern(&lf[173],11,"signal/xcpu");
lf[174]=C_h_intern(&lf[174],11,"signal/xfsz");
lf[175]=C_h_intern(&lf[175],12,"signals-list");
lf[176]=C_h_intern(&lf[176],18,"\003sysinterrupt-hook");
lf[177]=C_h_intern(&lf[177],14,"signal-handler");
lf[178]=C_h_intern(&lf[178],19,"set-signal-handler!");
lf[179]=C_h_intern(&lf[179],10,"errno/perm");
lf[180]=C_h_intern(&lf[180],11,"errno/noent");
lf[181]=C_h_intern(&lf[181],10,"errno/srch");
lf[182]=C_h_intern(&lf[182],10,"errno/intr");
lf[183]=C_h_intern(&lf[183],8,"errno/io");
lf[184]=C_h_intern(&lf[184],12,"errno/noexec");
lf[185]=C_h_intern(&lf[185],10,"errno/badf");
lf[186]=C_h_intern(&lf[186],11,"errno/child");
lf[187]=C_h_intern(&lf[187],11,"errno/nomem");
lf[188]=C_h_intern(&lf[188],11,"errno/acces");
lf[189]=C_h_intern(&lf[189],11,"errno/fault");
lf[190]=C_h_intern(&lf[190],10,"errno/busy");
lf[191]=C_h_intern(&lf[191],11,"errno/exist");
lf[192]=C_h_intern(&lf[192],12,"errno/notdir");
lf[193]=C_h_intern(&lf[193],11,"errno/isdir");
lf[194]=C_h_intern(&lf[194],11,"errno/inval");
lf[195]=C_h_intern(&lf[195],11,"errno/mfile");
lf[196]=C_h_intern(&lf[196],11,"errno/nospc");
lf[197]=C_h_intern(&lf[197],11,"errno/spipe");
lf[198]=C_h_intern(&lf[198],10,"errno/pipe");
lf[199]=C_h_intern(&lf[199],11,"errno/again");
lf[200]=C_h_intern(&lf[200],10,"errno/rofs");
lf[201]=C_h_intern(&lf[201],10,"errno/nxio");
lf[202]=C_h_intern(&lf[202],10,"errno/2big");
lf[203]=C_h_intern(&lf[203],10,"errno/xdev");
lf[204]=C_h_intern(&lf[204],11,"errno/nodev");
lf[205]=C_h_intern(&lf[205],11,"errno/nfile");
lf[206]=C_h_intern(&lf[206],11,"errno/notty");
lf[207]=C_h_intern(&lf[207],10,"errno/fbig");
lf[208]=C_h_intern(&lf[208],11,"errno/mlink");
lf[209]=C_h_intern(&lf[209],9,"errno/dom");
lf[210]=C_h_intern(&lf[210],11,"errno/range");
lf[211]=C_h_intern(&lf[211],12,"errno/deadlk");
lf[212]=C_h_intern(&lf[212],17,"errno/nametoolong");
lf[213]=C_h_intern(&lf[213],11,"errno/nolck");
lf[214]=C_h_intern(&lf[214],11,"errno/nosys");
lf[215]=C_h_intern(&lf[215],14,"errno/notempty");
lf[216]=C_h_intern(&lf[216],11,"errno/ilseq");
lf[217]=C_h_intern(&lf[217],16,"change-file-mode");
lf[218]=C_decode_literal(C_heaptop,"\376B\000\000\027cannot change file mode");
lf[219]=C_h_intern(&lf[219],17,"file-read-access\077");
lf[220]=C_h_intern(&lf[220],18,"file-write-access\077");
lf[221]=C_h_intern(&lf[221],20,"file-execute-access\077");
lf[222]=C_h_intern(&lf[222],12,"fileno/stdin");
lf[223]=C_h_intern(&lf[223],13,"fileno/stdout");
lf[224]=C_h_intern(&lf[224],13,"fileno/stderr");
lf[225]=C_h_intern(&lf[225],7,"\000append");
lf[226]=C_decode_literal(C_heaptop,"\376B\000\000\033invalid mode for input file");
lf[227]=C_decode_literal(C_heaptop,"\376B\000\000\001a");
lf[228]=C_decode_literal(C_heaptop,"\376B\000\000\025invalid mode argument");
lf[229]=C_decode_literal(C_heaptop,"\376B\000\000\001r");
lf[230]=C_decode_literal(C_heaptop,"\376B\000\000\001w");
lf[231]=C_decode_literal(C_heaptop,"\376B\000\000\020cannot open file");
lf[232]=C_decode_literal(C_heaptop,"\376B\000\000\010(fdport)");
lf[233]=C_h_intern(&lf[233],16,"open-input-file*");
lf[234]=C_h_intern(&lf[234],17,"open-output-file*");
lf[235]=C_h_intern(&lf[235],12,"port->fileno");
lf[236]=C_decode_literal(C_heaptop,"\376B\000\000\031port has no attached file");
lf[237]=C_decode_literal(C_heaptop,"\376B\000\000%cannot access file-descriptor of port");
lf[238]=C_h_intern(&lf[238],25,"\003syspeek-unsigned-integer");
lf[239]=C_h_intern(&lf[239],16,"duplicate-fileno");
lf[240]=C_decode_literal(C_heaptop,"\376B\000\000 cannot duplicate file descriptor");
lf[241]=C_h_intern(&lf[241],6,"setenv");
lf[242]=C_h_intern(&lf[242],8,"unsetenv");
lf[243]=C_h_intern(&lf[243],9,"substring");
lf[244]=C_h_intern(&lf[244],19,"current-environment");
lf[245]=C_h_intern(&lf[245],19,"seconds->local-time");
lf[246]=C_h_intern(&lf[246],18,"\003sysdecode-seconds");
lf[247]=C_h_intern(&lf[247],17,"seconds->utc-time");
lf[248]=C_h_intern(&lf[248],15,"seconds->string");
lf[249]=C_decode_literal(C_heaptop,"\376B\000\000 cannot convert seconds to string");
lf[250]=C_h_intern(&lf[250],12,"time->string");
lf[251]=C_decode_literal(C_heaptop,"\376B\000\000 time formatting overflows buffer");
lf[252]=C_decode_literal(C_heaptop,"\376B\000\000$cannot convert time vector to string");
lf[253]=C_decode_literal(C_heaptop,"\376B\000\000\025time vector too short");
lf[254]=C_h_intern(&lf[254],19,"local-time->seconds");
lf[255]=C_h_intern(&lf[255],15,"\003syscons-flonum");
lf[256]=C_decode_literal(C_heaptop,"\376B\000\000%cannot convert time vector to seconds");
lf[257]=C_decode_literal(C_heaptop,"\376B\000\000\025time vector too short");
lf[258]=C_h_intern(&lf[258],27,"local-timezone-abbreviation");
lf[259]=C_h_intern(&lf[259],5,"_exit");
lf[260]=C_h_intern(&lf[260],19,"set-buffering-mode!");
lf[261]=C_decode_literal(C_heaptop,"\376B\000\000\031cannot set buffering mode");
lf[262]=C_h_intern(&lf[262],5,"\000full");
lf[263]=C_h_intern(&lf[263],5,"\000line");
lf[264]=C_h_intern(&lf[264],5,"\000none");
lf[265]=C_decode_literal(C_heaptop,"\376B\000\000\026invalid buffering-mode");
lf[266]=C_h_intern(&lf[266],6,"regexp");
lf[267]=C_h_intern(&lf[267],21,"make-anchored-pattern");
lf[268]=C_h_intern(&lf[268],12,"string-match");
lf[269]=C_h_intern(&lf[269],12,"glob->regexp");
lf[270]=C_h_intern(&lf[270],13,"make-pathname");
lf[271]=C_h_intern(&lf[271],18,"decompose-pathname");
lf[272]=C_h_intern(&lf[272],4,"glob");
lf[273]=C_decode_literal(C_heaptop,"\376B\000\000\001.");
lf[274]=C_decode_literal(C_heaptop,"\376B\000\000\001*");
lf[275]=C_h_intern(&lf[275],13,"spawn/overlay");
lf[276]=C_h_intern(&lf[276],10,"spawn/wait");
lf[277]=C_h_intern(&lf[277],12,"spawn/nowait");
lf[278]=C_h_intern(&lf[278],13,"spawn/nowaito");
lf[279]=C_h_intern(&lf[279],12,"spawn/detach");
lf[280]=C_h_intern(&lf[280],16,"char-whitespace\077");
lf[282]=C_decode_literal(C_heaptop,"\376B\000\000\001\042");
lf[283]=C_decode_literal(C_heaptop,"\376B\000\000\001\042");
lf[284]=C_h_intern(&lf[284],24,"pathname-strip-directory");
lf[287]=C_h_intern(&lf[287],15,"process-execute");
lf[288]=C_decode_literal(C_heaptop,"\376B\000\000\026cannot execute process");
lf[289]=C_h_intern(&lf[289],13,"process-spawn");
lf[290]=C_decode_literal(C_heaptop,"\376B\000\000\024cannot spawn process");
lf[291]=C_h_intern(&lf[291],18,"current-process-id");
lf[292]=C_h_intern(&lf[292],17,"\003sysshell-command");
lf[293]=C_decode_literal(C_heaptop,"\376B\000\000 cannot retrieve system directory");
lf[294]=C_h_intern(&lf[294],6,"getenv");
lf[295]=C_decode_literal(C_heaptop,"\376B\000\000\007COMSPEC");
lf[296]=C_h_intern(&lf[296],27,"\003sysshell-command-arguments");
lf[297]=C_decode_literal(C_heaptop,"\376B\000\000\002/c");
lf[298]=C_h_intern(&lf[298],11,"process-run");
lf[300]=C_h_intern(&lf[300],11,"\003sysprocess");
lf[301]=C_h_intern(&lf[301],14,"\000process-error");
lf[302]=C_decode_literal(C_heaptop,"\376B\000\000\026cannot execute process");
lf[303]=C_h_intern(&lf[303],17,"\003sysmake-locative");
lf[304]=C_h_intern(&lf[304],8,"location");
lf[305]=C_h_intern(&lf[305],12,"\003sysfor-each");
lf[306]=C_h_intern(&lf[306],7,"process");
lf[307]=C_h_intern(&lf[307],8,"process*");
lf[308]=C_h_intern(&lf[308],16,"\003sysprocess-wait");
lf[309]=C_h_intern(&lf[309],12,"process-wait");
lf[310]=C_decode_literal(C_heaptop,"\376B\000\000 waiting for child process failed");
lf[311]=C_h_intern(&lf[311],5,"sleep");
lf[312]=C_h_intern(&lf[312],13,"get-host-name");
lf[313]=C_decode_literal(C_heaptop,"\376B\000\000\031cannot retrieve host-name");
lf[314]=C_h_intern(&lf[314],18,"system-information");
lf[315]=C_decode_literal(C_heaptop,"\376B\000\000\007windows");
lf[316]=C_decode_literal(C_heaptop,"\376B\000\000\042cannot retrieve system-information");
lf[317]=C_decode_literal(C_heaptop,"\376B\000\000!cannot retrieve current user-name");
lf[318]=C_h_intern(&lf[318],10,"find-files");
lf[319]=C_decode_literal(C_heaptop,"\376B\000\000\001.");
lf[320]=C_decode_literal(C_heaptop,"\376B\000\000\002..");
lf[321]=C_h_intern(&lf[321],19,"\003sysundefined-value");
lf[322]=C_decode_literal(C_heaptop,"\376B\000\000\001*");
lf[323]=C_h_intern(&lf[323],16,"\003sysdynamic-wind");
lf[324]=C_h_intern(&lf[324],13,"pathname-file");
lf[325]=C_decode_literal(C_heaptop,"\376B\000\000\001*");
lf[326]=C_h_intern(&lf[326],17,"change-file-owner");
lf[327]=C_h_intern(&lf[327],5,"error");
lf[328]=C_h_intern(&lf[328],11,"create-fifo");
lf[329]=C_h_intern(&lf[329],14,"create-session");
lf[330]=C_h_intern(&lf[330],20,"create-symbolic-link");
lf[331]=C_h_intern(&lf[331],26,"current-effective-group-id");
lf[332]=C_h_intern(&lf[332],25,"current-effective-user-id");
lf[333]=C_h_intern(&lf[333],27,"current-effective-user-name");
lf[334]=C_h_intern(&lf[334],16,"current-group-id");
lf[335]=C_h_intern(&lf[335],15,"current-user-id");
lf[336]=C_h_intern(&lf[336],18,"map-file-to-memory");
lf[337]=C_h_intern(&lf[337],9,"file-link");
lf[338]=C_h_intern(&lf[338],9,"file-lock");
lf[339]=C_h_intern(&lf[339],18,"file-lock/blocking");
lf[340]=C_h_intern(&lf[340],11,"file-select");
lf[341]=C_h_intern(&lf[341],14,"file-test-lock");
lf[342]=C_h_intern(&lf[342],13,"file-truncate");
lf[343]=C_h_intern(&lf[343],11,"file-unlock");
lf[344]=C_h_intern(&lf[344],10,"get-groups");
lf[345]=C_h_intern(&lf[345],17,"group-information");
lf[346]=C_h_intern(&lf[346],17,"initialize-groups");
lf[347]=C_h_intern(&lf[347],26,"memory-mapped-file-pointer");
lf[348]=C_h_intern(&lf[348],17,"parent-process-id");
lf[349]=C_h_intern(&lf[349],12,"process-fork");
lf[350]=C_h_intern(&lf[350],16,"process-group-id");
lf[351]=C_h_intern(&lf[351],14,"process-signal");
lf[352]=C_h_intern(&lf[352],18,"read-symbolic-link");
lf[353]=C_h_intern(&lf[353],10,"set-alarm!");
lf[354]=C_h_intern(&lf[354],13,"set-group-id!");
lf[355]=C_h_intern(&lf[355],11,"set-groups!");
lf[356]=C_h_intern(&lf[356],21,"set-process-group-id!");
lf[357]=C_h_intern(&lf[357],19,"set-root-directory!");
lf[358]=C_h_intern(&lf[358],16,"set-signal-mask!");
lf[359]=C_h_intern(&lf[359],12,"set-user-id!");
lf[360]=C_h_intern(&lf[360],11,"signal-mask");
lf[361]=C_h_intern(&lf[361],12,"signal-mask!");
lf[362]=C_h_intern(&lf[362],14,"signal-masked\077");
lf[363]=C_h_intern(&lf[363],14,"signal-unmask!");
lf[364]=C_h_intern(&lf[364],13,"terminal-name");
lf[365]=C_h_intern(&lf[365],14,"terminal-port\077");
lf[366]=C_h_intern(&lf[366],13,"terminal-size");
lf[367]=C_h_intern(&lf[367],22,"unmap-file-from-memory");
lf[368]=C_h_intern(&lf[368],16,"user-information");
lf[369]=C_h_intern(&lf[369],17,"utc-time->seconds");
lf[370]=C_h_intern(&lf[370],12,"string->time");
lf[371]=C_h_intern(&lf[371],16,"errno/wouldblock");
lf[372]=C_h_intern(&lf[372],5,"fifo\077");
lf[373]=C_h_intern(&lf[373],19,"memory-mapped-file\077");
lf[374]=C_h_intern(&lf[374],13,"map/anonymous");
lf[375]=C_h_intern(&lf[375],8,"map/file");
lf[376]=C_h_intern(&lf[376],9,"map/fixed");
lf[377]=C_h_intern(&lf[377],11,"map/private");
lf[378]=C_h_intern(&lf[378],10,"map/shared");
lf[379]=C_h_intern(&lf[379],10,"open/fsync");
lf[380]=C_h_intern(&lf[380],11,"open/noctty");
lf[381]=C_h_intern(&lf[381],13,"open/nonblock");
lf[382]=C_h_intern(&lf[382],9,"open/sync");
lf[383]=C_h_intern(&lf[383],10,"perm/isgid");
lf[384]=C_h_intern(&lf[384],10,"perm/isuid");
lf[385]=C_h_intern(&lf[385],10,"perm/isvtx");
lf[386]=C_h_intern(&lf[386],9,"prot/exec");
lf[387]=C_h_intern(&lf[387],9,"prot/none");
lf[388]=C_h_intern(&lf[388],9,"prot/read");
lf[389]=C_h_intern(&lf[389],10,"prot/write");
lf[390]=C_h_intern(&lf[390],11,"make-vector");
lf[391]=C_h_intern(&lf[391],17,"register-feature!");
lf[392]=C_h_intern(&lf[392],5,"posix");
C_register_lf2(lf,393,create_ptable());
t2=C_mutate(&lf[0],lf[1]);
t3=C_mutate(&lf[2],lf[3]);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1121,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
C_scheduler_toplevel(2,C_SCHEME_UNDEFINED,t4);}

/* k1119 */
static void C_ccall f_1121(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[3],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1121,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1124,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
C_regex_toplevel(2,C_SCHEME_UNDEFINED,t2);}

/* k1122 in k1119 */
static void C_ccall f_1124(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[3],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1124,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1127,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
C_extras_toplevel(2,C_SCHEME_UNDEFINED,t2);}

/* k1125 in k1122 in k1119 */
static void C_ccall f_1127(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[3],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1127,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1130,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
C_utils_toplevel(2,C_SCHEME_UNDEFINED,t2);}

/* k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1130(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[3],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1130,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1133,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm: 944  register-feature! */
t3=*((C_word*)lf[391]+1);
((C_proc3)C_retrieve_proc(t3))(3,t3,t2,lf[392]);}

/* k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1133(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word t21;
C_word t22;
C_word t23;
C_word t24;
C_word t25;
C_word t26;
C_word t27;
C_word t28;
C_word t29;
C_word t30;
C_word t31;
C_word t32;
C_word t33;
C_word t34;
C_word t35;
C_word t36;
C_word t37;
C_word t38;
C_word t39;
C_word t40;
C_word t41;
C_word t42;
C_word t43;
C_word t44;
C_word t45;
C_word t46;
C_word t47;
C_word t48;
C_word t49;
C_word t50;
C_word t51;
C_word t52;
C_word t53;
C_word t54;
C_word t55;
C_word ab[63],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1133,2,t0,t1);}
t2=*((C_word*)lf[4]+1);
t3=C_mutate(&lf[5],(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1145,a[2]=t2,a[3]=((C_word)li0),tmp=(C_word)a,a+=4,tmp));
t4=C_mutate((C_word*)lf[10]+1,lf[5]);
t5=C_mutate((C_word*)lf[11]+1,C_fix((C_word)PIPE_BUF));
t6=C_mutate((C_word*)lf[12]+1,C_fix((C_word)O_RDONLY));
t7=C_mutate((C_word*)lf[13]+1,C_fix((C_word)O_WRONLY));
t8=C_mutate((C_word*)lf[14]+1,C_fix((C_word)O_RDWR));
t9=C_mutate((C_word*)lf[15]+1,C_fix((C_word)O_RDWR));
t10=C_mutate((C_word*)lf[16]+1,C_fix((C_word)O_WRONLY));
t11=C_mutate((C_word*)lf[17]+1,C_fix((C_word)O_CREAT));
t12=C_mutate((C_word*)lf[18]+1,C_fix((C_word)O_APPEND));
t13=C_mutate((C_word*)lf[19]+1,C_fix((C_word)O_EXCL));
t14=C_mutate((C_word*)lf[20]+1,C_fix((C_word)O_TRUNC));
t15=C_mutate((C_word*)lf[21]+1,C_fix((C_word)O_BINARY));
t16=C_mutate((C_word*)lf[22]+1,C_fix((C_word)O_TEXT));
t17=C_mutate((C_word*)lf[23]+1,C_fix((C_word)O_NOINHERIT));
t18=C_mutate((C_word*)lf[24]+1,C_fix((C_word)S_IREAD));
t19=C_mutate((C_word*)lf[25]+1,C_fix((C_word)S_IWRITE));
t20=C_mutate((C_word*)lf[26]+1,C_fix((C_word)S_IEXEC));
t21=C_mutate((C_word*)lf[27]+1,C_fix((C_word)S_IREAD));
t22=C_mutate((C_word*)lf[28]+1,C_fix((C_word)S_IWRITE));
t23=C_mutate((C_word*)lf[29]+1,C_fix((C_word)S_IEXEC));
t24=C_mutate((C_word*)lf[30]+1,C_fix((C_word)S_IREAD));
t25=C_mutate((C_word*)lf[31]+1,C_fix((C_word)S_IWRITE));
t26=C_mutate((C_word*)lf[32]+1,C_fix((C_word)S_IEXEC));
t27=C_mutate((C_word*)lf[33]+1,C_fix((C_word)S_IREAD | S_IWRITE | S_IEXEC));
t28=C_mutate((C_word*)lf[34]+1,C_fix((C_word)S_IREAD | S_IWRITE | S_IEXEC));
t29=C_mutate((C_word*)lf[35]+1,C_fix((C_word)S_IREAD | S_IWRITE | S_IEXEC));
t30=(C_word)C_fixnum_or(C_fix((C_word)S_IREAD),C_fix((C_word)S_IREAD));
t31=(C_word)C_a_i_bitwise_ior(&a,2,C_fix((C_word)S_IREAD | S_IWRITE | S_IEXEC),t30);
t32=C_mutate((C_word*)lf[36]+1,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1191,a[2]=t31,a[3]=((C_word)li1),tmp=(C_word)a,a+=4,tmp));
t33=C_mutate((C_word*)lf[41]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1232,a[2]=((C_word)li2),tmp=(C_word)a,a+=3,tmp));
t34=*((C_word*)lf[43]+1);
t35=C_mutate((C_word*)lf[44]+1,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1250,a[2]=t34,a[3]=((C_word)li3),tmp=(C_word)a,a+=4,tmp));
t36=C_mutate((C_word*)lf[48]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1295,a[2]=((C_word)li4),tmp=(C_word)a,a+=3,tmp));
t37=*((C_word*)lf[51]+1);
t38=C_mutate((C_word*)lf[52]+1,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1337,a[2]=t37,a[3]=((C_word)li5),tmp=(C_word)a,a+=4,tmp));
t39=C_mutate((C_word*)lf[55]+1,C_fix((C_word)SEEK_SET));
t40=C_mutate((C_word*)lf[56]+1,C_fix((C_word)SEEK_END));
t41=C_mutate((C_word*)lf[57]+1,C_fix((C_word)SEEK_CUR));
t42=C_mutate(&lf[58],(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1375,a[2]=((C_word)li6),tmp=(C_word)a,a+=3,tmp));
t43=C_mutate((C_word*)lf[61]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1413,a[2]=((C_word)li7),tmp=(C_word)a,a+=3,tmp));
t44=C_mutate((C_word*)lf[63]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1444,a[2]=((C_word)li8),tmp=(C_word)a,a+=3,tmp));
t45=C_mutate((C_word*)lf[64]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1450,a[2]=((C_word)li9),tmp=(C_word)a,a+=3,tmp));
t46=C_mutate((C_word*)lf[65]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1456,a[2]=((C_word)li10),tmp=(C_word)a,a+=3,tmp));
t47=C_mutate((C_word*)lf[66]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1462,a[2]=((C_word)li11),tmp=(C_word)a,a+=3,tmp));
t48=C_mutate((C_word*)lf[67]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1468,a[2]=((C_word)li12),tmp=(C_word)a,a+=3,tmp));
t49=C_mutate((C_word*)lf[68]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1474,a[2]=((C_word)li13),tmp=(C_word)a,a+=3,tmp));
t50=C_mutate((C_word*)lf[69]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1480,a[2]=((C_word)li14),tmp=(C_word)a,a+=3,tmp));
t51=C_mutate((C_word*)lf[71]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1503,a[2]=((C_word)li15),tmp=(C_word)a,a+=3,tmp));
t52=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1508,a[2]=((C_word)li17),tmp=(C_word)a,a+=3,tmp);
t53=C_mutate((C_word*)lf[72]+1,*((C_word*)lf[69]+1));
t54=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1519,a[2]=t52,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1129 stat-type */
f_1508(t54,lf[73]);}

/* k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1519(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1519,2,t0,t1);}
t2=C_mutate((C_word*)lf[73]+1,t1);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1523,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1130 stat-type */
f_1508(t3,lf[74]);}

/* k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1523(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1523,2,t0,t1);}
t2=C_mutate((C_word*)lf[74]+1,t1);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1527,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1131 stat-type */
f_1508(t3,lf[75]);}

/* k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1527(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1527,2,t0,t1);}
t2=C_mutate((C_word*)lf[75]+1,t1);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1531,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1132 stat-type */
f_1508(t3,lf[76]);}

/* k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1531(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1531,2,t0,t1);}
t2=C_mutate((C_word*)lf[76]+1,t1);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1535,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1133 stat-type */
f_1508(t3,lf[77]);}

/* k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1535(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[3],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1535,2,t0,t1);}
t2=C_mutate((C_word*)lf[77]+1,t1);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1539,a[2]=((C_word*)t0)[3],tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm: 1134 stat-type */
f_1508(t3,lf[78]);}

/* k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1539(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word t21;
C_word t22;
C_word t23;
C_word t24;
C_word t25;
C_word t26;
C_word t27;
C_word t28;
C_word t29;
C_word t30;
C_word t31;
C_word t32;
C_word t33;
C_word t34;
C_word t35;
C_word t36;
C_word t37;
C_word t38;
C_word t39;
C_word t40;
C_word t41;
C_word t42;
C_word t43;
C_word t44;
C_word t45;
C_word t46;
C_word t47;
C_word t48;
C_word t49;
C_word t50;
C_word t51;
C_word t52;
C_word t53;
C_word t54;
C_word t55;
C_word t56;
C_word t57;
C_word t58;
C_word t59;
C_word t60;
C_word t61;
C_word t62;
C_word t63;
C_word t64;
C_word t65;
C_word t66;
C_word t67;
C_word t68;
C_word t69;
C_word t70;
C_word t71;
C_word t72;
C_word t73;
C_word ab[121],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1539,2,t0,t1);}
t2=C_mutate((C_word*)lf[78]+1,t1);
t3=C_mutate((C_word*)lf[79]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1541,a[2]=((C_word)li18),tmp=(C_word)a,a+=3,tmp));
t4=C_mutate((C_word*)lf[84]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1581,a[2]=((C_word)li19),tmp=(C_word)a,a+=3,tmp));
t5=C_mutate((C_word*)lf[89]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1642,a[2]=((C_word)li20),tmp=(C_word)a,a+=3,tmp));
t6=C_mutate((C_word*)lf[91]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1669,a[2]=((C_word)li21),tmp=(C_word)a,a+=3,tmp));
t7=C_mutate((C_word*)lf[93]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1696,a[2]=((C_word)li22),tmp=(C_word)a,a+=3,tmp));
t8=*((C_word*)lf[4]+1);
t9=*((C_word*)lf[43]+1);
t10=*((C_word*)lf[95]+1);
t11=C_mutate((C_word*)lf[96]+1,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1723,a[2]=t9,a[3]=((C_word)li27),tmp=(C_word)a,a+=4,tmp));
t12=C_mutate((C_word*)lf[100]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1883,a[2]=((C_word)li28),tmp=(C_word)a,a+=3,tmp));
t13=*((C_word*)lf[43]+1);
t14=C_mutate((C_word*)lf[99]+1,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1910,a[2]=t13,a[3]=((C_word)li29),tmp=(C_word)a,a+=4,tmp));
t15=*((C_word*)lf[103]+1);
t16=*((C_word*)lf[104]+1);
t17=*((C_word*)lf[105]+1);
t18=*((C_word*)lf[106]+1);
t19=*((C_word*)lf[107]+1);
t20=*((C_word*)lf[4]+1);
t21=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1961,a[2]=((C_word)li30),tmp=(C_word)a,a+=3,tmp);
t22=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1966,a[2]=((C_word)li31),tmp=(C_word)a,a+=3,tmp);
t23=*((C_word*)lf[110]+1);
t24=*((C_word*)lf[99]+1);
t25=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1977,a[2]=t24,a[3]=((C_word)li39),tmp=(C_word)a,a+=4,tmp);
t26=C_mutate((C_word*)lf[115]+1,(*a=C_CLOSURE_TYPE|12,a[1]=(C_word)f_2033,a[2]=t18,a[3]=t16,a[4]=t23,a[5]=t25,a[6]=t17,a[7]=t15,a[8]=t19,a[9]=t21,a[10]=t20,a[11]=t22,a[12]=((C_word)li41),tmp=(C_word)a,a+=13,tmp));
t27=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2390,a[2]=((C_word)li42),tmp=(C_word)a,a+=3,tmp);
t28=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2402,a[2]=((C_word)li43),tmp=(C_word)a,a+=3,tmp);
t29=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2408,a[2]=((C_word)li44),tmp=(C_word)a,a+=3,tmp);
t30=C_mutate((C_word*)lf[134]+1,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2426,a[2]=t28,a[3]=t29,a[4]=t27,a[5]=((C_word)li45),tmp=(C_word)a,a+=6,tmp));
t31=C_mutate((C_word*)lf[136]+1,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2462,a[2]=t28,a[3]=t29,a[4]=t27,a[5]=((C_word)li46),tmp=(C_word)a,a+=6,tmp));
t32=C_mutate((C_word*)lf[137]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2498,a[2]=((C_word)li47),tmp=(C_word)a,a+=3,tmp));
t33=C_mutate((C_word*)lf[140]+1,*((C_word*)lf[137]+1));
t34=*((C_word*)lf[134]+1);
t35=*((C_word*)lf[136]+1);
t36=*((C_word*)lf[137]+1);
t37=*((C_word*)lf[140]+1);
t38=C_mutate((C_word*)lf[141]+1,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2517,a[2]=t34,a[3]=t36,a[4]=((C_word)li50),tmp=(C_word)a,a+=5,tmp));
t39=C_mutate((C_word*)lf[142]+1,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2541,a[2]=t35,a[3]=t37,a[4]=((C_word)li53),tmp=(C_word)a,a+=5,tmp));
t40=C_mutate((C_word*)lf[143]+1,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2565,a[2]=t34,a[3]=t36,a[4]=((C_word)li55),tmp=(C_word)a,a+=5,tmp));
t41=C_mutate((C_word*)lf[145]+1,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2585,a[2]=t35,a[3]=t37,a[4]=((C_word)li57),tmp=(C_word)a,a+=5,tmp));
t42=C_mutate((C_word*)lf[147]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2605,a[2]=((C_word)li58),tmp=(C_word)a,a+=3,tmp));
t43=C_mutate((C_word*)lf[149]+1,C_fix((C_word)SIGTERM));
t44=C_mutate((C_word*)lf[150]+1,C_fix((C_word)SIGINT));
t45=C_mutate((C_word*)lf[151]+1,C_fix((C_word)SIGFPE));
t46=C_mutate((C_word*)lf[152]+1,C_fix((C_word)SIGILL));
t47=C_mutate((C_word*)lf[153]+1,C_fix((C_word)SIGSEGV));
t48=C_mutate((C_word*)lf[154]+1,C_fix((C_word)SIGABRT));
t49=C_mutate((C_word*)lf[155]+1,C_fix((C_word)SIGBREAK));
t50=C_set_block_item(lf[156],0,C_fix(0));
t51=C_set_block_item(lf[157],0,C_fix(0));
t52=C_set_block_item(lf[158],0,C_fix(0));
t53=C_set_block_item(lf[159],0,C_fix(0));
t54=C_set_block_item(lf[160],0,C_fix(0));
t55=C_set_block_item(lf[161],0,C_fix(0));
t56=C_set_block_item(lf[162],0,C_fix(0));
t57=C_set_block_item(lf[163],0,C_fix(0));
t58=C_set_block_item(lf[164],0,C_fix(0));
t59=C_set_block_item(lf[165],0,C_fix(0));
t60=C_set_block_item(lf[166],0,C_fix(0));
t61=C_set_block_item(lf[167],0,C_fix(0));
t62=C_set_block_item(lf[168],0,C_fix(0));
t63=C_set_block_item(lf[169],0,C_fix(0));
t64=C_set_block_item(lf[170],0,C_fix(0));
t65=C_set_block_item(lf[171],0,C_fix(0));
t66=C_set_block_item(lf[172],0,C_fix(0));
t67=C_set_block_item(lf[173],0,C_fix(0));
t68=C_set_block_item(lf[174],0,C_fix(0));
t69=(C_word)C_a_i_list(&a,7,*((C_word*)lf[149]+1),*((C_word*)lf[150]+1),*((C_word*)lf[151]+1),*((C_word*)lf[152]+1),*((C_word*)lf[153]+1),*((C_word*)lf[154]+1),*((C_word*)lf[155]+1));
t70=C_mutate((C_word*)lf[175]+1,t69);
t71=*((C_word*)lf[176]+1);
t72=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2679,a[2]=((C_word*)t0)[2],a[3]=t71,tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1450 make-vector */
t73=*((C_word*)lf[390]+1);
((C_proc4)(void*)(*((C_word*)t73+1)))(4,t73,t72,C_fix(256),C_SCHEME_FALSE);}

/* k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2679(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word t17;
C_word t18;
C_word t19;
C_word t20;
C_word t21;
C_word t22;
C_word t23;
C_word t24;
C_word t25;
C_word t26;
C_word t27;
C_word t28;
C_word t29;
C_word t30;
C_word t31;
C_word t32;
C_word t33;
C_word t34;
C_word t35;
C_word t36;
C_word t37;
C_word t38;
C_word t39;
C_word t40;
C_word t41;
C_word t42;
C_word t43;
C_word t44;
C_word t45;
C_word t46;
C_word t47;
C_word t48;
C_word t49;
C_word t50;
C_word t51;
C_word t52;
C_word t53;
C_word t54;
C_word t55;
C_word t56;
C_word t57;
C_word t58;
C_word t59;
C_word t60;
C_word t61;
C_word t62;
C_word t63;
C_word t64;
C_word t65;
C_word t66;
C_word t67;
C_word t68;
C_word t69;
C_word t70;
C_word t71;
C_word t72;
C_word t73;
C_word t74;
C_word t75;
C_word t76;
C_word t77;
C_word t78;
C_word t79;
C_word t80;
C_word t81;
C_word t82;
C_word t83;
C_word t84;
C_word t85;
C_word t86;
C_word t87;
C_word t88;
C_word t89;
C_word t90;
C_word t91;
C_word t92;
C_word t93;
C_word t94;
C_word t95;
C_word t96;
C_word t97;
C_word t98;
C_word t99;
C_word t100;
C_word t101;
C_word t102;
C_word t103;
C_word t104;
C_word t105;
C_word t106;
C_word t107;
C_word t108;
C_word t109;
C_word t110;
C_word t111;
C_word t112;
C_word t113;
C_word t114;
C_word t115;
C_word t116;
C_word t117;
C_word t118;
C_word t119;
C_word t120;
C_word t121;
C_word t122;
C_word t123;
C_word t124;
C_word t125;
C_word t126;
C_word t127;
C_word t128;
C_word t129;
C_word t130;
C_word t131;
C_word t132;
C_word t133;
C_word t134;
C_word t135;
C_word t136;
C_word t137;
C_word t138;
C_word t139;
C_word t140;
C_word t141;
C_word t142;
C_word t143;
C_word t144;
C_word t145;
C_word t146;
C_word t147;
C_word t148;
C_word t149;
C_word t150;
C_word t151;
C_word t152;
C_word t153;
C_word t154;
C_word t155;
C_word t156;
C_word t157;
C_word t158;
C_word t159;
C_word t160;
C_word t161;
C_word t162;
C_word t163;
C_word t164;
C_word t165;
C_word t166;
C_word t167;
C_word t168;
C_word t169;
C_word t170;
C_word t171;
C_word t172;
C_word t173;
C_word t174;
C_word t175;
C_word t176;
C_word t177;
C_word t178;
C_word t179;
C_word t180;
C_word ab[322],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2679,2,t0,t1);}
t2=C_mutate((C_word*)lf[177]+1,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2681,a[2]=t1,a[3]=((C_word)li59),tmp=(C_word)a,a+=4,tmp));
t3=C_mutate((C_word*)lf[178]+1,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2690,a[2]=t1,a[3]=((C_word)li60),tmp=(C_word)a,a+=4,tmp));
t4=C_mutate((C_word*)lf[176]+1,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2703,a[2]=((C_word*)t0)[3],a[3]=t1,a[4]=((C_word)li61),tmp=(C_word)a,a+=5,tmp));
t5=C_mutate((C_word*)lf[179]+1,C_fix((C_word)EPERM));
t6=C_mutate((C_word*)lf[180]+1,C_fix((C_word)ENOENT));
t7=C_mutate((C_word*)lf[181]+1,C_fix((C_word)ESRCH));
t8=C_mutate((C_word*)lf[182]+1,C_fix((C_word)EINTR));
t9=C_mutate((C_word*)lf[183]+1,C_fix((C_word)EIO));
t10=C_mutate((C_word*)lf[184]+1,C_fix((C_word)ENOEXEC));
t11=C_mutate((C_word*)lf[185]+1,C_fix((C_word)EBADF));
t12=C_mutate((C_word*)lf[186]+1,C_fix((C_word)ECHILD));
t13=C_mutate((C_word*)lf[187]+1,C_fix((C_word)ENOMEM));
t14=C_mutate((C_word*)lf[188]+1,C_fix((C_word)EACCES));
t15=C_mutate((C_word*)lf[189]+1,C_fix((C_word)EFAULT));
t16=C_mutate((C_word*)lf[190]+1,C_fix((C_word)EBUSY));
t17=C_mutate((C_word*)lf[191]+1,C_fix((C_word)EEXIST));
t18=C_mutate((C_word*)lf[192]+1,C_fix((C_word)ENOTDIR));
t19=C_mutate((C_word*)lf[193]+1,C_fix((C_word)EISDIR));
t20=C_mutate((C_word*)lf[194]+1,C_fix((C_word)EINVAL));
t21=C_mutate((C_word*)lf[195]+1,C_fix((C_word)EMFILE));
t22=C_mutate((C_word*)lf[196]+1,C_fix((C_word)ENOSPC));
t23=C_mutate((C_word*)lf[197]+1,C_fix((C_word)ESPIPE));
t24=C_mutate((C_word*)lf[198]+1,C_fix((C_word)EPIPE));
t25=C_mutate((C_word*)lf[199]+1,C_fix((C_word)EAGAIN));
t26=C_mutate((C_word*)lf[200]+1,C_fix((C_word)EROFS));
t27=C_mutate((C_word*)lf[201]+1,C_fix((C_word)ENXIO));
t28=C_mutate((C_word*)lf[202]+1,C_fix((C_word)E2BIG));
t29=C_mutate((C_word*)lf[203]+1,C_fix((C_word)EXDEV));
t30=C_mutate((C_word*)lf[204]+1,C_fix((C_word)ENODEV));
t31=C_mutate((C_word*)lf[205]+1,C_fix((C_word)ENFILE));
t32=C_mutate((C_word*)lf[206]+1,C_fix((C_word)ENOTTY));
t33=C_mutate((C_word*)lf[207]+1,C_fix((C_word)EFBIG));
t34=C_mutate((C_word*)lf[208]+1,C_fix((C_word)EMLINK));
t35=C_mutate((C_word*)lf[209]+1,C_fix((C_word)EDOM));
t36=C_mutate((C_word*)lf[210]+1,C_fix((C_word)ERANGE));
t37=C_mutate((C_word*)lf[211]+1,C_fix((C_word)EDEADLK));
t38=C_mutate((C_word*)lf[212]+1,C_fix((C_word)ENAMETOOLONG));
t39=C_mutate((C_word*)lf[213]+1,C_fix((C_word)ENOLCK));
t40=C_mutate((C_word*)lf[214]+1,C_fix((C_word)ENOSYS));
t41=C_mutate((C_word*)lf[215]+1,C_fix((C_word)ENOTEMPTY));
t42=C_mutate((C_word*)lf[216]+1,C_fix((C_word)EILSEQ));
t43=C_mutate((C_word*)lf[217]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2759,a[2]=((C_word)li62),tmp=(C_word)a,a+=3,tmp));
t44=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2789,a[2]=((C_word)li63),tmp=(C_word)a,a+=3,tmp);
t45=C_mutate((C_word*)lf[219]+1,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2813,a[2]=t44,a[3]=((C_word)li64),tmp=(C_word)a,a+=4,tmp));
t46=C_mutate((C_word*)lf[220]+1,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2819,a[2]=t44,a[3]=((C_word)li65),tmp=(C_word)a,a+=4,tmp));
t47=C_mutate((C_word*)lf[221]+1,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2825,a[2]=t44,a[3]=((C_word)li66),tmp=(C_word)a,a+=4,tmp));
t48=C_mutate((C_word*)lf[222]+1,C_fix((C_word)0));
t49=C_mutate((C_word*)lf[223]+1,C_fix((C_word)1));
t50=C_mutate((C_word*)lf[224]+1,C_fix((C_word)2));
t51=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2834,a[2]=((C_word)li67),tmp=(C_word)a,a+=3,tmp);
t52=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2871,a[2]=((C_word)li68),tmp=(C_word)a,a+=3,tmp);
t53=C_mutate((C_word*)lf[233]+1,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2889,a[2]=t51,a[3]=t52,a[4]=((C_word)li69),tmp=(C_word)a,a+=5,tmp));
t54=C_mutate((C_word*)lf[234]+1,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2903,a[2]=t51,a[3]=t52,a[4]=((C_word)li70),tmp=(C_word)a,a+=5,tmp));
t55=C_mutate((C_word*)lf[235]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2917,a[2]=((C_word)li71),tmp=(C_word)a,a+=3,tmp));
t56=C_mutate((C_word*)lf[239]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2952,a[2]=((C_word)li72),tmp=(C_word)a,a+=3,tmp));
t57=C_mutate((C_word*)lf[241]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2982,a[2]=((C_word)li73),tmp=(C_word)a,a+=3,tmp));
t58=C_mutate((C_word*)lf[242]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2999,a[2]=((C_word)li74),tmp=(C_word)a,a+=3,tmp));
t59=*((C_word*)lf[243]+1);
t60=C_mutate((C_word*)lf[244]+1,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3019,a[2]=t59,a[3]=((C_word)li77),tmp=(C_word)a,a+=4,tmp));
t61=C_mutate((C_word*)lf[245]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3084,a[2]=((C_word)li78),tmp=(C_word)a,a+=3,tmp));
t62=C_mutate((C_word*)lf[247]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3093,a[2]=((C_word)li79),tmp=(C_word)a,a+=3,tmp));
t63=C_mutate((C_word*)lf[248]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3112,a[2]=((C_word)li80),tmp=(C_word)a,a+=3,tmp));
t64=C_mutate((C_word*)lf[250]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3145,a[2]=((C_word)li81),tmp=(C_word)a,a+=3,tmp));
t65=C_mutate((C_word*)lf[254]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3225,a[2]=((C_word)li82),tmp=(C_word)a,a+=3,tmp));
t66=C_mutate((C_word*)lf[258]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3253,a[2]=((C_word)li83),tmp=(C_word)a,a+=3,tmp));
t67=C_mutate((C_word*)lf[259]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3265,a[2]=((C_word)li84),tmp=(C_word)a,a+=3,tmp));
t68=C_mutate((C_word*)lf[260]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3281,a[2]=((C_word)li85),tmp=(C_word)a,a+=3,tmp));
t69=*((C_word*)lf[266]+1);
t70=*((C_word*)lf[267]+1);
t71=*((C_word*)lf[268]+1);
t72=*((C_word*)lf[269]+1);
t73=*((C_word*)lf[96]+1);
t74=*((C_word*)lf[270]+1);
t75=*((C_word*)lf[271]+1);
t76=C_mutate((C_word*)lf[272]+1,(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_3340,a[2]=t72,a[3]=t70,a[4]=t69,a[5]=t73,a[6]=t71,a[7]=t74,a[8]=t75,a[9]=((C_word)li90),tmp=(C_word)a,a+=10,tmp));
t77=C_mutate((C_word*)lf[275]+1,C_fix((C_word)P_OVERLAY));
t78=C_mutate((C_word*)lf[276]+1,C_fix((C_word)P_WAIT));
t79=C_mutate((C_word*)lf[277]+1,C_fix((C_word)P_NOWAIT));
t80=C_mutate((C_word*)lf[278]+1,C_fix((C_word)P_NOWAITO));
t81=C_mutate((C_word*)lf[279]+1,C_fix((C_word)P_DETACH));
t82=*((C_word*)lf[280]+1);
t83=*((C_word*)lf[51]+1);
t84=*((C_word*)lf[107]+1);
t85=*((C_word*)lf[4]+1);
t86=C_mutate(&lf[281],(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_3455,a[2]=t85,a[3]=t83,a[4]=t84,a[5]=t82,a[6]=((C_word)li94),tmp=(C_word)a,a+=7,tmp));
t87=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3534,a[2]=((C_word)li95),tmp=(C_word)a,a+=3,tmp);
t88=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3551,a[2]=((C_word)li96),tmp=(C_word)a,a+=3,tmp);
t89=*((C_word*)lf[284]+1);
t90=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3568,a[2]=((C_word)li98),tmp=(C_word)a,a+=3,tmp);
t91=C_mutate(&lf[285],(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_3618,a[2]=t89,a[3]=t87,a[4]=t88,a[5]=t90,a[6]=((C_word)li99),tmp=(C_word)a,a+=7,tmp));
t92=C_mutate(&lf[286],(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3651,a[2]=((C_word)li100),tmp=(C_word)a,a+=3,tmp));
t93=C_mutate((C_word*)lf[287]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3666,a[2]=((C_word)li105),tmp=(C_word)a,a+=3,tmp));
t94=C_mutate((C_word*)lf[289]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3753,a[2]=((C_word)li110),tmp=(C_word)a,a+=3,tmp));
t95=C_mutate((C_word*)lf[291]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3840,a[2]=((C_word)li111),tmp=(C_word)a,a+=3,tmp));
t96=C_mutate((C_word*)lf[292]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3843,a[2]=((C_word)li112),tmp=(C_word)a,a+=3,tmp));
t97=C_mutate((C_word*)lf[296]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3864,a[2]=((C_word)li113),tmp=(C_word)a,a+=3,tmp));
t98=*((C_word*)lf[289]+1);
t99=*((C_word*)lf[294]+1);
t100=C_mutate((C_word*)lf[298]+1,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3870,a[2]=t98,a[3]=((C_word)li114),tmp=(C_word)a,a+=4,tmp));
t101=C_mutate(&lf[299],(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3899,a[2]=((C_word)li115),tmp=(C_word)a,a+=3,tmp));
t102=C_mutate((C_word*)lf[300]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3965,a[2]=((C_word)li116),tmp=(C_word)a,a+=3,tmp));
t103=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4084,a[2]=((C_word)li121),tmp=(C_word)a,a+=3,tmp);
t104=C_mutate((C_word*)lf[306]+1,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4146,a[2]=t103,a[3]=((C_word)li126),tmp=(C_word)a,a+=4,tmp));
t105=C_mutate((C_word*)lf[307]+1,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4226,a[2]=t103,a[3]=((C_word)li131),tmp=(C_word)a,a+=4,tmp));
t106=C_mutate((C_word*)lf[308]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4306,a[2]=((C_word)li132),tmp=(C_word)a,a+=3,tmp));
t107=C_mutate((C_word*)lf[309]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4318,a[2]=((C_word)li135),tmp=(C_word)a,a+=3,tmp));
t108=C_mutate((C_word*)lf[311]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4378,a[2]=((C_word)li136),tmp=(C_word)a,a+=3,tmp));
t109=C_mutate((C_word*)lf[312]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4381,a[2]=((C_word)li137),tmp=(C_word)a,a+=3,tmp));
t110=C_mutate((C_word*)lf[314]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4393,a[2]=((C_word)li138),tmp=(C_word)a,a+=3,tmp));
t111=C_mutate((C_word*)lf[110]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4424,a[2]=((C_word)li139),tmp=(C_word)a,a+=3,tmp));
t112=*((C_word*)lf[272]+1);
t113=*((C_word*)lf[268]+1);
t114=*((C_word*)lf[270]+1);
t115=*((C_word*)lf[100]+1);
t116=C_mutate((C_word*)lf[318]+1,(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_4439,a[2]=t115,a[3]=t114,a[4]=t112,a[5]=t113,a[6]=((C_word)li152),tmp=(C_word)a,a+=7,tmp));
t117=C_mutate((C_word*)lf[326]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4665,a[2]=((C_word)li153),tmp=(C_word)a,a+=3,tmp));
t118=C_mutate((C_word*)lf[328]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4671,a[2]=((C_word)li154),tmp=(C_word)a,a+=3,tmp));
t119=C_mutate((C_word*)lf[329]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4677,a[2]=((C_word)li155),tmp=(C_word)a,a+=3,tmp));
t120=C_mutate((C_word*)lf[330]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4683,a[2]=((C_word)li156),tmp=(C_word)a,a+=3,tmp));
t121=C_mutate((C_word*)lf[331]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4689,a[2]=((C_word)li157),tmp=(C_word)a,a+=3,tmp));
t122=C_mutate((C_word*)lf[332]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4695,a[2]=((C_word)li158),tmp=(C_word)a,a+=3,tmp));
t123=C_mutate((C_word*)lf[333]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4701,a[2]=((C_word)li159),tmp=(C_word)a,a+=3,tmp));
t124=C_mutate((C_word*)lf[334]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4707,a[2]=((C_word)li160),tmp=(C_word)a,a+=3,tmp));
t125=C_mutate((C_word*)lf[335]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4713,a[2]=((C_word)li161),tmp=(C_word)a,a+=3,tmp));
t126=C_mutate((C_word*)lf[336]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4719,a[2]=((C_word)li162),tmp=(C_word)a,a+=3,tmp));
t127=C_mutate((C_word*)lf[337]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4725,a[2]=((C_word)li163),tmp=(C_word)a,a+=3,tmp));
t128=C_mutate((C_word*)lf[338]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4731,a[2]=((C_word)li164),tmp=(C_word)a,a+=3,tmp));
t129=C_mutate((C_word*)lf[339]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4737,a[2]=((C_word)li165),tmp=(C_word)a,a+=3,tmp));
t130=C_mutate((C_word*)lf[340]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4743,a[2]=((C_word)li166),tmp=(C_word)a,a+=3,tmp));
t131=C_mutate((C_word*)lf[341]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4749,a[2]=((C_word)li167),tmp=(C_word)a,a+=3,tmp));
t132=C_mutate((C_word*)lf[342]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4755,a[2]=((C_word)li168),tmp=(C_word)a,a+=3,tmp));
t133=C_mutate((C_word*)lf[343]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4761,a[2]=((C_word)li169),tmp=(C_word)a,a+=3,tmp));
t134=C_mutate((C_word*)lf[344]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4767,a[2]=((C_word)li170),tmp=(C_word)a,a+=3,tmp));
t135=C_mutate((C_word*)lf[345]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4773,a[2]=((C_word)li171),tmp=(C_word)a,a+=3,tmp));
t136=C_mutate((C_word*)lf[346]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4779,a[2]=((C_word)li172),tmp=(C_word)a,a+=3,tmp));
t137=C_mutate((C_word*)lf[347]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4785,a[2]=((C_word)li173),tmp=(C_word)a,a+=3,tmp));
t138=C_mutate((C_word*)lf[348]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4791,a[2]=((C_word)li174),tmp=(C_word)a,a+=3,tmp));
t139=C_mutate((C_word*)lf[349]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4797,a[2]=((C_word)li175),tmp=(C_word)a,a+=3,tmp));
t140=C_mutate((C_word*)lf[350]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4803,a[2]=((C_word)li176),tmp=(C_word)a,a+=3,tmp));
t141=C_mutate((C_word*)lf[351]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4809,a[2]=((C_word)li177),tmp=(C_word)a,a+=3,tmp));
t142=C_mutate((C_word*)lf[352]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4815,a[2]=((C_word)li178),tmp=(C_word)a,a+=3,tmp));
t143=C_mutate((C_word*)lf[353]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4821,a[2]=((C_word)li179),tmp=(C_word)a,a+=3,tmp));
t144=C_mutate((C_word*)lf[354]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4827,a[2]=((C_word)li180),tmp=(C_word)a,a+=3,tmp));
t145=C_mutate((C_word*)lf[355]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4833,a[2]=((C_word)li181),tmp=(C_word)a,a+=3,tmp));
t146=C_mutate((C_word*)lf[356]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4839,a[2]=((C_word)li182),tmp=(C_word)a,a+=3,tmp));
t147=C_mutate((C_word*)lf[357]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4845,a[2]=((C_word)li183),tmp=(C_word)a,a+=3,tmp));
t148=C_mutate((C_word*)lf[358]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4851,a[2]=((C_word)li184),tmp=(C_word)a,a+=3,tmp));
t149=C_mutate((C_word*)lf[359]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4857,a[2]=((C_word)li185),tmp=(C_word)a,a+=3,tmp));
t150=C_mutate((C_word*)lf[360]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4863,a[2]=((C_word)li186),tmp=(C_word)a,a+=3,tmp));
t151=C_mutate((C_word*)lf[361]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4869,a[2]=((C_word)li187),tmp=(C_word)a,a+=3,tmp));
t152=C_mutate((C_word*)lf[362]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4875,a[2]=((C_word)li188),tmp=(C_word)a,a+=3,tmp));
t153=C_mutate((C_word*)lf[363]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4881,a[2]=((C_word)li189),tmp=(C_word)a,a+=3,tmp));
t154=C_mutate((C_word*)lf[364]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4887,a[2]=((C_word)li190),tmp=(C_word)a,a+=3,tmp));
t155=C_mutate((C_word*)lf[365]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4893,a[2]=((C_word)li191),tmp=(C_word)a,a+=3,tmp));
t156=C_mutate((C_word*)lf[366]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4899,a[2]=((C_word)li192),tmp=(C_word)a,a+=3,tmp));
t157=C_mutate((C_word*)lf[367]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4905,a[2]=((C_word)li193),tmp=(C_word)a,a+=3,tmp));
t158=C_mutate((C_word*)lf[368]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4911,a[2]=((C_word)li194),tmp=(C_word)a,a+=3,tmp));
t159=C_mutate((C_word*)lf[369]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4917,a[2]=((C_word)li195),tmp=(C_word)a,a+=3,tmp));
t160=C_mutate((C_word*)lf[370]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4923,a[2]=((C_word)li196),tmp=(C_word)a,a+=3,tmp));
t161=C_set_block_item(lf[371],0,C_fix(0));
t162=C_mutate((C_word*)lf[372]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4930,a[2]=((C_word)li197),tmp=(C_word)a,a+=3,tmp));
t163=C_mutate((C_word*)lf[373]+1,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4933,a[2]=((C_word)li198),tmp=(C_word)a,a+=3,tmp));
t164=C_set_block_item(lf[374],0,C_fix(0));
t165=C_set_block_item(lf[375],0,C_fix(0));
t166=C_set_block_item(lf[376],0,C_fix(0));
t167=C_set_block_item(lf[377],0,C_fix(0));
t168=C_set_block_item(lf[378],0,C_fix(0));
t169=C_set_block_item(lf[379],0,C_fix(0));
t170=C_set_block_item(lf[380],0,C_fix(0));
t171=C_set_block_item(lf[381],0,C_fix(0));
t172=C_set_block_item(lf[382],0,C_fix(0));
t173=C_set_block_item(lf[383],0,C_fix(0));
t174=C_set_block_item(lf[384],0,C_fix(0));
t175=C_set_block_item(lf[385],0,C_fix(0));
t176=C_set_block_item(lf[386],0,C_fix(0));
t177=C_set_block_item(lf[387],0,C_fix(0));
t178=C_set_block_item(lf[388],0,C_fix(0));
t179=C_set_block_item(lf[389],0,C_fix(0));
t180=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t180+1)))(2,t180,C_SCHEME_UNDEFINED);}

/* memory-mapped-file? in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4933(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_4933,3,t0,t1,t2);}
t3=t1;
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,C_SCHEME_FALSE);}

/* fifo? in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4930(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_4930,3,t0,t1,t2);}
t3=t1;
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,C_SCHEME_FALSE);}

/* string->time in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4923(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4923,2,t0,t1);}
/* posixwin.scm: 2092 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[370],lf[0]);}

/* utc-time->seconds in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4917(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4917,2,t0,t1);}
/* posixwin.scm: 2091 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[369],lf[0]);}

/* user-information in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4911(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4911,2,t0,t1);}
/* posixwin.scm: 2090 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[368],lf[0]);}

/* unmap-file-from-memory in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4905(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4905,2,t0,t1);}
/* posixwin.scm: 2089 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[367],lf[0]);}

/* terminal-size in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4899(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4899,2,t0,t1);}
/* posixwin.scm: 2088 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[366],lf[0]);}

/* terminal-port? in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4893(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4893,2,t0,t1);}
/* posixwin.scm: 2087 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[365],lf[0]);}

/* terminal-name in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4887(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4887,2,t0,t1);}
/* posixwin.scm: 2086 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[364],lf[0]);}

/* signal-unmask! in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4881(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4881,2,t0,t1);}
/* posixwin.scm: 2085 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[363],lf[0]);}

/* signal-masked? in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4875(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4875,2,t0,t1);}
/* posixwin.scm: 2084 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[362],lf[0]);}

/* signal-mask! in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4869(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4869,2,t0,t1);}
/* posixwin.scm: 2083 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[361],lf[0]);}

/* signal-mask in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4863(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4863,2,t0,t1);}
/* posixwin.scm: 2082 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[360],lf[0]);}

/* set-user-id! in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4857(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4857,2,t0,t1);}
/* posixwin.scm: 2081 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[359],lf[0]);}

/* set-signal-mask! in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4851(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4851,2,t0,t1);}
/* posixwin.scm: 2080 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[358],lf[0]);}

/* set-root-directory! in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4845(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4845,2,t0,t1);}
/* posixwin.scm: 2079 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[357],lf[0]);}

/* set-process-group-id! in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4839(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4839,2,t0,t1);}
/* posixwin.scm: 2078 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[356],lf[0]);}

/* set-groups! in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4833(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4833,2,t0,t1);}
/* posixwin.scm: 2077 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[355],lf[0]);}

/* set-group-id! in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4827(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4827,2,t0,t1);}
/* posixwin.scm: 2076 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[354],lf[0]);}

/* set-alarm! in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4821(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4821,2,t0,t1);}
/* posixwin.scm: 2075 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[353],lf[0]);}

/* read-symbolic-link in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4815(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4815,2,t0,t1);}
/* posixwin.scm: 2074 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[352],lf[0]);}

/* process-signal in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4809(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4809,2,t0,t1);}
/* posixwin.scm: 2073 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[351],lf[0]);}

/* process-group-id in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4803(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4803,2,t0,t1);}
/* posixwin.scm: 2072 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[350],lf[0]);}

/* process-fork in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4797(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4797,2,t0,t1);}
/* posixwin.scm: 2071 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[349],lf[0]);}

/* parent-process-id in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4791(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4791,2,t0,t1);}
/* posixwin.scm: 2070 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[348],lf[0]);}

/* memory-mapped-file-pointer in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4785(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4785,2,t0,t1);}
/* posixwin.scm: 2069 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[347],lf[0]);}

/* initialize-groups in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4779(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4779,2,t0,t1);}
/* posixwin.scm: 2068 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[346],lf[0]);}

/* group-information in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4773(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4773,2,t0,t1);}
/* posixwin.scm: 2067 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[345],lf[0]);}

/* get-groups in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4767(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4767,2,t0,t1);}
/* posixwin.scm: 2066 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[344],lf[0]);}

/* file-unlock in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4761(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4761,2,t0,t1);}
/* posixwin.scm: 2065 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[343],lf[0]);}

/* file-truncate in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4755(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4755,2,t0,t1);}
/* posixwin.scm: 2064 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[342],lf[0]);}

/* file-test-lock in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4749(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4749,2,t0,t1);}
/* posixwin.scm: 2063 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[341],lf[0]);}

/* file-select in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4743(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4743,2,t0,t1);}
/* posixwin.scm: 2062 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[340],lf[0]);}

/* file-lock/blocking in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4737(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4737,2,t0,t1);}
/* posixwin.scm: 2061 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[339],lf[0]);}

/* file-lock in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4731(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4731,2,t0,t1);}
/* posixwin.scm: 2060 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[338],lf[0]);}

/* file-link in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4725(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4725,2,t0,t1);}
/* posixwin.scm: 2059 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[337],lf[0]);}

/* map-file-to-memory in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4719(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4719,2,t0,t1);}
/* posixwin.scm: 2058 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[336],lf[0]);}

/* current-user-id in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4713(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4713,2,t0,t1);}
/* posixwin.scm: 2057 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[335],lf[0]);}

/* current-group-id in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4707(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4707,2,t0,t1);}
/* posixwin.scm: 2056 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[334],lf[0]);}

/* current-effective-user-name in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4701(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4701,2,t0,t1);}
/* posixwin.scm: 2055 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[333],lf[0]);}

/* current-effective-user-id in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4695(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4695,2,t0,t1);}
/* posixwin.scm: 2054 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[332],lf[0]);}

/* current-effective-group-id in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4689(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4689,2,t0,t1);}
/* posixwin.scm: 2053 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[331],lf[0]);}

/* create-symbolic-link in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4683(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4683,2,t0,t1);}
/* posixwin.scm: 2052 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[330],lf[0]);}

/* create-session in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4677(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4677,2,t0,t1);}
/* posixwin.scm: 2051 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[329],lf[0]);}

/* create-fifo in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4671(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4671,2,t0,t1);}
/* posixwin.scm: 2050 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[328],lf[0]);}

/* change-file-owner in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4665(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4665,2,t0,t1);}
/* posixwin.scm: 2049 error */
t2=*((C_word*)lf[327]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[326],lf[0]);}

/* find-files in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4439(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...){
C_word tmp;
C_word t4;
va_list v;
C_word *a,c2=c;
C_save_rest(t3,c2,4);
if(c<4) C_bad_min_argc_2(c,4,t0);
if(!C_demand(c*C_SIZEOF_PAIR+21)){
C_save_and_reclaim((void*)tr4r,(void*)f_4439r,4,t0,t1,t2,t3);}
else{
a=C_alloc((c-4)*3);
t4=C_restore_rest(a,C_rest_count(0));
f_4439r(t0,t1,t2,t3,t4);}}

static void C_ccall f_4439r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word *a=C_alloc(21);
t5=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_4441,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=t3,a[7]=t2,a[8]=((C_word)li147),tmp=(C_word)a,a+=9,tmp);
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4586,a[2]=t5,a[3]=((C_word)li148),tmp=(C_word)a,a+=4,tmp);
t7=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4591,a[2]=t6,a[3]=((C_word)li149),tmp=(C_word)a,a+=4,tmp);
t8=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4596,a[2]=t7,a[3]=((C_word)li151),tmp=(C_word)a,a+=4,tmp);
if(C_truep((C_word)C_i_nullp(t4))){
/* def-action786820 */
t9=t8;
f_4596(t9,t1);}
else{
t9=(C_word)C_i_car(t4);
t10=(C_word)C_i_cdr(t4);
if(C_truep((C_word)C_i_nullp(t10))){
/* def-id787818 */
t11=t7;
f_4591(t11,t1,t9);}
else{
t11=(C_word)C_i_car(t10);
t12=(C_word)C_i_cdr(t10);
if(C_truep((C_word)C_i_nullp(t12))){
/* def-limit788815 */
t13=t6;
f_4586(t13,t1,t9,t11);}
else{
t13=(C_word)C_i_car(t12);
t14=(C_word)C_i_cdr(t12);
if(C_truep((C_word)C_i_nullp(t14))){
/* body784790 */
t15=t5;
f_4441(t15,t1,t9,t11,t13);}
else{
/* ##sys#error */
t15=*((C_word*)lf[62]+1);
((C_proc4)(void*)(*((C_word*)t15+1)))(4,t15,t1,lf[2],t14);}}}}}

/* def-action786 in find-files in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_4596(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[3],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_4596,NULL,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4602,a[2]=((C_word)li150),tmp=(C_word)a,a+=3,tmp);
/* def-id787818 */
t3=((C_word*)t0)[2];
f_4591(t3,t1,t2);}

/* a4601 in def-action786 in find-files in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4602(C_word c,C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word ab[3],*a=ab;
if(c!=4) C_bad_argc_2(c,4,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr4,(void*)f_4602,4,t0,t1,t2,t3);}
t4=t1;
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,(C_word)C_a_i_cons(&a,2,t2,t3));}

/* def-id787 in find-files in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_4591(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_4591,NULL,3,t0,t1,t2);}
/* def-limit788815 */
t3=((C_word*)t0)[2];
f_4586(t3,t1,t2,C_SCHEME_END_OF_LIST);}

/* def-limit788 in find-files in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_4586(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_4586,NULL,4,t0,t1,t2,t3);}
/* body784790 */
t4=((C_word*)t0)[2];
f_4441(t4,t1,t2,t3,C_SCHEME_FALSE);}

/* body784 in find-files in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_4441(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word ab[22],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_4441,NULL,5,t0,t1,t2,t3,t4);}
t5=(C_word)C_i_check_string_2(((C_word*)t0)[7],lf[318]);
t6=C_fix(0);
t7=(*a=C_VECTOR_TYPE|1,a[1]=t6,tmp=(C_word)a,a+=2,tmp);
t8=(*a=C_CLOSURE_TYPE|11,a[1]=(C_word)f_4448,a[2]=((C_word*)t0)[7],a[3]=t3,a[4]=t1,a[5]=((C_word*)t0)[2],a[6]=t2,a[7]=((C_word*)t0)[3],a[8]=((C_word*)t0)[4],a[9]=t7,a[10]=((C_word*)t0)[5],a[11]=((C_word*)t0)[6],tmp=(C_word)a,a+=12,tmp);
t9=t4;
if(C_truep(t9)){
t10=(C_word)C_fixnump(t4);
t11=t8;
f_4448(t11,(C_truep(t10)?(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4581,a[2]=t4,a[3]=t7,a[4]=((C_word)li145),tmp=(C_word)a,a+=5,tmp):t4));}
else{
t10=t8;
f_4448(t10,(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4573,a[2]=((C_word)li146),tmp=(C_word)a,a+=3,tmp));}}

/* f_4573 in body784 in find-files in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4573(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4573,2,t0,t1);}
t2=t1;
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_SCHEME_TRUE);}

/* f_4581 in body784 in find-files in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4581(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4581,2,t0,t1);}
t2=t1;
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,(C_word)C_fixnum_lessp(((C_word*)((C_word*)t0)[3])[1],((C_word*)t0)[2]));}

/* k4446 in body784 in find-files in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_4448(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[20],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_4448,NULL,2,t0,t1);}
t2=(C_word)C_i_stringp(((C_word*)t0)[11]);
t3=(C_truep(t2)?(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4565,a[2]=((C_word*)t0)[11],a[3]=((C_word*)t0)[10],a[4]=((C_word)li140),tmp=(C_word)a,a+=5,tmp):((C_word*)t0)[11]);
t4=(*a=C_CLOSURE_TYPE|10,a[1]=(C_word)f_4458,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=t3,a[6]=((C_word*)t0)[6],a[7]=t1,a[8]=((C_word*)t0)[7],a[9]=((C_word*)t0)[8],a[10]=((C_word*)t0)[9],tmp=(C_word)a,a+=11,tmp);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4561,a[2]=t4,a[3]=((C_word*)t0)[8],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 2027 make-pathname */
t6=((C_word*)t0)[7];
((C_proc4)C_retrieve_proc(t6))(4,t6,t5,((C_word*)t0)[2],lf[325]);}

/* k4559 in k4446 in body784 in find-files in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4561(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 2027 glob */
t2=((C_word*)t0)[3];
((C_proc3)C_retrieve_proc(t2))(3,t2,((C_word*)t0)[2],t1);}

/* k4456 in k4446 in body784 in find-files in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4458(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[13],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4458,2,t0,t1);}
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|10,a[1]=(C_word)f_4460,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[5],a[4]=((C_word*)t0)[6],a[5]=((C_word*)t0)[7],a[6]=((C_word*)t0)[8],a[7]=((C_word*)t0)[9],a[8]=((C_word*)t0)[10],a[9]=t3,a[10]=((C_word)li144),tmp=(C_word)a,a+=11,tmp));
t5=((C_word*)t3)[1];
f_4460(t5,((C_word*)t0)[3],t1,((C_word*)t0)[2]);}

/* loop in k4456 in k4446 in body784 in find-files in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_4460(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word ab[13],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_4460,NULL,4,t0,t1,t2,t3);}
if(C_truep((C_word)C_i_nullp(t2))){
t4=t1;
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,t3);}
else{
t4=(C_word)C_slot(t2,C_fix(0));
t5=(C_word)C_slot(t2,C_fix(1));
t6=(*a=C_CLOSURE_TYPE|12,a[1]=(C_word)f_4479,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=t4,a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],a[9]=t3,a[10]=t5,a[11]=t1,a[12]=((C_word*)t0)[9],tmp=(C_word)a,a+=13,tmp);
/* posixwin.scm: 2033 directory? */
t7=((C_word*)t0)[2];
((C_proc3)C_retrieve_proc(t7))(3,t7,t6,t4);}}

/* k4477 in loop in k4456 in k4446 in body784 in find-files in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4479(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[19],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4479,2,t0,t1);}
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|10,a[1]=(C_word)f_4541,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[5],a[4]=((C_word*)t0)[6],a[5]=((C_word*)t0)[7],a[6]=((C_word*)t0)[8],a[7]=((C_word*)t0)[9],a[8]=((C_word*)t0)[10],a[9]=((C_word*)t0)[11],a[10]=((C_word*)t0)[12],tmp=(C_word)a,a+=11,tmp);
/* posixwin.scm: 2034 pathname-file */
t3=*((C_word*)lf[324]+1);
((C_proc3)C_retrieve_proc(t3))(3,t3,t2,((C_word*)t0)[5]);}
else{
t2=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_4547,a[2]=((C_word*)t0)[9],a[3]=((C_word*)t0)[5],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[10],a[6]=((C_word*)t0)[11],a[7]=((C_word*)t0)[12],tmp=(C_word)a,a+=8,tmp);
/* posixwin.scm: 2040 pproc */
t3=((C_word*)t0)[2];
((C_proc3)C_retrieve_proc(t3))(3,t3,t2,((C_word*)t0)[5]);}}

/* k4545 in k4477 in loop in k4456 in k4446 in body784 in find-files in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4547(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[5],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4547,2,t0,t1);}
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4554,a[2]=((C_word*)t0)[5],a[3]=((C_word*)t0)[6],a[4]=((C_word*)t0)[7],tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm: 2040 action */
t3=((C_word*)t0)[4];
((C_proc4)C_retrieve_proc(t3))(4,t3,t2,((C_word*)t0)[3],((C_word*)t0)[2]);}
else{
/* posixwin.scm: 2041 loop */
t2=((C_word*)((C_word*)t0)[7])[1];
f_4460(t2,((C_word*)t0)[6],((C_word*)t0)[5],((C_word*)t0)[2]);}}

/* k4552 in k4545 in k4477 in loop in k4456 in k4446 in body784 in find-files in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4554(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 2040 loop */
t2=((C_word*)((C_word*)t0)[4])[1];
f_4460(t2,((C_word*)t0)[3],((C_word*)t0)[2],t1);}

/* k4539 in k4477 in loop in k4456 in k4446 in body784 in find-files in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4541(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[10],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4541,2,t0,t1);}
if(C_truep((C_truep((C_word)C_i_equalp(t1,lf[319]))?C_SCHEME_TRUE:(C_truep((C_word)C_i_equalp(t1,lf[320]))?C_SCHEME_TRUE:C_SCHEME_FALSE)))){
/* posixwin.scm: 2034 loop */
t2=((C_word*)((C_word*)t0)[10])[1];
f_4460(t2,((C_word*)t0)[9],((C_word*)t0)[8],((C_word*)t0)[7]);}
else{
t2=(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_4494,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[7],a[6]=((C_word*)t0)[8],a[7]=((C_word*)t0)[9],a[8]=((C_word*)t0)[10],a[9]=((C_word*)t0)[6],tmp=(C_word)a,a+=10,tmp);
/* posixwin.scm: 2035 lproc */
t3=((C_word*)t0)[2];
((C_proc3)C_retrieve_proc(t3))(3,t3,t2,((C_word*)t0)[3]);}}

/* k4492 in k4539 in k4477 in loop in k4456 in k4446 in body784 in find-files in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4494(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word ab[29],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4494,2,t0,t1);}
if(C_truep(t1)){
t2=(C_word)C_fixnum_plus(((C_word*)((C_word*)t0)[9])[1],C_fix(1));
t3=t2;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_SCHEME_FALSE;
t6=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t7=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4504,a[2]=((C_word*)t0)[6],a[3]=((C_word*)t0)[7],a[4]=((C_word*)t0)[8],tmp=(C_word)a,a+=5,tmp);
t8=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_4506,a[2]=t4,a[3]=((C_word*)t0)[9],a[4]=t6,a[5]=((C_word)li141),tmp=(C_word)a,a+=6,tmp);
t9=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_4514,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[8],a[7]=((C_word)li142),tmp=(C_word)a,a+=8,tmp);
t10=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_4528,a[2]=t6,a[3]=((C_word*)t0)[9],a[4]=t4,a[5]=((C_word)li143),tmp=(C_word)a,a+=6,tmp);
/* posixwin.scm: 2037 ##sys#dynamic-wind */
t11=*((C_word*)lf[323]+1);
((C_proc5)(void*)(*((C_word*)t11+1)))(5,t11,t7,t8,t9,t10);}
else{
/* posixwin.scm: 2039 loop */
t2=((C_word*)((C_word*)t0)[8])[1];
f_4460(t2,((C_word*)t0)[7],((C_word*)t0)[6],((C_word*)t0)[5]);}}

/* a4527 in k4492 in k4539 in k4477 in loop in k4456 in k4446 in body784 in find-files in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4528(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4528,2,t0,t1);}
t2=C_mutate(((C_word *)((C_word*)t0)[4])+1,((C_word*)((C_word*)t0)[3])[1]);
t3=C_mutate(((C_word *)((C_word*)t0)[3])+1,((C_word*)((C_word*)t0)[2])[1]);
t4=t1;
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,*((C_word*)lf[321]+1));}

/* a4513 in k4492 in k4539 in k4477 in loop in k4456 in k4446 in body784 in find-files in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4514(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[9],*a=ab;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4514,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4522,a[2]=((C_word*)t0)[5],a[3]=t1,a[4]=((C_word*)t0)[6],tmp=(C_word)a,a+=5,tmp);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4526,a[2]=t2,a[3]=((C_word*)t0)[4],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 2038 make-pathname */
t4=((C_word*)t0)[3];
((C_proc4)C_retrieve_proc(t4))(4,t4,t3,((C_word*)t0)[2],lf[322]);}

/* k4524 in a4513 in k4492 in k4539 in k4477 in loop in k4456 in k4446 in body784 in find-files in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4526(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 2038 glob */
t2=((C_word*)t0)[3];
((C_proc3)C_retrieve_proc(t2))(3,t2,((C_word*)t0)[2],t1);}

/* k4520 in a4513 in k4492 in k4539 in k4477 in loop in k4456 in k4446 in body784 in find-files in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4522(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 2038 loop */
t2=((C_word*)((C_word*)t0)[4])[1];
f_4460(t2,((C_word*)t0)[3],t1,((C_word*)t0)[2]);}

/* a4505 in k4492 in k4539 in k4477 in loop in k4456 in k4446 in body784 in find-files in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4506(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4506,2,t0,t1);}
t2=C_mutate(((C_word *)((C_word*)t0)[4])+1,((C_word*)((C_word*)t0)[3])[1]);
t3=C_mutate(((C_word *)((C_word*)t0)[3])+1,((C_word*)((C_word*)t0)[2])[1]);
t4=t1;
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,*((C_word*)lf[321]+1));}

/* k4502 in k4492 in k4539 in k4477 in loop in k4456 in k4446 in body784 in find-files in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4504(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 2036 loop */
t2=((C_word*)((C_word*)t0)[4])[1];
f_4460(t2,((C_word*)t0)[3],((C_word*)t0)[2],t1);}

/* f_4565 in k4446 in body784 in find-files in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4565(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_4565,3,t0,t1,t2);}
/* posixwin.scm: 2025 string-match */
t3=((C_word*)t0)[3];
((C_proc4)C_retrieve_proc(t3))(4,t3,t1,((C_word*)t0)[2],t2);}

/* current-user-name in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4424(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[6],*a=ab;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4424,2,t0,t1);}
if(C_truep((C_word)C_get_user_name())){
/* ##sys#peek-c-string */
t2=*((C_word*)lf[8]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,C_mpointer(&a,(void*)C_username),C_fix(0));}
else{
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4434,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm: 2001 ##sys#update-errno */
t3=*((C_word*)lf[9]+1);
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,t2);}}

/* k4432 in current-user-name in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4434(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 2002 ##sys#error */
t2=*((C_word*)lf[62]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,((C_word*)t0)[2],lf[110],lf[317]);}

/* system-information in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4393(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[9],*a=ab;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4393,2,t0,t1);}
if(C_truep((C_word)C_sysinfo())){
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4404,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* ##sys#peek-c-string */
t3=*((C_word*)lf[8]+1);
((C_proc4)(void*)(*((C_word*)t3+1)))(4,t3,t2,C_mpointer(&a,(void*)C_hostname),C_fix(0));}
else{
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4419,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm: 1992 ##sys#update-errno */
t3=*((C_word*)lf[9]+1);
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,t2);}}

/* k4417 in system-information in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4419(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1993 ##sys#error */
t2=*((C_word*)lf[62]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,((C_word*)t0)[2],lf[314],lf[316]);}

/* k4402 in system-information in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4404(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[7],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4404,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4408,a[2]=t1,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* ##sys#peek-c-string */
t3=*((C_word*)lf[8]+1);
((C_proc4)(void*)(*((C_word*)t3+1)))(4,t3,t2,C_mpointer(&a,(void*)C_osrel),C_fix(0));}

/* k4406 in k4402 in system-information in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4408(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[8],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4408,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4412,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
/* ##sys#peek-c-string */
t3=*((C_word*)lf[8]+1);
((C_proc4)(void*)(*((C_word*)t3+1)))(4,t3,t2,C_mpointer(&a,(void*)C_osver),C_fix(0));}

/* k4410 in k4406 in k4402 in system-information in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4412(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[9],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4412,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_4416,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
/* ##sys#peek-c-string */
t3=*((C_word*)lf[8]+1);
((C_proc4)(void*)(*((C_word*)t3+1)))(4,t3,t2,C_mpointer(&a,(void*)C_processor),C_fix(0));}

/* k4414 in k4410 in k4406 in k4402 in system-information in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4416(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word ab[15],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4416,2,t0,t1);}
t2=((C_word*)t0)[5];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,(C_word)C_a_i_list(&a,5,lf[315],((C_word*)t0)[4],((C_word*)t0)[3],((C_word*)t0)[2],t1));}

/* get-host-name in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4381(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word ab[3],*a=ab;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4381,2,t0,t1);}
if(C_truep((C_word)C_get_hostname())){
/* ##sys#peek-c-string */
t2=*((C_word*)lf[8]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,C_mpointer(&a,(void*)C_hostname),C_fix(0));}
else{
/* posixwin.scm: 1982 ##sys#error */
t2=*((C_word*)lf[62]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,t1,lf[312],lf[313]);}}

/* sleep in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4378(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_4378,3,t0,t1,t2);}
t3=(C_word)C_sleep(t2);
t4=t1;
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,C_fix(0));}

/* process-wait in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4318(C_word c,C_word t0,C_word t1,C_word t2,...){
C_word tmp;
C_word t3;
va_list v;
C_word *a,c2=c;
C_save_rest(t2,c2,3);
if(c<3) C_bad_min_argc_2(c,3,t0);
if(!C_demand(c*C_SIZEOF_PAIR+9)){
C_save_and_reclaim((void*)tr3r,(void*)f_4318r,3,t0,t1,t2);}
else{
a=C_alloc((c-3)*3);
t3=C_restore_rest(a,C_rest_count(0));
f_4318r(t0,t1,t2,t3);}}

static void C_ccall f_4318r(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a=C_alloc(9);
t4=(C_word)C_i_nullp(t3);
t5=(C_truep(t4)?C_SCHEME_FALSE:(C_word)C_i_car(t3));
t6=(C_word)C_i_nullp(t3);
t7=(C_truep(t6)?C_SCHEME_END_OF_LIST:(C_word)C_i_cdr(t3));
if(C_truep((C_word)C_i_nullp(t7))){
t8=(C_word)C_i_check_exact_2(t2,lf[309]);
t9=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4339,a[2]=t5,a[3]=t2,a[4]=((C_word)li133),tmp=(C_word)a,a+=5,tmp);
t10=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4345,a[2]=t2,a[3]=((C_word)li134),tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1961 ##sys#call-with-values */
C_call_with_values(4,0,t1,t9,t10);}
else{
/* ##sys#error */
t8=*((C_word*)lf[62]+1);
((C_proc4)(void*)(*((C_word*)t8+1)))(4,t8,t1,lf[2],t7);}}

/* a4344 in process-wait in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4345(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word ab[4],*a=ab;
if(c!=5) C_bad_argc_2(c,5,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr5,(void*)f_4345,5,t0,t1,t2,t3,t4);}
t5=(C_word)C_eqp(t2,C_fix(-1));
if(C_truep(t5)){
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4355,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1964 ##sys#update-errno */
t7=*((C_word*)lf[9]+1);
((C_proc2)(void*)(*((C_word*)t7+1)))(2,t7,t6);}
else{
/* posixwin.scm: 1966 values */
C_values(5,0,t1,t2,t3,t4);}}

/* k4353 in a4344 in process-wait in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4355(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1965 ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);
((C_proc6)(void*)(*((C_word*)t2+1)))(6,t2,((C_word*)t0)[3],lf[301],lf[309],lf[310],((C_word*)t0)[2]);}

/* a4338 in process-wait in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4339(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4339,2,t0,t1);}
/* posixwin.scm: 1961 ##sys#process-wait */
t2=*((C_word*)lf[308]+1);
((C_proc4)C_retrieve_proc(t2))(4,t2,t1,((C_word*)t0)[3],((C_word*)t0)[2]);}

/* ##sys#process-wait in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4306(C_word c,C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr4,(void*)f_4306,4,t0,t1,t2,t3);}
if(C_truep((C_word)C_process_wait(t2,t3))){
/* posixwin.scm: 1954 values */
C_values(5,0,t1,t2,C_SCHEME_TRUE,C_fix((C_word)C_exstatus));}
else{
/* posixwin.scm: 1955 values */
C_values(5,0,t1,C_fix(-1),C_SCHEME_FALSE,C_SCHEME_FALSE);}}

/* process* in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4226(C_word c,C_word t0,C_word t1,C_word t2,...){
C_word tmp;
C_word t3;
va_list v;
C_word *a,c2=c;
C_save_rest(t2,c2,3);
if(c<3) C_bad_min_argc_2(c,3,t0);
if(!C_demand(c*C_SIZEOF_PAIR+17)){
C_save_and_reclaim((void*)tr3r,(void*)f_4226r,3,t0,t1,t2);}
else{
a=C_alloc((c-3)*3);
t3=C_restore_rest(a,C_rest_count(0));
f_4226r(t0,t1,t2,t3);}}

static void C_ccall f_4226r(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word *a=C_alloc(17);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4228,a[2]=t2,a[3]=((C_word*)t0)[2],a[4]=((C_word)li127),tmp=(C_word)a,a+=5,tmp);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4233,a[2]=t4,a[3]=((C_word)li128),tmp=(C_word)a,a+=4,tmp);
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4238,a[2]=t5,a[3]=((C_word)li129),tmp=(C_word)a,a+=4,tmp);
t7=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4243,a[2]=t6,a[3]=((C_word)li130),tmp=(C_word)a,a+=4,tmp);
if(C_truep((C_word)C_i_nullp(t3))){
/* def-args735748 */
t8=t7;
f_4243(t8,t1);}
else{
t8=(C_word)C_i_car(t3);
t9=(C_word)C_i_cdr(t3);
if(C_truep((C_word)C_i_nullp(t9))){
/* def-env736746 */
t10=t6;
f_4238(t10,t1,t8);}
else{
t10=(C_word)C_i_car(t9);
t11=(C_word)C_i_cdr(t9);
if(C_truep((C_word)C_i_nullp(t11))){
/* def-exactf737743 */
t12=t5;
f_4233(t12,t1,t8,t10);}
else{
t12=(C_word)C_i_car(t11);
t13=(C_word)C_i_cdr(t11);
if(C_truep((C_word)C_i_nullp(t13))){
/* body733739 */
t14=t4;
f_4228(t14,t1,t8,t10,t12);}
else{
/* ##sys#error */
t14=*((C_word*)lf[62]+1);
((C_proc4)(void*)(*((C_word*)t14+1)))(4,t14,t1,lf[2],t13);}}}}}

/* def-args735 in process* in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_4243(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_4243,NULL,2,t0,t1);}
/* def-env736746 */
t2=((C_word*)t0)[2];
f_4238(t2,t1,C_SCHEME_FALSE);}

/* def-env736 in process* in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_4238(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_4238,NULL,3,t0,t1,t2);}
/* def-exactf737743 */
t3=((C_word*)t0)[2];
f_4233(t3,t1,t2,C_SCHEME_FALSE);}

/* def-exactf737 in process* in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_4233(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_4233,NULL,4,t0,t1,t2,t3);}
/* body733739 */
t4=((C_word*)t0)[2];
f_4228(t4,t1,t2,t3,C_SCHEME_FALSE);}

/* body733 in process* in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_4228(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_4228,NULL,5,t0,t1,t2,t3,t4);}
/* posixwin.scm: 1948 %process */
f_4084(t1,lf[307],C_SCHEME_TRUE,((C_word*)t0)[2],t2,t3,t4);}

/* process in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4146(C_word c,C_word t0,C_word t1,C_word t2,...){
C_word tmp;
C_word t3;
va_list v;
C_word *a,c2=c;
C_save_rest(t2,c2,3);
if(c<3) C_bad_min_argc_2(c,3,t0);
if(!C_demand(c*C_SIZEOF_PAIR+17)){
C_save_and_reclaim((void*)tr3r,(void*)f_4146r,3,t0,t1,t2);}
else{
a=C_alloc((c-3)*3);
t3=C_restore_rest(a,C_rest_count(0));
f_4146r(t0,t1,t2,t3);}}

static void C_ccall f_4146r(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word *a=C_alloc(17);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4148,a[2]=t2,a[3]=((C_word*)t0)[2],a[4]=((C_word)li122),tmp=(C_word)a,a+=5,tmp);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4153,a[2]=t4,a[3]=((C_word)li123),tmp=(C_word)a,a+=4,tmp);
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4158,a[2]=t5,a[3]=((C_word)li124),tmp=(C_word)a,a+=4,tmp);
t7=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4163,a[2]=t6,a[3]=((C_word)li125),tmp=(C_word)a,a+=4,tmp);
if(C_truep((C_word)C_i_nullp(t3))){
/* def-args707720 */
t8=t7;
f_4163(t8,t1);}
else{
t8=(C_word)C_i_car(t3);
t9=(C_word)C_i_cdr(t3);
if(C_truep((C_word)C_i_nullp(t9))){
/* def-env708718 */
t10=t6;
f_4158(t10,t1,t8);}
else{
t10=(C_word)C_i_car(t9);
t11=(C_word)C_i_cdr(t9);
if(C_truep((C_word)C_i_nullp(t11))){
/* def-exactf709715 */
t12=t5;
f_4153(t12,t1,t8,t10);}
else{
t12=(C_word)C_i_car(t11);
t13=(C_word)C_i_cdr(t11);
if(C_truep((C_word)C_i_nullp(t13))){
/* body705711 */
t14=t4;
f_4148(t14,t1,t8,t10,t12);}
else{
/* ##sys#error */
t14=*((C_word*)lf[62]+1);
((C_proc4)(void*)(*((C_word*)t14+1)))(4,t14,t1,lf[2],t13);}}}}}

/* def-args707 in process in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_4163(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_4163,NULL,2,t0,t1);}
/* def-env708718 */
t2=((C_word*)t0)[2];
f_4158(t2,t1,C_SCHEME_FALSE);}

/* def-env708 in process in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_4158(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_4158,NULL,3,t0,t1,t2);}
/* def-exactf709715 */
t3=((C_word*)t0)[2];
f_4153(t3,t1,t2,C_SCHEME_FALSE);}

/* def-exactf709 in process in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_4153(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_4153,NULL,4,t0,t1,t2,t3);}
/* body705711 */
t4=((C_word*)t0)[2];
f_4148(t4,t1,t2,t3,C_SCHEME_FALSE);}

/* body705 in process in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_4148(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_4148,NULL,5,t0,t1,t2,t3,t4);}
/* posixwin.scm: 1945 %process */
f_4084(t1,lf[306],C_SCHEME_FALSE,((C_word*)t0)[2],t2,t3,t4);}

/* %process in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_4084(C_word t1,C_word t2,C_word t3,C_word t4,C_word t5,C_word t6,C_word t7){
C_word tmp;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word t16;
C_word ab[25],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_4084,NULL,7,t1,t2,t3,t4,t5,t6,t7);}
t8=(*a=C_VECTOR_TYPE|1,a[1]=t4,tmp=(C_word)a,a+=2,tmp);
t9=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t10=(*a=C_VECTOR_TYPE|1,a[1]=t7,tmp=(C_word)a,a+=2,tmp);
t11=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4086,a[2]=t2,a[3]=((C_word)li118),tmp=(C_word)a,a+=4,tmp);
t12=(C_word)C_i_check_string_2(((C_word*)t8)[1],t2);
t13=(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_4105,a[2]=t11,a[3]=t1,a[4]=t10,a[5]=t3,a[6]=t6,a[7]=t9,a[8]=t8,a[9]=t2,tmp=(C_word)a,a+=10,tmp);
if(C_truep(((C_word*)t9)[1])){
/* posixwin.scm: 1933 chkstrlst */
t14=t11;
f_4086(t14,t13,((C_word*)t9)[1]);}
else{
t14=C_set_block_item(t10,0,C_SCHEME_TRUE);
t15=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4140,a[2]=t13,a[3]=t8,a[4]=t9,tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm: 1936 ##sys#shell-command-arguments */
t16=*((C_word*)lf[296]+1);
((C_proc3)C_retrieve_proc(t16))(3,t16,t15,((C_word*)t8)[1]);}}

/* k4138 in %process in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4140(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4140,2,t0,t1);}
t2=C_mutate(((C_word *)((C_word*)t0)[4])+1,t1);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4144,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1937 ##sys#shell-command */
t4=*((C_word*)lf[292]+1);
((C_proc2)C_retrieve_proc(t4))(2,t4,t3);}

/* k4142 in k4138 in %process in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4144(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
t2=C_mutate(((C_word *)((C_word*)t0)[3])+1,t1);
t3=((C_word*)t0)[2];
f_4105(2,t3,t2);}

/* k4103 in %process in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4105(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[9],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4105,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_4108,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[6],a[6]=((C_word*)t0)[7],a[7]=((C_word*)t0)[8],a[8]=((C_word*)t0)[9],tmp=(C_word)a,a+=9,tmp);
if(C_truep(((C_word*)t0)[6])){
/* posixwin.scm: 1938 chkstrlst */
t3=((C_word*)t0)[2];
f_4086(t3,t2,((C_word*)t0)[6]);}
else{
t3=t2;
f_4108(2,t3,C_SCHEME_UNDEFINED);}}

/* k4106 in k4103 in %process in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4108(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[13],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4108,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_4113,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[6],a[6]=((C_word*)t0)[7],a[7]=((C_word*)t0)[8],a[8]=((C_word)li119),tmp=(C_word)a,a+=9,tmp);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4119,a[2]=((C_word*)t0)[4],a[3]=((C_word)li120),tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1939 ##sys#call-with-values */
C_call_with_values(4,0,((C_word*)t0)[2],t2,t3);}

/* a4118 in k4106 in k4103 in %process in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4119(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5){
C_word tmp;
C_word t6;
C_word *a;
if(c!=6) C_bad_argc_2(c,6,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr6,(void*)f_4119,6,t0,t1,t2,t3,t4,t5);}
if(C_truep(((C_word*)t0)[2])){
/* posixwin.scm: 1941 values */
C_values(6,0,t1,t2,t3,t4,t5);}
else{
/* posixwin.scm: 1942 values */
C_values(5,0,t1,t2,t3,t4);}}

/* a4112 in k4106 in k4103 in %process in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4113(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4113,2,t0,t1);}
/* posixwin.scm: 1939 ##sys#process */
t2=*((C_word*)lf[300]+1);
((C_proc10)(void*)(*((C_word*)t2+1)))(10,t2,t1,((C_word*)t0)[7],((C_word*)((C_word*)t0)[6])[1],((C_word*)((C_word*)t0)[5])[1],((C_word*)t0)[4],C_SCHEME_TRUE,C_SCHEME_TRUE,((C_word*)t0)[3],((C_word*)((C_word*)t0)[2])[1]);}

/* chkstrlst in %process in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_4086(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_4086,NULL,3,t0,t1,t2);}
t3=(C_word)C_i_check_list_2(t2,((C_word*)t0)[2]);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_4095,a[2]=((C_word*)t0)[2],a[3]=((C_word)li117),tmp=(C_word)a,a+=4,tmp);
/* for-each */
t5=*((C_word*)lf[305]+1);
((C_proc4)(void*)(*((C_word*)t5+1)))(4,t5,t1,t4,t2);}

/* a4094 in chkstrlst in %process in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4095(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_4095,3,t0,t1,t2);}
t3=t1;
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,(C_word)C_i_check_string_2(t2,((C_word*)t0)[2]));}

/* ##sys#process in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3965(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5,C_word t6,C_word t7,C_word t8,...){
C_word tmp;
C_word t9;
va_list v;
C_word *a,c2=c;
C_save_rest(t8,c2,9);
if(c<9) C_bad_min_argc_2(c,9,t0);
if(!C_demand(c*C_SIZEOF_PAIR+9)){
C_save_and_reclaim((void*)tr9r,(void*)f_3965r,9,t0,t1,t2,t3,t4,t5,t6,t7,t8);}
else{
a=C_alloc((c-9)*3);
t9=C_restore_rest(a,C_rest_count(0));
f_3965r(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9);}}

static void C_ccall f_3965r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5,C_word t6,C_word t7,C_word t8,C_word t9){
C_word tmp;
C_word t10;
C_word t11;
C_word t12;
C_word *a=C_alloc(9);
t10=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_3969,a[2]=t4,a[3]=t2,a[4]=t6,a[5]=t7,a[6]=t8,a[7]=t1,a[8]=t3,tmp=(C_word)a,a+=9,tmp);
if(C_truep((C_word)C_i_nullp(t9))){
t11=t10;
f_3969(2,t11,C_SCHEME_FALSE);}
else{
t11=(C_word)C_i_cdr(t9);
if(C_truep((C_word)C_i_nullp(t11))){
t12=t10;
f_3969(2,t12,(C_word)C_i_car(t9));}
else{
/* ##sys#error */
t12=*((C_word*)lf[62]+1);
((C_proc4)(void*)(*((C_word*)t12+1)))(4,t12,t10,lf[2],t9);}}}

/* k3967 in ##sys#process in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3969(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[14],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3969,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_3972,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[6],a[6]=((C_word*)t0)[7],a[7]=((C_word*)t0)[8],tmp=(C_word)a,a+=8,tmp);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_4060,a[2]=t2,tmp=(C_word)a,a+=3,tmp);
t4=(C_word)C_a_i_cons(&a,2,((C_word*)t0)[8],((C_word*)t0)[2]);
/* posixwin.scm: 1905 $quote-args-list */
t5=lf[281];
f_3455(t5,t3,t4,t1);}

/* k4058 in k3967 in ##sys#process in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4060(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1905 string-intersperse */
t2=*((C_word*)lf[108]+1);
((C_proc3)C_retrieve_proc(t2))(3,t2,((C_word*)t0)[2],t1);}

/* k3970 in k3967 in ##sys#process in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3972(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word ab[25],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3972,2,t0,t1);}
t2=(C_word)C_a_i_bytevector(&a,1,C_fix(1));
t3=(C_word)C_i_foreign_fixnum_argumentp(C_fix(-1));
t4=((*(int *)C_data_pointer(t2))=C_unfix(t3),C_SCHEME_UNDEFINED);
t5=(C_word)C_a_i_bytevector(&a,1,C_fix(1));
t6=(C_word)C_i_foreign_fixnum_argumentp(C_fix(-1));
t7=((*(int *)C_data_pointer(t5))=C_unfix(t6),C_SCHEME_UNDEFINED);
t8=(C_word)C_a_i_bytevector(&a,1,C_fix(1));
t9=(C_word)C_i_foreign_fixnum_argumentp(C_fix(-1));
t10=((*(int *)C_data_pointer(t8))=C_unfix(t9),C_SCHEME_UNDEFINED);
t11=(C_word)C_a_i_bytevector(&a,1,C_fix(1));
t12=(C_word)C_i_foreign_fixnum_argumentp(C_fix(-1));
t13=((*(int *)C_data_pointer(t11))=C_unfix(t12),C_SCHEME_UNDEFINED);
t14=(*a=C_CLOSURE_TYPE|12,a[1]=(C_word)f_4028,a[2]=((C_word*)t0)[2],a[3]=t8,a[4]=((C_word*)t0)[3],a[5]=t5,a[6]=((C_word*)t0)[4],a[7]=t11,a[8]=((C_word*)t0)[5],a[9]=t2,a[10]=((C_word*)t0)[6],a[11]=t1,a[12]=((C_word*)t0)[7],tmp=(C_word)a,a+=13,tmp);
/* ##sys#make-locative */
t15=*((C_word*)lf[303]+1);
((C_proc6)C_retrieve_proc(t15))(6,t15,t14,t2,C_fix(0),C_SCHEME_FALSE,lf[304]);}

/* k4026 in k3970 in k3967 in ##sys#process in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4028(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[14],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4028,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|13,a[1]=(C_word)f_4032,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],a[9]=((C_word*)t0)[9],a[10]=((C_word*)t0)[10],a[11]=t1,a[12]=((C_word*)t0)[11],a[13]=((C_word*)t0)[12],tmp=(C_word)a,a+=14,tmp);
/* ##sys#make-locative */
t3=*((C_word*)lf[303]+1);
((C_proc6)C_retrieve_proc(t3))(6,t3,t2,((C_word*)t0)[5],C_fix(0),C_SCHEME_FALSE,lf[304]);}

/* k4030 in k4026 in k3970 in k3967 in ##sys#process in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4032(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[15],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4032,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|14,a[1]=(C_word)f_4036,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],a[9]=((C_word*)t0)[9],a[10]=((C_word*)t0)[10],a[11]=t1,a[12]=((C_word*)t0)[11],a[13]=((C_word*)t0)[12],a[14]=((C_word*)t0)[13],tmp=(C_word)a,a+=15,tmp);
/* ##sys#make-locative */
t3=*((C_word*)lf[303]+1);
((C_proc6)C_retrieve_proc(t3))(6,t3,t2,((C_word*)t0)[3],C_fix(0),C_SCHEME_FALSE,lf[304]);}

/* k4034 in k4030 in k4026 in k3970 in k3967 in ##sys#process in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4036(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[16],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4036,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|15,a[1]=(C_word)f_4040,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],a[9]=((C_word*)t0)[9],a[10]=((C_word*)t0)[10],a[11]=t1,a[12]=((C_word*)t0)[11],a[13]=((C_word*)t0)[12],a[14]=((C_word*)t0)[13],a[15]=((C_word*)t0)[14],tmp=(C_word)a,a+=16,tmp);
/* ##sys#make-locative */
t3=*((C_word*)lf[303]+1);
((C_proc6)C_retrieve_proc(t3))(6,t3,t2,((C_word*)t0)[7],C_fix(0),C_SCHEME_FALSE,lf[304]);}

/* k4038 in k4034 in k4030 in k4026 in k3970 in k3967 in ##sys#process in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4040(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[17],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4040,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|16,a[1]=(C_word)f_4044,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],a[9]=((C_word*)t0)[9],a[10]=((C_word*)t0)[10],a[11]=t1,a[12]=((C_word*)t0)[11],a[13]=((C_word*)t0)[12],a[14]=((C_word*)t0)[13],a[15]=((C_word*)t0)[14],a[16]=((C_word*)t0)[15],tmp=(C_word)a,a+=17,tmp);
t3=(C_truep(((C_word*)t0)[6])?C_fix(0):C_fix(1));
t4=(C_truep(((C_word*)t0)[4])?C_fix(0):C_fix(2));
t5=(C_truep(((C_word*)t0)[8])?C_fix(0):C_fix(4));
/* posixwin.scm: 1912 + */
C_plus(5,0,t2,t3,t4,t5);}

/* k4042 in k4038 in k4034 in k4030 in k4026 in k3970 in k3967 in ##sys#process in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4044(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word ab[18],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4044,2,t0,t1);}
t2=((C_word*)t0)[16];
t3=((C_word*)t0)[15];
t4=((C_word*)t0)[14];
t5=((C_word*)t0)[13];
t6=((C_word*)t0)[12];
t7=((C_word*)t0)[11];
t8=(*a=C_CLOSURE_TYPE|17,a[1]=(C_word)f_3907,a[2]=t3,a[3]=((C_word*)t0)[15],a[4]=((C_word*)t0)[2],a[5]=((C_word*)t0)[3],a[6]=((C_word*)t0)[4],a[7]=((C_word*)t0)[5],a[8]=((C_word*)t0)[6],a[9]=((C_word*)t0)[7],a[10]=((C_word*)t0)[8],a[11]=((C_word*)t0)[9],a[12]=((C_word*)t0)[10],a[13]=t1,a[14]=t7,a[15]=t6,a[16]=t5,a[17]=t4,tmp=(C_word)a,a+=18,tmp);
if(C_truep(t2)){
t9=(C_word)C_i_foreign_string_argumentp(t2);
/* ##sys#make-c-string */
t10=*((C_word*)lf[39]+1);
((C_proc3)(void*)(*((C_word*)t10+1)))(3,t10,t8,t9);}
else{
t9=t8;
f_3907(2,t9,C_SCHEME_FALSE);}}

/* k3905 in k4042 in k4038 in k4034 in k4030 in k4026 in k3970 in k3967 in ##sys#process in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3907(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[18],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3907,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|17,a[1]=(C_word)f_3911,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[6],a[6]=((C_word*)t0)[7],a[7]=((C_word*)t0)[8],a[8]=((C_word*)t0)[9],a[9]=((C_word*)t0)[10],a[10]=((C_word*)t0)[11],a[11]=((C_word*)t0)[12],a[12]=t1,a[13]=((C_word*)t0)[13],a[14]=((C_word*)t0)[14],a[15]=((C_word*)t0)[15],a[16]=((C_word*)t0)[16],a[17]=((C_word*)t0)[17],tmp=(C_word)a,a+=18,tmp);
if(C_truep(((C_word*)t0)[2])){
t3=(C_word)C_i_foreign_string_argumentp(((C_word*)t0)[2]);
/* ##sys#make-c-string */
t4=*((C_word*)lf[39]+1);
((C_proc3)(void*)(*((C_word*)t4+1)))(3,t4,t2,t3);}
else{
t3=t2;
f_3911(2,t3,C_SCHEME_FALSE);}}

/* k3909 in k3905 in k4042 in k4038 in k4034 in k4030 in k4026 in k3970 in k3967 in ##sys#process in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3911(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word ab[13],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3911,2,t0,t1);}
t2=(C_truep(((C_word*)t0)[17])?(C_word)C_i_foreign_pointer_argumentp(((C_word*)t0)[17]):C_SCHEME_FALSE);
t3=(C_truep(((C_word*)t0)[16])?(C_word)C_i_foreign_pointer_argumentp(((C_word*)t0)[16]):C_SCHEME_FALSE);
t4=(C_truep(((C_word*)t0)[15])?(C_word)C_i_foreign_pointer_argumentp(((C_word*)t0)[15]):C_SCHEME_FALSE);
t5=(C_truep(((C_word*)t0)[14])?(C_word)C_i_foreign_pointer_argumentp(((C_word*)t0)[14]):C_SCHEME_FALSE);
t6=(C_word)C_i_foreign_fixnum_argumentp(((C_word*)t0)[13]);
if(C_truep((C_word)stub615(C_SCHEME_UNDEFINED,((C_word*)t0)[12],t1,C_SCHEME_FALSE,t2,t3,t4,t5,t6))){
t7=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_4001,a[2]=((C_word*)t0)[6],a[3]=((C_word*)t0)[7],a[4]=((C_word*)t0)[8],a[5]=((C_word*)t0)[9],a[6]=((C_word*)t0)[10],a[7]=((C_word*)t0)[11],tmp=(C_word)a,a+=8,tmp);
if(C_truep(((C_word*)t0)[5])){
/* posixwin.scm: 1915 open-input-file* */
t8=*((C_word*)lf[233]+1);
((C_proc3)C_retrieve_proc(t8))(3,t8,t7,C_fix((C_word)*((int *)C_data_pointer(((C_word*)t0)[4]))));}
else{
t8=t7;
f_4001(2,t8,C_SCHEME_FALSE);}}
else{
t7=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_4021,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[11],tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm: 1920 ##sys#update-errno */
t8=*((C_word*)lf[9]+1);
((C_proc2)(void*)(*((C_word*)t8+1)))(2,t8,t7);}}

/* k4019 in k3909 in k3905 in k4042 in k4038 in k4034 in k4030 in k4026 in k3970 in k3967 in ##sys#process in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4021(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1921 ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);
((C_proc6)(void*)(*((C_word*)t2+1)))(6,t2,((C_word*)t0)[4],lf[301],((C_word*)t0)[3],lf[302],((C_word*)t0)[2]);}

/* k3999 in k3909 in k3905 in k4042 in k4038 in k4034 in k4030 in k4026 in k3970 in k3967 in ##sys#process in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4001(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[7],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4001,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_4005,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[5],a[4]=((C_word*)t0)[6],a[5]=t1,a[6]=((C_word*)t0)[7],tmp=(C_word)a,a+=7,tmp);
if(C_truep(((C_word*)t0)[3])){
/* posixwin.scm: 1916 open-output-file* */
t3=*((C_word*)lf[234]+1);
((C_proc3)C_retrieve_proc(t3))(3,t3,t2,C_fix((C_word)*((int *)C_data_pointer(((C_word*)t0)[2]))));}
else{
t3=t2;
f_4005(2,t3,C_SCHEME_FALSE);}}

/* k4003 in k3999 in k3909 in k3905 in k4042 in k4038 in k4034 in k4030 in k4026 in k3970 in k3967 in ##sys#process in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4005(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[6],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_4005,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_4009,a[2]=((C_word*)t0)[4],a[3]=t1,a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[6],tmp=(C_word)a,a+=6,tmp);
if(C_truep(((C_word*)t0)[3])){
/* posixwin.scm: 1918 open-input-file* */
t3=*((C_word*)lf[233]+1);
((C_proc3)C_retrieve_proc(t3))(3,t3,t2,C_fix((C_word)*((int *)C_data_pointer(((C_word*)t0)[2]))));}
else{
t3=t2;
f_4009(2,t3,C_SCHEME_FALSE);}}

/* k4007 in k4003 in k3999 in k3909 in k3905 in k4042 in k4038 in k4034 in k4030 in k4026 in k3970 in k3967 in ##sys#process in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_4009(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1914 values */
C_values(6,0,((C_word*)t0)[5],((C_word*)t0)[4],((C_word*)t0)[3],C_fix((C_word)*((int *)C_data_pointer(((C_word*)t0)[2]))),t1);}

/* close-handle in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3899(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_3899,3,t0,t1,t2);}
t3=t1;
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,(C_word)stub603(C_SCHEME_UNDEFINED,t2));}

/* process-run in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3870(C_word c,C_word t0,C_word t1,C_word t2,...){
C_word tmp;
C_word t3;
va_list v;
C_word *a,c2=c;
C_save_rest(t2,c2,3);
if(c<3) C_bad_min_argc_2(c,3,t0);
if(!C_demand(c*C_SIZEOF_PAIR+5)){
C_save_and_reclaim((void*)tr3rv,(void*)f_3870r,3,t0,t1,t2);}
else{
a=C_alloc((c-3)*3);
t3=C_restore_rest_vector(a,C_rest_count(0));
f_3870r(t0,t1,t2,t3);}}

static void C_ccall f_3870r(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a=C_alloc(5);
t4=(C_word)C_notvemptyp(t3);
t5=(C_truep(t4)?(C_word)C_i_vector_ref(t3,C_fix(0)):C_SCHEME_FALSE);
if(C_truep(t5)){
/* posixwin.scm: 1873 process-spawn */
t6=((C_word*)t0)[2];
((C_proc5)C_retrieve_proc(t6))(5,t6,t1,*((C_word*)lf[277]+1),t2,t5);}
else{
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3887,a[2]=t2,a[3]=t1,a[4]=((C_word*)t0)[2],tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm: 1874 ##sys#shell-command */
t7=*((C_word*)lf[292]+1);
((C_proc2)C_retrieve_proc(t7))(2,t7,t6);}}

/* k3885 in process-run in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3887(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[5],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3887,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3891,a[2]=t1,a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm: 1874 ##sys#shell-command-arguments */
t3=*((C_word*)lf[296]+1);
((C_proc3)C_retrieve_proc(t3))(3,t3,t2,((C_word*)t0)[2]);}

/* k3889 in k3885 in process-run in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3891(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1874 process-spawn */
t2=((C_word*)t0)[4];
((C_proc5)C_retrieve_proc(t2))(5,t2,((C_word*)t0)[3],*((C_word*)lf[277]+1),((C_word*)t0)[2],t1);}

/* ##sys#shell-command-arguments in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3864(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word ab[6],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_3864,3,t0,t1,t2);}
t3=t1;
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,(C_word)C_a_i_list(&a,2,lf[297],t2));}

/* ##sys#shell-command in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3843(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[3],*a=ab;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3843,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3847,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm: 1857 getenv */
t3=*((C_word*)lf[294]+1);
((C_proc3)C_retrieve_proc(t3))(3,t3,t2,lf[295]);}

/* k3845 in ##sys#shell-command in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3847(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[6],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3847,2,t0,t1);}
if(C_truep(t1)){
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,t1);}
else{
if(C_truep((C_word)C_get_shlcmd())){
/* ##sys#peek-c-string */
t2=*((C_word*)lf[8]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,((C_word*)t0)[2],C_mpointer(&a,(void*)C_shlcmd),C_fix(0));}
else{
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3859,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm: 1861 ##sys#update-errno */
t3=*((C_word*)lf[9]+1);
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,t2);}}}

/* k3857 in k3845 in ##sys#shell-command in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3859(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1862 ##sys#error */
t2=*((C_word*)lf[62]+1);
((C_proc4)(void*)(*((C_word*)t2+1)))(4,t2,((C_word*)t0)[2],lf[292],lf[293]);}

/* current-process-id in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3840(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3840,2,t0,t1);}
t2=t1;
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,(C_word)stub591(C_SCHEME_UNDEFINED));}

/* process-spawn in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3753(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...){
C_word tmp;
C_word t4;
va_list v;
C_word *a,c2=c;
C_save_rest(t3,c2,4);
if(c<4) C_bad_min_argc_2(c,4,t0);
if(!C_demand(c*C_SIZEOF_PAIR+17)){
C_save_and_reclaim((void*)tr4r,(void*)f_3753r,4,t0,t1,t2,t3);}
else{
a=C_alloc((c-4)*3);
t4=C_restore_rest(a,C_rest_count(0));
f_3753r(t0,t1,t2,t3,t4);}}

static void C_ccall f_3753r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word t15;
C_word *a=C_alloc(17);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3755,a[2]=t3,a[3]=t2,a[4]=((C_word)li106),tmp=(C_word)a,a+=5,tmp);
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3767,a[2]=t5,a[3]=((C_word)li107),tmp=(C_word)a,a+=4,tmp);
t7=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3772,a[2]=t6,a[3]=((C_word)li108),tmp=(C_word)a,a+=4,tmp);
t8=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3777,a[2]=t7,a[3]=((C_word)li109),tmp=(C_word)a,a+=4,tmp);
if(C_truep((C_word)C_i_nullp(t4))){
/* def-arglst570584 */
t9=t8;
f_3777(t9,t1);}
else{
t9=(C_word)C_i_car(t4);
t10=(C_word)C_i_cdr(t4);
if(C_truep((C_word)C_i_nullp(t10))){
/* def-envlst571582 */
t11=t7;
f_3772(t11,t1,t9);}
else{
t11=(C_word)C_i_car(t10);
t12=(C_word)C_i_cdr(t10);
if(C_truep((C_word)C_i_nullp(t12))){
/* def-exactf572579 */
t13=t6;
f_3767(t13,t1,t9,t11);}
else{
t13=(C_word)C_i_car(t12);
t14=(C_word)C_i_cdr(t12);
if(C_truep((C_word)C_i_nullp(t14))){
/* body568574 */
t15=t5;
f_3755(t15,t1,t9,t11,t13);}
else{
/* ##sys#error */
t15=*((C_word*)lf[62]+1);
((C_proc4)(void*)(*((C_word*)t15+1)))(4,t15,t1,lf[2],t14);}}}}}

/* def-arglst570 in process-spawn in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_3777(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_3777,NULL,2,t0,t1);}
/* def-envlst571582 */
t2=((C_word*)t0)[2];
f_3772(t2,t1,C_SCHEME_FALSE);}

/* def-envlst571 in process-spawn in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_3772(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_3772,NULL,3,t0,t1,t2);}
/* def-exactf572579 */
t3=((C_word*)t0)[2];
f_3767(t3,t1,t2,C_SCHEME_FALSE);}

/* def-exactf572 in process-spawn in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_3767(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_3767,NULL,4,t0,t1,t2,t3);}
/* body568574 */
t4=((C_word*)t0)[2];
f_3755(t4,t1,t2,t3,C_SCHEME_FALSE);}

/* body568 in process-spawn in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_3755(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word ab[6],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_3755,NULL,5,t0,t1,t2,t3,t4);}
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_3759,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=t3,tmp=(C_word)a,a+=6,tmp);
/* posixwin.scm: 1848 $exec-setup */
t6=lf[285];
f_3618(t6,t5,lf[289],((C_word*)t0)[2],t2,t3,t4);}

/* k3757 in body568 in process-spawn in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3759(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
t2=(C_truep(((C_word*)t0)[5])?(C_word)C_spawnvpe(((C_word*)t0)[4],t1):(C_word)C_spawnvp(((C_word*)t0)[4],t1));
/* posixwin.scm: 1849 $exec-teardown */
f_3651(((C_word*)t0)[3],lf[289],lf[290],((C_word*)t0)[2],t2);}

/* process-execute in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3666(C_word c,C_word t0,C_word t1,C_word t2,...){
C_word tmp;
C_word t3;
va_list v;
C_word *a,c2=c;
C_save_rest(t2,c2,3);
if(c<3) C_bad_min_argc_2(c,3,t0);
if(!C_demand(c*C_SIZEOF_PAIR+16)){
C_save_and_reclaim((void*)tr3r,(void*)f_3666r,3,t0,t1,t2);}
else{
a=C_alloc((c-3)*3);
t3=C_restore_rest(a,C_rest_count(0));
f_3666r(t0,t1,t2,t3);}}

static void C_ccall f_3666r(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word t13;
C_word t14;
C_word *a=C_alloc(16);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3668,a[2]=t2,a[3]=((C_word)li101),tmp=(C_word)a,a+=4,tmp);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3680,a[2]=t4,a[3]=((C_word)li102),tmp=(C_word)a,a+=4,tmp);
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3685,a[2]=t5,a[3]=((C_word)li103),tmp=(C_word)a,a+=4,tmp);
t7=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3690,a[2]=t6,a[3]=((C_word)li104),tmp=(C_word)a,a+=4,tmp);
if(C_truep((C_word)C_i_nullp(t3))){
/* def-arglst540554 */
t8=t7;
f_3690(t8,t1);}
else{
t8=(C_word)C_i_car(t3);
t9=(C_word)C_i_cdr(t3);
if(C_truep((C_word)C_i_nullp(t9))){
/* def-envlst541552 */
t10=t6;
f_3685(t10,t1,t8);}
else{
t10=(C_word)C_i_car(t9);
t11=(C_word)C_i_cdr(t9);
if(C_truep((C_word)C_i_nullp(t11))){
/* def-exactf542549 */
t12=t5;
f_3680(t12,t1,t8,t10);}
else{
t12=(C_word)C_i_car(t11);
t13=(C_word)C_i_cdr(t11);
if(C_truep((C_word)C_i_nullp(t13))){
/* body538544 */
t14=t4;
f_3668(t14,t1,t8,t10,t12);}
else{
/* ##sys#error */
t14=*((C_word*)lf[62]+1);
((C_proc4)(void*)(*((C_word*)t14+1)))(4,t14,t1,lf[2],t13);}}}}}

/* def-arglst540 in process-execute in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_3690(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_3690,NULL,2,t0,t1);}
/* def-envlst541552 */
t2=((C_word*)t0)[2];
f_3685(t2,t1,C_SCHEME_FALSE);}

/* def-envlst541 in process-execute in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_3685(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_3685,NULL,3,t0,t1,t2);}
/* def-exactf542549 */
t3=((C_word*)t0)[2];
f_3680(t3,t1,t2,C_SCHEME_FALSE);}

/* def-exactf542 in process-execute in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_3680(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_3680,NULL,4,t0,t1,t2,t3);}
/* body538544 */
t4=((C_word*)t0)[2];
f_3668(t4,t1,t2,t3,C_SCHEME_FALSE);}

/* body538 in process-execute in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_3668(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word ab[5],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_3668,NULL,5,t0,t1,t2,t3,t4);}
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3672,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm: 1843 $exec-setup */
t6=lf[285];
f_3618(t6,t5,lf[287],((C_word*)t0)[2],t2,t3,t4);}

/* k3670 in body538 in process-execute in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3672(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
t2=(C_truep(((C_word*)t0)[4])?(C_word)C_execve(t1):(C_word)C_execvp(t1));
/* posixwin.scm: 1844 $exec-teardown */
f_3651(((C_word*)t0)[3],lf[287],lf[288],((C_word*)t0)[2],t2);}

/* $exec-teardown in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_3651(C_word t1,C_word t2,C_word t3,C_word t4,C_word t5){
C_word tmp;
C_word t6;
C_word t7;
C_word ab[7],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_3651,NULL,5,t1,t2,t3,t4,t5);}
t6=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_3655,a[2]=t4,a[3]=t3,a[4]=t2,a[5]=t1,a[6]=t5,tmp=(C_word)a,a+=7,tmp);
/* posixwin.scm: 1835 ##sys#update-errno */
t7=*((C_word*)lf[9]+1);
((C_proc2)(void*)(*((C_word*)t7+1)))(2,t7,t6);}

/* k3653 in $exec-teardown in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3655(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word *a;
t2=(C_word)C_free_exec_args();
t3=(C_word)C_free_exec_env();
t4=(C_word)C_eqp(((C_word*)t0)[6],C_fix(-1));
if(C_truep(t4)){
/* posixwin.scm: 1839 ##sys#error */
t5=*((C_word*)lf[62]+1);
((C_proc5)(void*)(*((C_word*)t5+1)))(5,t5,((C_word*)t0)[5],((C_word*)t0)[4],((C_word*)t0)[3],((C_word*)t0)[2]);}
else{
t5=((C_word*)t0)[5];
((C_proc2)(void*)(*((C_word*)t5+1)))(2,t5,((C_word*)t0)[6]);}}

/* $exec-setup in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_3618(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5,C_word t6){
C_word tmp;
C_word t7;
C_word t8;
C_word t9;
C_word ab[11],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_3618,NULL,7,t0,t1,t2,t3,t4,t5,t6);}
t7=(C_word)C_i_check_string_2(t3,t2);
t8=(*a=C_CLOSURE_TYPE|10,a[1]=(C_word)f_3625,a[2]=t6,a[3]=t4,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=t5,a[7]=t2,a[8]=((C_word*)t0)[5],a[9]=t3,a[10]=t1,tmp=(C_word)a,a+=11,tmp);
/* posixwin.scm: 1827 pathname-strip-directory */
t9=((C_word*)t0)[2];
((C_proc3)C_retrieve_proc(t9))(3,t9,t8,t3);}

/* k3623 in $exec-setup in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3625(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[11],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3625,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|10,a[1]=(C_word)f_3628,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],a[9]=((C_word*)t0)[9],a[10]=((C_word*)t0)[10],tmp=(C_word)a,a+=11,tmp);
t3=(C_word)C_block_size(t1);
/* posixwin.scm: 1828 setarg */
t4=((C_word*)t0)[4];
f_3534(5,t4,t2,C_fix(0),t1,t3);}

/* k3626 in k3623 in $exec-setup in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3628(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[14],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3628,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_3631,a[2]=((C_word*)t0)[5],a[3]=((C_word*)t0)[6],a[4]=((C_word*)t0)[7],a[5]=((C_word*)t0)[8],a[6]=((C_word*)t0)[9],a[7]=((C_word*)t0)[10],tmp=(C_word)a,a+=8,tmp);
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_3645,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[7],a[4]=t2,a[5]=((C_word*)t0)[8],tmp=(C_word)a,a+=6,tmp);
/* posixwin.scm: 1829 $quote-args-list */
t4=lf[281];
f_3455(t4,t3,((C_word*)t0)[3],((C_word*)t0)[2]);}

/* k3643 in k3626 in k3623 in $exec-setup in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3645(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1829 build-exec-argvec */
f_3568(((C_word*)t0)[4],((C_word*)t0)[3],t1,((C_word*)t0)[2],C_fix(1));}

/* k3629 in k3626 in k3623 in $exec-setup in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3631(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3631,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3634,a[2]=((C_word*)t0)[6],a[3]=((C_word*)t0)[7],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1830 build-exec-argvec */
f_3568(t2,((C_word*)t0)[4],((C_word*)t0)[3],((C_word*)t0)[2],C_fix(0));}

/* k3632 in k3629 in k3626 in k3623 in $exec-setup in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3634(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[3],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3634,2,t0,t1);}
t2=(C_word)C_flushall();
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3641,a[2]=((C_word*)t0)[3],tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm: 1832 ##sys#expand-home-path */
t4=*((C_word*)lf[40]+1);
((C_proc3)C_retrieve_proc(t4))(3,t4,t3,((C_word*)t0)[2]);}

/* k3639 in k3632 in k3629 in k3626 in k3623 in $exec-setup in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3641(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1832 ##sys#make-c-string */
t2=*((C_word*)lf[39]+1);
((C_proc3)(void*)(*((C_word*)t2+1)))(3,t2,((C_word*)t0)[2],t1);}

/* build-exec-argvec in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_3568(C_word t1,C_word t2,C_word t3,C_word t4,C_word t5){
C_word tmp;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word ab[8],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_3568,NULL,5,t1,t2,t3,t4,t5);}
if(C_truep(t3)){
t6=(C_word)C_i_check_list_2(t3,t2);
t7=C_SCHEME_UNDEFINED;
t8=(*a=C_VECTOR_TYPE|1,a[1]=t7,tmp=(C_word)a,a+=2,tmp);
t9=C_set_block_item(t8,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_3580,a[2]=t8,a[3]=t2,a[4]=t4,a[5]=((C_word)li97),tmp=(C_word)a,a+=6,tmp));
t10=((C_word*)t8)[1];
f_3580(t10,t1,t3,t5);}
else{
/* posixwin.scm: 1824 argvec-setter */
t6=t4;
((C_proc5)C_retrieve_proc(t6))(5,t6,t1,t5,C_SCHEME_FALSE,C_fix(0));}}

/* do505 in build-exec-argvec in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_3580(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word ab[6],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_3580,NULL,4,t0,t1,t2,t3);}
if(C_truep((C_word)C_i_nullp(t2))){
/* posixwin.scm: 1820 argvec-setter */
t4=((C_word*)t0)[4];
((C_proc5)C_retrieve_proc(t4))(5,t4,t1,t3,C_SCHEME_FALSE,C_fix(0));}
else{
t4=(C_word)C_i_car(t2);
t5=(C_word)C_i_check_string_2(t4,((C_word*)t0)[3]);
t6=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_3599,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=t3,a[5]=t2,tmp=(C_word)a,a+=6,tmp);
t7=(C_word)C_block_size(t4);
/* posixwin.scm: 1823 argvec-setter */
t8=((C_word*)t0)[4];
((C_proc5)C_retrieve_proc(t8))(5,t8,t6,t3,t4,t7);}}

/* k3597 in do505 in build-exec-argvec in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3599(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
t2=(C_word)C_i_cdr(((C_word*)t0)[5]);
t3=(C_word)C_fixnum_plus(((C_word*)t0)[4],C_fix(1));
t4=((C_word*)((C_word*)t0)[3])[1];
f_3580(t4,((C_word*)t0)[2],t2,t3);}

/* setenv in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3551(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr5,(void*)f_3551,5,t0,t1,t2,t3,t4);}
t5=(C_word)C_i_foreign_fixnum_argumentp(t2);
t6=(C_truep(t3)?(C_word)C_i_foreign_block_argumentp(t3):C_SCHEME_FALSE);
t7=(C_word)C_i_foreign_fixnum_argumentp(t4);
t8=t1;
((C_proc2)(void*)(*((C_word*)t8+1)))(2,t8,(C_word)stub494(C_SCHEME_UNDEFINED,t5,t6,t7));}

/* setarg in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3534(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
if(c!=5) C_bad_argc_2(c,5,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr5,(void*)f_3534,5,t0,t1,t2,t3,t4);}
t5=(C_word)C_i_foreign_fixnum_argumentp(t2);
t6=(C_truep(t3)?(C_word)C_i_foreign_block_argumentp(t3):C_SCHEME_FALSE);
t7=(C_word)C_i_foreign_fixnum_argumentp(t4);
t8=t1;
((C_proc2)(void*)(*((C_word*)t8+1)))(2,t8,(C_word)stub484(C_SCHEME_UNDEFINED,t5,t6,t7));}

/* $quote-args-list in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_3455(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word ab[14],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_3455,NULL,4,t0,t1,t2,t3);}
if(C_truep(t3)){
t4=t1;
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,t2);}
else{
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_3460,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=((C_word)li92),tmp=(C_word)a,a+=6,tmp);
t5=C_SCHEME_UNDEFINED;
t6=(*a=C_VECTOR_TYPE|1,a[1]=t5,tmp=(C_word)a,a+=2,tmp);
t7=C_set_block_item(t6,0,(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_3498,a[2]=t4,a[3]=((C_word*)t0)[2],a[4]=t6,a[5]=((C_word)li93),tmp=(C_word)a,a+=6,tmp));
t8=((C_word*)t6)[1];
f_3498(t8,t1,t2,C_SCHEME_END_OF_LIST);}}

/* loop in $quote-args-list in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_3498(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word ab[11],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_3498,NULL,4,t0,t1,t2,t3);}
if(C_truep((C_word)C_i_nullp(t2))){
/* posixwin.scm: 1801 reverse */
t4=*((C_word*)lf[117]+1);
((C_proc3)(void*)(*((C_word*)t4+1)))(3,t4,t1,t3);}
else{
t4=(C_word)C_i_car(t2);
t5=(C_word)C_i_cdr(t2);
t6=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_3526,a[2]=t5,a[3]=t1,a[4]=((C_word*)t0)[4],a[5]=t3,tmp=(C_word)a,a+=6,tmp);
t7=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3529,a[2]=t4,a[3]=t6,a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm: 1806 needs-quoting? */
t8=((C_word*)t0)[2];
f_3460(t8,t7,t4);}}

/* k3527 in loop in $quote-args-list in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3529(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(C_truep(t1)){
/* posixwin.scm: 1806 string-append */
t2=((C_word*)t0)[4];
((C_proc5)C_retrieve_proc(t2))(5,t2,((C_word*)t0)[3],lf[282],((C_word*)t0)[2],lf[283]);}
else{
t2=((C_word*)t0)[3];
f_3526(2,t2,((C_word*)t0)[2]);}}

/* k3524 in loop in $quote-args-list in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3526(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[3],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3526,2,t0,t1);}
t2=(C_word)C_a_i_cons(&a,2,t1,((C_word*)t0)[5]);
/* posixwin.scm: 1803 loop */
t3=((C_word*)((C_word*)t0)[4])[1];
f_3498(t3,((C_word*)t0)[3],((C_word*)t0)[2],t2);}

/* needs-quoting? in $quote-args-list in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_3460(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word ab[6],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_3460,NULL,3,t0,t1,t2);}
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_3464,a[2]=t1,a[3]=t2,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
/* posixwin.scm: 1793 string-length */
t4=((C_word*)t0)[2];
((C_proc3)C_retrieve_proc(t4))(3,t4,t3,t2);}

/* k3462 in needs-quoting? in $quote-args-list in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3464(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[10],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3464,2,t0,t1);}
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_3469,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=t3,a[6]=t1,a[7]=((C_word)li91),tmp=(C_word)a,a+=8,tmp));
t5=((C_word*)t3)[1];
f_3469(t5,((C_word*)t0)[2],C_fix(0));}

/* loop in k3462 in needs-quoting? in $quote-args-list in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_3469(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[9],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_3469,NULL,3,t0,t1,t2);}
t3=(C_word)C_eqp(t2,((C_word*)t0)[6]);
if(C_truep(t3)){
t4=t1;
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,C_SCHEME_FALSE);}
else{
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3482,a[2]=((C_word*)t0)[5],a[3]=t2,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3493,a[2]=t4,a[3]=((C_word*)t0)[4],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1797 string-ref */
t6=((C_word*)t0)[3];
((C_proc4)C_retrieve_proc(t6))(4,t6,t5,((C_word*)t0)[2],t2);}}

/* k3491 in loop in k3462 in needs-quoting? in $quote-args-list in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3493(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1797 char-whitespace? */
t2=((C_word*)t0)[3];
((C_proc3)C_retrieve_proc(t2))(3,t2,((C_word*)t0)[2],t1);}

/* k3480 in loop in k3462 in needs-quoting? in $quote-args-list in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3482(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_truep(t1)){
t2=((C_word*)t0)[4];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_SCHEME_TRUE);}
else{
t2=(C_word)C_fixnum_plus(((C_word*)t0)[3],C_fix(1));
/* posixwin.scm: 1798 loop */
t3=((C_word*)((C_word*)t0)[2])[1];
f_3469(t3,((C_word*)t0)[4],t2);}}

/* glob in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3340(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
va_list v;
C_word *a,c2=c;
C_save_rest(t1,c2,2);
if(!C_demand(c*C_SIZEOF_PAIR+13)){
C_save_and_reclaim((void*)tr2r,(void*)f_3340r,2,t0,t1);}
else{
a=C_alloc((c-2)*3);
t2=C_restore_rest(a,C_rest_count(0));
f_3340r(t0,t1,t2);}}

static void C_ccall f_3340r(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a=C_alloc(13);
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|10,a[1]=(C_word)f_3346,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=t4,a[9]=((C_word*)t0)[8],a[10]=((C_word)li89),tmp=(C_word)a,a+=11,tmp));
t6=((C_word*)t4)[1];
f_3346(t6,t1,t2);}

/* conc-loop in glob in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_3346(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[16],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_3346,NULL,3,t0,t1,t2);}
if(C_truep((C_word)C_i_nullp(t2))){
t3=t1;
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,C_SCHEME_END_OF_LIST);}
else{
t3=(C_word)C_i_car(t2);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3361,a[2]=t3,a[3]=((C_word*)t0)[9],a[4]=((C_word)li86),tmp=(C_word)a,a+=5,tmp);
t5=(*a=C_CLOSURE_TYPE|10,a[1]=(C_word)f_3367,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],a[9]=t2,a[10]=((C_word)li88),tmp=(C_word)a,a+=11,tmp);
/* ##sys#call-with-values */
C_call_with_values(4,0,t1,t4,t5);}}

/* a3366 in conc-loop in glob in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3367(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word ab[15],*a=ab;
if(c!=5) C_bad_argc_2(c,5,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr5,(void*)f_3367,5,t0,t1,t2,t3,t4);}
t5=(*a=C_CLOSURE_TYPE|10,a[1]=(C_word)f_3371,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=t1,a[6]=((C_word*)t0)[6],a[7]=t2,a[8]=((C_word*)t0)[7],a[9]=((C_word*)t0)[8],a[10]=((C_word*)t0)[9],tmp=(C_word)a,a+=11,tmp);
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3444,a[2]=t5,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
t7=(C_truep(t3)?t3:lf[274]);
/* posixwin.scm: 1754 make-pathname */
t8=((C_word*)t0)[7];
((C_proc5)C_retrieve_proc(t8))(5,t8,t6,C_SCHEME_FALSE,t7,t4);}

/* k3442 in a3366 in conc-loop in glob in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3444(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1754 glob->regexp */
t2=((C_word*)t0)[3];
((C_proc3)C_retrieve_proc(t2))(3,t2,((C_word*)t0)[2],t1);}

/* k3369 in a3366 in conc-loop in glob in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3371(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[10],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3371,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_3374,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[6],a[6]=((C_word*)t0)[7],a[7]=((C_word*)t0)[8],a[8]=((C_word*)t0)[9],a[9]=((C_word*)t0)[10],tmp=(C_word)a,a+=10,tmp);
/* posixwin.scm: 1755 make-anchored-pattern */
t3=((C_word*)t0)[2];
((C_proc3)C_retrieve_proc(t3))(3,t3,t2,t1);}

/* k3372 in k3369 in a3366 in conc-loop in glob in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3374(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[9],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3374,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_3377,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[6],a[6]=((C_word*)t0)[7],a[7]=((C_word*)t0)[8],a[8]=((C_word*)t0)[9],tmp=(C_word)a,a+=9,tmp);
/* posixwin.scm: 1756 regexp */
t3=((C_word*)t0)[2];
((C_proc3)C_retrieve_proc(t3))(3,t3,t2,t1);}

/* k3375 in k3372 in k3369 in a3366 in conc-loop in glob in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3377(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[9],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3377,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_3384,a[2]=((C_word*)t0)[3],a[3]=t1,a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],tmp=(C_word)a,a+=9,tmp);
t3=(C_truep(((C_word*)t0)[5])?((C_word*)t0)[5]:lf[273]);
/* posixwin.scm: 1757 directory */
t4=((C_word*)t0)[2];
((C_proc4)C_retrieve_proc(t4))(4,t4,t2,t3,C_SCHEME_TRUE);}

/* k3382 in k3375 in k3372 in k3369 in a3366 in conc-loop in glob in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3384(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[12],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3384,2,t0,t1);}
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_3386,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[6],a[6]=t3,a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],a[9]=((C_word)li87),tmp=(C_word)a,a+=10,tmp));
t5=((C_word*)t3)[1];
f_3386(t5,((C_word*)t0)[2],t1);}

/* loop in k3382 in k3375 in k3372 in k3369 in a3366 in conc-loop in glob in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_3386(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[7],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_3386,NULL,3,t0,t1,t2);}
if(C_truep((C_word)C_i_nullp(t2))){
t3=(C_word)C_i_cdr(((C_word*)t0)[8]);
/* posixwin.scm: 1758 conc-loop */
t4=((C_word*)((C_word*)t0)[7])[1];
f_3346(t4,t1,t3);}
else{
t3=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_3403,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[5],a[4]=((C_word*)t0)[6],a[5]=t2,a[6]=t1,tmp=(C_word)a,a+=7,tmp);
t4=(C_word)C_i_car(t2);
/* posixwin.scm: 1759 string-match */
t5=((C_word*)t0)[3];
((C_proc4)C_retrieve_proc(t5))(4,t5,t3,((C_word*)t0)[2],t4);}}

/* k3401 in loop in k3382 in k3375 in k3372 in k3369 in a3366 in conc-loop in glob in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3403(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[5],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3403,2,t0,t1);}
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3413,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[5],a[4]=((C_word*)t0)[6],tmp=(C_word)a,a+=5,tmp);
t3=(C_word)C_i_car(t1);
/* posixwin.scm: 1760 make-pathname */
t4=((C_word*)t0)[3];
((C_proc4)C_retrieve_proc(t4))(4,t4,t2,((C_word*)t0)[2],t3);}
else{
t2=(C_word)C_i_cdr(((C_word*)t0)[5]);
/* posixwin.scm: 1761 loop */
t3=((C_word*)((C_word*)t0)[4])[1];
f_3386(t3,((C_word*)t0)[6],t2);}}

/* k3411 in k3401 in loop in k3382 in k3375 in k3372 in k3369 in a3366 in conc-loop in glob in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3413(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3413,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3417,a[2]=t1,a[3]=((C_word*)t0)[4],tmp=(C_word)a,a+=4,tmp);
t3=(C_word)C_i_cdr(((C_word*)t0)[3]);
/* posixwin.scm: 1760 loop */
t4=((C_word*)((C_word*)t0)[2])[1];
f_3386(t4,t2,t3);}

/* k3415 in k3411 in k3401 in loop in k3382 in k3375 in k3372 in k3369 in a3366 in conc-loop in glob in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3417(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word ab[3],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3417,2,t0,t1);}
t2=((C_word*)t0)[3];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,(C_word)C_a_i_cons(&a,2,((C_word*)t0)[2],t1));}

/* a3360 in conc-loop in glob in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3361(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3361,2,t0,t1);}
/* posixwin.scm: 1753 decompose-pathname */
t2=((C_word*)t0)[3];
((C_proc3)C_retrieve_proc(t2))(3,t2,t1,((C_word*)t0)[2]);}

/* set-buffering-mode! in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3281(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...){
C_word tmp;
C_word t4;
va_list v;
C_word *a,c2=c;
C_save_rest(t3,c2,4);
if(c<4) C_bad_min_argc_2(c,4,t0);
if(!C_demand(c*C_SIZEOF_PAIR+6)){
C_save_and_reclaim((void*)tr4rv,(void*)f_3281r,4,t0,t1,t2,t3);}
else{
a=C_alloc((c-4)*3);
t4=C_restore_rest_vector(a,C_rest_count(0));
f_3281r(t0,t1,t2,t3,t4);}}

static void C_ccall f_3281r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word *a=C_alloc(6);
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_3285,a[2]=t1,a[3]=t2,a[4]=t3,a[5]=t4,tmp=(C_word)a,a+=6,tmp);
/* posixwin.scm: 1724 ##sys#check-port */
t6=*((C_word*)lf[139]+1);
((C_proc4)(void*)(*((C_word*)t6+1)))(4,t6,t5,t2,lf[260]);}

/* k3283 in set-buffering-mode! in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3285(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word ab[5],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3285,2,t0,t1);}
t2=(C_word)C_notvemptyp(((C_word*)t0)[5]);
t3=(C_truep(t2)?(C_word)C_i_vector_ref(((C_word*)t0)[5],C_fix(0)):C_fix((C_word)BUFSIZ));
t4=((C_word*)t0)[4];
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3291,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t3,tmp=(C_word)a,a+=5,tmp);
t6=(C_word)C_eqp(t4,lf[262]);
if(C_truep(t6)){
t7=t5;
f_3291(2,t7,C_fix((C_word)_IOFBF));}
else{
t7=(C_word)C_eqp(t4,lf[263]);
if(C_truep(t7)){
t8=t5;
f_3291(2,t8,C_fix((C_word)_IOLBF));}
else{
t8=(C_word)C_eqp(t4,lf[264]);
if(C_truep(t8)){
t9=t5;
f_3291(2,t9,C_fix((C_word)_IONBF));}
else{
/* posixwin.scm: 1730 ##sys#error */
t9=*((C_word*)lf[62]+1);
((C_proc6)(void*)(*((C_word*)t9+1)))(6,t9,t5,lf[260],lf[265],((C_word*)t0)[4],((C_word*)t0)[3]);}}}}

/* k3289 in k3283 in set-buffering-mode! in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3291(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word *a;
t2=(C_word)C_i_check_exact_2(((C_word*)t0)[4],lf[260]);
t3=(C_word)C_slot(((C_word*)t0)[3],C_fix(7));
t4=(C_word)C_eqp(lf[81],t3);
t5=(C_truep(t4)?(C_word)C_setvbuf(((C_word*)t0)[3],t1,((C_word*)t0)[4]):C_fix(-1));
if(C_truep((C_word)C_fixnum_lessp(t5,C_fix(0)))){
/* posixwin.scm: 1736 ##sys#error */
t6=*((C_word*)lf[62]+1);
((C_proc7)(void*)(*((C_word*)t6+1)))(7,t6,((C_word*)t0)[2],lf[260],lf[261],((C_word*)t0)[3],t1,((C_word*)t0)[4]);}
else{
t6=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t6+1)))(2,t6,C_SCHEME_UNDEFINED);}}

/* _exit in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3265(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
va_list v;
C_word *a,c2=c;
C_save_rest(t1,c2,2);
if(!C_demand(c*C_SIZEOF_PAIR+0)){
C_save_and_reclaim((void*)tr2rv,(void*)f_3265r,2,t0,t1);}
else{
a=C_alloc((c-2)*3);
t2=C_restore_rest_vector(a,C_rest_count(0));
f_3265r(t0,t1,t2);}}

static void C_ccall f_3265r(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
t3=(C_word)C_notvemptyp(t2);
t4=(C_truep(t3)?(C_word)C_i_vector_ref(t2,C_fix(0)):C_fix(0));
t5=(C_word)C_i_foreign_fixnum_argumentp(t4);
t6=t1;
((C_proc2)(void*)(*((C_word*)t6+1)))(2,t6,(C_word)stub413(C_SCHEME_UNDEFINED,t5));}

/* local-timezone-abbreviation in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3253(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[5],*a=ab;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3253,2,t0,t1);}
t2=(C_word)C_a_i_bytevector(&a,1,C_fix(3));
/* ##sys#peek-c-string */
t3=*((C_word*)lf[8]+1);
((C_proc4)(void*)(*((C_word*)t3+1)))(4,t3,t1,(C_word)stub408(t2),C_fix(0));}

/* local-time->seconds in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3225(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[4],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_3225,3,t0,t1,t2);}
t3=(C_word)C_i_check_vector_2(t2,lf[254]);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3232,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
t5=(C_word)C_block_size(t2);
if(C_truep((C_word)C_fixnum_lessp(t5,C_fix(10)))){
/* posixwin.scm: 1700 ##sys#error */
t6=*((C_word*)lf[62]+1);
((C_proc5)(void*)(*((C_word*)t6+1)))(5,t6,t4,lf[254],lf[257],t2);}
else{
t6=t4;
f_3232(2,t6,C_SCHEME_UNDEFINED);}}

/* k3230 in local-time->seconds in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3232(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(C_truep((C_word)C_mktime(((C_word*)t0)[3]))){
/* posixwin.scm: 1702 ##sys#cons-flonum */
t2=*((C_word*)lf[255]+1);
((C_proc2)C_retrieve_proc(t2))(2,t2,((C_word*)t0)[2]);}
else{
/* posixwin.scm: 1703 ##sys#error */
t2=*((C_word*)lf[62]+1);
((C_proc5)(void*)(*((C_word*)t2+1)))(5,t2,((C_word*)t0)[2],lf[254],lf[256],((C_word*)t0)[3]);}}

/* time->string in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3145(C_word c,C_word t0,C_word t1,C_word t2,...){
C_word tmp;
C_word t3;
va_list v;
C_word *a,c2=c;
C_save_rest(t2,c2,3);
if(c<3) C_bad_min_argc_2(c,3,t0);
if(!C_demand(c*C_SIZEOF_PAIR+4)){
C_save_and_reclaim((void*)tr3r,(void*)f_3145r,3,t0,t1,t2);}
else{
a=C_alloc((c-3)*3);
t3=C_restore_rest(a,C_rest_count(0));
f_3145r(t0,t1,t2,t3);}}

static void C_ccall f_3145r(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word *a=C_alloc(4);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3149,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
if(C_truep((C_word)C_i_nullp(t3))){
t5=t4;
f_3149(2,t5,C_SCHEME_FALSE);}
else{
t5=(C_word)C_i_cdr(t3);
if(C_truep((C_word)C_i_nullp(t5))){
t6=t4;
f_3149(2,t6,(C_word)C_i_car(t3));}
else{
/* ##sys#error */
t6=*((C_word*)lf[62]+1);
((C_proc4)(void*)(*((C_word*)t6+1)))(4,t6,t4,lf[2],t3);}}}

/* k3147 in time->string in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3149(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[5],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3149,2,t0,t1);}
t2=(C_word)C_i_check_vector_2(((C_word*)t0)[3],lf[250]);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3155,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[2],a[4]=t1,tmp=(C_word)a,a+=5,tmp);
t4=(C_word)C_block_size(((C_word*)t0)[3]);
if(C_truep((C_word)C_fixnum_lessp(t4,C_fix(10)))){
/* posixwin.scm: 1687 ##sys#error */
t5=*((C_word*)lf[62]+1);
((C_proc5)(void*)(*((C_word*)t5+1)))(5,t5,t3,lf[250],lf[253],((C_word*)t0)[3]);}
else{
t5=t3;
f_3155(2,t5,C_SCHEME_UNDEFINED);}}

/* k3153 in k3147 in time->string in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3155(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word ab[17],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3155,2,t0,t1);}
if(C_truep(((C_word*)t0)[4])){
t2=(C_word)C_i_check_string_2(((C_word*)t0)[4],lf[250]);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3164,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3174,a[2]=t3,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1691 ##sys#make-c-string */
t5=*((C_word*)lf[39]+1);
((C_proc3)(void*)(*((C_word*)t5+1)))(3,t5,t4,((C_word*)t0)[4]);}
else{
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3177,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
t3=((C_word*)t0)[2];
t4=(C_word)C_a_i_bytevector(&a,1,C_fix(3));
/* ##sys#peek-c-string */
t5=*((C_word*)lf[8]+1);
((C_proc4)(void*)(*((C_word*)t5+1)))(4,t5,t2,(C_word)stub382(t4,t3),C_fix(0));}}

/* k3175 in k3153 in k3147 in time->string in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3177(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_truep(t1)){
t2=(C_word)C_block_size(t1);
t3=(C_word)C_fixnum_difference(t2,C_fix(1));
/* posixwin.scm: 1695 ##sys#substring */
t4=*((C_word*)lf[53]+1);
((C_proc5)C_retrieve_proc(t4))(5,t4,((C_word*)t0)[3],t1,C_fix(0),t3);}
else{
/* posixwin.scm: 1696 ##sys#error */
t2=*((C_word*)lf[62]+1);
((C_proc5)(void*)(*((C_word*)t2+1)))(5,t2,((C_word*)t0)[3],lf[250],lf[252],((C_word*)t0)[2]);}}

/* k3172 in k3153 in k3147 in time->string in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3174(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[5],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3174,2,t0,t1);}
t2=((C_word*)t0)[3];
t3=(C_word)C_a_i_bytevector(&a,1,C_fix(3));
/* ##sys#peek-c-string */
t4=*((C_word*)lf[8]+1);
((C_proc4)(void*)(*((C_word*)t4+1)))(4,t4,((C_word*)t0)[2],(C_word)stub388(t3,t2,t1),C_fix(0));}

/* k3162 in k3153 in k3147 in time->string in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3164(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(C_truep(t1)){
t2=((C_word*)t0)[3];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,t1);}
else{
/* posixwin.scm: 1692 ##sys#error */
t2=*((C_word*)lf[62]+1);
((C_proc5)(void*)(*((C_word*)t2+1)))(5,t2,((C_word*)t0)[3],lf[250],lf[251],((C_word*)t0)[2]);}}

/* seconds->string in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3112(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word ab[9],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_3112,3,t0,t1,t2);}
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3116,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t4=t2;
t5=(C_word)C_a_i_bytevector(&a,1,C_fix(3));
t6=(C_word)C_i_foreign_integer_argumentp(t4);
t7=(C_word)stub373(t5,t6);
/* ##sys#peek-c-string */
t8=*((C_word*)lf[8]+1);
((C_proc4)(void*)(*((C_word*)t8+1)))(4,t8,t3,t7,C_fix(0));}

/* k3114 in seconds->string in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3116(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_truep(t1)){
t2=(C_word)C_block_size(t1);
t3=(C_word)C_fixnum_difference(t2,C_fix(1));
/* posixwin.scm: 1679 ##sys#substring */
t4=*((C_word*)lf[53]+1);
((C_proc5)C_retrieve_proc(t4))(5,t4,((C_word*)t0)[3],t1,C_fix(0),t3);}
else{
/* posixwin.scm: 1680 ##sys#error */
t2=*((C_word*)lf[62]+1);
((C_proc5)(void*)(*((C_word*)t2+1)))(5,t2,((C_word*)t0)[3],lf[248],lf[249],((C_word*)t0)[2]);}}

/* seconds->utc-time in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3093(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_3093,3,t0,t1,t2);}
t3=(C_word)C_i_check_number_2(t2,lf[247]);
/* posixwin.scm: 1672 ##sys#decode-seconds */
t4=*((C_word*)lf[246]+1);
((C_proc4)C_retrieve_proc(t4))(4,t4,t1,t2,C_SCHEME_TRUE);}

/* seconds->local-time in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3084(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_3084,3,t0,t1,t2);}
t3=(C_word)C_i_check_number_2(t2,lf[245]);
/* posixwin.scm: 1668 ##sys#decode-seconds */
t4=*((C_word*)lf[246]+1);
((C_proc4)C_retrieve_proc(t4))(4,t4,t1,t2,C_SCHEME_FALSE);}

/* current-environment in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3019(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[7],*a=ab;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3019,2,t0,t1);}
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_3025,a[2]=((C_word*)t0)[2],a[3]=t3,a[4]=((C_word)li76),tmp=(C_word)a,a+=5,tmp));
t5=((C_word*)t3)[1];
f_3025(t5,t1,C_fix(0));}

/* loop in current-environment in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_3025(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word ab[11],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_3025,NULL,3,t0,t1,t2);}
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_3029,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],a[5]=t2,tmp=(C_word)a,a+=6,tmp);
t4=t2;
t5=(C_word)C_a_i_bytevector(&a,1,C_fix(3));
t6=(C_word)C_i_foreign_fixnum_argumentp(t4);
t7=(C_word)stub356(t5,t6);
/* ##sys#peek-c-string */
t8=*((C_word*)lf[8]+1);
((C_proc4)(void*)(*((C_word*)t8+1)))(4,t8,t3,t7,C_fix(0));}

/* k3027 in loop in current-environment in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3029(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[10],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3029,2,t0,t1);}
if(C_truep(t1)){
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_3037,a[2]=t3,a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=t1,a[7]=((C_word)li75),tmp=(C_word)a,a+=8,tmp));
t5=((C_word*)t3)[1];
f_3037(t5,((C_word*)t0)[2],C_fix(0));}
else{
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_SCHEME_END_OF_LIST);}}

/* scan in k3027 in loop in current-environment in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_3037(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a;
loop:
a=C_alloc(8);
if(!C_stack_probe(a)){
C_save_and_reclaim((void*)trf_3037,NULL,3,t0,t1,t2);}
t3=(C_word)C_eqp(C_make_character(61),(C_word)C_subchar(((C_word*)t0)[6],t2));
if(C_truep(t3)){
t4=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_3063,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[6],a[4]=t2,a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],a[7]=t1,tmp=(C_word)a,a+=8,tmp);
/* posixwin.scm: 1660 substring */
t5=((C_word*)t0)[3];
((C_proc5)C_retrieve_proc(t5))(5,t5,t4,((C_word*)t0)[6],C_fix(0),t2);}
else{
t4=(C_word)C_fixnum_plus(t2,C_fix(1));
/* posixwin.scm: 1661 scan */
t7=t1;
t8=t4;
t1=t7;
t2=t8;
goto loop;}}

/* k3061 in scan in k3027 in loop in current-environment in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3063(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[6],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3063,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_3067,a[2]=((C_word*)t0)[5],a[3]=((C_word*)t0)[6],a[4]=((C_word*)t0)[7],a[5]=t1,tmp=(C_word)a,a+=6,tmp);
t3=(C_word)C_fixnum_plus(((C_word*)t0)[4],C_fix(1));
t4=(C_word)C_block_size(((C_word*)t0)[3]);
/* posixwin.scm: 1660 substring */
t5=((C_word*)t0)[2];
((C_proc5)C_retrieve_proc(t5))(5,t5,t2,((C_word*)t0)[3],t3,t4);}

/* k3065 in k3061 in scan in k3027 in loop in current-environment in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3067(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[7],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3067,2,t0,t1);}
t2=(C_word)C_a_i_cons(&a,2,((C_word*)t0)[5],t1);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_3055,a[2]=t2,a[3]=((C_word*)t0)[4],tmp=(C_word)a,a+=4,tmp);
t4=(C_word)C_fixnum_plus(((C_word*)t0)[3],C_fix(1));
/* posixwin.scm: 1660 loop */
t5=((C_word*)((C_word*)t0)[2])[1];
f_3025(t5,t3,t4);}

/* k3053 in k3065 in k3061 in scan in k3027 in loop in current-environment in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3055(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word ab[3],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_3055,2,t0,t1);}
t2=((C_word*)t0)[3];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,(C_word)C_a_i_cons(&a,2,((C_word*)t0)[2],t1));}

/* unsetenv in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2999(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word ab[3],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_2999,3,t0,t1,t2);}
t3=(C_word)C_i_check_string_2(t2,lf[242]);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_3007,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm: 1648 ##sys#make-c-string */
t5=*((C_word*)lf[39]+1);
((C_proc3)(void*)(*((C_word*)t5+1)))(3,t5,t4,t2);}

/* k3005 in unsetenv in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_3007(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
t2=(C_word)C_putenv(t1);
t3=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,C_SCHEME_UNDEFINED);}

/* setenv in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2982(C_word c,C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word ab[4],*a=ab;
if(c!=4) C_bad_argc_2(c,4,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr4,(void*)f_2982,4,t0,t1,t2,t3);}
t4=(C_word)C_i_check_string_2(t2,lf[241]);
t5=(C_word)C_i_check_string_2(t3,lf[241]);
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2993,a[2]=t3,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1643 ##sys#make-c-string */
t7=*((C_word*)lf[39]+1);
((C_proc3)(void*)(*((C_word*)t7+1)))(3,t7,t6,t2);}

/* k2991 in setenv in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2993(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2993,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2997,a[2]=((C_word*)t0)[3],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1643 ##sys#make-c-string */
t3=*((C_word*)lf[39]+1);
((C_proc3)(void*)(*((C_word*)t3+1)))(3,t3,t2,((C_word*)t0)[2]);}

/* k2995 in k2991 in setenv in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2997(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
t2=(C_word)C_setenv(((C_word*)t0)[3],t1);
t3=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,C_SCHEME_UNDEFINED);}

/* duplicate-fileno in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2952(C_word c,C_word t0,C_word t1,C_word t2,...){
C_word tmp;
C_word t3;
va_list v;
C_word *a,c2=c;
C_save_rest(t2,c2,3);
if(c<3) C_bad_min_argc_2(c,3,t0);
if(!C_demand(c*C_SIZEOF_PAIR+4)){
C_save_and_reclaim((void*)tr3rv,(void*)f_2952r,3,t0,t1,t2);}
else{
a=C_alloc((c-3)*3);
t3=C_restore_rest_vector(a,C_rest_count(0));
f_2952r(t0,t1,t2,t3);}}

static void C_ccall f_2952r(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a=C_alloc(4);
t4=(C_word)C_i_check_exact_2(t2,*((C_word*)lf[239]+1));
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2959,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
if(C_truep((C_word)C_vemptyp(t3))){
t6=t5;
f_2959(t6,(C_word)C_dup(t2));}
else{
t6=(C_word)C_i_vector_ref(t3,C_fix(0));
t7=(C_word)C_i_check_exact_2(t6,lf[239]);
t8=t5;
f_2959(t8,(C_word)C_dup2(t2,t6));}}

/* k2957 in duplicate-fileno in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_2959(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[8],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_2959,NULL,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2962,a[2]=t1,a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
if(C_truep((C_word)C_fixnum_lessp(t1,C_fix(0)))){
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2968,a[2]=((C_word*)t0)[2],a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1633 ##sys#update-errno */
t4=*((C_word*)lf[9]+1);
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,t3);}
else{
t3=t2;
f_2962(2,t3,C_SCHEME_UNDEFINED);}}

/* k2966 in k2957 in duplicate-fileno in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2968(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1634 ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);
((C_proc6)(void*)(*((C_word*)t2+1)))(6,t2,((C_word*)t0)[3],lf[37],lf[239],lf[240],((C_word*)t0)[2]);}

/* k2960 in k2957 in duplicate-fileno in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2962(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
t2=((C_word*)t0)[3];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,((C_word*)t0)[2]);}

/* port->fileno in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2917(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word ab[4],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_2917,3,t0,t1,t2);}
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2921,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1615 ##sys#check-port */
t4=*((C_word*)lf[139]+1);
((C_proc4)(void*)(*((C_word*)t4+1)))(4,t4,t3,t2,lf[235]);}

/* k2919 in port->fileno in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2921(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2921,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2950,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1616 ##sys#peek-unsigned-integer */
t3=*((C_word*)lf[238]+1);
((C_proc4)(void*)(*((C_word*)t3+1)))(4,t3,t2,((C_word*)t0)[2],C_fix(0));}

/* k2948 in k2919 in port->fileno in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2950(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[8],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2950,2,t0,t1);}
if(C_truep((C_word)C_i_zerop(t1))){
/* posixwin.scm: 1622 ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);
((C_proc6)(void*)(*((C_word*)t2+1)))(6,t2,((C_word*)t0)[3],lf[46],lf[235],lf[236],((C_word*)t0)[2]);}
else{
t2=(C_word)C_C_fileno(((C_word*)t0)[2]);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2930,a[2]=t2,a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
if(C_truep((C_word)C_fixnum_lessp(t2,C_fix(0)))){
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2936,a[2]=((C_word*)t0)[2],a[3]=t3,tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1619 ##sys#update-errno */
t5=*((C_word*)lf[9]+1);
((C_proc2)(void*)(*((C_word*)t5+1)))(2,t5,t4);}
else{
t4=t3;
f_2930(2,t4,C_SCHEME_UNDEFINED);}}}

/* k2934 in k2948 in k2919 in port->fileno in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2936(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1620 ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);
((C_proc6)(void*)(*((C_word*)t2+1)))(6,t2,((C_word*)t0)[3],lf[37],lf[235],lf[237],((C_word*)t0)[2]);}

/* k2928 in k2948 in k2919 in port->fileno in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2930(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
t2=((C_word*)t0)[3];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,((C_word*)t0)[2]);}

/* open-output-file* in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2903(C_word c,C_word t0,C_word t1,C_word t2,...){
C_word tmp;
C_word t3;
va_list v;
C_word *a,c2=c;
C_save_rest(t2,c2,3);
if(c<3) C_bad_min_argc_2(c,3,t0);
if(!C_demand(c*C_SIZEOF_PAIR+5)){
C_save_and_reclaim((void*)tr3r,(void*)f_2903r,3,t0,t1,t2);}
else{
a=C_alloc((c-3)*3);
t3=C_restore_rest(a,C_rest_count(0));
f_2903r(t0,t1,t2,t3);}}

static void C_ccall f_2903r(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word *a=C_alloc(5);
t4=(C_word)C_i_check_exact_2(t2,lf[234]);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2915,a[2]=t1,a[3]=((C_word*)t0)[3],a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm: 1611 mode */
f_2834(t5,C_SCHEME_FALSE,t3);}

/* k2913 in open-output-file* in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2915(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[2],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2915,2,t0,t1);}
t2=(C_word)C_fdopen(&a,2,((C_word*)t0)[4],t1);
/* posixwin.scm: 1611 check */
f_2871(((C_word*)t0)[2],((C_word*)t0)[4],C_SCHEME_FALSE,t2);}

/* open-input-file* in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2889(C_word c,C_word t0,C_word t1,C_word t2,...){
C_word tmp;
C_word t3;
va_list v;
C_word *a,c2=c;
C_save_rest(t2,c2,3);
if(c<3) C_bad_min_argc_2(c,3,t0);
if(!C_demand(c*C_SIZEOF_PAIR+5)){
C_save_and_reclaim((void*)tr3r,(void*)f_2889r,3,t0,t1,t2);}
else{
a=C_alloc((c-3)*3);
t3=C_restore_rest(a,C_rest_count(0));
f_2889r(t0,t1,t2,t3);}}

static void C_ccall f_2889r(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word *a=C_alloc(5);
t4=(C_word)C_i_check_exact_2(t2,lf[233]);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2901,a[2]=t1,a[3]=((C_word*)t0)[3],a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm: 1607 mode */
f_2834(t5,C_SCHEME_TRUE,t3);}

/* k2899 in open-input-file* in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2901(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[2],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2901,2,t0,t1);}
t2=(C_word)C_fdopen(&a,2,((C_word*)t0)[4],t1);
/* posixwin.scm: 1607 check */
f_2871(((C_word*)t0)[2],((C_word*)t0)[4],C_SCHEME_TRUE,t2);}

/* check in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_2871(C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word ab[6],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_2871,NULL,4,t1,t2,t3,t4);}
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2875,a[2]=t3,a[3]=t2,a[4]=t1,a[5]=t4,tmp=(C_word)a,a+=6,tmp);
/* posixwin.scm: 1598 ##sys#update-errno */
t6=*((C_word*)lf[9]+1);
((C_proc2)(void*)(*((C_word*)t6+1)))(2,t6,t5);}

/* k2873 in check in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2875(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2875,2,t0,t1);}
if(C_truep((C_word)C_null_pointerp(((C_word*)t0)[5]))){
/* posixwin.scm: 1600 ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);
((C_proc5)(void*)(*((C_word*)t2+1)))(5,t2,((C_word*)t0)[4],lf[37],lf[231],((C_word*)t0)[3]);}
else{
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2887,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[5],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1601 ##sys#make-port */
t3=*((C_word*)lf[131]+1);
((C_proc6)(void*)(*((C_word*)t3+1)))(6,t3,t2,((C_word*)t0)[2],*((C_word*)lf[132]+1),lf[232],lf[81]);}}

/* k2885 in k2873 in check in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2887(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
t2=(C_word)C_set_file_ptr(t1,((C_word*)t0)[3]);
t3=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,t1);}

/* mode in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_2834(C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word ab[3],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_2834,NULL,3,t1,t2,t3);}
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2842,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
if(C_truep((C_word)C_i_pairp(t3))){
t5=(C_word)C_i_car(t3);
t6=(C_word)C_eqp(t5,lf[225]);
if(C_truep(t6)){
t7=t2;
if(C_truep(t7)){
/* posixwin.scm: 1593 ##sys#error */
t8=*((C_word*)lf[62]+1);
((C_proc4)(void*)(*((C_word*)t8+1)))(4,t8,t4,lf[226],t5);}
else{
t8=t4;
f_2842(2,t8,lf[227]);}}
else{
/* posixwin.scm: 1594 ##sys#error */
t7=*((C_word*)lf[62]+1);
((C_proc4)(void*)(*((C_word*)t7+1)))(4,t7,t4,lf[228],t5);}}
else{
t5=t4;
f_2842(2,t5,(C_truep(t2)?lf[229]:lf[230]));}}

/* k2840 in mode in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2842(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1589 ##sys#make-c-string */
t2=*((C_word*)lf[39]+1);
((C_proc3)(void*)(*((C_word*)t2+1)))(3,t2,((C_word*)t0)[2],t1);}

/* file-execute-access? in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2825(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_2825,3,t0,t1,t2);}
/* posixwin.scm: 1573 check */
f_2789(t1,t2,C_fix((C_word)2),lf[221]);}

/* file-write-access? in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2819(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_2819,3,t0,t1,t2);}
/* posixwin.scm: 1572 check */
f_2789(t1,t2,C_fix((C_word)4),lf[220]);}

/* file-read-access? in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2813(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_2813,3,t0,t1,t2);}
/* posixwin.scm: 1571 check */
f_2789(t1,t2,C_fix((C_word)2),lf[219]);}

/* check in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_2789(C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word ab[7],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_2789,NULL,4,t1,t2,t3,t4);}
t5=(C_word)C_i_check_string_2(t2,t4);
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2807,a[2]=t1,a[3]=t3,tmp=(C_word)a,a+=4,tmp);
t7=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2811,a[2]=t6,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm: 1568 ##sys#expand-home-path */
t8=*((C_word*)lf[40]+1);
((C_proc3)C_retrieve_proc(t8))(3,t8,t7,t2);}

/* k2809 in check in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2811(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1568 ##sys#make-c-string */
t2=*((C_word*)lf[39]+1);
((C_proc3)(void*)(*((C_word*)t2+1)))(3,t2,((C_word*)t0)[2],t1);}

/* k2805 in check in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2807(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2807,2,t0,t1);}
t2=(C_word)C_access(t1,((C_word*)t0)[3]);
t3=(C_word)C_eqp(C_fix(0),t2);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2799,a[2]=t3,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
if(C_truep(t3)){
t5=t4;
f_2799(2,t5,C_SCHEME_UNDEFINED);}
else{
/* posixwin.scm: 1569 ##sys#update-errno */
t5=*((C_word*)lf[9]+1);
((C_proc2)(void*)(*((C_word*)t5+1)))(2,t5,t4);}}

/* k2797 in k2805 in check in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2799(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
t2=((C_word*)t0)[3];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,((C_word*)t0)[2]);}

/* change-file-mode in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2759(C_word c,C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word ab[8],*a=ab;
if(c!=4) C_bad_argc_2(c,4,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr4,(void*)f_2759,4,t0,t1,t2,t3);}
t4=(C_word)C_i_check_string_2(t2,lf[217]);
t5=(C_word)C_i_check_exact_2(t3,lf[217]);
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2783,a[2]=t2,a[3]=t1,a[4]=t3,tmp=(C_word)a,a+=5,tmp);
t7=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2787,a[2]=t6,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm: 1557 ##sys#expand-home-path */
t8=*((C_word*)lf[40]+1);
((C_proc3)C_retrieve_proc(t8))(3,t8,t7,t2);}

/* k2785 in change-file-mode in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2787(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1557 ##sys#make-c-string */
t2=*((C_word*)lf[39]+1);
((C_proc3)(void*)(*((C_word*)t2+1)))(3,t2,((C_word*)t0)[2],t1);}

/* k2781 in change-file-mode in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2783(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[5],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2783,2,t0,t1);}
t2=(C_word)C_chmod(t1,((C_word*)t0)[4]);
if(C_truep((C_word)C_fixnum_lessp(t2,C_fix(0)))){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2775,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[2],a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm: 1558 ##sys#update-errno */
t4=*((C_word*)lf[9]+1);
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,t3);}
else{
t3=((C_word*)t0)[3];
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,C_SCHEME_UNDEFINED);}}

/* k2773 in k2781 in change-file-mode in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2775(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1559 ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);
((C_proc7)(void*)(*((C_word*)t2+1)))(7,t2,((C_word*)t0)[4],lf[37],lf[217],lf[218],((C_word*)t0)[3],((C_word*)t0)[2]);}

/* ##sys#interrupt-hook in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2703(C_word c,C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word ab[4],*a=ab;
if(c!=4) C_bad_argc_2(c,4,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr4,(void*)f_2703,4,t0,t1,t2,t3);}
t4=(C_word)C_slot(((C_word*)t0)[3],t2);
if(C_truep(t4)){
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2713,a[2]=t3,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1465 h */
t6=t4;
((C_proc3)C_retrieve_proc(t6))(3,t6,t5,t2);}
else{
/* posixwin.scm: 1467 oldhook */
t5=((C_word*)t0)[2];
((C_proc4)C_retrieve_proc(t5))(4,t5,t1,t2,t3);}}

/* k2711 in ##sys#interrupt-hook in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2713(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1466 ##sys#context-switch */
C_context_switch(3,0,((C_word*)t0)[3],((C_word*)t0)[2]);}

/* set-signal-handler! in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2690(C_word c,C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word *a;
if(c!=4) C_bad_argc_2(c,4,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr4,(void*)f_2690,4,t0,t1,t2,t3);}
t4=(C_word)C_i_check_exact_2(t2,lf[178]);
t5=(C_truep(t3)?t2:C_SCHEME_FALSE);
t6=(C_word)C_establish_signal_handler(t2,t5);
t7=t1;
((C_proc2)(void*)(*((C_word*)t7+1)))(2,t7,(C_word)C_i_vector_set(((C_word*)t0)[2],t2,t3));}

/* signal-handler in k2677 in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2681(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_2681,3,t0,t1,t2);}
t3=(C_word)C_i_check_exact_2(t2,lf[177]);
t4=t1;
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,(C_word)C_slot(((C_word*)t0)[2],t2));}

/* create-pipe in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2605(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
va_list v;
C_word *a,c2=c;
C_save_rest(t1,c2,2);
if(!C_demand(c*C_SIZEOF_PAIR+3)){
C_save_and_reclaim((void*)tr2r,(void*)f_2605r,2,t0,t1);}
else{
a=C_alloc((c-2)*3);
t2=C_restore_rest(a,C_rest_count(0));
f_2605r(t0,t1,t2);}}

static void C_ccall f_2605r(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word *a=C_alloc(3);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2609,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
if(C_truep((C_word)C_i_nullp(t2))){
t4=t3;
f_2609(2,t4,(C_word)C_fixnum_or(*((C_word*)lf[21]+1),*((C_word*)lf[23]+1)));}
else{
t4=(C_word)C_i_cdr(t2);
if(C_truep((C_word)C_i_nullp(t4))){
t5=t3;
f_2609(2,t5,(C_word)C_i_car(t2));}
else{
/* ##sys#error */
t5=*((C_word*)lf[62]+1);
((C_proc4)(void*)(*((C_word*)t5+1)))(4,t5,t3,lf[2],t2);}}}

/* k2607 in create-pipe in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2609(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[6],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2609,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2612,a[2]=((C_word*)t0)[2],tmp=(C_word)a,a+=3,tmp);
if(C_truep((C_word)C_fixnum_lessp((C_word)C_pipe(C_SCHEME_FALSE,t1),C_fix(0)))){
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2621,a[2]=t2,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm: 1402 ##sys#update-errno */
t4=*((C_word*)lf[9]+1);
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,t3);}
else{
t3=t2;
f_2612(2,t3,C_SCHEME_UNDEFINED);}}

/* k2619 in k2607 in create-pipe in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2621(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1403 ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);
((C_proc5)(void*)(*((C_word*)t2+1)))(5,t2,((C_word*)t0)[2],lf[37],lf[147],lf[148]);}

/* k2610 in k2607 in create-pipe in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2612(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1404 values */
C_values(4,0,((C_word*)t0)[2],C_fix((C_word)C_pipefds[ 0 ]),C_fix((C_word)C_pipefds[ 1 ]));}

/* with-output-to-pipe in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2585(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...){
C_word tmp;
C_word t4;
va_list v;
C_word *a,c2=c;
C_save_rest(t3,c2,4);
if(c<4) C_bad_min_argc_2(c,4,t0);
if(!C_demand(c*C_SIZEOF_PAIR+6)){
C_save_and_reclaim((void*)tr4r,(void*)f_2585r,4,t0,t1,t2,t3);}
else{
a=C_alloc((c-4)*3);
t4=C_restore_rest(a,C_rest_count(0));
f_2585r(t0,t1,t2,t3,t4);}}

static void C_ccall f_2585r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word *a=C_alloc(6);
t5=*((C_word*)lf[146]+1);
t6=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2589,a[2]=t3,a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=t5,tmp=(C_word)a,a+=6,tmp);
C_apply(5,0,t6,((C_word*)t0)[2],t2,t4);}

/* k2587 in with-output-to-pipe in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2589(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[6],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2589,2,t0,t1);}
t2=C_mutate((C_word*)lf[146]+1,t1);
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2595,a[2]=t1,a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=((C_word)li56),tmp=(C_word)a,a+=6,tmp);
/* posixwin.scm: 1387 ##sys#call-with-values */
C_call_with_values(4,0,((C_word*)t0)[3],((C_word*)t0)[2],t3);}

/* a2594 in k2587 in with-output-to-pipe in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2595(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
va_list v;
C_word *a,c2=c;
C_save_rest(t1,c2,2);
if(!C_demand(c*C_SIZEOF_PAIR+5)){
C_save_and_reclaim((void*)tr2r,(void*)f_2595r,2,t0,t1);}
else{
a=C_alloc((c-2)*3);
t2=C_restore_rest(a,C_rest_count(0));
f_2595r(t0,t1,t2);}}

static void C_ccall f_2595r(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a=C_alloc(5);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2599,a[2]=t2,a[3]=t1,a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm: 1389 close-output-pipe */
t4=((C_word*)t0)[3];
((C_proc3)C_retrieve_proc(t4))(3,t4,t3,((C_word*)t0)[2]);}

/* k2597 in a2594 in k2587 in with-output-to-pipe in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2599(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
t2=C_mutate((C_word*)lf[146]+1,((C_word*)t0)[4]);
C_apply_values(3,0,((C_word*)t0)[3],((C_word*)t0)[2]);}

/* with-input-from-pipe in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2565(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...){
C_word tmp;
C_word t4;
va_list v;
C_word *a,c2=c;
C_save_rest(t3,c2,4);
if(c<4) C_bad_min_argc_2(c,4,t0);
if(!C_demand(c*C_SIZEOF_PAIR+6)){
C_save_and_reclaim((void*)tr4r,(void*)f_2565r,4,t0,t1,t2,t3);}
else{
a=C_alloc((c-4)*3);
t4=C_restore_rest(a,C_rest_count(0));
f_2565r(t0,t1,t2,t3,t4);}}

static void C_ccall f_2565r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word *a=C_alloc(6);
t5=*((C_word*)lf[144]+1);
t6=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2569,a[2]=t3,a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=t5,tmp=(C_word)a,a+=6,tmp);
C_apply(5,0,t6,((C_word*)t0)[2],t2,t4);}

/* k2567 in with-input-from-pipe in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2569(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[6],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2569,2,t0,t1);}
t2=C_mutate((C_word*)lf[144]+1,t1);
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2575,a[2]=t1,a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=((C_word)li54),tmp=(C_word)a,a+=6,tmp);
/* posixwin.scm: 1377 ##sys#call-with-values */
C_call_with_values(4,0,((C_word*)t0)[3],((C_word*)t0)[2],t3);}

/* a2574 in k2567 in with-input-from-pipe in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2575(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
va_list v;
C_word *a,c2=c;
C_save_rest(t1,c2,2);
if(!C_demand(c*C_SIZEOF_PAIR+5)){
C_save_and_reclaim((void*)tr2r,(void*)f_2575r,2,t0,t1);}
else{
a=C_alloc((c-2)*3);
t2=C_restore_rest(a,C_rest_count(0));
f_2575r(t0,t1,t2);}}

static void C_ccall f_2575r(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a=C_alloc(5);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2579,a[2]=t2,a[3]=t1,a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm: 1379 close-input-pipe */
t4=((C_word*)t0)[3];
((C_proc3)C_retrieve_proc(t4))(3,t4,t3,((C_word*)t0)[2]);}

/* k2577 in a2574 in k2567 in with-input-from-pipe in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2579(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
t2=C_mutate((C_word*)lf[144]+1,((C_word*)t0)[4]);
C_apply_values(3,0,((C_word*)t0)[3],((C_word*)t0)[2]);}

/* call-with-output-pipe in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2541(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...){
C_word tmp;
C_word t4;
va_list v;
C_word *a,c2=c;
C_save_rest(t3,c2,4);
if(c<4) C_bad_min_argc_2(c,4,t0);
if(!C_demand(c*C_SIZEOF_PAIR+5)){
C_save_and_reclaim((void*)tr4r,(void*)f_2541r,4,t0,t1,t2,t3);}
else{
a=C_alloc((c-4)*3);
t4=C_restore_rest(a,C_rest_count(0));
f_2541r(t0,t1,t2,t3,t4);}}

static void C_ccall f_2541r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word *a=C_alloc(5);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2545,a[2]=t1,a[3]=((C_word*)t0)[3],a[4]=t3,tmp=(C_word)a,a+=5,tmp);
C_apply(5,0,t5,((C_word*)t0)[2],t2,t4);}

/* k2543 in call-with-output-pipe in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2545(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[10],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2545,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2550,a[2]=t1,a[3]=((C_word*)t0)[4],a[4]=((C_word)li51),tmp=(C_word)a,a+=5,tmp);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2556,a[2]=t1,a[3]=((C_word*)t0)[3],a[4]=((C_word)li52),tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm: 1367 ##sys#call-with-values */
C_call_with_values(4,0,((C_word*)t0)[2],t2,t3);}

/* a2555 in k2543 in call-with-output-pipe in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2556(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
va_list v;
C_word *a,c2=c;
C_save_rest(t1,c2,2);
if(!C_demand(c*C_SIZEOF_PAIR+4)){
C_save_and_reclaim((void*)tr2r,(void*)f_2556r,2,t0,t1);}
else{
a=C_alloc((c-2)*3);
t2=C_restore_rest(a,C_rest_count(0));
f_2556r(t0,t1,t2);}}

static void C_ccall f_2556r(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a=C_alloc(4);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2560,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1370 close-output-pipe */
t4=((C_word*)t0)[3];
((C_proc3)C_retrieve_proc(t4))(3,t4,t3,((C_word*)t0)[2]);}

/* k2558 in a2555 in k2543 in call-with-output-pipe in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2560(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
C_apply_values(3,0,((C_word*)t0)[3],((C_word*)t0)[2]);}

/* a2549 in k2543 in call-with-output-pipe in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2550(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2550,2,t0,t1);}
/* posixwin.scm: 1368 proc */
t2=((C_word*)t0)[3];
((C_proc3)C_retrieve_proc(t2))(3,t2,t1,((C_word*)t0)[2]);}

/* call-with-input-pipe in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2517(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...){
C_word tmp;
C_word t4;
va_list v;
C_word *a,c2=c;
C_save_rest(t3,c2,4);
if(c<4) C_bad_min_argc_2(c,4,t0);
if(!C_demand(c*C_SIZEOF_PAIR+5)){
C_save_and_reclaim((void*)tr4r,(void*)f_2517r,4,t0,t1,t2,t3);}
else{
a=C_alloc((c-4)*3);
t4=C_restore_rest(a,C_rest_count(0));
f_2517r(t0,t1,t2,t3,t4);}}

static void C_ccall f_2517r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word *a=C_alloc(5);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2521,a[2]=t1,a[3]=((C_word*)t0)[3],a[4]=t3,tmp=(C_word)a,a+=5,tmp);
C_apply(5,0,t5,((C_word*)t0)[2],t2,t4);}

/* k2519 in call-with-input-pipe in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2521(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[10],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2521,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2526,a[2]=t1,a[3]=((C_word*)t0)[4],a[4]=((C_word)li48),tmp=(C_word)a,a+=5,tmp);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2532,a[2]=t1,a[3]=((C_word*)t0)[3],a[4]=((C_word)li49),tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm: 1359 ##sys#call-with-values */
C_call_with_values(4,0,((C_word*)t0)[2],t2,t3);}

/* a2531 in k2519 in call-with-input-pipe in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2532(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
va_list v;
C_word *a,c2=c;
C_save_rest(t1,c2,2);
if(!C_demand(c*C_SIZEOF_PAIR+4)){
C_save_and_reclaim((void*)tr2r,(void*)f_2532r,2,t0,t1);}
else{
a=C_alloc((c-2)*3);
t2=C_restore_rest(a,C_rest_count(0));
f_2532r(t0,t1,t2);}}

static void C_ccall f_2532r(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a=C_alloc(4);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2536,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1362 close-input-pipe */
t4=((C_word*)t0)[3];
((C_proc3)C_retrieve_proc(t4))(3,t4,t3,((C_word*)t0)[2]);}

/* k2534 in a2531 in k2519 in call-with-input-pipe in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2536(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
C_apply_values(3,0,((C_word*)t0)[3],((C_word*)t0)[2]);}

/* a2525 in k2519 in call-with-input-pipe in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2526(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2526,2,t0,t1);}
/* posixwin.scm: 1360 proc */
t2=((C_word*)t0)[3];
((C_proc3)C_retrieve_proc(t2))(3,t2,t1,((C_word*)t0)[2]);}

/* close-input-pipe in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2498(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word ab[4],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_2498,3,t0,t1,t2);}
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2502,a[2]=t1,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1346 ##sys#check-port */
t4=*((C_word*)lf[139]+1);
((C_proc4)(void*)(*((C_word*)t4+1)))(4,t4,t3,t2,lf[137]);}

/* k2500 in close-input-pipe in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2502(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[5],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2502,2,t0,t1);}
t2=(C_word)close_pipe(((C_word*)t0)[3]);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2505,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[2],a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm: 1348 ##sys#update-errno */
t4=*((C_word*)lf[9]+1);
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,t3);}

/* k2503 in k2500 in close-input-pipe in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2505(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
t2=(C_word)C_eqp(C_fix(-1),((C_word*)t0)[4]);
if(C_truep(t2)){
/* posixwin.scm: 1349 ##sys#signal-hook */
t3=*((C_word*)lf[6]+1);
((C_proc6)(void*)(*((C_word*)t3+1)))(6,t3,((C_word*)t0)[3],lf[37],lf[137],lf[138],((C_word*)t0)[2]);}
else{
t3=((C_word*)t0)[3];
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,C_SCHEME_UNDEFINED);}}

/* open-output-pipe in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2462(C_word c,C_word t0,C_word t1,C_word t2,...){
C_word tmp;
C_word t3;
va_list v;
C_word *a,c2=c;
C_save_rest(t2,c2,3);
if(c<3) C_bad_min_argc_2(c,3,t0);
if(!C_demand(c*C_SIZEOF_PAIR+11)){
C_save_and_reclaim((void*)tr3r,(void*)f_2462r,3,t0,t1,t2);}
else{
a=C_alloc((c-3)*3);
t3=C_restore_rest(a,C_rest_count(0));
f_2462r(t0,t1,t2,t3);}}

static void C_ccall f_2462r(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a=C_alloc(11);
t4=(C_word)C_i_check_string_2(t2,lf[136]);
t5=f_2390(t3);
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2476,a[2]=t2,a[3]=t1,a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
t7=(C_word)C_eqp(t5,lf[128]);
if(C_truep(t7)){
t8=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2483,a[2]=t6,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm: 1341 ##sys#make-c-string */
t9=*((C_word*)lf[39]+1);
((C_proc3)(void*)(*((C_word*)t9+1)))(3,t9,t8,t2);}
else{
t8=(C_word)C_eqp(t5,lf[135]);
if(C_truep(t8)){
t9=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2493,a[2]=t6,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm: 1342 ##sys#make-c-string */
t10=*((C_word*)lf[39]+1);
((C_proc3)(void*)(*((C_word*)t10+1)))(3,t10,t9,t2);}
else{
/* posixwin.scm: 1343 badmode */
f_2402(t6,t5);}}}

/* k2491 in open-output-pipe in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2493(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word ab[2],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2493,2,t0,t1);}
t2=((C_word*)t0)[2];
f_2476(2,t2,(C_word)open_binary_output_pipe(&a,1,t1));}

/* k2481 in open-output-pipe in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2483(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word ab[2],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2483,2,t0,t1);}
t2=((C_word*)t0)[2];
f_2476(2,t2,(C_word)open_text_output_pipe(&a,1,t1));}

/* k2474 in open-output-pipe in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2476(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1338 check */
f_2408(((C_word*)t0)[3],((C_word*)t0)[2],C_SCHEME_FALSE,t1);}

/* open-input-pipe in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2426(C_word c,C_word t0,C_word t1,C_word t2,...){
C_word tmp;
C_word t3;
va_list v;
C_word *a,c2=c;
C_save_rest(t2,c2,3);
if(c<3) C_bad_min_argc_2(c,3,t0);
if(!C_demand(c*C_SIZEOF_PAIR+11)){
C_save_and_reclaim((void*)tr3r,(void*)f_2426r,3,t0,t1,t2);}
else{
a=C_alloc((c-3)*3);
t3=C_restore_rest(a,C_rest_count(0));
f_2426r(t0,t1,t2,t3);}}

static void C_ccall f_2426r(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word *a=C_alloc(11);
t4=(C_word)C_i_check_string_2(t2,lf[134]);
t5=f_2390(t3);
t6=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2440,a[2]=t2,a[3]=t1,a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
t7=(C_word)C_eqp(t5,lf[128]);
if(C_truep(t7)){
t8=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2447,a[2]=t6,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm: 1331 ##sys#make-c-string */
t9=*((C_word*)lf[39]+1);
((C_proc3)(void*)(*((C_word*)t9+1)))(3,t9,t8,t2);}
else{
t8=(C_word)C_eqp(t5,lf[135]);
if(C_truep(t8)){
t9=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2457,a[2]=t6,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm: 1332 ##sys#make-c-string */
t10=*((C_word*)lf[39]+1);
((C_proc3)(void*)(*((C_word*)t10+1)))(3,t10,t9,t2);}
else{
/* posixwin.scm: 1333 badmode */
f_2402(t6,t5);}}}

/* k2455 in open-input-pipe in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2457(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word ab[2],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2457,2,t0,t1);}
t2=((C_word*)t0)[2];
f_2440(2,t2,(C_word)open_binary_input_pipe(&a,1,t1));}

/* k2445 in open-input-pipe in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2447(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word ab[2],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2447,2,t0,t1);}
t2=((C_word*)t0)[2];
f_2440(2,t2,(C_word)open_text_input_pipe(&a,1,t1));}

/* k2438 in open-input-pipe in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2440(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1328 check */
f_2408(((C_word*)t0)[3],((C_word*)t0)[2],C_SCHEME_TRUE,t1);}

/* check in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_2408(C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word ab[6],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_2408,NULL,4,t1,t2,t3,t4);}
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2412,a[2]=t3,a[3]=t2,a[4]=t1,a[5]=t4,tmp=(C_word)a,a+=6,tmp);
/* posixwin.scm: 1318 ##sys#update-errno */
t6=*((C_word*)lf[9]+1);
((C_proc2)(void*)(*((C_word*)t6+1)))(2,t6,t5);}

/* k2410 in check in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2412(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2412,2,t0,t1);}
if(C_truep((C_word)C_null_pointerp(((C_word*)t0)[5]))){
/* posixwin.scm: 1320 ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);
((C_proc5)(void*)(*((C_word*)t2+1)))(5,t2,((C_word*)t0)[4],lf[37],lf[130],((C_word*)t0)[3]);}
else{
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2424,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[5],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1321 ##sys#make-port */
t3=*((C_word*)lf[131]+1);
((C_proc6)(void*)(*((C_word*)t3+1)))(6,t3,t2,((C_word*)t0)[2],*((C_word*)lf[132]+1),lf[133],lf[81]);}}

/* k2422 in k2410 in check in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2424(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
t2=(C_word)C_set_file_ptr(t1,((C_word*)t0)[3]);
t3=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,t1);}

/* badmode in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_2402(C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_2402,NULL,2,t1,t2);}
/* posixwin.scm: 1316 ##sys#error */
t3=*((C_word*)lf[62]+1);
((C_proc4)(void*)(*((C_word*)t3+1)))(4,t3,t1,lf[129],t2);}

/* mode in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static C_word C_fcall f_2390(C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_stack_check;
t2=(C_word)C_i_pairp(t1);
return((C_truep(t2)?(C_word)C_slot(t1,C_fix(0)):lf[128]));}

/* canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2033(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word ab[28],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_2033,3,t0,t1,t2);}
t3=(C_word)C_i_check_string_2(t2,lf[115]);
t4=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_2040,a[2]=t1,a[3]=((C_word*)t0)[6],a[4]=((C_word*)t0)[7],a[5]=((C_word*)t0)[8],a[6]=((C_word*)t0)[9],a[7]=((C_word*)t0)[10],a[8]=((C_word*)t0)[11],tmp=(C_word)a,a+=9,tmp);
t5=(C_word)C_block_size(t2);
t6=(C_word)C_eqp(C_fix(0),t5);
if(C_truep(t6)){
t7=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2173,a[2]=t4,a[3]=((C_word*)t0)[10],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1255 cwd */
t8=((C_word*)t0)[5];
f_1977(t8,t7);}
else{
t7=(*a=C_CLOSURE_TYPE|10,a[1]=(C_word)f_2179,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[8],a[5]=((C_word*)t0)[11],a[6]=((C_word*)t0)[4],a[7]=((C_word*)t0)[5],a[8]=t2,a[9]=t4,a[10]=((C_word*)t0)[10],tmp=(C_word)a,a+=11,tmp);
t8=(C_word)C_block_size(t2);
if(C_truep((C_word)C_fixnum_lessp(t8,C_fix(3)))){
t9=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2380,a[2]=((C_word*)t0)[11],a[3]=t7,tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1257 sref */
t10=((C_word*)t0)[8];
((C_proc4)C_retrieve_proc(t10))(4,t10,t9,t2,C_fix(0));}
else{
t9=t7;
f_2179(t9,C_SCHEME_FALSE);}}}

/* k2378 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2380(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1257 sep? */
t2=((C_word*)t0)[3];
f_2179(t2,f_1966(t1));}

/* k2177 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_2179(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word ab[34],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_2179,NULL,2,t0,t1);}
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2186,a[2]=((C_word*)t0)[8],a[3]=((C_word*)t0)[9],a[4]=((C_word*)t0)[10],tmp=(C_word)a,a+=5,tmp);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2190,a[2]=t2,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm: 1259 cwd */
t4=((C_word*)t0)[7];
f_1977(t4,t3);}
else{
t2=(C_word)C_block_size(((C_word*)t0)[8]);
t3=(C_word)C_eqp(C_fix(1),t2);
if(C_truep(t3)){
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2203,a[2]=((C_word*)t0)[8],a[3]=((C_word*)t0)[9],a[4]=((C_word*)t0)[10],tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm: 1262 cwd */
t5=((C_word*)t0)[7];
f_1977(t5,t4);}
else{
t4=(*a=C_CLOSURE_TYPE|10,a[1]=(C_word)f_2209,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[7],a[7]=((C_word*)t0)[6],a[8]=((C_word*)t0)[8],a[9]=((C_word*)t0)[9],a[10]=((C_word*)t0)[10],tmp=(C_word)a,a+=11,tmp);
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2355,a[2]=((C_word*)t0)[8],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=t4,tmp=(C_word)a,a+=6,tmp);
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2366,a[2]=t5,a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1263 sref */
t7=((C_word*)t0)[4];
((C_proc4)C_retrieve_proc(t7))(4,t7,t6,((C_word*)t0)[8],C_fix(0));}}}

/* k2364 in k2177 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2366(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1263 char=? */
t2=((C_word*)t0)[3];
((C_proc4)C_retrieve_proc(t2))(4,t2,((C_word*)t0)[2],C_make_character(126),t1);}

/* k2353 in k2177 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2355(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2355,2,t0,t1);}
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2362,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[5],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1264 sref */
t3=((C_word*)t0)[3];
((C_proc4)C_retrieve_proc(t3))(4,t3,t2,((C_word*)t0)[2],C_fix(1));}
else{
t2=((C_word*)t0)[5];
f_2209(t2,C_SCHEME_FALSE);}}

/* k2360 in k2353 in k2177 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2362(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1264 sep? */
t2=((C_word*)t0)[3];
f_2209(t2,f_1966(t1));}

/* k2207 in k2177 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_2209(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word ab[35],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_2209,NULL,2,t0,t1);}
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2216,a[2]=((C_word*)t0)[7],a[3]=((C_word*)t0)[8],a[4]=((C_word*)t0)[9],a[5]=((C_word*)t0)[10],tmp=(C_word)a,a+=6,tmp);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2232,a[2]=t2,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm: 1266 cwd */
t4=((C_word*)t0)[6];
f_1977(t4,t3);}
else{
t2=(C_word)C_block_size(((C_word*)t0)[8]);
t3=(C_word)C_eqp(C_fix(2),t2);
if(C_truep(t3)){
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2245,a[2]=((C_word*)t0)[8],a[3]=((C_word*)t0)[9],a[4]=((C_word*)t0)[10],tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm: 1272 cwd */
t5=((C_word*)t0)[6];
f_1977(t5,t4);}
else{
t4=(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_2251,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[6],a[6]=((C_word*)t0)[5],a[7]=((C_word*)t0)[10],a[8]=((C_word*)t0)[8],a[9]=((C_word*)t0)[9],tmp=(C_word)a,a+=10,tmp);
t5=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_2327,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[8],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=t4,tmp=(C_word)a,a+=7,tmp);
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2348,a[2]=t5,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1273 sref */
t7=((C_word*)t0)[4];
((C_proc4)C_retrieve_proc(t7))(4,t7,t6,((C_word*)t0)[8],C_fix(0));}}}

/* k2346 in k2207 in k2177 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2348(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1273 alpha? */
t2=((C_word*)t0)[3];
((C_proc3)C_retrieve_proc(t2))(3,t2,((C_word*)t0)[2],t1);}

/* k2325 in k2207 in k2177 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2327(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[10],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2327,2,t0,t1);}
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2333,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[6],tmp=(C_word)a,a+=6,tmp);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2344,a[2]=t2,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1274 sref */
t4=((C_word*)t0)[4];
((C_proc4)C_retrieve_proc(t4))(4,t4,t3,((C_word*)t0)[3],C_fix(1));}
else{
t2=((C_word*)t0)[6];
f_2251(t2,C_SCHEME_FALSE);}}

/* k2342 in k2325 in k2207 in k2177 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2344(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1274 char=? */
t2=((C_word*)t0)[3];
((C_proc4)C_retrieve_proc(t2))(4,t2,((C_word*)t0)[2],C_make_character(58),t1);}

/* k2331 in k2325 in k2207 in k2177 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2333(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2333,2,t0,t1);}
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2340,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[5],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1275 sref */
t3=((C_word*)t0)[3];
((C_proc4)C_retrieve_proc(t3))(4,t3,t2,((C_word*)t0)[2],C_fix(2));}
else{
t2=((C_word*)t0)[5];
f_2251(t2,C_SCHEME_FALSE);}}

/* k2338 in k2331 in k2325 in k2207 in k2177 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2340(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1275 sep? */
t2=((C_word*)t0)[3];
f_2251(t2,f_1966(t1));}

/* k2249 in k2207 in k2177 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_2251(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[19],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_2251,NULL,2,t0,t1);}
if(C_truep(t1)){
t2=((C_word*)t0)[9];
f_2040(2,t2,((C_word*)t0)[8]);}
else{
t2=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_2257,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[5],a[4]=((C_word*)t0)[6],a[5]=((C_word*)t0)[8],a[6]=((C_word*)t0)[9],a[7]=((C_word*)t0)[7],tmp=(C_word)a,a+=8,tmp);
t3=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_2303,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[8],a[4]=((C_word*)t0)[4],a[5]=t2,a[6]=((C_word*)t0)[3],tmp=(C_word)a,a+=7,tmp);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2324,a[2]=t3,a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1277 sref */
t5=((C_word*)t0)[4];
((C_proc4)C_retrieve_proc(t5))(4,t5,t4,((C_word*)t0)[8],C_fix(0));}}

/* k2322 in k2249 in k2207 in k2177 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2324(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1277 char=? */
t2=((C_word*)t0)[3];
((C_proc4)C_retrieve_proc(t2))(4,t2,((C_word*)t0)[2],C_make_character(47),t1);}

/* k2301 in k2249 in k2207 in k2177 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2303(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[10],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2303,2,t0,t1);}
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2309,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[6],tmp=(C_word)a,a+=6,tmp);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2320,a[2]=t2,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1278 sref */
t4=((C_word*)t0)[4];
((C_proc4)C_retrieve_proc(t4))(4,t4,t3,((C_word*)t0)[3],C_fix(1));}
else{
t2=((C_word*)t0)[5];
f_2257(2,t2,C_SCHEME_FALSE);}}

/* k2318 in k2301 in k2249 in k2207 in k2177 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2320(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1278 alpha? */
t2=((C_word*)t0)[3];
((C_proc3)C_retrieve_proc(t2))(3,t2,((C_word*)t0)[2],t1);}

/* k2307 in k2301 in k2249 in k2207 in k2177 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2309(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2309,2,t0,t1);}
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2316,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[5],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1279 sref */
t3=((C_word*)t0)[3];
((C_proc4)C_retrieve_proc(t3))(4,t3,t2,((C_word*)t0)[2],C_fix(2));}
else{
t2=((C_word*)t0)[4];
f_2257(2,t2,C_SCHEME_FALSE);}}

/* k2314 in k2307 in k2301 in k2249 in k2207 in k2177 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2316(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1279 char=? */
t2=((C_word*)t0)[3];
((C_proc4)C_retrieve_proc(t2))(4,t2,((C_word*)t0)[2],C_make_character(58),t1);}

/* k2255 in k2249 in k2207 in k2177 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2257(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[12],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2257,2,t0,t1);}
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2264,a[2]=((C_word*)t0)[5],a[3]=((C_word*)t0)[6],a[4]=((C_word*)t0)[7],tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm: 1281 ##sys#substring */
t3=*((C_word*)lf[53]+1);
((C_proc5)C_retrieve_proc(t3))(5,t3,t2,((C_word*)t0)[5],C_fix(1),C_fix(3));}
else{
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_2300,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[5],a[4]=((C_word*)t0)[6],a[5]=((C_word*)t0)[7],a[6]=((C_word*)t0)[4],tmp=(C_word)a,a+=7,tmp);
/* posixwin.scm: 1285 sref */
t3=((C_word*)t0)[2];
((C_proc4)C_retrieve_proc(t3))(4,t3,t2,((C_word*)t0)[5],C_fix(0));}}

/* k2298 in k2255 in k2249 in k2207 in k2177 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2300(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[13],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2300,2,t0,t1);}
t2=f_1966(t1);
if(C_truep(t2)){
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2285,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],tmp=(C_word)a,a+=5,tmp);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2289,a[2]=t3,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm: 1287 cwd */
t5=((C_word*)t0)[2];
f_1977(t5,t4);}
else{
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2296,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm: 1290 cwd */
t4=((C_word*)t0)[2];
f_1977(t4,t3);}}

/* k2294 in k2298 in k2255 in k2249 in k2207 in k2177 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2296(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1290 sappend */
t2=((C_word*)t0)[4];
((C_proc5)C_retrieve_proc(t2))(5,t2,((C_word*)t0)[3],t1,lf[127],((C_word*)t0)[2]);}

/* k2287 in k2298 in k2255 in k2249 in k2207 in k2177 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2289(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1287 ##sys#substring */
t2=*((C_word*)lf[53]+1);
((C_proc5)C_retrieve_proc(t2))(5,t2,((C_word*)t0)[2],t1,C_fix(0),C_fix(2));}

/* k2283 in k2298 in k2255 in k2249 in k2207 in k2177 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2285(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1286 sappend */
t2=((C_word*)t0)[4];
((C_proc4)C_retrieve_proc(t2))(4,t2,((C_word*)t0)[3],t1,((C_word*)t0)[2]);}

/* k2262 in k2255 in k2249 in k2207 in k2177 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2264(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[5],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2264,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2268,a[2]=t1,a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
t3=(C_word)C_block_size(((C_word*)t0)[2]);
/* posixwin.scm: 1283 ##sys#substring */
t4=*((C_word*)lf[53]+1);
((C_proc5)C_retrieve_proc(t4))(5,t4,t2,((C_word*)t0)[2],C_fix(3),t3);}

/* k2266 in k2262 in k2255 in k2249 in k2207 in k2177 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2268(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1280 sappend */
t2=((C_word*)t0)[4];
((C_proc5)C_retrieve_proc(t2))(5,t2,((C_word*)t0)[3],((C_word*)t0)[2],lf[126],t1);}

/* k2243 in k2207 in k2177 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2245(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1272 sappend */
t2=((C_word*)t0)[4];
((C_proc5)C_retrieve_proc(t2))(5,t2,((C_word*)t0)[3],t1,lf[125],((C_word*)t0)[2]);}

/* k2230 in k2207 in k2177 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2232(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1266 ##sys#substring */
t2=*((C_word*)lf[53]+1);
((C_proc5)C_retrieve_proc(t2))(5,t2,((C_word*)t0)[2],t1,C_fix(0),C_fix(3));}

/* k2214 in k2207 in k2177 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2216(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[6],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2216,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2220,a[2]=((C_word*)t0)[3],a[3]=t1,a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
/* posixwin.scm: 1268 user */
t3=((C_word*)t0)[2];
((C_proc2)C_retrieve_proc(t3))(2,t3,t2);}

/* k2218 in k2214 in k2207 in k2177 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2220(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[6],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2220,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2224,a[2]=t1,a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
t3=(C_word)C_block_size(((C_word*)t0)[2]);
/* posixwin.scm: 1269 ##sys#substring */
t4=*((C_word*)lf[53]+1);
((C_proc5)C_retrieve_proc(t4))(5,t4,t2,((C_word*)t0)[2],C_fix(1),t3);}

/* k2222 in k2218 in k2214 in k2207 in k2177 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2224(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1265 sappend */
t2=((C_word*)t0)[5];
((C_proc6)C_retrieve_proc(t2))(6,t2,((C_word*)t0)[4],((C_word*)t0)[3],lf[124],((C_word*)t0)[2],t1);}

/* k2201 in k2177 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2203(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1262 sappend */
t2=((C_word*)t0)[4];
((C_proc5)C_retrieve_proc(t2))(5,t2,((C_word*)t0)[3],t1,lf[123],((C_word*)t0)[2]);}

/* k2188 in k2177 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2190(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1259 ##sys#substring */
t2=*((C_word*)lf[53]+1);
((C_proc5)C_retrieve_proc(t2))(5,t2,((C_word*)t0)[2],t1,C_fix(0),C_fix(2));}

/* k2184 in k2177 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2186(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1258 sappend */
t2=((C_word*)t0)[4];
((C_proc4)C_retrieve_proc(t2))(4,t2,((C_word*)t0)[3],t1,((C_word*)t0)[2]);}

/* k2171 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2173(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1255 sappend */
t2=((C_word*)t0)[3];
((C_proc4)C_retrieve_proc(t2))(4,t2,((C_word*)t0)[2],t1,lf[122]);}

/* k2038 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2040(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[13],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2040,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|9,a[1]=(C_word)f_2047,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],a[9]=t1,tmp=(C_word)a,a+=10,tmp);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_2159,a[2]=t2,tmp=(C_word)a,a+=3,tmp);
t4=(C_word)C_block_size(t1);
/* posixwin.scm: 1291 ##sys#substring */
t5=*((C_word*)lf[53]+1);
((C_proc5)C_retrieve_proc(t5))(5,t5,t3,t1,C_fix(3),t4);}

/* k2157 in k2038 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2159(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* string-split */
t2=*((C_word*)lf[120]+1);
((C_proc4)C_retrieve_proc(t2))(4,t2,((C_word*)t0)[2],t1,lf[121]);}

/* k2045 in k2038 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2047(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[13],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2047,2,t0,t1);}
t2=C_SCHEME_UNDEFINED;
t3=(*a=C_VECTOR_TYPE|1,a[1]=t2,tmp=(C_word)a,a+=2,tmp);
t4=C_set_block_item(t3,0,(*a=C_CLOSURE_TYPE|10,a[1]=(C_word)f_2049,a[2]=((C_word*)t0)[3],a[3]=t3,a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=((C_word*)t0)[6],a[7]=((C_word*)t0)[7],a[8]=((C_word*)t0)[8],a[9]=((C_word*)t0)[9],a[10]=((C_word)li40),tmp=(C_word)a,a+=11,tmp));
t5=((C_word*)t3)[1];
f_2049(t5,((C_word*)t0)[2],t1,C_SCHEME_END_OF_LIST);}

/* loop in k2045 in k2038 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_2049(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word ab[13],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_2049,NULL,4,t0,t1,t2,t3);}
t4=(*a=C_CLOSURE_TYPE|12,a[1]=(C_word)f_2056,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t2,a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],a[7]=t3,a[8]=((C_word*)t0)[6],a[9]=((C_word*)t0)[7],a[10]=((C_word*)t0)[8],a[11]=((C_word*)t0)[9],a[12]=t1,tmp=(C_word)a,a+=13,tmp);
/* posixwin.scm: 1293 null? */
t5=((C_word*)t0)[4];
((C_proc3)C_retrieve_proc(t5))(3,t5,t4,t2);}

/* k2054 in loop in k2045 in k2038 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2056(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word ab[20],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2056,2,t0,t1);}
if(C_truep(t1)){
t2=(*a=C_CLOSURE_TYPE|8,a[1]=(C_word)f_2062,a[2]=((C_word*)t0)[6],a[3]=((C_word*)t0)[7],a[4]=((C_word*)t0)[8],a[5]=((C_word*)t0)[9],a[6]=((C_word*)t0)[10],a[7]=((C_word*)t0)[11],a[8]=((C_word*)t0)[12],tmp=(C_word)a,a+=9,tmp);
/* posixwin.scm: 1294 null? */
t3=((C_word*)t0)[5];
((C_proc3)C_retrieve_proc(t3))(3,t3,t2,((C_word*)t0)[7]);}
else{
t2=(C_word)C_i_cdr(((C_word*)t0)[4]);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2128,a[2]=t2,a[3]=((C_word*)t0)[12],a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2131,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[7],a[5]=t3,tmp=(C_word)a,a+=6,tmp);
t5=(C_word)C_i_car(((C_word*)t0)[4]);
/* posixwin.scm: 1305 string=? */
t6=((C_word*)t0)[2];
((C_proc4)C_retrieve_proc(t6))(4,t6,t4,lf[119],t5);}}

/* k2129 in k2054 in loop in k2045 in k2038 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2131(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[5],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2131,2,t0,t1);}
if(C_truep(t1)){
t2=((C_word*)t0)[5];
f_2128(t2,(C_word)C_i_cdr(((C_word*)t0)[4]));}
else{
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2140,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],tmp=(C_word)a,a+=5,tmp);
t3=(C_word)C_i_car(((C_word*)t0)[3]);
/* posixwin.scm: 1307 string=? */
t4=((C_word*)t0)[2];
((C_proc4)C_retrieve_proc(t4))(4,t4,t2,lf[118],t3);}}

/* k2138 in k2129 in k2054 in loop in k2045 in k2038 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2140(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[3],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2140,2,t0,t1);}
if(C_truep(t1)){
t2=((C_word*)t0)[4];
f_2128(t2,((C_word*)t0)[3]);}
else{
t2=(C_word)C_i_car(((C_word*)t0)[2]);
t3=((C_word*)t0)[4];
f_2128(t3,(C_word)C_a_i_cons(&a,2,t2,((C_word*)t0)[3]));}}

/* k2126 in k2054 in loop in k2045 in k2038 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_2128(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1303 loop */
t2=((C_word*)((C_word*)t0)[4])[1];
f_2049(t2,((C_word*)t0)[3],((C_word*)t0)[2],t1);}

/* k2060 in k2054 in loop in k2045 in k2038 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2062(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[12],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2062,2,t0,t1);}
if(C_truep(t1)){
/* posixwin.scm: 1295 ##sys#substring */
t2=*((C_word*)lf[53]+1);
((C_proc5)C_retrieve_proc(t2))(5,t2,((C_word*)t0)[8],((C_word*)t0)[7],C_fix(0),C_fix(3));}
else{
t2=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_2109,a[2]=((C_word*)t0)[7],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[8],a[6]=((C_word*)t0)[5],a[7]=((C_word*)t0)[6],tmp=(C_word)a,a+=8,tmp);
t3=(C_word)C_block_size(((C_word*)t0)[7]);
t4=(C_word)C_a_i_minus(&a,2,t3,C_fix(1));
/* posixwin.scm: 1296 sref */
t5=((C_word*)t0)[2];
((C_proc4)C_retrieve_proc(t5))(4,t5,t2,((C_word*)t0)[7],t4);}}

/* k2107 in k2060 in k2054 in loop in k2045 in k2038 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2109(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[12],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2109,2,t0,t1);}
t2=f_1966(t1);
if(C_truep(t2)){
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2078,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[6],tmp=(C_word)a,a+=6,tmp);
/* posixwin.scm: 1298 ##sys#substring */
t4=*((C_word*)lf[53]+1);
((C_proc5)C_retrieve_proc(t4))(5,t4,t3,((C_word*)t0)[2],C_fix(0),C_fix(3));}
else{
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_2097,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],a[5]=((C_word*)t0)[6],tmp=(C_word)a,a+=6,tmp);
/* posixwin.scm: 1301 ##sys#substring */
t4=*((C_word*)lf[53]+1);
((C_proc5)C_retrieve_proc(t4))(5,t4,t3,((C_word*)t0)[2],C_fix(0),C_fix(3));}}

/* k2095 in k2107 in k2060 in k2054 in loop in k2045 in k2038 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2097(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[9],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2097,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2101,a[2]=t1,a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],tmp=(C_word)a,a+=5,tmp);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2105,a[2]=t2,a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1302 reverse */
t4=*((C_word*)lf[117]+1);
((C_proc3)(void*)(*((C_word*)t4+1)))(3,t4,t3,((C_word*)t0)[2]);}

/* k2103 in k2095 in k2107 in k2060 in k2054 in loop in k2045 in k2038 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2105(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1302 isperse */
f_1961(((C_word*)t0)[2],t1);}

/* k2099 in k2095 in k2107 in k2060 in k2054 in loop in k2045 in k2038 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2101(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1300 sappend */
t2=((C_word*)t0)[4];
((C_proc4)C_retrieve_proc(t2))(4,t2,((C_word*)t0)[3],((C_word*)t0)[2],t1);}

/* k2076 in k2107 in k2060 in k2054 in loop in k2045 in k2038 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2078(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[12],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2078,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2082,a[2]=t1,a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],tmp=(C_word)a,a+=5,tmp);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2086,a[2]=t2,a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
t4=(C_word)C_a_i_cons(&a,2,lf[116],((C_word*)t0)[2]);
/* posixwin.scm: 1299 reverse */
t5=*((C_word*)lf[117]+1);
((C_proc3)(void*)(*((C_word*)t5+1)))(3,t5,t3,t4);}

/* k2084 in k2076 in k2107 in k2060 in k2054 in loop in k2045 in k2038 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2086(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1299 isperse */
f_1961(((C_word*)t0)[2],t1);}

/* k2080 in k2076 in k2107 in k2060 in k2054 in loop in k2045 in k2038 in canonical-path in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2082(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1297 sappend */
t2=((C_word*)t0)[4];
((C_proc4)C_retrieve_proc(t2))(4,t2,((C_word*)t0)[3],((C_word*)t0)[2],t1);}

/* cwd in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_1977(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[7],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_1977,NULL,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1984,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1986,a[2]=((C_word*)t0)[2],a[3]=((C_word)li38),tmp=(C_word)a,a+=4,tmp);
/* call-with-current-continuation */
t4=*((C_word*)lf[114]+1);
((C_proc3)(void*)(*((C_word*)t4+1)))(3,t4,t2,t3);}

/* a1985 in cwd in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1986(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word ab[9],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_1986,3,t0,t1,t2);}
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1992,a[2]=t2,a[3]=((C_word)li33),tmp=(C_word)a,a+=4,tmp);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_2010,a[2]=t2,a[3]=((C_word*)t0)[2],a[4]=((C_word)li37),tmp=(C_word)a,a+=5,tmp);
/* with-exception-handler */
t5=*((C_word*)lf[113]+1);
((C_proc4)C_retrieve_proc(t5))(4,t5,t1,t3,t4);}

/* a2009 in a1985 in cwd in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2010(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[8],*a=ab;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2010,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2016,a[2]=((C_word*)t0)[3],a[3]=((C_word)li34),tmp=(C_word)a,a+=4,tmp);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2022,a[2]=((C_word*)t0)[2],a[3]=((C_word)li36),tmp=(C_word)a,a+=4,tmp);
/* ##sys#call-with-values */
C_call_with_values(4,0,t1,t2,t3);}

/* a2021 in a2009 in a1985 in cwd in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2022(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
va_list v;
C_word *a,c2=c;
C_save_rest(t1,c2,2);
if(!C_demand(c*C_SIZEOF_PAIR+4)){
C_save_and_reclaim((void*)tr2r,(void*)f_2022r,2,t0,t1);}
else{
a=C_alloc((c-2)*3);
t2=C_restore_rest(a,C_rest_count(0));
f_2022r(t0,t1,t2);}}

static void C_ccall f_2022r(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a=C_alloc(4);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_2028,a[2]=t2,a[3]=((C_word)li35),tmp=(C_word)a,a+=4,tmp);
/* g187189 */
t4=((C_word*)t0)[2];
((C_proc3)C_retrieve_proc(t4))(3,t4,t1,t3);}

/* a2027 in a2021 in a2009 in a1985 in cwd in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2028(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2028,2,t0,t1);}
C_apply_values(3,0,t1,((C_word*)t0)[2]);}

/* a2015 in a2009 in a1985 in cwd in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_2016(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_2016,2,t0,t1);}
/* posixwin.scm: 1250 cw */
t2=((C_word*)t0)[2];
((C_proc2)C_retrieve_proc(t2))(2,t2,t1);}

/* a1991 in a1985 in cwd in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1992(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word ab[4],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_1992,3,t0,t1,t2);}
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1998,a[2]=t2,a[3]=((C_word)li32),tmp=(C_word)a,a+=4,tmp);
/* g187189 */
t4=((C_word*)t0)[2];
((C_proc3)C_retrieve_proc(t4))(3,t4,t1,t3);}

/* a1997 in a1991 in a1985 in cwd in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1998(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(c!=2) C_bad_argc_2(c,2,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1998,2,t0,t1);}
t2=(C_word)C_i_structurep(((C_word*)t0)[2],lf[111]);
t3=(C_truep(t2)?(C_word)C_slot(((C_word*)t0)[2],C_fix(1)):C_SCHEME_FALSE);
t4=t1;
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,lf[112]);}

/* k1982 in cwd in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1984(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
t2=t1;
((C_proc2)C_retrieve_proc(t2))(2,t2,((C_word*)t0)[2]);}

/* sep? in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static C_word C_fcall f_1966(C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_stack_check;
t2=(C_word)C_eqp(C_make_character(47),t1);
return((C_truep(t2)?t2:(C_word)C_eqp(C_make_character(92),t1)));}

/* isperse in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_1961(C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_1961,NULL,2,t1,t2);}
/* string-intersperse */
t3=*((C_word*)lf[108]+1);
((C_proc4)C_retrieve_proc(t3))(4,t3,t1,t2,lf[109]);}

/* current-directory in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1910(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
va_list v;
C_word *a,c2=c;
C_save_rest(t1,c2,2);
if(!C_demand(c*C_SIZEOF_PAIR+4)){
C_save_and_reclaim((void*)tr2r,(void*)f_1910r,2,t0,t1);}
else{
a=C_alloc((c-2)*3);
t2=C_restore_rest(a,C_rest_count(0));
f_1910r(t0,t1,t2);}}

static void C_ccall f_1910r(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word *a=C_alloc(4);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1914,a[2]=((C_word*)t0)[2],a[3]=t1,tmp=(C_word)a,a+=4,tmp);
if(C_truep((C_word)C_i_nullp(t2))){
t4=t3;
f_1914(2,t4,C_SCHEME_FALSE);}
else{
t4=(C_word)C_i_cdr(t2);
if(C_truep((C_word)C_i_nullp(t4))){
t5=t3;
f_1914(2,t5,(C_word)C_i_car(t2));}
else{
/* ##sys#error */
t5=*((C_word*)lf[62]+1);
((C_proc4)(void*)(*((C_word*)t5+1)))(4,t5,t3,lf[2],t2);}}}

/* k1912 in current-directory in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1914(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[3],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1914,2,t0,t1);}
if(C_truep(t1)){
/* posixwin.scm: 1228 change-directory */
t2=*((C_word*)lf[91]+1);
((C_proc3)C_retrieve_proc(t2))(3,t2,((C_word*)t0)[3],t1);}
else{
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1923,a[2]=((C_word*)t0)[3],tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm: 1229 make-string */
t3=((C_word*)t0)[2];
((C_proc3)C_retrieve_proc(t3))(3,t3,t2,C_fix(256));}}

/* k1921 in k1912 in current-directory in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1923(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[5],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1923,2,t0,t1);}
t2=(C_word)C_curdir(t1);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1926,a[2]=t1,a[3]=((C_word*)t0)[2],a[4]=t2,tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm: 1231 ##sys#update-errno */
t4=*((C_word*)lf[9]+1);
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,t3);}

/* k1924 in k1921 in k1912 in current-directory in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1926(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
if(C_truep(((C_word*)t0)[4])){
/* posixwin.scm: 1233 ##sys#substring */
t2=*((C_word*)lf[53]+1);
((C_proc5)C_retrieve_proc(t2))(5,t2,((C_word*)t0)[3],((C_word*)t0)[2],C_fix(0),((C_word*)t0)[4]);}
else{
/* posixwin.scm: 1234 ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);
((C_proc5)(void*)(*((C_word*)t2+1)))(5,t2,((C_word*)t0)[3],lf[37],lf[99],lf[102]);}}

/* directory? in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1883(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word ab[9],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_1883,3,t0,t1,t2);}
t3=(C_word)C_i_check_string_2(t2,lf[100]);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1890,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1904,a[2]=t4,tmp=(C_word)a,a+=3,tmp);
t6=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1908,a[2]=t5,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm: 1221 ##sys#expand-home-path */
t7=*((C_word*)lf[40]+1);
((C_proc3)C_retrieve_proc(t7))(3,t7,t6,t2);}

/* k1906 in directory? in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1908(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1221 ##sys#platform-fixup-pathname */
t2=*((C_word*)lf[101]+1);
((C_proc3)C_retrieve_proc(t2))(3,t2,((C_word*)t0)[2],t1);}

/* k1902 in directory? in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1904(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1220 ##sys#file-info */
t2=*((C_word*)lf[70]+1);
((C_proc3)(void*)(*((C_word*)t2+1)))(3,t2,((C_word*)t0)[2],t1);}

/* k1888 in directory? in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1890(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_truep(t1)){
t2=(C_word)C_slot(t1,C_fix(4));
t3=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,(C_word)C_eqp(C_fix(1),t2));}
else{
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_SCHEME_FALSE);}}

/* directory in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1723(C_word c,C_word t0,C_word t1,...){
C_word tmp;
C_word t2;
va_list v;
C_word *a,c2=c;
C_save_rest(t1,c2,2);
if(!C_demand(c*C_SIZEOF_PAIR+12)){
C_save_and_reclaim((void*)tr2r,(void*)f_1723r,2,t0,t1);}
else{
a=C_alloc((c-2)*3);
t2=C_restore_rest(a,C_rest_count(0));
f_1723r(t0,t1,t2);}}

static void C_ccall f_1723r(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a=C_alloc(12);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1725,a[2]=((C_word*)t0)[2],a[3]=((C_word)li24),tmp=(C_word)a,a+=4,tmp);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1826,a[2]=t3,a[3]=((C_word)li25),tmp=(C_word)a,a+=4,tmp);
t5=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1831,a[2]=t4,a[3]=((C_word)li26),tmp=(C_word)a,a+=4,tmp);
if(C_truep((C_word)C_i_nullp(t2))){
/* def-spec123149 */
t6=t5;
f_1831(t6,t1);}
else{
t6=(C_word)C_i_car(t2);
t7=(C_word)C_i_cdr(t2);
if(C_truep((C_word)C_i_nullp(t7))){
/* def-show-dotfiles?124147 */
t8=t4;
f_1826(t8,t1,t6);}
else{
t8=(C_word)C_i_car(t7);
t9=(C_word)C_i_cdr(t7);
if(C_truep((C_word)C_i_nullp(t9))){
/* body121126 */
t10=t3;
f_1725(t10,t1,t6,t8);}
else{
/* ##sys#error */
t10=*((C_word*)lf[62]+1);
((C_proc4)(void*)(*((C_word*)t10+1)))(4,t10,t1,lf[2],t9);}}}}

/* def-spec123 in directory in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_1831(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_1831,NULL,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1839,a[2]=t1,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1191 current-directory */
t3=*((C_word*)lf[99]+1);
((C_proc2)C_retrieve_proc(t3))(2,t3,t2);}

/* k1837 in def-spec123 in directory in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1839(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* def-show-dotfiles?124147 */
t2=((C_word*)t0)[3];
f_1826(t2,((C_word*)t0)[2],t1);}

/* def-show-dotfiles?124 in directory in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_1826(C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word *a;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_1826,NULL,3,t0,t1,t2);}
/* body121126 */
t3=((C_word*)t0)[2];
f_1725(t3,t1,t2,C_SCHEME_FALSE);}

/* body121 in directory in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_1725(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word ab[5],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_1725,NULL,4,t0,t1,t2,t3);}
t4=(C_word)C_i_check_string_2(t2,lf[96]);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1732,a[2]=t3,a[3]=t2,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm: 1193 make-string */
t6=((C_word*)t0)[2];
((C_proc3)C_retrieve_proc(t6))(3,t6,t5,C_fix(256));}

/* k1730 in body121 in directory in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1732(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[6],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1732,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_1735,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
/* posixwin.scm: 1194 ##sys#make-pointer */
t3=*((C_word*)lf[98]+1);
((C_proc2)C_retrieve_proc(t3))(2,t3,t2);}

/* k1733 in k1730 in body121 in directory in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1735(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[7],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1735,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|6,a[1]=(C_word)f_1738,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],a[6]=t1,tmp=(C_word)a,a+=7,tmp);
/* posixwin.scm: 1195 ##sys#make-pointer */
t3=*((C_word*)lf[98]+1);
((C_proc2)C_retrieve_proc(t3))(2,t3,t2);}

/* k1736 in k1733 in k1730 in body121 in directory in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1738(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[11],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1738,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_1742,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[5],a[7]=((C_word*)t0)[6],tmp=(C_word)a,a+=8,tmp);
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1825,a[2]=t2,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm: 1196 ##sys#expand-home-path */
t4=*((C_word*)lf[40]+1);
((C_proc3)C_retrieve_proc(t4))(3,t4,t3,((C_word*)t0)[4]);}

/* k1823 in k1736 in k1733 in k1730 in body121 in directory in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1825(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1196 ##sys#make-c-string */
t2=*((C_word*)lf[39]+1);
((C_proc3)(void*)(*((C_word*)t2+1)))(3,t2,((C_word*)t0)[2],t1);}

/* k1740 in k1736 in k1733 in k1730 in body121 in directory in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1742(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word ab[14],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1742,2,t0,t1);}
t2=(C_word)C_opendir(t1,((C_word*)t0)[7]);
if(C_truep((C_word)C_null_pointerp(((C_word*)t0)[7]))){
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1751,a[2]=((C_word*)t0)[5],a[3]=((C_word*)t0)[6],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1199 ##sys#update-errno */
t4=*((C_word*)lf[9]+1);
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,t3);}
else{
t3=C_SCHEME_UNDEFINED;
t4=(*a=C_VECTOR_TYPE|1,a[1]=t3,tmp=(C_word)a,a+=2,tmp);
t5=C_set_block_item(t4,0,(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_1759,a[2]=((C_word*)t0)[2],a[3]=t4,a[4]=((C_word*)t0)[3],a[5]=((C_word*)t0)[4],a[6]=((C_word*)t0)[7],a[7]=((C_word)li23),tmp=(C_word)a,a+=8,tmp));
t6=((C_word*)t4)[1];
f_1759(t6,((C_word*)t0)[6]);}}

/* loop in k1740 in k1736 in k1733 in k1730 in body121 in directory in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_1759(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[6],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_1759,NULL,2,t0,t1);}
t2=(C_word)C_readdir(((C_word*)t0)[6],((C_word*)t0)[5]);
if(C_truep((C_word)C_null_pointerp(((C_word*)t0)[5]))){
t3=(C_word)C_closedir(((C_word*)t0)[6]);
t4=t1;
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,C_SCHEME_END_OF_LIST);}
else{
t3=(C_word)C_foundfile(((C_word*)t0)[5],((C_word*)t0)[4]);
t4=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_1769,a[2]=((C_word*)t0)[2],a[3]=t1,a[4]=((C_word*)t0)[3],a[5]=t3,tmp=(C_word)a,a+=6,tmp);
/* posixwin.scm: 1208 ##sys#substring */
t5=*((C_word*)lf[53]+1);
((C_proc5)C_retrieve_proc(t5))(5,t5,t4,((C_word*)t0)[4],C_fix(0),t3);}}

/* k1767 in loop in k1740 in k1736 in k1733 in k1730 in body121 in directory in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1769(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word ab[5],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1769,2,t0,t1);}
t2=(C_word)C_i_string_ref(t1,C_fix(0));
t3=(C_word)C_i_greaterp(((C_word*)t0)[5],C_fix(1));
t4=(C_truep(t3)?(C_word)C_i_string_ref(t1,C_fix(1)):C_SCHEME_FALSE);
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1781,a[2]=t1,a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
t6=(C_word)C_eqp(t2,C_make_character(46));
if(C_truep(t6)){
t7=(C_word)C_i_not(t4);
if(C_truep(t7)){
t8=t5;
f_1781(t8,t7);}
else{
t8=(C_word)C_eqp(t4,C_make_character(46));
t9=(C_truep(t8)?(C_word)C_eqp(((C_word*)t0)[5],C_fix(2)):C_SCHEME_FALSE);
t10=t5;
f_1781(t10,(C_truep(t9)?t9:(C_word)C_i_not(((C_word*)t0)[2])));}}
else{
t7=t5;
f_1781(t7,C_SCHEME_FALSE);}}

/* k1779 in k1767 in loop in k1740 in k1736 in k1733 in k1730 in body121 in directory in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_1781(C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_1781,NULL,2,t0,t1);}
if(C_truep(t1)){
/* posixwin.scm: 1215 loop */
t2=((C_word*)((C_word*)t0)[4])[1];
f_1759(t2,((C_word*)t0)[3]);}
else{
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1791,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1216 loop */
t3=((C_word*)((C_word*)t0)[4])[1];
f_1759(t3,t2);}}

/* k1789 in k1779 in k1767 in loop in k1740 in k1736 in k1733 in k1730 in body121 in directory in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1791(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word ab[3],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1791,2,t0,t1);}
t2=((C_word*)t0)[3];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,(C_word)C_a_i_cons(&a,2,((C_word*)t0)[2],t1));}

/* k1749 in k1740 in k1736 in k1733 in k1730 in body121 in directory in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1751(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1200 ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);
((C_proc6)(void*)(*((C_word*)t2+1)))(6,t2,((C_word*)t0)[3],lf[37],lf[96],lf[97],((C_word*)t0)[2]);}

/* delete-directory in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1696(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[7],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_1696,3,t0,t1,t2);}
t3=(C_word)C_i_check_string_2(t2,lf[93]);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1717,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1721,a[2]=t4,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm: 1183 ##sys#expand-home-path */
t6=*((C_word*)lf[40]+1);
((C_proc3)C_retrieve_proc(t6))(3,t6,t5,t2);}

/* k1719 in delete-directory in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1721(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1183 ##sys#make-c-string */
t2=*((C_word*)lf[39]+1);
((C_proc3)(void*)(*((C_word*)t2+1)))(3,t2,((C_word*)t0)[2],t1);}

/* k1715 in delete-directory in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1717(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1717,2,t0,t1);}
t2=(C_word)C_rmdir(t1);
if(C_truep((C_word)C_i_zerop(t2))){
t3=((C_word*)t0)[3];
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,C_SCHEME_UNDEFINED);}
else{
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1709,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1184 ##sys#update-errno */
t4=*((C_word*)lf[9]+1);
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,t3);}}

/* k1707 in k1715 in delete-directory in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1709(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1185 ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);
((C_proc6)(void*)(*((C_word*)t2+1)))(6,t2,((C_word*)t0)[3],lf[37],lf[93],lf[94],((C_word*)t0)[2]);}

/* change-directory in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1669(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[7],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_1669,3,t0,t1,t2);}
t3=(C_word)C_i_check_string_2(t2,lf[91]);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1690,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1694,a[2]=t4,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm: 1176 ##sys#expand-home-path */
t6=*((C_word*)lf[40]+1);
((C_proc3)C_retrieve_proc(t6))(3,t6,t5,t2);}

/* k1692 in change-directory in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1694(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1176 ##sys#make-c-string */
t2=*((C_word*)lf[39]+1);
((C_proc3)(void*)(*((C_word*)t2+1)))(3,t2,((C_word*)t0)[2],t1);}

/* k1688 in change-directory in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1690(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1690,2,t0,t1);}
t2=(C_word)C_chdir(t1);
if(C_truep((C_word)C_i_zerop(t2))){
t3=((C_word*)t0)[3];
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,C_SCHEME_UNDEFINED);}
else{
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1682,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1177 ##sys#update-errno */
t4=*((C_word*)lf[9]+1);
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,t3);}}

/* k1680 in k1688 in change-directory in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1682(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1178 ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);
((C_proc6)(void*)(*((C_word*)t2+1)))(6,t2,((C_word*)t0)[3],lf[37],lf[91],lf[92],((C_word*)t0)[2]);}

/* create-directory in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1642(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[7],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_1642,3,t0,t1,t2);}
t3=(C_word)C_i_check_string_2(t2,lf[89]);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1663,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1667,a[2]=t4,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm: 1169 ##sys#expand-home-path */
t6=*((C_word*)lf[40]+1);
((C_proc3)C_retrieve_proc(t6))(3,t6,t5,t2);}

/* k1665 in create-directory in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1667(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1169 ##sys#make-c-string */
t2=*((C_word*)lf[39]+1);
((C_proc3)(void*)(*((C_word*)t2+1)))(3,t2,((C_word*)t0)[2],t1);}

/* k1661 in create-directory in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1663(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1663,2,t0,t1);}
t2=(C_word)C_mkdir(t1);
if(C_truep((C_word)C_i_zerop(t2))){
t3=((C_word*)t0)[3];
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,C_SCHEME_UNDEFINED);}
else{
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1655,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1170 ##sys#update-errno */
t4=*((C_word*)lf[9]+1);
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,t3);}}

/* k1653 in k1661 in create-directory in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1655(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1171 ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);
((C_proc6)(void*)(*((C_word*)t2+1)))(6,t2,((C_word*)t0)[3],lf[37],lf[89],lf[90],((C_word*)t0)[2]);}

/* set-file-position! in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1581(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...){
C_word tmp;
C_word t4;
va_list v;
C_word *a,c2=c;
C_save_rest(t3,c2,4);
if(c<4) C_bad_min_argc_2(c,4,t0);
if(!C_demand(c*C_SIZEOF_PAIR+6)){
C_save_and_reclaim((void*)tr4rv,(void*)f_1581r,4,t0,t1,t2,t3);}
else{
a=C_alloc((c-4)*3);
t4=C_restore_rest_vector(a,C_rest_count(0));
f_1581r(t0,t1,t2,t3,t4);}}

static void C_ccall f_1581r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word *a=C_alloc(6);
t5=(C_word)C_notvemptyp(t4);
t6=(C_truep(t5)?(C_word)C_i_vector_ref(t4,C_fix(0)):C_fix((C_word)SEEK_SET));
t7=(C_word)C_i_check_exact_2(t3,lf[84]);
t8=(C_word)C_i_check_exact_2(t6,lf[84]);
t9=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_1594,a[2]=t6,a[3]=t3,a[4]=t2,a[5]=t1,tmp=(C_word)a,a+=6,tmp);
if(C_truep((C_word)C_fixnum_lessp(t3,C_fix(0)))){
/* posixwin.scm: 1154 ##sys#signal-hook */
t10=*((C_word*)lf[6]+1);
((C_proc7)(void*)(*((C_word*)t10+1)))(7,t10,t9,lf[87],lf[84],lf[88],t3,t2);}
else{
t10=t9;
f_1594(2,t10,C_SCHEME_UNDEFINED);}}

/* k1592 in set-file-position! in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1594(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[11],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1594,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1600,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[5],tmp=(C_word)a,a+=5,tmp);
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_1609,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t2,a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
/* posixwin.scm: 1155 port? */
t4=*((C_word*)lf[83]+1);
((C_proc3)C_retrieve_proc(t4))(3,t4,t3,((C_word*)t0)[4]);}

/* k1607 in k1592 in set-file-position! in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1609(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_truep(t1)){
t2=(C_word)C_slot(((C_word*)t0)[5],C_fix(7));
t3=(C_word)C_eqp(t2,lf[81]);
t4=((C_word*)t0)[4];
f_1600(2,t4,(C_truep(t3)?(C_word)C_fseek(((C_word*)t0)[5],((C_word*)t0)[3],((C_word*)t0)[2]):C_SCHEME_FALSE));}
else{
if(C_truep((C_word)C_fixnump(((C_word*)t0)[5]))){
t2=((C_word*)t0)[4];
f_1600(2,t2,(C_word)C_lseek(((C_word*)t0)[5],((C_word*)t0)[3],((C_word*)t0)[2]));}
else{
/* posixwin.scm: 1159 ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);
((C_proc6)(void*)(*((C_word*)t2+1)))(6,t2,((C_word*)t0)[4],lf[46],lf[84],lf[86],((C_word*)t0)[5]);}}}

/* k1598 in k1592 in set-file-position! in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1600(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[5],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1600,2,t0,t1);}
if(C_truep(t1)){
t2=((C_word*)t0)[4];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_SCHEME_UNDEFINED);}
else{
t2=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1603,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=((C_word*)t0)[4],tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm: 1160 ##sys#update-errno */
t3=*((C_word*)lf[9]+1);
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,t2);}}

/* k1601 in k1598 in k1592 in set-file-position! in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1603(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1161 ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);
((C_proc7)(void*)(*((C_word*)t2+1)))(7,t2,((C_word*)t0)[4],lf[37],lf[84],lf[85],((C_word*)t0)[3],((C_word*)t0)[2]);}

/* file-position in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1541(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word ab[8],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_1541,3,t0,t1,t2);}
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1545,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1560,a[2]=t3,a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1138 port? */
t5=*((C_word*)lf[83]+1);
((C_proc3)C_retrieve_proc(t5))(3,t5,t4,t2);}

/* k1558 in file-position in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1560(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word *a;
if(C_truep(t1)){
t2=(C_word)C_slot(((C_word*)t0)[3],C_fix(7));
t3=(C_word)C_eqp(t2,lf[81]);
t4=((C_word*)t0)[2];
f_1545(2,t4,(C_truep(t3)?(C_word)C_ftell(((C_word*)t0)[3]):C_fix(-1)));}
else{
if(C_truep((C_word)C_fixnump(((C_word*)t0)[3]))){
t2=((C_word*)t0)[2];
f_1545(2,t2,(C_word)C_lseek(((C_word*)t0)[3],C_fix(0),C_fix((C_word)SEEK_CUR)));}
else{
/* posixwin.scm: 1143 ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);
((C_proc6)(void*)(*((C_word*)t2+1)))(6,t2,((C_word*)t0)[2],lf[46],lf[79],lf[82],((C_word*)t0)[3]);}}}

/* k1543 in file-position in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1545(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[8],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1545,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1548,a[2]=t1,a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
if(C_truep((C_word)C_fixnum_lessp(t1,C_fix(0)))){
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1554,a[2]=((C_word*)t0)[2],a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1145 ##sys#update-errno */
t4=*((C_word*)lf[9]+1);
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,t3);}
else{
t3=t2;
f_1548(2,t3,C_SCHEME_UNDEFINED);}}

/* k1552 in k1543 in file-position in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1554(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1146 ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);
((C_proc6)(void*)(*((C_word*)t2+1)))(6,t2,((C_word*)t0)[3],lf[37],lf[79],lf[80],((C_word*)t0)[2]);}

/* k1546 in k1543 in file-position in k1537 in k1533 in k1529 in k1525 in k1521 in k1517 in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1548(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
t2=((C_word*)t0)[3];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,((C_word*)t0)[2]);}

/* stat-type in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_1508(C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_1508,NULL,2,t1,t2);}
t3=t1;
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1510,a[2]=t2,a[3]=((C_word)li16),tmp=(C_word)a,a+=4,tmp));}

/* f_1510 in stat-type in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1510(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_1510,3,t0,t1,t2);}
t3=(C_word)C_i_check_string_2(t2,((C_word*)t0)[2]);
t4=t1;
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,C_SCHEME_FALSE);}

/* symbolic-link? in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1503(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word *a;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_1503,3,t0,t1,t2);}
t3=(C_word)C_i_check_string_2(t2,lf[71]);
t4=t1;
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,C_SCHEME_FALSE);}

/* regular-file? in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1480(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[6],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_1480,3,t0,t1,t2);}
t3=(C_word)C_i_check_string_2(t2,lf[69]);
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1487,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1501,a[2]=t4,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm: 1116 ##sys#expand-home-path */
t6=*((C_word*)lf[40]+1);
((C_proc3)C_retrieve_proc(t6))(3,t6,t5,t2);}

/* k1499 in regular-file? in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1501(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1116 ##sys#file-info */
t2=*((C_word*)lf[70]+1);
((C_proc3)(void*)(*((C_word*)t2+1)))(3,t2,((C_word*)t0)[2],t1);}

/* k1485 in regular-file? in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1487(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word *a;
if(C_truep(t1)){
t2=(C_word)C_slot(t1,C_fix(4));
t3=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,(C_word)C_eqp(C_fix(0),t2));}
else{
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_SCHEME_FALSE);}}

/* file-permissions in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1474(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word ab[3],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_1474,3,t0,t1,t2);}
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1478,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm: 1112 ##sys#stat */
f_1375(t3,t2);}

/* k1476 in file-permissions in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1478(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_fix(C_MOST_POSITIVE_FIXNUM&(C_word)C_statbuf.st_mode));}

/* file-owner in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1468(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word ab[3],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_1468,3,t0,t1,t2);}
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1472,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm: 1111 ##sys#stat */
f_1375(t3,t2);}

/* k1470 in file-owner in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1472(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_fix(C_MOST_POSITIVE_FIXNUM&(C_word)C_statbuf.st_uid));}

/* file-change-time in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1462(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word ab[3],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_1462,3,t0,t1,t2);}
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1466,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm: 1110 ##sys#stat */
f_1375(t3,t2);}

/* k1464 in file-change-time in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1466(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1466,2,t0,t1);}
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_flonum(&a,C_statbuf.st_ctime));}

/* file-access-time in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1456(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word ab[3],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_1456,3,t0,t1,t2);}
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1460,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm: 1109 ##sys#stat */
f_1375(t3,t2);}

/* k1458 in file-access-time in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1460(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1460,2,t0,t1);}
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_flonum(&a,C_statbuf.st_atime));}

/* file-modification-time in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1450(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word ab[3],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_1450,3,t0,t1,t2);}
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1454,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm: 1108 ##sys#stat */
f_1375(t3,t2);}

/* k1452 in file-modification-time in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1454(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1454,2,t0,t1);}
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_flonum(&a,C_statbuf.st_mtime));}

/* file-size in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1444(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word ab[3],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_1444,3,t0,t1,t2);}
t3=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1448,a[2]=t1,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm: 1107 ##sys#stat */
f_1375(t3,t2);}

/* k1446 in file-size in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1448(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_fix(C_MOST_POSITIVE_FIXNUM&(C_word)C_statbuf.st_size));}

/* file-stat in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1413(C_word c,C_word t0,C_word t1,C_word t2,...){
C_word tmp;
C_word t3;
va_list v;
C_word *a,c2=c;
C_save_rest(t2,c2,3);
if(c<3) C_bad_min_argc_2(c,3,t0);
if(!C_demand(c*C_SIZEOF_PAIR+4)){
C_save_and_reclaim((void*)tr3r,(void*)f_1413r,3,t0,t1,t2);}
else{
a=C_alloc((c-3)*3);
t3=C_restore_rest(a,C_rest_count(0));
f_1413r(t0,t1,t2,t3);}}

static void C_ccall f_1413r(C_word t0,C_word t1,C_word t2,C_word t3){
C_word tmp;
C_word t4;
C_word t5;
C_word t6;
C_word *a=C_alloc(4);
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1417,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
if(C_truep((C_word)C_i_nullp(t3))){
t5=t4;
f_1417(2,t5,C_SCHEME_FALSE);}
else{
t5=(C_word)C_i_cdr(t3);
if(C_truep((C_word)C_i_nullp(t5))){
t6=t4;
f_1417(2,t6,(C_word)C_i_car(t3));}
else{
/* ##sys#error */
t6=*((C_word*)lf[62]+1);
((C_proc4)(void*)(*((C_word*)t6+1)))(4,t6,t4,lf[2],t3);}}}

/* k1415 in file-stat in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1417(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[3],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1417,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1420,a[2]=((C_word*)t0)[3],tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm: 1101 ##sys#stat */
f_1375(t2,((C_word*)t0)[2]);}

/* k1418 in k1415 in file-stat in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1420(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word ab[26],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1420,2,t0,t1);}
t2=((C_word*)t0)[2];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,(C_word)C_a_i_vector(&a,13,C_fix(C_MOST_POSITIVE_FIXNUM&(C_word)C_statbuf.st_ino),C_fix(C_MOST_POSITIVE_FIXNUM&(C_word)C_statbuf.st_mode),C_fix(C_MOST_POSITIVE_FIXNUM&(C_word)C_statbuf.st_nlink),C_fix(C_MOST_POSITIVE_FIXNUM&(C_word)C_statbuf.st_uid),C_fix(C_MOST_POSITIVE_FIXNUM&(C_word)C_statbuf.st_gid),C_fix(C_MOST_POSITIVE_FIXNUM&(C_word)C_statbuf.st_size),C_flonum(&a,C_statbuf.st_atime),C_flonum(&a,C_statbuf.st_ctime),C_flonum(&a,C_statbuf.st_mtime),C_fix(0),C_fix(0),C_fix(0),C_fix(0)));}

/* ##sys#stat in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_fcall f_1375(C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[10],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)trf_1375,NULL,2,t1,t2);}
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1379,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
if(C_truep((C_word)C_fixnump(t2))){
t4=t3;
f_1379(2,t4,(C_word)C_fstat(t2));}
else{
if(C_truep((C_word)C_i_stringp(t2))){
t4=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1404,a[2]=t3,tmp=(C_word)a,a+=3,tmp);
t5=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1408,a[2]=t4,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm: 1094 ##sys#expand-home-path */
t6=*((C_word*)lf[40]+1);
((C_proc3)C_retrieve_proc(t6))(3,t6,t5,t2);}
else{
/* posixwin.scm: 1095 ##sys#signal-hook */
t4=*((C_word*)lf[6]+1);
((C_proc5)(void*)(*((C_word*)t4+1)))(5,t4,t3,lf[46],lf[60],t2);}}}

/* k1406 in ##sys#stat in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1408(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1094 ##sys#make-c-string */
t2=*((C_word*)lf[39]+1);
((C_proc3)(void*)(*((C_word*)t2+1)))(3,t2,((C_word*)t0)[2],t1);}

/* k1402 in ##sys#stat in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1404(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
t2=((C_word*)t0)[2];
f_1379(2,t2,(C_word)C_stat(t1));}

/* k1377 in ##sys#stat in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1379(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1379,2,t0,t1);}
if(C_truep((C_word)C_fixnum_lessp(t1,C_fix(0)))){
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1388,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1097 ##sys#update-errno */
t3=*((C_word*)lf[9]+1);
((C_proc2)(void*)(*((C_word*)t3+1)))(2,t3,t2);}
else{
t2=((C_word*)t0)[3];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,C_SCHEME_UNDEFINED);}}

/* k1386 in k1377 in ##sys#stat in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1388(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1098 ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);
((C_proc5)(void*)(*((C_word*)t2+1)))(5,t2,((C_word*)t0)[3],lf[37],lf[59],((C_word*)t0)[2]);}

/* file-mkstemp in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1337(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word ab[5],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_1337,3,t0,t1,t2);}
t3=(C_word)C_i_check_string_2(t2,lf[52]);
t4=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1344,a[2]=((C_word*)t0)[2],a[3]=t2,a[4]=t1,tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm: 1063 ##sys#make-c-string */
t5=*((C_word*)lf[39]+1);
((C_proc3)(void*)(*((C_word*)t5+1)))(3,t5,t4,t2);}

/* k1342 in file-mkstemp in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1344(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[6],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1344,2,t0,t1);}
t2=(C_word)C_mkstemp(t1);
t3=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_1347,a[2]=((C_word*)t0)[3],a[3]=t1,a[4]=t2,a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
/* posixwin.scm: 1065 string-length */
t4=((C_word*)t0)[2];
((C_proc3)C_retrieve_proc(t4))(3,t4,t3,t1);}

/* k1345 in k1342 in file-mkstemp in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1347(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word ab[10],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1347,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_1350,a[2]=((C_word*)t0)[3],a[3]=t1,a[4]=((C_word*)t0)[4],a[5]=((C_word*)t0)[5],tmp=(C_word)a,a+=6,tmp);
t3=(C_word)C_eqp(C_fix(-1),((C_word*)t0)[4]);
if(C_truep(t3)){
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1367,a[2]=((C_word*)t0)[2],a[3]=t2,tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1067 ##sys#update-errno */
t5=*((C_word*)lf[9]+1);
((C_proc2)(void*)(*((C_word*)t5+1)))(2,t5,t4);}
else{
t4=t2;
f_1350(2,t4,C_SCHEME_UNDEFINED);}}

/* k1365 in k1345 in k1342 in file-mkstemp in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1367(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1068 ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);
((C_proc6)(void*)(*((C_word*)t2+1)))(6,t2,((C_word*)t0)[3],lf[37],lf[52],lf[54],((C_word*)t0)[2]);}

/* k1348 in k1345 in k1342 in file-mkstemp in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1350(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[4],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1350,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1357,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[5],tmp=(C_word)a,a+=4,tmp);
t3=(C_word)C_fixnum_difference(((C_word*)t0)[3],C_fix(1));
/* posixwin.scm: 1069 ##sys#substring */
t4=*((C_word*)lf[53]+1);
((C_proc5)C_retrieve_proc(t4))(5,t4,t2,((C_word*)t0)[2],C_fix(0),t3);}

/* k1355 in k1348 in k1345 in k1342 in file-mkstemp in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1357(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1069 values */
C_values(4,0,((C_word*)t0)[3],((C_word*)t0)[2],t1);}

/* file-write in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1295(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...){
C_word tmp;
C_word t4;
va_list v;
C_word *a,c2=c;
C_save_rest(t3,c2,4);
if(c<4) C_bad_min_argc_2(c,4,t0);
if(!C_demand(c*C_SIZEOF_PAIR+6)){
C_save_and_reclaim((void*)tr4rv,(void*)f_1295r,4,t0,t1,t2,t3);}
else{
a=C_alloc((c-4)*3);
t4=C_restore_rest_vector(a,C_rest_count(0));
f_1295r(t0,t1,t2,t3,t4);}}

static void C_ccall f_1295r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a=C_alloc(6);
t5=(C_word)C_i_check_exact_2(t2,lf[48]);
t6=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_1302,a[2]=t1,a[3]=t2,a[4]=t3,a[5]=t4,tmp=(C_word)a,a+=6,tmp);
t7=(C_truep((C_word)C_blockp(t3))?(C_word)C_byteblockp(t3):C_SCHEME_FALSE);
if(C_truep(t7)){
t8=t6;
f_1302(2,t8,C_SCHEME_UNDEFINED);}
else{
/* posixwin.scm: 1050 ##sys#signal-hook */
t8=*((C_word*)lf[6]+1);
((C_proc6)(void*)(*((C_word*)t8+1)))(6,t8,t6,lf[46],lf[48],lf[50],t3);}}

/* k1300 in file-write in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1302(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word ab[9],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1302,2,t0,t1);}
t2=(C_word)C_notvemptyp(((C_word*)t0)[5]);
t3=(C_truep(t2)?(C_word)C_i_vector_ref(((C_word*)t0)[5],C_fix(0)):(C_word)C_block_size(((C_word*)t0)[4]));
t4=(C_word)C_i_check_exact_2(t3,lf[48]);
t5=(C_word)C_write(((C_word*)t0)[3],((C_word*)t0)[4],t3);
t6=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1311,a[2]=t5,a[3]=((C_word*)t0)[2],tmp=(C_word)a,a+=4,tmp);
t7=(C_word)C_eqp(C_fix(-1),t5);
if(C_truep(t7)){
t8=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1317,a[2]=t3,a[3]=((C_word*)t0)[3],a[4]=t6,tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm: 1055 ##sys#update-errno */
t9=*((C_word*)lf[9]+1);
((C_proc2)(void*)(*((C_word*)t9+1)))(2,t9,t8);}
else{
t8=t6;
f_1311(2,t8,C_SCHEME_UNDEFINED);}}

/* k1315 in k1300 in file-write in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1317(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1056 ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);
((C_proc7)(void*)(*((C_word*)t2+1)))(7,t2,((C_word*)t0)[4],lf[37],lf[48],lf[49],((C_word*)t0)[3],((C_word*)t0)[2]);}

/* k1309 in k1300 in file-write in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1311(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
t2=((C_word*)t0)[3];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,((C_word*)t0)[2]);}

/* file-read in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1250(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...){
C_word tmp;
C_word t4;
va_list v;
C_word *a,c2=c;
C_save_rest(t3,c2,4);
if(c<4) C_bad_min_argc_2(c,4,t0);
if(!C_demand(c*C_SIZEOF_PAIR+5)){
C_save_and_reclaim((void*)tr4rv,(void*)f_1250r,4,t0,t1,t2,t3);}
else{
a=C_alloc((c-4)*3);
t4=C_restore_rest_vector(a,C_rest_count(0));
f_1250r(t0,t1,t2,t3,t4);}}

static void C_ccall f_1250r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word *a=C_alloc(5);
t5=(C_word)C_i_check_exact_2(t2,lf[44]);
t6=(C_word)C_i_check_exact_2(t3,lf[44]);
t7=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1260,a[2]=t1,a[3]=t3,a[4]=t2,tmp=(C_word)a,a+=5,tmp);
if(C_truep((C_word)C_notvemptyp(t4))){
t8=t7;
f_1260(2,t8,(C_word)C_i_vector_ref(t4,C_fix(0)));}
else{
/* posixwin.scm: 1037 make-string */
t8=((C_word*)t0)[2];
((C_proc3)C_retrieve_proc(t8))(3,t8,t7,t3);}}

/* k1258 in file-read in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1260(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word ab[6],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1260,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_1263,a[2]=((C_word*)t0)[2],a[3]=((C_word*)t0)[3],a[4]=t1,a[5]=((C_word*)t0)[4],tmp=(C_word)a,a+=6,tmp);
t3=(C_truep((C_word)C_blockp(t1))?(C_word)C_byteblockp(t1):C_SCHEME_FALSE);
if(C_truep(t3)){
t4=t2;
f_1263(2,t4,C_SCHEME_UNDEFINED);}
else{
/* posixwin.scm: 1039 ##sys#signal-hook */
t4=*((C_word*)lf[6]+1);
((C_proc6)(void*)(*((C_word*)t4+1)))(6,t4,t2,lf[46],lf[44],lf[47],t1);}}

/* k1261 in k1258 in file-read in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1263(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[10],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1263,2,t0,t1);}
t2=(C_word)C_read(((C_word*)t0)[5],((C_word*)t0)[4],((C_word*)t0)[3]);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1266,a[2]=t2,a[3]=((C_word*)t0)[4],a[4]=((C_word*)t0)[2],tmp=(C_word)a,a+=5,tmp);
t4=(C_word)C_eqp(C_fix(-1),t2);
if(C_truep(t4)){
t5=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1275,a[2]=((C_word*)t0)[3],a[3]=((C_word*)t0)[5],a[4]=t3,tmp=(C_word)a,a+=5,tmp);
/* posixwin.scm: 1042 ##sys#update-errno */
t6=*((C_word*)lf[9]+1);
((C_proc2)(void*)(*((C_word*)t6+1)))(2,t6,t5);}
else{
t5=t3;
f_1266(2,t5,C_SCHEME_UNDEFINED);}}

/* k1273 in k1261 in k1258 in file-read in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1275(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1043 ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);
((C_proc7)(void*)(*((C_word*)t2+1)))(7,t2,((C_word*)t0)[4],lf[37],lf[44],lf[45],((C_word*)t0)[3],((C_word*)t0)[2]);}

/* k1264 in k1261 in k1258 in file-read in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1266(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word ab[6],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1266,2,t0,t1);}
t2=((C_word*)t0)[4];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,(C_word)C_a_i_list(&a,2,((C_word*)t0)[3],((C_word*)t0)[2]));}

/* file-close in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1232(C_word c,C_word t0,C_word t1,C_word t2){
C_word tmp;
C_word t3;
C_word t4;
C_word t5;
C_word ab[4],*a=ab;
if(c!=3) C_bad_argc_2(c,3,t0);
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr3,(void*)f_1232,3,t0,t1,t2);}
t3=(C_word)C_i_check_exact_2(t2,lf[41]);
if(C_truep((C_word)C_fixnum_lessp((C_word)C_close(t2),C_fix(0)))){
t4=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1245,a[2]=t2,a[3]=t1,tmp=(C_word)a,a+=4,tmp);
/* posixwin.scm: 1029 ##sys#update-errno */
t5=*((C_word*)lf[9]+1);
((C_proc2)(void*)(*((C_word*)t5+1)))(2,t5,t4);}
else{
t4=t1;
((C_proc2)(void*)(*((C_word*)t4+1)))(2,t4,C_SCHEME_UNDEFINED);}}

/* k1243 in file-close in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1245(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1030 ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);
((C_proc6)(void*)(*((C_word*)t2+1)))(6,t2,((C_word*)t0)[3],lf[37],lf[41],lf[42],((C_word*)t0)[2]);}

/* file-open in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1191(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,...){
C_word tmp;
C_word t4;
va_list v;
C_word *a,c2=c;
C_save_rest(t3,c2,4);
if(c<4) C_bad_min_argc_2(c,4,t0);
if(!C_demand(c*C_SIZEOF_PAIR+9)){
C_save_and_reclaim((void*)tr4rv,(void*)f_1191r,4,t0,t1,t2,t3);}
else{
a=C_alloc((c-4)*3);
t4=C_restore_rest_vector(a,C_rest_count(0));
f_1191r(t0,t1,t2,t3,t4);}}

static void C_ccall f_1191r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4){
C_word tmp;
C_word t5;
C_word t6;
C_word t7;
C_word t8;
C_word t9;
C_word t10;
C_word t11;
C_word t12;
C_word *a=C_alloc(9);
t5=(C_word)C_notvemptyp(t4);
t6=(C_truep(t5)?(C_word)C_i_vector_ref(t4,C_fix(0)):((C_word*)t0)[2]);
t7=(C_word)C_i_check_string_2(t2,lf[36]);
t8=(C_word)C_i_check_exact_2(t3,lf[36]);
t9=(C_word)C_i_check_exact_2(t6,lf[36]);
t10=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_1208,a[2]=t2,a[3]=t1,a[4]=t6,a[5]=t3,tmp=(C_word)a,a+=6,tmp);
t11=(*a=C_CLOSURE_TYPE|2,a[1]=(C_word)f_1224,a[2]=t10,tmp=(C_word)a,a+=3,tmp);
/* posixwin.scm: 1019 ##sys#expand-home-path */
t12=*((C_word*)lf[40]+1);
((C_proc3)C_retrieve_proc(t12))(3,t12,t11,t2);}

/* k1222 in file-open in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1224(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1019 ##sys#make-c-string */
t2=*((C_word*)lf[39]+1);
((C_proc3)(void*)(*((C_word*)t2+1)))(3,t2,((C_word*)t0)[2],t1);}

/* k1206 in file-open in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1208(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word ab[10],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1208,2,t0,t1);}
t2=(C_word)C_open(t1,((C_word*)t0)[5],((C_word*)t0)[4]);
t3=(*a=C_CLOSURE_TYPE|3,a[1]=(C_word)f_1211,a[2]=t2,a[3]=((C_word*)t0)[3],tmp=(C_word)a,a+=4,tmp);
t4=(C_word)C_eqp(C_fix(-1),t2);
if(C_truep(t4)){
t5=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_1217,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[5],a[4]=((C_word*)t0)[2],a[5]=t3,tmp=(C_word)a,a+=6,tmp);
/* posixwin.scm: 1021 ##sys#update-errno */
t6=*((C_word*)lf[9]+1);
((C_proc2)(void*)(*((C_word*)t6+1)))(2,t6,t5);}
else{
t5=t3;
f_1211(2,t5,C_SCHEME_UNDEFINED);}}

/* k1215 in k1206 in file-open in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1217(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 1022 ##sys#signal-hook */
t2=*((C_word*)lf[6]+1);
((C_proc8)(void*)(*((C_word*)t2+1)))(8,t2,((C_word*)t0)[5],lf[37],lf[36],lf[38],((C_word*)t0)[4],((C_word*)t0)[3],((C_word*)t0)[2]);}

/* k1209 in k1206 in file-open in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1211(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
t2=((C_word*)t0)[3];
((C_proc2)(void*)(*((C_word*)t2+1)))(2,t2,((C_word*)t0)[2]);}

/* posix-error in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1145(C_word c,C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,...){
C_word tmp;
C_word t5;
va_list v;
C_word *a,c2=c;
C_save_rest(t4,c2,5);
if(c<5) C_bad_min_argc_2(c,5,t0);
if(!C_demand(c*C_SIZEOF_PAIR+8)){
C_save_and_reclaim((void*)tr5r,(void*)f_1145r,5,t0,t1,t2,t3,t4);}
else{
a=C_alloc((c-5)*3);
t5=C_restore_rest(a,C_rest_count(0));
f_1145r(t0,t1,t2,t3,t4,t5);}}

static void C_ccall f_1145r(C_word t0,C_word t1,C_word t2,C_word t3,C_word t4,C_word t5){
C_word tmp;
C_word t6;
C_word t7;
C_word *a=C_alloc(8);
t6=(*a=C_CLOSURE_TYPE|7,a[1]=(C_word)f_1149,a[2]=t4,a[3]=((C_word*)t0)[2],a[4]=t5,a[5]=t3,a[6]=t2,a[7]=t1,tmp=(C_word)a,a+=8,tmp);
/* posixwin.scm: 950  ##sys#update-errno */
t7=*((C_word*)lf[9]+1);
((C_proc2)(void*)(*((C_word*)t7+1)))(2,t7,t6);}

/* k1147 in posix-error in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1149(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word t3;
C_word t4;
C_word t5;
C_word t6;
C_word t7;
C_word ab[16],*a=ab;
if(!C_stack_probe(&a)){
C_save_and_reclaim((void*)tr2,(void*)f_1149,2,t0,t1);}
t2=(*a=C_CLOSURE_TYPE|5,a[1]=(C_word)f_1156,a[2]=((C_word*)t0)[4],a[3]=((C_word*)t0)[5],a[4]=((C_word*)t0)[6],a[5]=((C_word*)t0)[7],tmp=(C_word)a,a+=6,tmp);
t3=(*a=C_CLOSURE_TYPE|4,a[1]=(C_word)f_1160,a[2]=((C_word*)t0)[2],a[3]=t2,a[4]=((C_word*)t0)[3],tmp=(C_word)a,a+=5,tmp);
t4=(C_word)C_a_i_bytevector(&a,1,C_fix(3));
t5=(C_word)C_i_foreign_fixnum_argumentp(t1);
t6=(C_word)stub3(t4,t5);
/* ##sys#peek-c-string */
t7=*((C_word*)lf[8]+1);
((C_proc4)(void*)(*((C_word*)t7+1)))(4,t7,t3,t6,C_fix(0));}

/* k1158 in k1147 in posix-error in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1160(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
/* posixwin.scm: 951  string-append */
t2=((C_word*)t0)[4];
((C_proc5)C_retrieve_proc(t2))(5,t2,((C_word*)t0)[3],((C_word*)t0)[2],lf[7],t1);}

/* k1154 in k1147 in posix-error in k1131 in k1128 in k1125 in k1122 in k1119 */
static void C_ccall f_1156(C_word c,C_word t0,C_word t1){
C_word tmp;
C_word t2;
C_word *a;
C_apply(7,0,((C_word*)t0)[5],*((C_word*)lf[6]+1),((C_word*)t0)[4],((C_word*)t0)[3],t1,((C_word*)t0)[2]);}

#ifdef C_ENABLE_PTABLES
static C_PTABLE_ENTRY ptable[448] = {
{"toplevelposixwin.scm",(void*)C_posix_toplevel},
{"f_1121posixwin.scm",(void*)f_1121},
{"f_1124posixwin.scm",(void*)f_1124},
{"f_1127posixwin.scm",(void*)f_1127},
{"f_1130posixwin.scm",(void*)f_1130},
{"f_1133posixwin.scm",(void*)f_1133},
{"f_1519posixwin.scm",(void*)f_1519},
{"f_1523posixwin.scm",(void*)f_1523},
{"f_1527posixwin.scm",(void*)f_1527},
{"f_1531posixwin.scm",(void*)f_1531},
{"f_1535posixwin.scm",(void*)f_1535},
{"f_1539posixwin.scm",(void*)f_1539},
{"f_2679posixwin.scm",(void*)f_2679},
{"f_4933posixwin.scm",(void*)f_4933},
{"f_4930posixwin.scm",(void*)f_4930},
{"f_4923posixwin.scm",(void*)f_4923},
{"f_4917posixwin.scm",(void*)f_4917},
{"f_4911posixwin.scm",(void*)f_4911},
{"f_4905posixwin.scm",(void*)f_4905},
{"f_4899posixwin.scm",(void*)f_4899},
{"f_4893posixwin.scm",(void*)f_4893},
{"f_4887posixwin.scm",(void*)f_4887},
{"f_4881posixwin.scm",(void*)f_4881},
{"f_4875posixwin.scm",(void*)f_4875},
{"f_4869posixwin.scm",(void*)f_4869},
{"f_4863posixwin.scm",(void*)f_4863},
{"f_4857posixwin.scm",(void*)f_4857},
{"f_4851posixwin.scm",(void*)f_4851},
{"f_4845posixwin.scm",(void*)f_4845},
{"f_4839posixwin.scm",(void*)f_4839},
{"f_4833posixwin.scm",(void*)f_4833},
{"f_4827posixwin.scm",(void*)f_4827},
{"f_4821posixwin.scm",(void*)f_4821},
{"f_4815posixwin.scm",(void*)f_4815},
{"f_4809posixwin.scm",(void*)f_4809},
{"f_4803posixwin.scm",(void*)f_4803},
{"f_4797posixwin.scm",(void*)f_4797},
{"f_4791posixwin.scm",(void*)f_4791},
{"f_4785posixwin.scm",(void*)f_4785},
{"f_4779posixwin.scm",(void*)f_4779},
{"f_4773posixwin.scm",(void*)f_4773},
{"f_4767posixwin.scm",(void*)f_4767},
{"f_4761posixwin.scm",(void*)f_4761},
{"f_4755posixwin.scm",(void*)f_4755},
{"f_4749posixwin.scm",(void*)f_4749},
{"f_4743posixwin.scm",(void*)f_4743},
{"f_4737posixwin.scm",(void*)f_4737},
{"f_4731posixwin.scm",(void*)f_4731},
{"f_4725posixwin.scm",(void*)f_4725},
{"f_4719posixwin.scm",(void*)f_4719},
{"f_4713posixwin.scm",(void*)f_4713},
{"f_4707posixwin.scm",(void*)f_4707},
{"f_4701posixwin.scm",(void*)f_4701},
{"f_4695posixwin.scm",(void*)f_4695},
{"f_4689posixwin.scm",(void*)f_4689},
{"f_4683posixwin.scm",(void*)f_4683},
{"f_4677posixwin.scm",(void*)f_4677},
{"f_4671posixwin.scm",(void*)f_4671},
{"f_4665posixwin.scm",(void*)f_4665},
{"f_4439posixwin.scm",(void*)f_4439},
{"f_4596posixwin.scm",(void*)f_4596},
{"f_4602posixwin.scm",(void*)f_4602},
{"f_4591posixwin.scm",(void*)f_4591},
{"f_4586posixwin.scm",(void*)f_4586},
{"f_4441posixwin.scm",(void*)f_4441},
{"f_4573posixwin.scm",(void*)f_4573},
{"f_4581posixwin.scm",(void*)f_4581},
{"f_4448posixwin.scm",(void*)f_4448},
{"f_4561posixwin.scm",(void*)f_4561},
{"f_4458posixwin.scm",(void*)f_4458},
{"f_4460posixwin.scm",(void*)f_4460},
{"f_4479posixwin.scm",(void*)f_4479},
{"f_4547posixwin.scm",(void*)f_4547},
{"f_4554posixwin.scm",(void*)f_4554},
{"f_4541posixwin.scm",(void*)f_4541},
{"f_4494posixwin.scm",(void*)f_4494},
{"f_4528posixwin.scm",(void*)f_4528},
{"f_4514posixwin.scm",(void*)f_4514},
{"f_4526posixwin.scm",(void*)f_4526},
{"f_4522posixwin.scm",(void*)f_4522},
{"f_4506posixwin.scm",(void*)f_4506},
{"f_4504posixwin.scm",(void*)f_4504},
{"f_4565posixwin.scm",(void*)f_4565},
{"f_4424posixwin.scm",(void*)f_4424},
{"f_4434posixwin.scm",(void*)f_4434},
{"f_4393posixwin.scm",(void*)f_4393},
{"f_4419posixwin.scm",(void*)f_4419},
{"f_4404posixwin.scm",(void*)f_4404},
{"f_4408posixwin.scm",(void*)f_4408},
{"f_4412posixwin.scm",(void*)f_4412},
{"f_4416posixwin.scm",(void*)f_4416},
{"f_4381posixwin.scm",(void*)f_4381},
{"f_4378posixwin.scm",(void*)f_4378},
{"f_4318posixwin.scm",(void*)f_4318},
{"f_4345posixwin.scm",(void*)f_4345},
{"f_4355posixwin.scm",(void*)f_4355},
{"f_4339posixwin.scm",(void*)f_4339},
{"f_4306posixwin.scm",(void*)f_4306},
{"f_4226posixwin.scm",(void*)f_4226},
{"f_4243posixwin.scm",(void*)f_4243},
{"f_4238posixwin.scm",(void*)f_4238},
{"f_4233posixwin.scm",(void*)f_4233},
{"f_4228posixwin.scm",(void*)f_4228},
{"f_4146posixwin.scm",(void*)f_4146},
{"f_4163posixwin.scm",(void*)f_4163},
{"f_4158posixwin.scm",(void*)f_4158},
{"f_4153posixwin.scm",(void*)f_4153},
{"f_4148posixwin.scm",(void*)f_4148},
{"f_4084posixwin.scm",(void*)f_4084},
{"f_4140posixwin.scm",(void*)f_4140},
{"f_4144posixwin.scm",(void*)f_4144},
{"f_4105posixwin.scm",(void*)f_4105},
{"f_4108posixwin.scm",(void*)f_4108},
{"f_4119posixwin.scm",(void*)f_4119},
{"f_4113posixwin.scm",(void*)f_4113},
{"f_4086posixwin.scm",(void*)f_4086},
{"f_4095posixwin.scm",(void*)f_4095},
{"f_3965posixwin.scm",(void*)f_3965},
{"f_3969posixwin.scm",(void*)f_3969},
{"f_4060posixwin.scm",(void*)f_4060},
{"f_3972posixwin.scm",(void*)f_3972},
{"f_4028posixwin.scm",(void*)f_4028},
{"f_4032posixwin.scm",(void*)f_4032},
{"f_4036posixwin.scm",(void*)f_4036},
{"f_4040posixwin.scm",(void*)f_4040},
{"f_4044posixwin.scm",(void*)f_4044},
{"f_3907posixwin.scm",(void*)f_3907},
{"f_3911posixwin.scm",(void*)f_3911},
{"f_4021posixwin.scm",(void*)f_4021},
{"f_4001posixwin.scm",(void*)f_4001},
{"f_4005posixwin.scm",(void*)f_4005},
{"f_4009posixwin.scm",(void*)f_4009},
{"f_3899posixwin.scm",(void*)f_3899},
{"f_3870posixwin.scm",(void*)f_3870},
{"f_3887posixwin.scm",(void*)f_3887},
{"f_3891posixwin.scm",(void*)f_3891},
{"f_3864posixwin.scm",(void*)f_3864},
{"f_3843posixwin.scm",(void*)f_3843},
{"f_3847posixwin.scm",(void*)f_3847},
{"f_3859posixwin.scm",(void*)f_3859},
{"f_3840posixwin.scm",(void*)f_3840},
{"f_3753posixwin.scm",(void*)f_3753},
{"f_3777posixwin.scm",(void*)f_3777},
{"f_3772posixwin.scm",(void*)f_3772},
{"f_3767posixwin.scm",(void*)f_3767},
{"f_3755posixwin.scm",(void*)f_3755},
{"f_3759posixwin.scm",(void*)f_3759},
{"f_3666posixwin.scm",(void*)f_3666},
{"f_3690posixwin.scm",(void*)f_3690},
{"f_3685posixwin.scm",(void*)f_3685},
{"f_3680posixwin.scm",(void*)f_3680},
{"f_3668posixwin.scm",(void*)f_3668},
{"f_3672posixwin.scm",(void*)f_3672},
{"f_3651posixwin.scm",(void*)f_3651},
{"f_3655posixwin.scm",(void*)f_3655},
{"f_3618posixwin.scm",(void*)f_3618},
{"f_3625posixwin.scm",(void*)f_3625},
{"f_3628posixwin.scm",(void*)f_3628},
{"f_3645posixwin.scm",(void*)f_3645},
{"f_3631posixwin.scm",(void*)f_3631},
{"f_3634posixwin.scm",(void*)f_3634},
{"f_3641posixwin.scm",(void*)f_3641},
{"f_3568posixwin.scm",(void*)f_3568},
{"f_3580posixwin.scm",(void*)f_3580},
{"f_3599posixwin.scm",(void*)f_3599},
{"f_3551posixwin.scm",(void*)f_3551},
{"f_3534posixwin.scm",(void*)f_3534},
{"f_3455posixwin.scm",(void*)f_3455},
{"f_3498posixwin.scm",(void*)f_3498},
{"f_3529posixwin.scm",(void*)f_3529},
{"f_3526posixwin.scm",(void*)f_3526},
{"f_3460posixwin.scm",(void*)f_3460},
{"f_3464posixwin.scm",(void*)f_3464},
{"f_3469posixwin.scm",(void*)f_3469},
{"f_3493posixwin.scm",(void*)f_3493},
{"f_3482posixwin.scm",(void*)f_3482},
{"f_3340posixwin.scm",(void*)f_3340},
{"f_3346posixwin.scm",(void*)f_3346},
{"f_3367posixwin.scm",(void*)f_3367},
{"f_3444posixwin.scm",(void*)f_3444},
{"f_3371posixwin.scm",(void*)f_3371},
{"f_3374posixwin.scm",(void*)f_3374},
{"f_3377posixwin.scm",(void*)f_3377},
{"f_3384posixwin.scm",(void*)f_3384},
{"f_3386posixwin.scm",(void*)f_3386},
{"f_3403posixwin.scm",(void*)f_3403},
{"f_3413posixwin.scm",(void*)f_3413},
{"f_3417posixwin.scm",(void*)f_3417},
{"f_3361posixwin.scm",(void*)f_3361},
{"f_3281posixwin.scm",(void*)f_3281},
{"f_3285posixwin.scm",(void*)f_3285},
{"f_3291posixwin.scm",(void*)f_3291},
{"f_3265posixwin.scm",(void*)f_3265},
{"f_3253posixwin.scm",(void*)f_3253},
{"f_3225posixwin.scm",(void*)f_3225},
{"f_3232posixwin.scm",(void*)f_3232},
{"f_3145posixwin.scm",(void*)f_3145},
{"f_3149posixwin.scm",(void*)f_3149},
{"f_3155posixwin.scm",(void*)f_3155},
{"f_3177posixwin.scm",(void*)f_3177},
{"f_3174posixwin.scm",(void*)f_3174},
{"f_3164posixwin.scm",(void*)f_3164},
{"f_3112posixwin.scm",(void*)f_3112},
{"f_3116posixwin.scm",(void*)f_3116},
{"f_3093posixwin.scm",(void*)f_3093},
{"f_3084posixwin.scm",(void*)f_3084},
{"f_3019posixwin.scm",(void*)f_3019},
{"f_3025posixwin.scm",(void*)f_3025},
{"f_3029posixwin.scm",(void*)f_3029},
{"f_3037posixwin.scm",(void*)f_3037},
{"f_3063posixwin.scm",(void*)f_3063},
{"f_3067posixwin.scm",(void*)f_3067},
{"f_3055posixwin.scm",(void*)f_3055},
{"f_2999posixwin.scm",(void*)f_2999},
{"f_3007posixwin.scm",(void*)f_3007},
{"f_2982posixwin.scm",(void*)f_2982},
{"f_2993posixwin.scm",(void*)f_2993},
{"f_2997posixwin.scm",(void*)f_2997},
{"f_2952posixwin.scm",(void*)f_2952},
{"f_2959posixwin.scm",(void*)f_2959},
{"f_2968posixwin.scm",(void*)f_2968},
{"f_2962posixwin.scm",(void*)f_2962},
{"f_2917posixwin.scm",(void*)f_2917},
{"f_2921posixwin.scm",(void*)f_2921},
{"f_2950posixwin.scm",(void*)f_2950},
{"f_2936posixwin.scm",(void*)f_2936},
{"f_2930posixwin.scm",(void*)f_2930},
{"f_2903posixwin.scm",(void*)f_2903},
{"f_2915posixwin.scm",(void*)f_2915},
{"f_2889posixwin.scm",(void*)f_2889},
{"f_2901posixwin.scm",(void*)f_2901},
{"f_2871posixwin.scm",(void*)f_2871},
{"f_2875posixwin.scm",(void*)f_2875},
{"f_2887posixwin.scm",(void*)f_2887},
{"f_2834posixwin.scm",(void*)f_2834},
{"f_2842posixwin.scm",(void*)f_2842},
{"f_2825posixwin.scm",(void*)f_2825},
{"f_2819posixwin.scm",(void*)f_2819},
{"f_2813posixwin.scm",(void*)f_2813},
{"f_2789posixwin.scm",(void*)f_2789},
{"f_2811posixwin.scm",(void*)f_2811},
{"f_2807posixwin.scm",(void*)f_2807},
{"f_2799posixwin.scm",(void*)f_2799},
{"f_2759posixwin.scm",(void*)f_2759},
{"f_2787posixwin.scm",(void*)f_2787},
{"f_2783posixwin.scm",(void*)f_2783},
{"f_2775posixwin.scm",(void*)f_2775},
{"f_2703posixwin.scm",(void*)f_2703},
{"f_2713posixwin.scm",(void*)f_2713},
{"f_2690posixwin.scm",(void*)f_2690},
{"f_2681posixwin.scm",(void*)f_2681},
{"f_2605posixwin.scm",(void*)f_2605},
{"f_2609posixwin.scm",(void*)f_2609},
{"f_2621posixwin.scm",(void*)f_2621},
{"f_2612posixwin.scm",(void*)f_2612},
{"f_2585posixwin.scm",(void*)f_2585},
{"f_2589posixwin.scm",(void*)f_2589},
{"f_2595posixwin.scm",(void*)f_2595},
{"f_2599posixwin.scm",(void*)f_2599},
{"f_2565posixwin.scm",(void*)f_2565},
{"f_2569posixwin.scm",(void*)f_2569},
{"f_2575posixwin.scm",(void*)f_2575},
{"f_2579posixwin.scm",(void*)f_2579},
{"f_2541posixwin.scm",(void*)f_2541},
{"f_2545posixwin.scm",(void*)f_2545},
{"f_2556posixwin.scm",(void*)f_2556},
{"f_2560posixwin.scm",(void*)f_2560},
{"f_2550posixwin.scm",(void*)f_2550},
{"f_2517posixwin.scm",(void*)f_2517},
{"f_2521posixwin.scm",(void*)f_2521},
{"f_2532posixwin.scm",(void*)f_2532},
{"f_2536posixwin.scm",(void*)f_2536},
{"f_2526posixwin.scm",(void*)f_2526},
{"f_2498posixwin.scm",(void*)f_2498},
{"f_2502posixwin.scm",(void*)f_2502},
{"f_2505posixwin.scm",(void*)f_2505},
{"f_2462posixwin.scm",(void*)f_2462},
{"f_2493posixwin.scm",(void*)f_2493},
{"f_2483posixwin.scm",(void*)f_2483},
{"f_2476posixwin.scm",(void*)f_2476},
{"f_2426posixwin.scm",(void*)f_2426},
{"f_2457posixwin.scm",(void*)f_2457},
{"f_2447posixwin.scm",(void*)f_2447},
{"f_2440posixwin.scm",(void*)f_2440},
{"f_2408posixwin.scm",(void*)f_2408},
{"f_2412posixwin.scm",(void*)f_2412},
{"f_2424posixwin.scm",(void*)f_2424},
{"f_2402posixwin.scm",(void*)f_2402},
{"f_2390posixwin.scm",(void*)f_2390},
{"f_2033posixwin.scm",(void*)f_2033},
{"f_2380posixwin.scm",(void*)f_2380},
{"f_2179posixwin.scm",(void*)f_2179},
{"f_2366posixwin.scm",(void*)f_2366},
{"f_2355posixwin.scm",(void*)f_2355},
{"f_2362posixwin.scm",(void*)f_2362},
{"f_2209posixwin.scm",(void*)f_2209},
{"f_2348posixwin.scm",(void*)f_2348},
{"f_2327posixwin.scm",(void*)f_2327},
{"f_2344posixwin.scm",(void*)f_2344},
{"f_2333posixwin.scm",(void*)f_2333},
{"f_2340posixwin.scm",(void*)f_2340},
{"f_2251posixwin.scm",(void*)f_2251},
{"f_2324posixwin.scm",(void*)f_2324},
{"f_2303posixwin.scm",(void*)f_2303},
{"f_2320posixwin.scm",(void*)f_2320},
{"f_2309posixwin.scm",(void*)f_2309},
{"f_2316posixwin.scm",(void*)f_2316},
{"f_2257posixwin.scm",(void*)f_2257},
{"f_2300posixwin.scm",(void*)f_2300},
{"f_2296posixwin.scm",(void*)f_2296},
{"f_2289posixwin.scm",(void*)f_2289},
{"f_2285posixwin.scm",(void*)f_2285},
{"f_2264posixwin.scm",(void*)f_2264},
{"f_2268posixwin.scm",(void*)f_2268},
{"f_2245posixwin.scm",(void*)f_2245},
{"f_2232posixwin.scm",(void*)f_2232},
{"f_2216posixwin.scm",(void*)f_2216},
{"f_2220posixwin.scm",(void*)f_2220},
{"f_2224posixwin.scm",(void*)f_2224},
{"f_2203posixwin.scm",(void*)f_2203},
{"f_2190posixwin.scm",(void*)f_2190},
{"f_2186posixwin.scm",(void*)f_2186},
{"f_2173posixwin.scm",(void*)f_2173},
{"f_2040posixwin.scm",(void*)f_2040},
{"f_2159posixwin.scm",(void*)f_2159},
{"f_2047posixwin.scm",(void*)f_2047},
{"f_2049posixwin.scm",(void*)f_2049},
{"f_2056posixwin.scm",(void*)f_2056},
{"f_2131posixwin.scm",(void*)f_2131},
{"f_2140posixwin.scm",(void*)f_2140},
{"f_2128posixwin.scm",(void*)f_2128},
{"f_2062posixwin.scm",(void*)f_2062},
{"f_2109posixwin.scm",(void*)f_2109},
{"f_2097posixwin.scm",(void*)f_2097},
{"f_2105posixwin.scm",(void*)f_2105},
{"f_2101posixwin.scm",(void*)f_2101},
{"f_2078posixwin.scm",(void*)f_2078},
{"f_2086posixwin.scm",(void*)f_2086},
{"f_2082posixwin.scm",(void*)f_2082},
{"f_1977posixwin.scm",(void*)f_1977},
{"f_1986posixwin.scm",(void*)f_1986},
{"f_2010posixwin.scm",(void*)f_2010},
{"f_2022posixwin.scm",(void*)f_2022},
{"f_2028posixwin.scm",(void*)f_2028},
{"f_2016posixwin.scm",(void*)f_2016},
{"f_1992posixwin.scm",(void*)f_1992},
{"f_1998posixwin.scm",(void*)f_1998},
{"f_1984posixwin.scm",(void*)f_1984},
{"f_1966posixwin.scm",(void*)f_1966},
{"f_1961posixwin.scm",(void*)f_1961},
{"f_1910posixwin.scm",(void*)f_1910},
{"f_1914posixwin.scm",(void*)f_1914},
{"f_1923posixwin.scm",(void*)f_1923},
{"f_1926posixwin.scm",(void*)f_1926},
{"f_1883posixwin.scm",(void*)f_1883},
{"f_1908posixwin.scm",(void*)f_1908},
{"f_1904posixwin.scm",(void*)f_1904},
{"f_1890posixwin.scm",(void*)f_1890},
{"f_1723posixwin.scm",(void*)f_1723},
{"f_1831posixwin.scm",(void*)f_1831},
{"f_1839posixwin.scm",(void*)f_1839},
{"f_1826posixwin.scm",(void*)f_1826},
{"f_1725posixwin.scm",(void*)f_1725},
{"f_1732posixwin.scm",(void*)f_1732},
{"f_1735posixwin.scm",(void*)f_1735},
{"f_1738posixwin.scm",(void*)f_1738},
{"f_1825posixwin.scm",(void*)f_1825},
{"f_1742posixwin.scm",(void*)f_1742},
{"f_1759posixwin.scm",(void*)f_1759},
{"f_1769posixwin.scm",(void*)f_1769},
{"f_1781posixwin.scm",(void*)f_1781},
{"f_1791posixwin.scm",(void*)f_1791},
{"f_1751posixwin.scm",(void*)f_1751},
{"f_1696posixwin.scm",(void*)f_1696},
{"f_1721posixwin.scm",(void*)f_1721},
{"f_1717posixwin.scm",(void*)f_1717},
{"f_1709posixwin.scm",(void*)f_1709},
{"f_1669posixwin.scm",(void*)f_1669},
{"f_1694posixwin.scm",(void*)f_1694},
{"f_1690posixwin.scm",(void*)f_1690},
{"f_1682posixwin.scm",(void*)f_1682},
{"f_1642posixwin.scm",(void*)f_1642},
{"f_1667posixwin.scm",(void*)f_1667},
{"f_1663posixwin.scm",(void*)f_1663},
{"f_1655posixwin.scm",(void*)f_1655},
{"f_1581posixwin.scm",(void*)f_1581},
{"f_1594posixwin.scm",(void*)f_1594},
{"f_1609posixwin.scm",(void*)f_1609},
{"f_1600posixwin.scm",(void*)f_1600},
{"f_1603posixwin.scm",(void*)f_1603},
{"f_1541posixwin.scm",(void*)f_1541},
{"f_1560posixwin.scm",(void*)f_1560},
{"f_1545posixwin.scm",(void*)f_1545},
{"f_1554posixwin.scm",(void*)f_1554},
{"f_1548posixwin.scm",(void*)f_1548},
{"f_1508posixwin.scm",(void*)f_1508},
{"f_1510posixwin.scm",(void*)f_1510},
{"f_1503posixwin.scm",(void*)f_1503},
{"f_1480posixwin.scm",(void*)f_1480},
{"f_1501posixwin.scm",(void*)f_1501},
{"f_1487posixwin.scm",(void*)f_1487},
{"f_1474posixwin.scm",(void*)f_1474},
{"f_1478posixwin.scm",(void*)f_1478},
{"f_1468posixwin.scm",(void*)f_1468},
{"f_1472posixwin.scm",(void*)f_1472},
{"f_1462posixwin.scm",(void*)f_1462},
{"f_1466posixwin.scm",(void*)f_1466},
{"f_1456posixwin.scm",(void*)f_1456},
{"f_1460posixwin.scm",(void*)f_1460},
{"f_1450posixwin.scm",(void*)f_1450},
{"f_1454posixwin.scm",(void*)f_1454},
{"f_1444posixwin.scm",(void*)f_1444},
{"f_1448posixwin.scm",(void*)f_1448},
{"f_1413posixwin.scm",(void*)f_1413},
{"f_1417posixwin.scm",(void*)f_1417},
{"f_1420posixwin.scm",(void*)f_1420},
{"f_1375posixwin.scm",(void*)f_1375},
{"f_1408posixwin.scm",(void*)f_1408},
{"f_1404posixwin.scm",(void*)f_1404},
{"f_1379posixwin.scm",(void*)f_1379},
{"f_1388posixwin.scm",(void*)f_1388},
{"f_1337posixwin.scm",(void*)f_1337},
{"f_1344posixwin.scm",(void*)f_1344},
{"f_1347posixwin.scm",(void*)f_1347},
{"f_1367posixwin.scm",(void*)f_1367},
{"f_1350posixwin.scm",(void*)f_1350},
{"f_1357posixwin.scm",(void*)f_1357},
{"f_1295posixwin.scm",(void*)f_1295},
{"f_1302posixwin.scm",(void*)f_1302},
{"f_1317posixwin.scm",(void*)f_1317},
{"f_1311posixwin.scm",(void*)f_1311},
{"f_1250posixwin.scm",(void*)f_1250},
{"f_1260posixwin.scm",(void*)f_1260},
{"f_1263posixwin.scm",(void*)f_1263},
{"f_1275posixwin.scm",(void*)f_1275},
{"f_1266posixwin.scm",(void*)f_1266},
{"f_1232posixwin.scm",(void*)f_1232},
{"f_1245posixwin.scm",(void*)f_1245},
{"f_1191posixwin.scm",(void*)f_1191},
{"f_1224posixwin.scm",(void*)f_1224},
{"f_1208posixwin.scm",(void*)f_1208},
{"f_1217posixwin.scm",(void*)f_1217},
{"f_1211posixwin.scm",(void*)f_1211},
{"f_1145posixwin.scm",(void*)f_1145},
{"f_1149posixwin.scm",(void*)f_1149},
{"f_1160posixwin.scm",(void*)f_1160},
{"f_1156posixwin.scm",(void*)f_1156},
{NULL,NULL}};
#endif

static C_PTABLE_ENTRY *create_ptable(void){
#ifdef C_ENABLE_PTABLES
return ptable;
#else
return NULL;
#endif
}
/* end of file */
